

jQuery.fn.ForceNumericOnly =
	function () {
		return this.each(function () {
			$(this).keydown(function (e) {
				var key = e.charCode || e.keyCode || 0;
				// allow backspace, tab, delete, enter, arrows, numbers and keypad numbers ONLY
				// home, end, period, and numpad decimal
				return (
					key == 8 ||
					key == 9 ||
					key == 13 ||
					key == 46 ||
					key == 110 ||
					key == 190 ||
					(key >= 35 && key <= 40) ||
					(key >= 48 && key <= 57) ||
					(key >= 96 && key <= 105));
			});
		});
	};



(function ($) {

	$.fn.numeric = function (options) {

		return this.each(function () {
			var $this = $(this);

			$this.keypress(options, function (e) {
				// allow backspace and delete 
				if (e.which == 8 || e.which == 0)
					return true;

				//if the letter is not digit 
				if (e.which < 48 || e.which > 57)
					return false;

				// check max range 
				var dest = e.which - 48;
				var result = this.value + dest.toString();
				if (result > e.data.max) {
					return false;
				}
			});
		});
	};
})(jQuery);

jQuery(document).ready(function () {

	$(".btn-delete").click(function() {		
		
		fid = $(this).attr('data-link');
		
		Swal.fire({
			title: 'Confirm deletion',
			//text: 'Μετά την απενεργοποίηση του αρχεία δεν είναι διαθέσιμο για την επιλογή του στο Timeline ',
			type: "warning",
			showCancelButton: true,
			confirmButtonColor: "#DD6B55",
			confirmButtonText: "Yes!",
			cancelButtonText: "No!"
		}).then((result) => {

			if (result.value==true) {
				location.href="index.php?ACTION=_delete_record&"+fid;
			}
		});		
	});

	$(".btn_form").click(function () {

		$.validator.setDefaults({ ignore: ":hidden:not(select)" });
		//$.validator.messages.required = 'Υποχρεωτικό πεδίο';
		//$.validator.messages.minlength = jQuery.validator.format("Εισάγετε τουλάχιστον {0} χαρακτήρες.");
		//$.validator.messages.email = 'Εισάγετε έγκυρο λογαριασμό email';
		$("#validate_form").validate({
			rules: {
				email: {
					required: true,
					minlength: 5
				},
				password: {
					required: true,
					minlength: 5
				},
				three_digit_id_number_o: {
					required: true,
					minlength: 3,
					maxlength: 3,
					number: true
				}
			},
			messages: {
				three_digit_id_number_o: "Enter only numbers"
			}
		});
		
		
		if ($('#validate_form').valid()) {
			$("#validate_form").submit();
		}
		return false;
	});
	$(".btn_form2").click(function () {

		$.validator.setDefaults({ ignore: ":hidden:not(select)" });
		//$.validator.messages.required = 'Υποχρεωτικό πεδίο';
		//$.validator.messages.minlength = jQuery.validator.format("Εισάγετε τουλάχιστον {0} χαρακτήρες.");
		//$.validator.messages.email = 'Εισάγετε έγκυρο λογαριασμό email';
				
		$("#edit_operators_table").validate({
			rules: {
				email: {
					required: true,
					minlength: 5
				},
				password: {
					required: true,
					minlength: 5
				},
				three_digit_id_number_o: {
					required: true,
					minlength: 3,
					maxlength: 3,
					number: true
				},



			},
			messages: {
				three_digit_id_number_o: "Enter only numbers"
			}
		});

		if ($('#edit_operators_table').valid()) {
			$("#edit_operators_table").submit();
		}
		return false;
	});


	/******************************************************************************************************************************************************************************************************************************************/
	/************************************************/
	/*** Φορμα login μετά το καλάθι					*/
	/************************************************/
	$("#btnLogin").click(function () {

		$.ajax({
			type: "POST",
			url: "index.php?ACTION=_ajax_check_login",
			data: $("#frmLogin").serialize(),
			success: function (data) {

				if (data.trim() == 1) {
					location.href = 'index.php?SCREEN=vitrine2';
				} else {
					$("#ErrLoginUser").html("<br>Τα στοιχεία του χρήστη που πληκτρολογήσατε δεν είναι έγκυρα.");
				}
			}
		});


		return false;
	});
	
	
	$(".select_agency").change(function () {
		th = $(this);
		
		$.ajax({
			type: "POST",
			url: "index.php?ACTION=_ajax_search_operator",
			data: { AgencyID:th.val() },
			success: function (data) {
				$("#Operator_html").html(data);
			}
		});

		return false;
	});
	


	$('#datecreatepicker').datepicker(
		{ format: 'dd/mm/yyyy' }
	);
	$('#datecreatepicker2').datepicker(
		{ format: 'dd/mm/yyyy' }
	);

	$('#search-select-1').multiselect({ enableClickableOptGroups: true });
	$('#search-select-2').multiselect({ enableClickableOptGroups: true });


});