<?php
include('includes/connect.php');
session_start();
if (isset($_SESSION["ssUser"]['loggedin']) && $_SESSION["ssUser"]['loggedin'] == true && $_SESSION["ssUser"]['access_level'] != 3) {

//Time out if user is inactive
include('includes/timeout.php');

//Localization settings
include('includes/get_lang.php');

?>

</html>
<head>
<meta charset="utf-8">
<title>CAN-MDS SURVEILLANCE SYSTEM</title>
<link rel="stylesheet" href="css/style.css" />
<link href="css/jquery-checktree.css" rel="stylesheet" type="text/css">
<link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css">
<?php include_once("includes/analyticstracking.php") ?>
</head>
<body>

<table id="table_wrapper">
	<tr>
		<td id="left_collumn">
		
			<div class="title">
				<p><?php echo get_trans("All known Incidents for this Child"); ?></p>
			</div>
			
			<table class="ki_table" style="margin-top:20px;">
				<tr>
					<td class="col1 header"><?php echo get_trans("Incident's ID"); ?></td>
					<td class="col1 header"><?php echo get_trans("Date-Time of Record"); ?></td>
					<td class="col1 header"><?php echo get_trans("Date of Incident"); ?></td>
					<td class="col1 header" style="width:100px;"><?php echo get_trans("Display"); ?></td>
				</tr>
				
				<?php
					$counter = 0;
					if (isset($_POST['display_all_records'])){
						//We just need the childs id no matter if its a known or new child
						if (isset($_SESSION["Data"]['known_childs_id']))
							$child_id = $_SESSION["Data"]['known_childs_id'];
						else 
							$child_id = $_SESSION["Data"]['new_childs_id'];
							
						$db->query("SELECT * FROM i_incident I WHERE child_id='".$child_id."' AND I.date_time_of_record_for_db = (SELECT MAX(I2.date_time_of_record_for_db) FROM i_incident I2 WHERE I2.incident_id=I.incident_id)");
						while($db->next()) {
							$counter++;
							echo '<tr><td style="padding:5px;">'.$db->Record['incident_id'].'</td>';
							echo '<td style="padding:5px;">'.$db->Record['datetime_of_record'].'</td>';
							//echo '<td style="padding:5px;">'.$db->Record['date_of_incident'].'</td>';
							echo '<td style="padding:5px;">'. get_trans($db->Record['type_of_incident']);
							if ($db->Record['exact_date_of_incident'] == 'YYYY-MM-DD') {
								if ($db->Record['start_date'] !== '') {
									echo ' - '.$db->Record['start_date'];
								}
								if ($db->Record['duration_first_note'] !== '' ){
									echo ' '.get_trans('for').' '. get_trans($db->Record['duration_first_note']);
								}
								if ((int)$db->Record['duration_years'] !== 0 ){
									if ((int)$db->Record['duration_years'] == 1)
										echo ' '.$db->Record['duration_years'].' '. get_trans('year');
									else
										echo ' '.$db->Record['duration_years'].' '. get_trans('years');
								}
								if ((int)$db->Record['duration_months'] !== 0 ){
									if ((int)$db->Record['duration_months'] == 1)
										echo ' '.$db->Record['duration_months'].' '. get_trans('month');
									else
										echo ' '.$db->Record['duration_months'].' '. get_trans('months');
								}
								if ((int)$db->Record['duration_days'] !== 0 ){
									if ((int)$db->Record['duration_days'] == 1)
										echo ' '.$db->Record['duration_days'].' '. get_trans('day');
									else
										echo ' '.$db->Record['duration_days'].' '. get_trans('days');
								}
								if ($db->Record['duration_last_note'] !== '' ){
									echo ' '. get_trans($db->Record['duration_last_note']);
								}
								if ($db->Record['duration_special_situation'] !== '' ){
									echo ' '. get_trans($db->Record['duration_special_situation']);
								}
								
							} else if ($db->Record['exact_date_of_incident'] !== '') {
								echo ' - '. get_trans($db->Record['exact_date_of_incident']);
							}
							if ($db->Record['last_known_cm_date'] !== '') {
								echo ' - '.get_trans('Last known CM date').': '. get_trans($db->Record['last_known_cm_date']);
							}
							echo '</td>';
							
							echo '<form action="display_record.php" method="post">';
							echo '<td style="padding:5px; width:100px; text-align:center;"><button id="display_button'.$counter.'" class="display_button" type="submit" title="Display record" name="display_known_record"><i class="fa fa-search fa-lg"></i></button>';
							echo '<input type="hidden" name="date_time_of_record_for_db" value="'.$db->Record['date_time_of_record_for_db'].'">';
							echo '<input type="hidden" name="operators_id" value="'.$db->Record['recorded_by_operator'].'">';
							echo '<input type="hidden" name="known_child_id" value="'.$db->Record['child_id'].'">';
							echo '</form>';							
						}
					}
				?>
				
			</table>
						
			<form action="record_complete.php" method="post">
				<div class="next">
					<input class="next_button" type="submit" name="back" value="< <?php echo get_trans("Back"); ?>" />
					<?php
					//Session that keeps the page the user is coming from in order to take him back with a back_button
					$_SESSION["Data"]['back_button'] = 'display_all_records';
					?>
				</div>
			</form>
			
		</td>
		<td id="right_collumn">
			<?php include 'includes/logout_top_right.php'; ?>
			<?php include 'includes/records_table.php'; ?>	
		</td> 
	</tr>
</table>

<?php include 'includes/scripts.php'; ?>
<!-- Language Selection -->
<script type="text/javascript">
$(document).ready(function() {
	$('#polyglotLanguageSwitcher').polyglotLanguageSwitcher({
		effect: 'slideDown',
		testMode: true,
		onChange: function(evt){
			$.ajax({
				type: 'GET',
				url: 'display_all_records.php',
				data: 'lang=' + evt.selectedItem
				,success: function() {
					//window.location.reload(true);
					window.location.href = 'record_complete.php';
				}
			});
		}
		// afterLoad: function(evt){
			// alert("The selected language has been loaded: "+evt.selectedItem);
		// }
	});
});
</script>

<script>
$(document).ready(function(){
	$('.display_button').each(function(i){ 
		i = i + 1; // i starts count from 1 instead of 0
		$('#display_button'+i).hover(function() {
			$('#display_button'+i).addClass('transition');    
		}, function() {
			$('#display_button'+i).removeClass('transition');
		});
	});
});
</script>

</body>
</html>

<?php
	



} else {
	header("location: index.php");
}
?>