<?php
class mysqldb
{
        var $Database;
        var $Auto_Free = 1; ## Set to 1 for automatic mysql_free_result()
        var $Record = array();
        var $Query;
        var $Row;
        var $Errno = 0;
        var $Error = "";
        var $dbLink = 0;
        var $Result = 0;
        var $DataField = array();
        var $OriginalQuery = "";
		var $UpdateID;

		function connect($Host,$User,$Pass,$db)
		{
			$this->dbLink = mysqli_connect($Host,$User,$Pass,$db);
			if (!$this->dbLink) {
			    echo "Error: Unable to connect to MySQL." . PHP_EOL;
			    echo "Debugging errno: " . mysqli_connect_errno() . PHP_EOL;
			    echo "Debugging error: " . mysqli_connect_error() . PHP_EOL;
			    exit;
			}

			/* change character set to utf8 */
			if (!mysqli_set_charset($this->dbLink, "utf8")) {
			    printf("Error loading character set utf8: %s\n", mysqli_error($this->dbLink));
			    exit();
			} 

			return $this->dbLink;
		}
      
        function free()
        {
            $this->Record = array();
            $this->Result = 0;
            unset($this->Row);
        }
		
        function query($Query,$Debug=0)
        {	
        
                $Query = trim($Query);
                if(!$Query) return;
                if($this->Result) $this->free();
                $this->OriginalQuery=$Query;

				$this->DataField = array();
                $this->Result =  mysqli_query($this->dbLink,$Query);
							
                if($Debug>=0 && !$this->Result) {	
                	if ($_SERVER['REMOTE_ADDR'] == '85.72.38.217')  {
						dev($Query);
						dev(error_get_last(),mysqli_error($this->dbLink));
					}
					trigger_error("Query: ".$Query);	
					trigger_error(error_get_last());	
					trigger_error(mysqli_error($this->dbLink));						
					
                } elseif($Debug==1)  {
					if ($_SERVER['REMOTE_ADDR'] == '85.72.38.217')  {
						dev($Query);
					}
                }

                $this->Row = @$this->num_rows();
                return($this->Result);
        }
		

		function insert($tbl,$Fld)
		{
		    $keys = array_keys($Fld); 
		    $vals = array_values($Fld); 
		   
		    $key = ''; 
		    $val = ''; 
		    $type = ''; 
		    foreach($keys AS $key_value) { 
		        if($key == '') { 
		            $key = '`'.$key_value.'`'; 
		            $val = '?'; 
		        } else { 
		            $key .= ', `'.$key_value.'`'; 
		            $val .= ', ?'; 
		        } 
		        $typeDef[]="s";
		    } 
 			
		    if ($stmt = mysqli_prepare($this->dbLink,"INSERT INTO `$tbl` ($key) values ($val)")) {
		        for($i = 0; $i < count($typeDef); $i++) { 
		            $params[$keys[$i]] = $typeDef[$i]; 
		        } 

		        $this->bindParameters($stmt, $params); 
		       
		        for($i = 0; $i < count($typeDef); $i++) { 		            
		            $params[$keys[$i]] = $vals[$i]; 
		        } 
		        
	     		if(!$stmt->execute() ) { trigger_error("Execute Statement Error: $tbl ".mysqli_error($this->dbLink)); exit(); } 

		        $stmt->close();  
			} else {
				trigger_error(mysqli_error($this->dbLink)); exit();
		    }
		}
	
		function query_bind($sql,$arData) {
			$ret = array();
			if ($stmt = mysqli_prepare($this->dbLink,$sql)) {
				
				if (count($arData)==1) {
					mysqli_stmt_bind_param($stmt,"s",$arData[0]);			
				} elseif (count($arData)==2) {
					mysqli_stmt_bind_param($stmt,"ss",$arData[0],$arData[1]);			
				}
				mysqli_stmt_execute($stmt);
				$result = mysqli_stmt_get_result($stmt);
				
				if ($row = mysqli_fetch_array($result, MYSQLI_BOTH)) {
					foreach($row as $k=>$v) {							
						$row[$k]=str_replace('\"','"',$v);							
					}
				   $ret=$row;
				}
				
				if(!$stmt->execute() ) { trigger_error("Execute Statement Error: $tbl ".mysqli_error($this->dbLink)); exit(); } 
				
				mysqli_stmt_close($stmt);
			}
			
			return $ret;
		}
		
		function update($tbl,$Primary,$Field)
		{
			$query_bind = array();
			
			$set_v=$set_k="";

			$i_cnt = (count($Field)+count($Primary))-1;

			$i_str="";
			for($i=0;$i<=$i_cnt;$i++) {
			  $i_str.="s";
			  $typeDef[]="s";
			}

			foreach($Field as $k=>$v) {
				$set_v.="`".$k."`"."=?,";
				$query_bind[$k]=$v;
			}

			foreach($Primary as $k=>$v) {
				$set_k.="`".$k."`"."=? and ";
				$query_bind[$k]=$v;
			}  
	  	
			$keys = array();
		    $keys = array_keys($query_bind); 			
			
		    $vals = array_values($query_bind); 

		    if ($stmt = mysqli_prepare($this->dbLink,"UPDATE `".$tbl."` SET ".substr($set_v,0,-1)." WHERE ".substr($set_k,0,-4))) {
		        for($i = 0; $i < count($typeDef); $i++) { 
		            $params[$keys[$i]] = $typeDef[$i]; 
		        } 
		       
		        $this->bindParameters($stmt, $params); 
		        
		        for($i = 0; $i < count($typeDef); $i++) { 		            
		            $params[$keys[$i]] = $vals[$i]; 
		        } 
		        
	     		if(!$stmt->execute() ) { trigger_error("Execute Statement Error: $tbl ".mysqli_error($this->dbLink)); exit(); }  

		        $stmt->close();  
			} else { 
		       trigger_error(mysqli_error($this->dbLink)); exit();
		    }
		}

		function bindParameters(&$statement, &$params) { 
		  $args   = array(); 
		  $args[] = implode('', array_values($params)); 

		  foreach ($params as $paramName => $paramType) { 
		    $args[] = &$params[$paramName]; 
		    $params[$paramName] = null; 
		  } 
		  call_user_func_array(array(&$statement, 'bind_param'), $args); 
		} 
      
        function next()
        {
			if(!$this->Result) return 0;
			$tmpG = $tmp = array();
			
			$Rec = mysqli_fetch_array($this->Result);
			
			$this->Record=$Rec;
			
			$this->Row++;
			$status = is_array($this->Record);
			if (!$status && $this->Auto_Free) $this->free();
			return $status;
        }

        function insert_id()
        {
                return(@mysqli_insert_id($this->dbLink ? $this->dbLink : NULL));
        }

        function affected_rows()
        {
                return(@mysqli_affected_rows($this->dbLink ? $this->dbLink : NULL));
        }

        function num_rows()
        {
        	if ($this->Result) {
        		return mysqli_num_rows($this->Result);
        	} else {
        		return 0;
        	} 
        }

        function num_fields()
        {
                //return($this->Result ? @mysql_num_fields($this->Result) : 0);
        }

        function eof()
        {
                return($this->Row>$this->num_rows());
        }

        function close()
        {
                mysqli_close($this->dbLink ? $this->dbLink : NULL);
        }
}
?>