SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

CREATE DATABASE IF NOT EXISTS `can_mds` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;
USE `can_mds`;

CREATE TABLE `c_child` (
  `id` int(11) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `recorded_by_agency` varchar(15) NOT NULL,
  `recorded_by_operator` varchar(25) NOT NULL,
  `datetime_of_record` varchar(20) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `type_of_record` enum('first_record','updated_record') NOT NULL,
  `recorded_by_agency_nid` int(11) NOT NULL DEFAULT '0',
  `recorded_by_operator_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `c_child_dob` (
  `id` int(11) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `name` varchar(40) NOT NULL,
  `date` varchar(10) DEFAULT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `c_child_health` (
  `id` int(11) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `health` varchar(80) DEFAULT NULL,
  `behavior_problem` varchar(20) DEFAULT NULL,
  `type_of_problem` varchar(80) DEFAULT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `c_child_sex` (
  `id` int(11) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `name` varchar(30) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `c_citizenship_status` (
  `id` int(11) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `name` varchar(80) NOT NULL,
  `nationality` varchar(80) DEFAULT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `data_forms_of_maltreatment_acts_committed` (
  `id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `parent_id` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `data_forms_of_maltreatment_acts_committed` (`id`, `name`, `parent_id`) VALUES
(1, 'Violent acts against self /Self-harm actions', NULL),
(2, 'Eating disorder', 1),
(3, 'Substance use/ abuse', 1),
(4, 'Runaway', 1),
(5, 'Self-inflicted injuries', 1),
(6, 'Suicidal thoughts', 1),
(7, 'Suicide attempt', 1),
(8, 'Actual suicide', 1),
(9, 'Other self-harm action (unspecified)', 1),
(10, 'Physical violence acts committed [with or without injury]', NULL),
(11, 'Physical violent acts/ corporal punishment/“disciplines”', 10),
(12, 'Slapping', 11),
(13, 'Smacking', 11),
(14, 'Spanking', 11),
(15, 'Pinching', 11),
(16, 'Twisting ear(s)', 11),
(17, 'Pulling hair', 11),
(18, 'Hitting with an object', 11),
(19, 'Beating', 11),
(20, 'Tying up or tying to something /restraining to cloth sacks', 11),
(21, 'Locking up', 11),
(22, 'Leaving child to lie in their own excrement', 11),
(23, 'Pushing', 11),
(24, 'Throwing', 11),
(25, 'Shaking', 11),
(26, 'Grabbing', 11),
(27, 'Choking', 11),
(28, 'Squeezing neck', 11),
(29, 'Kicking', 11),
(30, 'Hitting on head (with hand or against the wall)', 11),
(31, 'Boxing ear', 11),
(32, 'Scratching', 11),
(33, 'Biting', 11),
(34, 'Burning', 11),
(35, 'Scalding', 11),
(36, 'Violent acts known also as harmful practices', 10),
(37, 'Hitting on the soles of the feet', 36),
(38, 'Forcing to ingest spicy food', 36),
(39, 'Forced feeding', 36),
(40, 'Forcing children to stay in uncomfortable positions', 36),
(41, 'Binding', 36),
(42, 'Inflicting scars/ scarring', 36),
(43, 'Teeth extraction as punishment', 36),
(44, 'Branding', 36),
(45, 'Fattening', 36),
(46, '“Retribution” acts of violence', 36),
(47, 'Virginity testing (inspecting girls’ genitalia)', 36),
(48, 'Forced circumcision', 36),
(49, 'Female genital mutilation', 36),
(50, 'Uvulectomy', 36),
(51, 'Forced marriage and early marriage', 36),
(52, 'Violent and degrading initiation rites / “hazing”', 36),
(53, 'Practices as “exorcism” after accusations of “witchcraft”', 36),
(54, 'Forced sterilization, particularly girls', 36),
(55, 'Violence in the guise of treatment', 36),
(56, 'Deliberate infliction of disabilities for exploiting/begging', 36),
(57, 'Acts of life threatening maltreatment (with intention)', 10),
(58, 'Administering unnecessary invasive medical procedures', 57),
(59, 'Administering non prescribed substances', 57),
(60, '(intentional) Poisoning', 57),
(61, 'Threatening with a knife (also psychological abuse)', 57),
(62, 'Threatening with a gun (also psychological abuse)', 57),
(63, 'Stabbing', 57),
(64, 'Shooting', 57),
(65, 'Threatening with a gun (also psychological abuse)', 57),
(66, 'Stabbing', 57),
(67, 'Dowry-related violence/death (also harmful practice)', 57),
(68, '“Honour” crimes (also harmful practice)', 57),
(69, 'Abduction-related acts', 10),
(70, 'Non-family abduction', 69),
(71, 'Family abduction', 69),
(72, 'Institutional and system violations of child rights', 10),
(73, 'Caning', 72),
(74, 'Flogging', 72),
(75, 'Stoning', 72),
(76, 'Torture (all forms)', 72),
(77, 'Amputations', 72),
(78, 'Imposing of death sentence for crimes committed', 72),
(79, 'Other described physical acts', 10),
(80, 'No specific information for reported/suspected physical violence', 10),
(81, 'Sexual violence acts committed [with or without injury]', NULL),
(82, 'Sexual violence acts', 81),
(83, 'Acts involving penetration (intrusion)', 82),
(84, 'Without force', 83),
(85, 'anus', 84),
(86, 'vulva', 84),
(87, 'mouth', 84),
(88, 'unspecified', 84),
(89, 'Involving use of force', 83),
(90, 'anus', 89),
(91, 'vulva', 89),
(92, 'mouth', 89),
(93, 'unspecified', 89),
(94, 'Attempted sexual abuse (not involving penetration)', 82),
(95, 'with physical contact', 94),
(96, 'without physical contact', 94),
(97, 'Threatened sexual abuse', 82),
(98, 'with physical contact', 97),
(99, 'without physical contact', 97),
(100, 'Touching/fondling genitals', 82),
(101, 'Showing genitals to child', 82),
(102, 'Sexual harassment', 82),
(103, 'Voyeurism /spying on the children intimate behaviours', 82),
(104, 'Providing sexually explicit materials', 82),
(105, 'Forced exposure to pornography', 82),
(106, 'Forcing to witness sexual violence against mother', 82),
(107, 'Sexual “luring” (via ICT)', 82),
(108, 'Online sexual stalking /harassment', 82),
(109, 'Other Sexual violence acts', 82),
(110, 'Sexual exploitation acts', 81),
(111, 'Child prostitution', 110),
(112, 'Use of children in commercial sexual exploitation', 110),
(113, 'Sexual exploitation in travel and tourism', 110),
(114, 'Sexual slavery', 110),
(115, 'Sale of children for sexual purposes', 110),
(116, 'Trafficking (within and between countries)', 110),
(117, 'Involvement in pornography', 110),
(118, 'Forced marriage and early marriage', 110),
(119, 'Other sexual exploitation acts (unspecified)', 110),
(120, 'No specific information for reported/suspected sexual violence', 81),
(121, 'Psychological violence acts committed [with or without injury]', NULL),
(122, 'Violent acts with or without obvious consequences', 121),
(123, 'Bullying/ Psychological bullying and hazing', 122),
(124, 'by other children', 123),
(125, 'by adults', 123),
(126, 'Homophobic bullying /related to sexual orientation', 122),
(127, 'by other children', 126),
(128, 'by adults', 126),
(129, 'Cyber bullying (via ICTs / mobile phones /Internet)', 122),
(130, 'by other children', 129),
(131, 'by adults', 129),
(132, 'Ignoring and favoritism', 122),
(133, 'Denying emotional responsiveness', 122),
(134, 'Over protection', 122),
(135, 'Isolation (social)', 122),
(136, 'Close confinement (tying/binding)', 122),
(137, 'Placement in solitary confinement', 122),
(138, 'Degrading /inhuman conditions of detention', 122),
(139, 'Humiliation /Insults, name-calling, belittling, ridiculing', 122),
(140, 'Humiliation via ICT', 122),
(141, 'Rejection and Spurning', 122),
(142, 'Verbal assaults', 122),
(143, 'Terrorization / Scaring', 122),
(144, 'Threats of sexual violence (with or without contact)', 122),
(145, 'Threats of other maltreatment', 122),
(146, 'Other related acts hurting child’s feelings', 122),
(147, 'Exploitation related psychological violent acts', 121),
(148, 'Exploiting and corrupting', 147),
(149, 'Labour/economic exploitation', 147),
(150, 'Forcing to undertake adult’s responsibilities', 147),
(151, 'Forcing to begging', 147),
(152, 'Forcing to criminal behaviour', 147),
(153, 'Forcing to participate in religious ritual', 147),
(154, 'Forcing to participate in a violent political event', 147),
(155, 'No specific info for reported/suspected exploitation acts', 147),
(156, 'Exposure related psychological violent acts', 121),
(157, 'Exposure to any kind of violence in the family / DV', 156),
(158, 'Exposure to violence against other children', 157),
(159, 'Exposure to intimate partner violence', 157),
(160, 'Exposure to violence against other adults', 157),
(161, 'Exposition to the homicide of a significant person', 157),
(162, 'Exposure to a violent environment outside the family', 156),
(163, 'Exposure to violence via electronic means', 156),
(164, 'information and communication technologies', 163),
(165, 'in the mass media', 163),
(166, 'No specific info for reported/suspected related exposure', 156),
(167, 'No specific info for reported/suspected psych/l abuse violent acts', 121);

CREATE TABLE `data_forms_of_maltreatment_omissions` (
  `id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `parent_id` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `data_forms_of_maltreatment_omissions` (`id`, `name`, `parent_id`) VALUES
(1, 'Omissions in child’s care / Neglect', NULL),
(2, 'Emotional neglect related omissions', 1),
(3, 'Persistent ignoring of the child’s emotional needs/ Chronic inattention to the child ', 2),
(4, 'Psychologically “unavailable” caregivers ', 2),
(5, 'Inappropriately advanced expectations (def.  According to child’s characteristics) ', 2),
(6, 'No specific information for omissions related to emotional neglect', 2),
(7, 'Physical neglect related omissions', 1),
(8, 'Inadequate / inappropriate nutrition ', 7),
(9, 'Inadequate / inappropriate personal hygiene ', 7),
(10, 'Inadequate / inappropriate clothing ', 7),
(11, 'Inadequate / inappropriate shelter ', 7),
(12, 'No specific information for omissions related child’s physical needs', 7),
(13, 'Medical neglect related omissions', 1),
(14, 'Refusal to provide preventive health care (vaccinations, vision, and dental care)', 13),
(15, 'Refusal to allow /provide needed medical care for diagnosed health condition/ impairment', 13),
(16, 'Unjustified delay to seek needed care', 13),
(17, 'Failure to provide with basic medical care', 13),
(18, 'Withholding essential medical care', 13),
(19, 'No specific information for omissions related child’s medical needs', 13),
(20, 'Educational neglect related omissions', 1),
(21, 'Persistent failure to register child at the school', 20),
(22, 'Has not attended school at all', 21),
(23, 'Dropped out', 21),
(24, 'Persistent failure to enrol at the school resulting to irregular school attendance', 20),
(25, 'compulsory school', 24),
(26, 'non compulsory (ECEC)', 24),
(27, 'Chronic truancy', 20),
(28, 'Refusal to attend special educational needs', 20),
(29, 'Refusal to allow needed attention to special educational needs', 28),
(30, 'Refusal to provide needed attention to special educational needs', 28),
(31, 'No specific information for omissions related child’s educational needs', 20),
(32, 'Risk exposure related omissions', 1),
(33, 'Exposure to hazardous/ dangerous environments', 32),
(34, 'Inside household', 33),
(35, 'Outside home', 33),
(36, 'Exposure to substances use/misuse by others', 32),
(37, 'Alcohol', 36),
(38, 'Drugs', 36),
(39, 'Other substances', 36),
(40, 'No specific information for reported/ suspected omissions for exposure to risks', 32),
(41, 'Supervision related omissions', 1),
(42, 'Inadequate/ lack of supervision resulting in physical harm', 41),
(43, 'Persisted lack of supervision concerning substance use/misuse by the child', 41),
(44, 'Alcohol', 43),
(45, 'Drugs', 43),
(46, 'Other substances', 43),
(47, 'No specific information for omissions related to the child’s supervision', 41),
(48, 'Refusal of custody/abandonment', 1),
(49, 'Unstable custody arrangements', 48),
(50, 'Illegal transfers of custody', 48),
(51, 'Refusal of custody', 48),
(52, 'Abandonment (primary caregiver(s) runaway / migrate and leave the children behind)', 48),
(53, 'children out of wedlock', 52),
(54, 'children with disabilities', 52),
(55, 'No specific information for omissions related child’s refusal of custody', 48);

CREATE TABLE `data_nationalities` (
  `id` int(3) NOT NULL,
  `iso_3166_code` varchar(2) DEFAULT NULL,
  `name` varchar(44) DEFAULT NULL,
  `demonym` varchar(25) DEFAULT NULL,
  `nome` varchar(48) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `data_nationalities` (`id`, `iso_3166_code`, `name`, `demonym`, `nome`) VALUES
(1, 'AD', 'Andorra', 'Andorran', 'Andorra'),
(2, 'AE', 'United Arab Emirates', 'Emirian', 'Emirati Arabi Uniti'),
(3, 'AF', 'Afghanistan', 'Afghani', 'Afghanistan'),
(4, 'AG', 'Antigua and Barbuda', 'Antiguan', 'Antigua e Barbuda'),
(5, 'AI', 'Anguilla', 'Anguillan', 'Anguilla'),
(6, 'AL', 'Albania', 'Albanian', 'Albania'),
(7, 'AM', 'Armenia', 'Armenian', 'Armenia'),
(8, 'AO', 'Angola', 'Angolan', 'Angola'),
(9, 'AQ', 'Antarctica', 'Antarctic', 'Antartide'),
(10, 'AR', 'Argentina', 'Argentine', 'Argentina'),
(11, 'AS', 'American Samoa', 'Samoan', 'Samoa Americane'),
(12, 'AT', 'Austria', 'Austrian', 'Austria'),
(13, 'AU', 'Australia', 'Australian', 'Australia'),
(14, 'AW', 'Aruba', 'Arubian', 'Aruba'),
(15, 'AX', 'Eland Islands', 'Elandic', 'Isole Aland'),
(16, 'AZ', 'Azerbaijan', 'Azerbaijani', 'Azerbaijan'),
(17, 'BA', 'Bosnia and Herzegovina', 'Bosnian', 'Bosnia Erzegovina'),
(18, 'BB', 'Barbados', 'Barbadian', 'Barbados'),
(19, 'BD', 'Bangladesh', 'Bangladeshi', 'Bangladesh'),
(20, 'BE', 'Belgium', 'Belgian', 'Belgio'),
(21, 'BF', 'Burkina Faso', 'Burkinabe', 'Burkina Faso'),
(22, 'BG', 'Bulgaria', 'Bulgarian', 'Bulgaria'),
(23, 'BH', 'Bahrain', 'Bahrainian', 'Bahrain'),
(24, 'BI', 'Burundi', 'Burundian', 'Burundi'),
(25, 'BJ', 'Benin', 'Beninese', 'Benin'),
(26, 'BL', 'Saint Bartholemy', 'Bartholemois', 'Saint-Bartholemy'),
(27, 'BM', 'Bermuda', 'Bermudan', 'Bermuda'),
(28, 'BN', 'Brunei', 'Bruneian', 'Brunei'),
(29, 'BO', 'Bolivia', 'Bolivian', 'Bolivia'),
(30, 'BQ', 'Caribbean Netherlands', '', 'Caraibi Olandesi'),
(31, 'BR', 'Brazil', 'Brazilian', 'Brasile'),
(32, 'BS', 'Bahamas', 'Bahameese', 'Bahamas'),
(33, 'BT', 'Bhutan', 'Bhutanese', 'Bhutan'),
(34, 'BV', 'Bouvet Island', '', 'Isola Bouvet'),
(35, 'BW', 'Botswana', 'Motswana', 'Botswana'),
(36, 'BY', 'Belarus', 'Belarusian', 'Bielorussia'),
(37, 'BZ', 'Belize', 'Belizean', 'Belize'),
(38, 'CA', 'Canada', 'Canadian', 'Canada'),
(39, 'CC', 'Cocos (Keeling) Islands', 'Cocossian', 'Isole Cocos (Keeling)'),
(40, 'CD', 'Democratic Republic of the Congo', 'Congolese', 'Repubblica Democratica del Congo'),
(41, 'CF', 'Central African Republic', 'Central African', 'Repubblica Centrafricana'),
(42, 'CG', 'Congo (Republic of)', 'Congolese', 'Congo (Repubblica di)'),
(43, 'CH', 'Switzerland', 'Swiss', 'Svizzera'),
(44, 'CI', 'Cote d\'Ivoire (Ivory Coast)', 'Ivorian', 'Costa d\'Avorio '),
(45, 'CK', 'Cook Islands', 'Cook Islander', 'Isole Cook'),
(46, 'CL', 'Chile', 'Chilean', 'Cile'),
(47, 'CM', 'Cameroon', 'Cameroonian', 'Camerun'),
(48, 'CN', 'China', 'Chinese', 'Cina (Repubblica Popolare)'),
(49, 'CO', 'Colombia', 'Colombian', 'Colombia'),
(50, 'CR', 'Costa Rica', 'Costa Rican', 'Costa Rica'),
(51, 'CU', 'Cuba', 'Cuban', 'Cuba'),
(52, 'CV', 'Cape Verde', 'Cape Verdean', 'Capo Verde'),
(53, 'CW', 'Curacao', 'Curacaoan', 'Curacao'),
(54, 'CX', 'Christmas Island', 'Christmas Islander', 'Isola di Natale'),
(55, 'CY', 'Cyprus', 'Cypriot', 'Cipro'),
(56, 'CZ', 'Czech Republic', 'Czech', 'Repubblica Ceca'),
(57, 'DE', 'Germany', 'German', 'Germania'),
(58, 'DJ', 'Djibouti', 'Djiboutian', 'Djibouti'),
(59, 'DK', 'Denmark', 'Danish', 'Danimarca'),
(60, 'DM', 'Dominica', 'Dominican', 'Dominica'),
(61, 'DO', 'Dominican Republic', 'Dominican', 'Repubblica Dominicana'),
(62, 'DZ', 'Algeria', 'Algerian', 'Algeria'),
(63, 'EC', 'Ecuador', 'Ecuadorean', 'Ecuador'),
(64, 'EE', 'Estonia', 'Estonian', 'Estonia'),
(65, 'EG', 'Egypt', 'Egyptian', 'Egitto'),
(66, 'EH', 'Western Saharan', 'Western Saharan', 'Sahara Occidentale '),
(67, 'ER', 'Eritrea', 'Eritrean', 'Eritrea'),
(68, 'ES', 'Spain', 'Spanish', 'Spagna'),
(69, 'ET', 'Ethiopia', 'Ethiopian', 'Etiopia'),
(70, 'FI', 'Finland', 'Finnish', 'Finlandia'),
(71, 'FJ', 'Fiji', 'Fijian', 'Fiji'),
(72, 'FK', 'Falkland Islands', 'Falkland Islander', 'Isole Falkland'),
(73, 'FM', 'Micronesia', 'Micronesian', 'Micronesia'),
(74, 'FO', 'Faroe Islands', 'Faroese', 'Isole Faroe'),
(75, 'FR', 'France', 'French', 'Francia'),
(76, 'GA', 'Gabon', 'Gabonese', 'Gabon'),
(77, 'GB', 'United Kingdom', 'British', 'Regno Unito'),
(78, 'GD', 'Grenada', 'Grenadian', 'Grenada'),
(79, 'GE', 'Georgia', 'Georgian', 'Georgia'),
(80, 'GF', 'French Guiana', 'French Guianese', 'Guyana Francese'),
(81, 'GG', 'Guernsey', '', 'Maglione'),
(82, 'GH', 'Ghana', 'Ghanaian', 'Ghana'),
(83, 'GI', 'Gibralter', 'Gibralterian', 'Gibilterra'),
(84, 'GL', 'Greenland', 'Greenlander', 'Groenlandia'),
(85, 'GM', 'Gambia', 'Gambian', 'Gambia'),
(86, 'GN', 'Guinea', 'Guinean', 'Guinea'),
(87, 'GP', 'Guadeloupe', 'Guadeloupean', 'Guadeloupe'),
(88, 'GQ', 'Equatorial Guinea', 'Equatorial Guinean', 'Guinea Equatoriale'),
(89, 'GR', 'Greece', 'Greek', 'Grecia'),
(90, 'GS', 'South Georgia and the South Sandwich Islands', '', 'Georgia del Sud e isole Sandwich del Sud'),
(91, 'GT', 'Guatemala', 'Guatemalan', 'Guatemala'),
(92, 'GU', 'Guam', 'Guamanian', 'Guam'),
(93, 'GW', 'Guinea-Bissau', 'Guinean', 'Guinea-Bissau'),
(94, 'GY', 'Guyana', 'Guyanese', 'Guyana'),
(95, 'HK', 'Hong Kong', 'Hong Konger', 'Hong Kong'),
(96, 'HM', 'Heard and McDonald Islands', '', 'Heard e McDonald'),
(97, 'HN', 'Honduras', 'Honduran', 'Honduras'),
(98, 'HR', 'Croatia', 'Croatian', 'Croazia'),
(99, 'HT', 'Haiti', 'Haitian', 'Haiti'),
(100, 'HU', 'Hungary', 'Hungarian', 'Ungheria'),
(101, 'ID', 'Indonesia', 'Indonesian', 'Indonesia'),
(102, 'IE', 'Ireland', 'Irish', 'Irlanda'),
(103, 'IL', 'Israel', 'Israeli', 'Israele'),
(104, 'IM', 'Isle of Man', 'Manx', 'Isola di Man'),
(105, 'IN', 'India', 'Indian', 'India'),
(106, 'IO', 'British Indian Ocean Territory', '', 'Territorio britannico dell\'Oceano Indiano'),
(107, 'IQ', 'Iraq', 'Iraqi', 'Iraq'),
(108, 'IR', 'Iran', 'Iranian', 'Iran'),
(109, 'IS', 'Iceland', 'Icelander', 'Islanda'),
(110, 'IT', 'Italy', 'Italian', 'Italia'),
(111, 'JE', 'Jersey', '', 'Jersey'),
(112, 'JM', 'Jamaica', 'Jamaican', 'Giamaica'),
(113, 'JO', 'Jordan', 'Jordanian', 'Giordania'),
(114, 'JP', 'Japan', 'Japanese', 'Giappone'),
(115, 'KE', 'Kenya', 'Kenyan', 'Kenya'),
(116, 'KG', 'Kyrgyzstan', 'Kyrgyzstani', 'Kyrgyzstan'),
(117, 'KH', 'Cambodia', 'Cambodian', 'Cambogia'),
(118, 'KI', 'Kiribati', 'I-Kiribati', 'Kiribati'),
(119, 'KM', 'Comoros', 'Comoran', 'Comore'),
(120, 'KN', 'Saint Kitts and Nevis', 'Kittian', 'Saint Kitts e Nevis'),
(121, 'KP', 'North Korea', 'North Korean', 'Corea del Nord'),
(122, 'KR', 'South Korea', 'South Korean', 'Corea del Sud'),
(123, 'KW', 'Kuwait', 'Kuwaiti', 'Kuwait'),
(124, 'KY', 'Cayman Islands', 'Caymanian', 'Isole Cayman'),
(125, 'KZ', 'Kazakhstan', 'Kazakhstani', 'Kazakistan'),
(126, 'LA', 'Laos', 'Laotian', 'Laos'),
(127, 'LB', 'Lebanon', 'Lebanese', 'Libano'),
(128, 'LC', 'Saint Lucia', 'Saint Lucian', 'Santa Lucia'),
(129, 'LI', 'Liechtenstein', 'Liechtensteiner', 'Liechtenstein'),
(130, 'LK', 'Sri Lanka', 'Sri Lankan', 'Sri Lanka'),
(131, 'LR', 'Liberia', 'Liberian', 'Liberia'),
(132, 'LS', 'Lesotho', 'Mosotho', 'Lesoto'),
(133, 'LT', 'Lithuania', 'Lithunian', 'Lituania'),
(134, 'LU', 'Luxembourg', 'Luxembourger', 'Lussemburgo'),
(135, 'LV', 'Latvia', 'Latvian', 'Lettonia'),
(136, 'LY', 'Libya', 'Libyan', 'Libia'),
(137, 'MA', 'Morocco', 'Moroccan', 'Marocco'),
(138, 'MC', 'Monaco', 'Monacan', 'Monaco'),
(139, 'MD', 'Moldova', 'Moldovan', 'Moldova'),
(140, 'ME', 'Montenegro', 'Montenegrin', 'Montenegro'),
(141, 'MF', 'Saint Martin (France)', '', 'Saint Martin (Francia)'),
(142, 'MG', 'Madagascar', 'Malagasy', 'Madagascar'),
(143, 'MH', 'Marshall Islands', 'Marshallese', 'Isole Marshall'),
(144, 'MK', 'Macedonia', 'Macedonian', 'Macedonia'),
(145, 'ML', 'Mali', 'Malian', 'Mali'),
(146, 'MM', 'Burma (Republic of the Union of Myanmar)', 'Myanmarese', 'Birmania (Repubblica dell\'Unione di Birmania)'),
(147, 'MN', 'Mongolia', 'Mongolian', 'Mongolia'),
(148, 'MO', 'Macau', 'Macanese', 'Macau'),
(149, 'MP', 'Northern Mariana Islands', 'Northern Mariana Islander', 'Isole Marianne Settentrionali'),
(150, 'MQ', 'Martinique', 'Martinican', 'Martinica'),
(151, 'MR', 'Mauritania', 'Mauritanian', 'Mauritania'),
(152, 'MS', 'Montserrat', 'Montserratian', 'Montserrat'),
(153, 'MT', 'Malta', 'Maltese', 'Malta'),
(154, 'MU', 'Mauritius', 'Mauritian', 'Mauritius'),
(155, 'MV', 'Maldives', 'Maldivan', 'Maldive'),
(156, 'MW', 'Malawi', 'Malawian', 'Malawi'),
(157, 'MX', 'Mexico', 'Mexican', 'Messico'),
(158, 'MY', 'Malaysia', 'Malaysian', 'Malaysia'),
(159, 'MZ', 'Mozambique', 'Mozambican', 'Mozambico'),
(160, 'NA', 'Namibia', 'Namibian', 'Namibia'),
(161, 'NC', 'New Caledonia', 'New Caledonian', 'Nuova Caledonia'),
(162, 'NE', 'Niger', 'Nigerien', 'Niger'),
(163, 'NF', 'Norfolk Island', 'Norfolk Islander', 'Norfolk Island'),
(164, 'NG', 'Nigeria', 'Nigerian', 'Nigeria'),
(165, 'NI', 'Nicaragua', 'Nicaraguan', 'Nicaragua'),
(166, 'NL', 'Netherlands', 'Dutch', 'Paesi Bassi'),
(167, 'NO', 'Norway', 'Norwegian', 'Norvegia'),
(168, 'NP', 'Nepal', 'Nepalese', 'Nepal'),
(169, 'NR', 'Nauru', 'Nauruan', 'Nauru'),
(170, 'NU', 'Niue', 'Niuean', 'Niue'),
(171, 'NZ', 'New Zealand', 'New Zealander', 'Nuova Zelanda'),
(172, 'OM', 'Oman', 'Omani', 'Oman'),
(173, 'PA', 'Panama', 'Panamanian', 'Panama'),
(174, 'PE', 'Peru', 'Peruvian', 'Peru'),
(175, 'PF', 'French Polynesia', 'French Polynesian', 'Polinesia Francese'),
(176, 'PG', 'Papua New Guinea', 'Papua New Guinean', 'Papua Nuova Guinea'),
(177, 'PH', 'Philippines', 'Filipino', 'Filippine'),
(178, 'PK', 'Pakistan', 'Pakistani', 'Pakistan'),
(179, 'PL', 'Poland', 'Polish', 'Polonia'),
(180, 'PM', 'St. Pierre and Miquelon', 'Saint-Pierrais', 'St. Pierre e Miquelon'),
(181, 'PN', 'Pitcairn', 'Pitcairn Islander', 'Pitcairn'),
(182, 'PR', 'Puerto Rico', 'Puerto Rican', 'Puerto Rico'),
(183, 'PS', 'Palestine', 'Palestinian', 'Palestina'),
(184, 'PT', 'Portugal', 'Portuguese', 'Portogallo'),
(185, 'PW', 'Palau', 'Palauan', 'Palau'),
(186, 'PY', 'Paraguay', 'Paraguayan', 'Paraguay'),
(187, 'QA', 'Qatar', 'Qatari', 'Qatar'),
(188, 'RE', 'Reunion', '', 'Reunion'),
(189, 'RO', 'Romania', 'Romanian', 'Romania'),
(190, 'RS', 'Serbia', 'Serbian', 'Serbia'),
(191, 'RU', 'Russian Federation', 'Russian', 'Federazione Russa'),
(192, 'RW', 'Rwanda', 'Rwandan', 'Ruanda'),
(193, 'SA', 'Saudi Arabia', 'Saudi Arabian', 'Arabia Saudita'),
(194, 'SB', 'Solomon Islands', 'Solomon Islander', 'Isole Salomone'),
(195, 'SC', 'Seychelles', 'Seychellois', 'Seychelles'),
(196, 'SD', 'Sudan', 'Sudanese', 'Sudan'),
(197, 'SE', 'Sweden', 'Swedish', 'Svezia'),
(198, 'SG', 'Singapore', 'Singaporean', 'Singapore'),
(199, 'SH', 'Saint Helena', 'Saint Helenian', 'Sant\'Elena'),
(200, 'SI', 'Slovenia', 'Slovenian', 'Slovenia'),
(201, 'SJ', 'Svalbard and Jan Mayen Islands', '', 'Isole Svalbard e Jan Mayen'),
(202, 'SK', 'Slovakia', 'Slovakian', 'Slovacchia'),
(203, 'SL', 'Sierra Leone', 'Sierra Leonean', 'Sierra Leone'),
(204, 'SM', 'San Marino', 'Sanmarinese', 'San Marino'),
(205, 'SN', 'Senegal', 'Senegalese', 'Senegal'),
(206, 'SO', 'Somalia', 'Somali', 'Somalia'),
(207, 'SR', 'Suriname', 'Surinamer', 'Suriname'),
(208, 'SS', 'South Sudan', 'Sudanese', 'Sud Sudan'),
(209, 'ST', 'Sao Tome and Principe', 'Sao Tomean', 'Sao Tome e Principe'),
(210, 'SV', 'El Salvador', 'Salvadorean', 'El Salvador'),
(211, 'SX', 'Saint Martin (Netherlands)', '', 'Saint Martin (Paesi Bassi)'),
(212, 'SY', 'Syria', 'Syrian', 'Siria'),
(213, 'SZ', 'Swaziland', 'Swazi', 'Swaziland'),
(214, 'TC', 'Turks and Caicos Islands', 'Turks and Caicos Islander', 'Isole Turks e Caicos'),
(215, 'TD', 'Chad', 'Chadian', 'Ciad'),
(216, 'TF', 'French Southern Territories', '', 'Terre australi e antartiche francesi'),
(217, 'TG', 'Togo', 'Togolese', 'Togo'),
(218, 'TH', 'Thailand', 'Thai', 'Thailandia'),
(219, 'TJ', 'Tajikistan', 'Tajikistani', 'Tajikistan'),
(220, 'TK', 'Tokelau', 'Tokelauan', 'Tokelau'),
(221, 'TL', 'Timor-Leste', 'Timorese', 'Timor Est'),
(222, 'TM', 'Turkmenistan', 'Turkmen', 'Turkmenistan'),
(223, 'TN', 'Tunisia', 'Tunisian', 'Tunisia'),
(224, 'TO', 'Tonga', 'Tongan', 'Tonga'),
(225, 'TR', 'Turkey', 'Turkish', 'Turchia'),
(226, 'TT', 'Trinidad and Tobago', 'Trinidadian', 'Trinidad e Tobago'),
(227, 'TV', 'Tuvalu', 'Tuvaluan', 'Tuvalu'),
(228, 'TW', 'Taiwan', 'Taiwanese', 'Taiwan'),
(229, 'TZ', 'Tanzania', 'Tanzanian', 'Tanzania'),
(230, 'UA', 'Ukraine', 'Ukrainian', 'Ucraina'),
(231, 'UG', 'Uganda', 'Ugandan', 'Uganda'),
(232, 'UM', 'United States Minor Outlying Islands', '', 'Isole minori esterne degli Stati Uniti d\'America'),
(233, 'US', 'United States of America', 'American', 'Stati Uniti d\'America'),
(234, 'UY', 'Uruguay', 'Uruguayan', 'Uruguay'),
(235, 'UZ', 'Uzbekistan', 'Uzbekistani', 'Uzbekistan'),
(236, 'VA', 'Vatican', '', 'Vaticano'),
(237, 'VC', 'Saint Vincent and Grenadines', 'Saint Vincentian', 'Saint Vincent e Grenadine'),
(238, 'VE', 'Venezuela', 'Venezuelan', 'Venezuela'),
(239, 'VG', 'British Virgin Islands', 'Virgin Islander', 'Isole Vergini Britanniche'),
(240, 'VI', 'United States Virgin Islands', 'Virgin Islander', 'Isole Vergini degli Stati Uniti'),
(241, 'VN', 'Vietnam', 'Vietnamese', 'Vietnam'),
(242, 'VU', 'Vanuatu', 'Ni-Vanuatu', 'Vanuatu'),
(243, 'WF', 'Wallis and Futuna Islands', 'Wallisian', 'Wallis e Futuna'),
(244, 'WS', 'Samoa', 'Samoan', 'Samoa'),
(245, 'YE', 'Yemen', 'Yemeni', 'Yemen'),
(246, 'YT', 'Mayotte', 'Mahoran', 'Mayotte'),
(247, 'ZA', 'South Africa', 'South African', 'Sud Africa'),
(248, 'ZM', 'Zambia', 'Zambian', 'Zambia'),
(249, 'ZW', 'Zimbabwe', 'Zimbabwean', 'Zimbabwe');

CREATE TABLE `f_caregivers` (
  `id` int(11) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `caregiver1` varchar(40) NOT NULL,
  `relationship1` varchar(40) NOT NULL,
  `sex1` varchar(40) DEFAULT NULL,
  `dob1` varchar(40) DEFAULT NULL,
  `date1` varchar(10) DEFAULT NULL,
  `caregiver2` varchar(40) DEFAULT NULL,
  `relationship2` varchar(40) DEFAULT NULL,
  `sex2` varchar(40) DEFAULT NULL,
  `dob2` varchar(40) DEFAULT NULL,
  `date2` varchar(10) DEFAULT NULL,
  `cg1_nationality` varchar(100) DEFAULT NULL,
  `cg1_nationality_possessed_from_birth` varchar(100) DEFAULT NULL,
  `cg1_nationality_belongs_to_the_european_union` varchar(100) DEFAULT NULL,
  `cg1_other_nationality` varchar(100) DEFAULT NULL,
  `cg2_nationality` varchar(100) DEFAULT NULL,
  `cg2_nationality_possessed_from_birth` varchar(100) DEFAULT NULL,
  `cg2_nationality_belongs_to_the_european_union` varchar(100) DEFAULT NULL,
  `cg2_other_nationality` varchar(100) DEFAULT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `f_members_of_family` (
  `id` int(11) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `session_name` varchar(20) NOT NULL,
  `name` varchar(40) NOT NULL,
  `session_number` varchar(20) DEFAULT NULL,
  `number` varchar(3) DEFAULT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `f_members_of_family_sub1` (
  `id` int(11) NOT NULL,
  `mof_session` varchar(20) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `session_name` varchar(20) NOT NULL,
  `name` varchar(40) NOT NULL,
  `session_number` varchar(20) DEFAULT NULL,
  `number` varchar(3) DEFAULT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `f_members_of_family_sub2` (
  `id` int(11) NOT NULL,
  `mof_session_sub1` varchar(20) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `session_name` varchar(20) NOT NULL,
  `name` varchar(20) NOT NULL,
  `session_number` varchar(20) DEFAULT NULL,
  `number` varchar(3) DEFAULT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `f_type_of_family` (
  `id` int(11) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `name` varchar(255) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `i_forms_of_maltreatment` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `child_id` varchar(255) DEFAULT NULL,
  `session_name` varchar(25) NOT NULL,
  `name` varchar(80) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `i_forms_of_maltreatment_sub1` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `child_id` varchar(255) DEFAULT NULL,
  `fom_session` varchar(25) NOT NULL,
  `session_name` varchar(25) NOT NULL,
  `name` varchar(75) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `i_forms_of_maltreatment_sub2` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `child_id` varchar(255) DEFAULT NULL,
  `fom_session_sub1` varchar(25) NOT NULL,
  `session_name` varchar(25) NOT NULL,
  `name` varchar(100) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `i_forms_of_maltreatment_sub3` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `child_id` varchar(255) DEFAULT NULL,
  `fom_session_sub2` varchar(25) NOT NULL,
  `session_name` varchar(25) NOT NULL,
  `name` varchar(255) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `i_forms_of_maltreatment_sub4` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `child_id` varchar(255) DEFAULT NULL,
  `fom_session_sub3` varchar(25) NOT NULL,
  `session_name` varchar(25) NOT NULL,
  `name` varchar(80) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `i_incident` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `date_of_incident` varchar(200) NOT NULL,
  `type_of_incident` varchar(90) NOT NULL,
  `exact_date_of_incident` varchar(40) NOT NULL,
  `start_date` varchar(10) DEFAULT NULL,
  `duration_first_note` varchar(20) DEFAULT NULL,
  `duration_years` int(11) DEFAULT NULL,
  `duration_months` int(11) DEFAULT NULL,
  `duration_days` int(11) DEFAULT NULL,
  `duration_last_note` varchar(20) DEFAULT NULL,
  `duration_special_situation` varchar(20) DEFAULT NULL,
  `last_known_cm_date` varchar(10) DEFAULT NULL,
  `datetime_of_record` varchar(20) NOT NULL,
  `date_of_record` varchar(8) NOT NULL,
  `time_of_record` varchar(6) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `recorded_by_agency` varchar(15) NOT NULL,
  `recorded_by_operator` varchar(25) NOT NULL,
  `type_of_record` enum('first_record','updated_record') NOT NULL,
  `recorded_by_ip` varchar(39) DEFAULT NULL,
  `recorded_by_agency_nid` int(11) NOT NULL DEFAULT '0',
  `recorded_by_operator_nid` int(11) NOT NULL DEFAULT '0',
  `child_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `i_perpetrator` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `perpetrator_1` varchar(80) DEFAULT NULL,
  `perpetrator_1_gender` varchar(80) DEFAULT NULL,
  `perpetrator_2` varchar(80) DEFAULT NULL,
  `perpetrator_2_gender` varchar(80) DEFAULT NULL,
  `other_perpetrator` varchar(80) DEFAULT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `i_place_of_incident` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `session_name` varchar(25) NOT NULL,
  `name` varchar(255) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `i_source_of_information` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `name` varchar(80) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `i_specific_circumstances` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `session_name` varchar(25) NOT NULL,
  `name` varchar(250) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `notifications` (
  `notificationID` int(11) NOT NULL,
  `n_to` varchar(255) NOT NULL,
  `n_subject` varchar(255) NOT NULL,
  `n_text` text NOT NULL,
  `RecDate` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `agent_id` int(11) NOT NULL DEFAULT '0',
  `SendDate` datetime DEFAULT NULL,
  `mail_error` text
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `s_feedback` (
  `id` int(11) NOT NULL,
  `referral_agency_id` varchar(214) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `child_id` varchar(255) NOT NULL,
  `status` varchar(50) NOT NULL,
  `recorded_by_operator` varchar(225) NOT NULL,
  `referral_agency_nid` int(11) NOT NULL DEFAULT '0',
  `recorded_by_operator_nid` int(11) NOT NULL DEFAULT '0',
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0',
  `date_time_of_record_for_db` datetime NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `s_institutional_response` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `name` varchar(50) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `s_institutional_response_sub1` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `session_name` varchar(25) NOT NULL,
  `name` varchar(80) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `s_institutional_response_sub2` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `ir_session_sub1` varchar(25) NOT NULL,
  `session_name` varchar(20) NOT NULL,
  `name` varchar(250) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `s_referrals_to_services` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `name` varchar(35) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `s_referrals_to_services_sub1` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `session_name` varchar(20) NOT NULL,
  `name` varchar(50) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `s_referrals_to_services_sub2` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `rts_session_sub1` varchar(20) NOT NULL,
  `session_name` varchar(20) NOT NULL,
  `name` varchar(250) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `s_referrals_to_services_sub3` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `rts_session_sub2` varchar(20) NOT NULL,
  `session_name` varchar(25) NOT NULL,
  `name` varchar(30) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `child_nid` int(11) NOT NULL DEFAULT '0',
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `s_referrals_to_services_sub4` (
  `id` int(11) NOT NULL,
  `incident_id` varchar(255) NOT NULL,
  `rts_session_sub3` varchar(20) NOT NULL,
  `session_name` varchar(25) NOT NULL,
  `name` varchar(30) NOT NULL,
  `date_time_of_record_for_db` datetime NOT NULL,
  `incident_nid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `u_admin` (
  `id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `password` varchar(255) NOT NULL,
  `salt` varchar(255) NOT NULL,
  `language_id` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `u_admin` (`id`, `name`, `email`, `password`, `salt`, `language_id`) VALUES
(1, 'Admin', 'can-mds', 'a159e10ba4fabf462274cf3546270417fb6fedbe', 'DusuzaTMadTyG4R5bn2fEyXnJPNx92RU4zrAkdS8dWlUNwhz4tbb1VOXd6o2kOOUTo1U9w3p31kExNasrYgxDNvI6CgwVNPIuE4juefd4hzk54ONmvVbvp5cPdtTUrIT', 2);

CREATE TABLE `u_agencies` (
  `id` int(11) NOT NULL,
  `agency_id` varchar(124) NOT NULL,
  `country` varchar(2) NOT NULL,
  `subdivision` varchar(10) NOT NULL,
  `type_of_organization` varchar(3) NOT NULL,
  `three_digit_id_number_a` varchar(3) NOT NULL,
  `agency_name` varchar(120) NOT NULL,
  `street_name` varchar(100) DEFAULT NULL,
  `street_number` varchar(10) DEFAULT NULL,
  `post_code` varchar(10) DEFAULT NULL,
  `town` varchar(100) DEFAULT NULL,
  `phone` varchar(20) DEFAULT NULL,
  `email` varchar(30) DEFAULT NULL,
  `password` varchar(255) NOT NULL,
  `salt` varchar(255) NOT NULL,
  `country_nid` int(11) NOT NULL DEFAULT '0',
  `type_of_organization_nid` int(11) NOT NULL DEFAULT '0',
  `Active` tinyint(4) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `u_agencies` (`id`, `agency_id`, `country`, `subdivision`, `type_of_organization`, `three_digit_id_number_a`, `agency_name`, `street_name`, `street_number`, `post_code`, `town`, `phone`, `email`, `password`, `salt`, `country_nid`, `type_of_organization_nid`, `Active`) VALUES
(1, 'GR-A1-ROI-001', 'GR', 'A1', 'ROI', '001', 'Institute of Child Health, Department of Mental Health and Social Welfare', 'Fokidos', '1', '11627', 'Athens', '+302107715791', 'ich_dos@otenet.gr', '', '', 1, 14, 1),
(2, 'RO-CJ-ROI-001', 'RO', 'CJ', 'ROI', '001', 'Babes-Bolyai University, Department of Sociology and Social Work, Romania', '1', '1', '1', '1', '1', NULL, 'd435f2a6b53ae82e0af21d7f9e71fad7f4e316fb', 'fml4Ftw7C4afGEULCOzqq6hI4unPLAx6HRibVz6URwgqo1ZuHo494o9fZtIyfdBhXxFreItlx68V3LjFx6kSsvIiXfyVR0jxXal1EqShAfYfRfVQfahLrzquhUTgOO2I', 8, 14, 1),
(3, 'BE-BRU-ROI-001', 'BE', 'BRU', 'ROI', '001', 'Coördinatiecel Internationaal Kind en Gezin - Kind en Gezin Academie - Belgium', 'Hallepoortlaan', '27', '1060', 'Brussels', '+32 494 700 727', NULL, '565126bc0dcbf150676864feda89fb8ab35df705', '1uUcMXFHrzDiMoU81AHE9rpnFEnk9qVA1JcJ6M1kUlma1UjwAMr7SjoGoleCT9AJChuJlvz9EMsYwHGiQhnzvsLqlwjIGYHld7UufCsJFalv1rJXc8cdjZvJ53qC3ob1', 2, 14, 1),
(4, 'BG-01-ROI-001', 'BG', '01', 'ROI', '001', 'South West University \"Neofit Rilski\", Faculty of Public Health and Sport - Bulgaria', NULL, NULL, NULL, NULL, NULL, NULL, '', '', 4, 14, 1),
(5, 'CH-LU-ROI-001', 'CH', 'LU', 'ROI', '001', 'Lucerne University of Applied Sciences & Arts, School of Social Work - Switzerland', NULL, NULL, NULL, NULL, NULL, NULL, '', '', 3, 14, 1),
(6, 'DE-BW-ROI-001', 'DE', 'BW', 'ROI', '001', 'University Ulm, Department of Child and Adolescent Psychiatry/Psychotherapy - Germany', NULL, NULL, NULL, NULL, NULL, NULL, '', '', 5, 14, 1),
(7, 'FR-75-RSS-001', 'FR', '75', 'RSS', '001', 'Observatoire national de la protection de l\'enfance (ONPE) - FRANCE', 'Boulevard Bessières', '63bis', '75017', 'Paris', '', 'alstephan@onpe.gouv.fr', '431de6d6db59d2e1d7b62801d06075f01f6d458a', 'FqyswvS915kvODOaDksnCPQJYkJm8pj7U3ROi3XJYilcBOjobD7vcQ6iP9kcWgLNRVhYiFVbPQ7NQe2y3uaDT4W7otg5RzXNRr20mjdPIGSQowgDQxADuRGUIKhD7aPZ', 6, 13, 1),
(8, 'IT-FI-ROI-001', 'IT', 'FI', 'ROI', '001', 'Istituto degli Innocenti, Italy', NULL, NULL, NULL, NULL, NULL, NULL, '', '', 7, 14, 1),
(12, 'GR-A1-NGO-001', 'GR', 'A1', 'NGO', '001', 'European Anti-Violence Network', 'Ζαχαρίτσα', '112', '11742', 'Αθήνα', '+306977819770', NULL, '', '', 1, 12, 1),
(14, 'BG-BG-PES-003', 'BG', 'BG', 'PES', '003', 'NATIONAL CENTER FOR PUBLIC HEALTH AND ANALYSIS', '', '', '', '', '', NULL, '', '', 4, 16, 1),
(15, 'BG-004-SWS-004', 'BG', '004', 'SWS', '004', 'Regional Directorate of Social Work, Blagoevgrad', '', '', '', '', '', NULL, '', '', 4, 7, 1),
(16, 'IT-FI-SHC-001', 'IT', 'FI', 'SHC', '001', 'Ospedale', '', '', '', 'firenze', '', NULL, '', '', 7, 3, 1),
(17, 'BG-CHL-ORS-006', 'BG', 'CHL', 'ORS', '006', 'Animus Association', '', '', '', '', '', NULL, '', '', 4, 19, 1),
(18, 'BG-007-NGO-007', 'BG', '007', 'NGO', '007', 'For our children', '', '', '', '', '', NULL, '', '', 4, 12, 1),
(19, 'BG-008-NGO-008', 'BG', '008', 'NGO', '008', 'SAPI', '', '', '', '', '', NULL, '', '', 4, 12, 1),
(20, 'BG-009-IAU-009', 'BG', '009', 'IAU', '009', 'State Agency for Child Protection', 'Triaditsa', '2', '1051', 'Sofia', '+359 2 933 90 10', 'sacp@sacp.government.bg', '', '', 4, 6, 1),
(21, 'BG-010-PHC-010', 'BG', '010', 'PHC', '010', 'Kindergarden', '', '', '', '', '', NULL, '', '', 4, 2, 1),
(22, 'BG-011-PHC-011', 'BG', '011', 'PHC', '011', 'Private hosptal', '', '', '', '', '', NULL, '', '', 4, 2, 1),
(23, 'BG-012-PHC-012', 'BG', '012', 'PHC', '012', 'General Practitioner', '', '', '', '', '', NULL, '', '', 4, 2, 1),
(24, 'BG-013-MHS-002', 'BG', '013', 'MHS', '002', 'Psychiatric practice', '', '', '', '', '', NULL, '', '', 4, 5, 1),
(25, 'BG-014-PES-014', 'BG', '014', 'PES', '014', 'National Institute for Public Health', '', '', '', '', '', NULL, '', '', 4, 16, 1),
(26, 'GR-Α1-PEF-010', 'GR', 'Α1', 'PEF', '010', 'Δ/νση Παιδικών και Βρεφονηπιακών Σταθμών Δήμου Νίκαιας-Αγ.Ι.Ρέντη (ΝΠΔΔ) 4ος Νηπ. Σταθμός Νίκαιας', 'Ακροπόλεως & Νέστορος', '52', '', 'ΑΘήνα', '2104965928', NULL, '', '', 1, 15, 1),
(27, 'GR-A1-SHC-011', 'GR', 'A1', 'SHC', '011', 'Γενικό Νοσοκομείο Ελευσίνας ΘΡΙΑΣΙΟ', 'Λ Γεννηματά', '', '10683', 'Ελευσίνα', '2132028000', NULL, '', '', 1, 3, 1),
(28, 'GR-A1-POL-001', 'GR', 'A1', 'POL', '001', 'Ελληνική Αστυνομία', '', '', '', 'ΑΘήνα', '', 'dinapogias@gmail.com', '', '', 1, 9, 1),
(29, 'GR-A1-NGO-002', 'GR', 'A1', 'NGO', '002', 'Το Χαμόγελο του Παιδιού', 'Στουρνάρη', '16', '10683', 'ΑΘήνα', '2103306140', NULL, '', '', 1, 12, 1),
(30, 'GR-A1-THC-012', 'GR', 'A1', 'THC', '012', 'Γενικό Νοσοκομείο Παίδων Πεντέλης', 'Ιπποκράτους', '8', '12454', 'Πεντέλη Αθήνα', '', NULL, '', '', 1, 4, 1),
(31, 'GR-A1-PHC-013', 'GR', 'A1', 'PHC', '013', 'ΙΥΠ Δ/νση Κοινωνικής και Αναπτυξιακής Παιδιατρικής', 'Μεσογείων', '38-40', '11527', 'Γουδή ΑΘήνα', '2107701227', NULL, '', '', 1, 2, 1),
(32, 'GR-A1-JUD-001', 'GR', 'A1', 'JUD', '001', 'Υπηρεσία Επιμελητών Ανηλίκων & Κοινωνικής Αρωγής, Τμήμα Επιμελητών Ανηλίκων', 'Δέγλερη', '2', '11522', 'ΑΘήνα', '2108701300', NULL, '', '', 1, 1, 1),
(33, 'GR-A1-SWS-001', 'GR', 'A1', 'SWS', '001', 'Κοινωνική Υπηρεσία Δήμου Ηλιούπολης', 'Σοφ. Βενιζέλου 112-114 & Πρωτοπαππα', '', '16341', 'Ηλιούπολη', '2109970000-9', NULL, '', '', 1, 7, 1),
(34, 'GR-A1-THC-014', 'GR', 'A1', 'THC', '014', 'Νοσοκομείο Παίδων \"Η Αγία Σοφία\"', 'Θηβών & Παπαδιαμαντοπούλου', '', '11527', 'Γουδή ΑΘήνα', '2107460000', NULL, '', '', 1, 4, 1),
(35, 'GR-A1-THC-015', 'GR', 'A1', 'THC', '015', 'Νοσοκομείο Παίδων Αθηνών \"Π&Α Κυριακού\"', 'Θηβών & Λειβαδίας', '', '11527', 'Γουδή Αθήνα', '2132009000', NULL, '', '', 1, 4, 1),
(36, 'GR-A1-PES-001', 'GR', 'A1', 'PES', '001', 'Διεύθυνση ΠΕ Β\'Αθήνας', 'Σαντορίνης 4 & Ανάφης', '', '14121', 'Αγία Παρασκευή Αθήνα', '2106012696', NULL, '', '', 1, 16, 1),
(37, 'GR-Α1-PHC-001', 'GR', 'Α1', 'PHC', '001', 'Κέντρο Υγείας Παιδιού Καισαριανής', 'Σολομωνίδου & Φιλαδελφείας', '', '16121', 'Καισαριανή', '2107233872', NULL, '', '', 1, 2, 1),
(38, 'GR-A1-ORS-001', 'GR', 'A1', 'ORS', '001', 'Ίδρυμα Νεολαίας και Δια Βίου Μάθησης', 'Αχαρνών 417 & Κοκκινάκη', '', '11143', 'ΑΘήνα', '2131314522', NULL, '', '', 1, 19, 1),
(40, 'GR-Α1-MHS-004', 'GR', 'Α1', 'MHS', '004', 'Κέντρο Ημέρας για το Παιδί \"Λιθαράκι\"', 'Αδριανού', '21', '15451', 'Νέο Ψυχικό', '2106514865', NULL, '', '', 1, 5, 1),
(41, 'GR-A1-NGO-003', 'GR', 'A1', 'NGO', '003', 'Κέντρο Ερευνών Ρίζες', 'Σμύρνης', '10', '16121', 'Καισαριανή', '210-3811764', NULL, '', '', 1, 12, 1),
(42, 'GR-A1-ORS-002', 'GR', 'A1', 'ORS', '002', 'ΚΕΔΔΥ Ανατολικής Αττικής', 'Αδριανού', '26', '19400', 'Κορωπί', '2106028050', NULL, '', '', 1, 19, 1),
(48, 'BE-11-CPS-22', 'BE', '11', 'CPS', '22', 'ΠΕΡΔΙΚΟΥΛΗΣ Χ & ΣΙΑ Ε.Ε.', 'Λ ΣΟΦΟΥ 5, 111', '111', '57010', 'ΘΕΣΣΑΛΟΝΙΚΗ', '2319675211', NULL, 'c36c53ddc411fc2a991316a93adcc135318ab325', 'dQnP6k6CTkNujaCEXBwO013L1JmFzu3C4AYF1mFM2qdaXqyeesYwfuALQyjuQAtCPUGI1Tw3YJCwE7uSUf19yd4QS7AoqpWBVMoLaOGPxh9gU6nAJ3fgZp1zIBnm8sbI', 2, 8, 1),
(51, 'RO-232-a-112', 'RO', '232', 'a', '112', 'Agency Name', 'Λ ΣΟΦΟΥ 5, 111', '111', '57010', 'ΘΕΣΣΑΛΟΝΙΚΗ', '2319675211', NULL, '96da4891c419622f38cabfa894800b9cfd3cb9b7', '5ogZsfMhWENPOJD451SXVwWddIKf90pVdS6tAG0Fjq36Ezt2PqP04HRhDCw9b7DEsvOOEyPZo6uzKgcjzqJt5xI9MBKgeSkBM0vi7jRBPjNFBdx1fLU7uoMb9w2X91We', 8, 11, 1),
(52, 'GR-A-SWS-010', 'GR', 'A', 'SWS', '010', 'Institute of Child Health, Department of Mental Health and Social Welfare', 'Fokidos', '1', '11526', 'Athens', '00302107715791', 'ich_dos@otenet.gr', 'c837bc691a188f2bbc7b7ff3e9923cbf5a6ec755', '04hKkEys2fndYzjIobmpIiwZvDR5caqi4V4NJvQGeAB3iYUtUTmvrH2r6OPLrndwbMReNJuZgXuLeYoaEtgmIDQH9nmmTolSXIMjXpedqXBaabEXoH1twAjKZstZ0O5n', 1, 7, 1),
(53, 'GR-A1-SWS-010', 'GR', 'A1', 'SWS', '010', 'ICH', 'Φωκίδος', '7', '11627', 'Αμπελόκηποι, Αθήνα', '+302107715791', 'dinapogias@gmail.com', 'f8a2e664f4a8dbc7948700b8b0d82fdd71c2b50d', '1PypXrujQqG0FQ1Ve3irvFyDSm1uXhHL7rQQK02MKAB3Xuw09KGRbzzGU26yxzFvtaqiEjcgMA9IZ6VAUQIgAO9tDdMv60ffLR5n9b0pgnzSVYhKyNBe0Xp9sD1Xd7lC', 1, 7, 1),
(54, 'ES-CT-NGO-001', 'ES', 'CT', 'NGO', '001', 'Fundació Aroa', 'Carrer Gran de Gràcia', '77', '08012 ', 'Barcelona', '0034669057540', 'aroa@fundacioaroa.org', '2b5f16b04d409d8ae988dfb96483500b229143cb', 'G9BZOP3hbU4FPQ3uDl89tgp3WEbHEwOJasjohyXxnAt10Vka8pBwHi2b2Z1UqKCyJkQkhVVy2Rnvg1fZvZqqdRyV2cpiUwJVts8CS4T4kJFEPhH6ni6Lshsb3NboF6Jo', 12, 12, 1),
(55, 'GR-I-SWS-313', 'GR', 'I', 'SWS', '313', 'EKABH', 'Θεοδώρου Γεωμέτρου', '26', '11743', 'Αθήνα', '+306977819770', 'dinapogias@gmail.com', '4147ad3afcdba3c94c5a4e4090871d091998c2b3', 'imWATv1SBajVOkijWHmk4T1ot7z64NuEbEsSLQpFnfVTgNEx2L8fgyrM8u4Whtkb0gicMzyzqeNbxu6Jt9JkO7dDwm32dMAEyIct1pbHadDFPmwkGMgkeqqERNPxPxpa', 1, 7, 1),
(56, 'BG-01-SWS-001', 'BG', '01', 'SWS', '001', 'Regional Directorate for Social Work', 'Ivan Michael', '56', '2700', 'Blagoevgrad', '+3592736641', 'v_stancheva@abv.bg', 'd569e2cbf1f6714b71f3b6d9a5caadeff2f762cc', '4FWQllDSH0DLX3T1tlM6IalMFKkGet3UGEjHckdLTrSHv13K0nSfEeNvwZzZDZ1pHt5VajaYk7ZJAyOANZXyUktoL6RpBEYWdMe9NCixbYLzhwZwyE99ruamMJpYESxM', 4, 7, 1),
(57, 'CY-01-CPS-001', 'CY', '01', 'CPS', '001', 'Social Welfare Services', 'Prodromou', '63', '2063', 'Nicosia', '22406652', 'central.sws@sws.mlsi.giv,cy', '58c01536d9446d75481c5147e3efd45eb1721884', '09JO0At5I2CxEJCOoqqdhebXAnVgkORt75LjVmUFfNzkfU494T2gEULXVGj7ykwWRaPHFl66CyqWmsWPouv54RdeLtfySypNKNdP7GLTUT9QioiTXE6SFtaeQa9qpqd3', 13, 8, 1),
(58, 'BG-01-PHC-123', 'BG', '01', 'PHC', '123', 'Regional Association of General practitioners', 'Ivan Mihajlov 12', '12', '2700', 'Blagoevgrad', '+359 73 292929', 'maya.tcholakova@gmail.com', 'd49cbedbe7eede3943ce2edc47a8363722617cec', 'wpr3bEmRZ0jr4ZmVmdTqe1M2j2z6JdUOtNVzePYzvBjozPX0Mj0JqqHkMBOQgyOSva5lBdsohhol0YrsbRXg3VzXcMSJyfoJyq24lxRZd9kRqI8flzl6kCe8SUhv1MX4', 4, 2, 1),
(59, 'GR-009-CPS-009', 'GR', '009', 'CPS', '009', 'SURREY COUNTY COUNCIL', 'TEST 8', '8', '119100', 'Athens', '+306999999999', 'test@test.com', '47885d1a1746977009dc8c64d424c0ce0691e75f', 'tZDzGUYLPmlDYPKP30aVC9MVUZRAgtllgNtxCOKUv8gQt9yisSQIKNer1dTT5MRumb5OfTjP5joZlI1Pl63n9vkCFMza9An3sjHzrWYhPnZAuZRdSB4pmKMlBeFW28su', 1, 8, 1),
(60, 'ES-ILF-JUD-135', 'ES', 'ILF', 'JUD', '135', 'Legal Forensic Institute', 'Gran Via', '100', '08001', 'Barcelona', '93.123.45.67', 'info@blablabla.org', '4585758f5f73fa87094822775b3ee84e580c15d6', 'fYK8P7vEFY5UajKOpMJ9LaATzCNjxIjhBlADky0PjMq2haayeg7Nfs5LXzcVMJLvFXK9OaMoPFmp4wBpZ1WhNELNpfucItwlHd0VMRoqvu1DgLVwtOVc9Imq66YoBqMC', 12, 1, 1),
(61, 'RO-Bucharest-NGO-009', 'RO', 'Bucharest', 'NGO', '009', 'Federația Organizațiilor Nonguvernamentale pentru Copil', 'Matei Basarab', '41', '50100', 'București', '0755560363', 'daniela.gheorghe@fonpc.ro', '69abd400e84f8ece3988619900ddb0303551a589', 'wA9ie0YYAInkTG5sDc4t8t9ri7e94hQfejXtTkJnhtf715NGvrCR5pbdlHTUH4Urbb5f5kIThagAyF7IleMKsJy7hjX8x7yAASvGa92lsE2K18MAzSKhU0OkQobFDRxr', 8, 12, 1),
(62, 'FR-FR-BRE-SHC-052', 'FR', 'FR-BRE', 'SHC', '052', 'Unité d\'accueil Médico-Judiciaire Pédiatrique - Centre Hospitalier de Saint Malo', 'rue de la Marne', '7', '35400', 'Saint Malo', '0299000000', 'alstephan@onpe.gouv.fr', '802a7aad61f8fc977c29c0fa5987cb93bb27f1d0', 'qtju7q9Xy2UE83xpZkMdc6jR2dtJgTG1PG1OfoQQZyZMfMjR5Rgz1ENy1qeH7yVUbnX9oVdQF5UV6sLY29o1NVuhH3vV2JDvPtHgrkCgJ8qeunye1FW3aoIYpeprDUZy', 6, 3, 1),
(63, 'GR-GR-I-CPS-120', 'GR', 'GR-I', 'CPS', '120', 'NoPlace', 'NoPlace ', '23', '15772', 'Athens', '2104067762', 'aretic@gmail.com', '168ffc7bc225703514f12482441f5c06bb0e3a3a', 'YGW4SRrGOdIs4tUJvSqkjh6ZaJZuF6eGUS78UeMTt9wxp66rPAr27DQshSWAV2IOPPwSUq6b7pgfryhpli1qqmtNJWWzQPbExPoH3LOc6opXP5RpLjhvNE0lziklde4F', 1, 8, 1),
(65, 'ES-BCN-PHC-997', 'ES', 'BCN', 'PHC', '997', 'CAP Manso', 'Manso', '231', '08001', 'Barcelona', '934456217', 'manso@help.cat', 'c1db71d0afb8ae6f8a216d0640e63e92ae16d692', 'TYVN0ct0VYRhIjjkmf8dBA6Egp8renAEeZCM6tg4k6i9jfxyPkQQNWGzJoNQ0Um43R5SbAhDCpcGrlpz0LaBlRAB6AIJBms0xjXIWN6LjernnKoHWCZIMcYNebK3lWAL', 12, 2, 1),
(66, 'RO-RO-CJ-CPS-072', 'RO', 'RO-CJ', 'CPS', '072', 'Directia de Asistenta Sociala si Medicala', 'Piata Unirii', '1', '49099', 'Cluj-Napoca', '0264599316', 'dianatotelecan@yahoo.com', '6f60aa70e3a91aade7b1318abcb20d36b21a8a7e', 'uA0S3XAzHOgLwaf74CGOZSUmrTu88YSrLxIsyezMG2HuLLFC5z9wXUjFEsimOynIGkKMKX2XMcMiRjVeoC4xEUdgvsvrbFKIySGPHxugHTjf5sw63gOHL5FyPqO2cttx', 8, 8, 1),
(67, 'CY-01-CPS-002', 'CY', '01', 'CPS', '002', 'Hope For Children CRC Policy Center', 'Limassol av.', '75', '2121', 'Nicosia', '99593368', 'neocleous.a@uncrcpc.org', 'ff0b936320f8484437e63fd92178ec9854da1c8e', '7CnNevak3bCa7vrPQeqxeaudjqCCsasptcn5oShrIrnSnzTc7jz9TT9z2j5W9PJGYJ6xA15j7WEDpepznnTGp69leBC7cefQFDrF15foL4MPMNAsZF0KRmMqEtWR1TCx', 13, 8, 1),
(68, 'GR-GR-69-CPS-001', 'GR', 'GR-69', 'CPS', '001', 'test', 'test', 'test', '57010', 'thessaloniki', '23100000', 'test@demo.gr', 'eb6791f644505d57a7c2d3e3031ea22a410a3053', 'BVUTu8T4hlk44ddobLaDKASF2WjCDfGonSPqyO9vrrBLUECysTKoCIyhlAPgZhufzupquzbYztx4wENRzZdxbrqmIkzVDl12ryP43yxEK62G7wnrbUWypyKe3MMBfUqV', 1, 8, 1),
(69, 'GR-I-ROI-001', 'GR', 'I', 'ROI', '001', 'Agency 1 GR Attiki Research organization', 'Agency 1 street', '1', '111526', 'Athens', '+302107715791', 'dinapogias@gmail.com', 'df58d570cd5e5324f5f6d45af59792604a75da9f', '5X8ncbopAyX4LW0XbtqA4soXdHWITF97WTD7tZeWz1Cc5hhji3LfsEnHUyYjcA00VTglaN9Z87YQuA5KODTHZE2sALLT38UhocPd6AGPYudu3gji20vH4QgLT4zV5P04', 1, 14, 1),
(70, 'GR-B-SWS-001', 'GR', 'B', 'SWS', '001', 'Agency 2 GR Kentriki Makedonia SWS', 'Agency 2 street', '1', '11526', 'Thessaloniki', '+302310000000', 'aretic@gmail.com', '74bd820415afca5b077f821f02e7ff0275fb6764', 'okpteiddOO3ykGdfgFvKc0sORD5R9zitXdyjBmKVH52G15A5xHMEFXpnNfWL6ePFAr3LJ5gSz5lsG5p8fngUVDu8rAQazgWBq6VYthSFrDi61eEWNdA6x11QtLGqGjVV', 1, 7, 1),
(71, 'GR-M-SMS-001', 'GR', 'M', 'SMS', '001', 'Agency 3 Kriti Social and Medical Services', 'Agency 3 street', '1', '11526', 'Rethymno', '+302831000000', 'dinapogias@gmail.com', 'd8f5299f306de38c6e4355fc743dd0cc9fd917a6', 'UsWTLUK9dHjuNW3Z7nuti7Oq0TCEhXF3QklWE7K4mXN4jdUU5Pmk3EPWAoMgM8sIXtWUaDf9Z8D1gaqk3FJX4HgbcNW9b7LGTUEYBUm73S2ImZ7tzoGU9qdC6pBpVfm8', 1, 20, 1),
(72, 'GR-F-NGO-001', 'GR', 'F', 'NGO', '001', 'Agency 4 Ionia Nisia NGO', 'Agency 4 street', '1', '11526', 'Kerkira', '+300000000000', 'aretic@gmail.com', '61592a0f4b83fa192eaa225287c579f07c7f4a68', 'N7eu8IivWeaW0dliABfV4MHidnP9a8hgF0klSAe5YRSuoxrEMUD9dO8c2gtC7XdlDkHW7vcHtqbNUpSz8Gf9ndwesrKvQJszqrI2ZDXutxUCvYlNE00CUFmLNoZCTbSk', 1, 12, 1),
(73, 'ES-08-NGO-001', 'ES', '08', 'NGO', '001', 'EDUVIC', 'Castelao', '124', '08902', 'L\'Hospitalet del Llobregat', '933320012', 'eduvic@eduvic.coop', 'a40346e96d2f6f3dc597d1d16eec194efc4bfed6', 'JSpLJDinpXewmjEhVd3lYuQiyje1EwZeRUun9BfGS08HzbR6XG1pzRKzm51bA2xH2eLWNmiPu7cigWA16Q8ThcmlD52X6BwtBijNtO7OcodvCmIvrndD8t9s0egXyYNg', 12, 12, 1),
(74, 'ES-08-NGO-002', 'ES', '08', 'NGO', '002', 'ABD Fundación', 'Quevedo', '2 bxs', '08012', 'Barcelona', '932890530', 'abd@abd-ong.org', 'df05f72d536188fe31aee1a0fca8591322a6e4e2', 'T5h6JjoJo818CFhvWFremLVl8Y98kfjd2YxXvBsOXzGK616tlcB9M1PGaC93bk8TZMVWtfOyLGACCVhx7y0F7e3WyE7k3AeFP3mtMEgY2JEsBExsEaW1lhnFi1aqGEnl', 12, 12, 1),
(75, 'ES-08-SWS-001', 'ES', '08', 'SWS', '001', 'Serveis Socials Ajuntament de Barcelona', 'Valencia', '344', '08009', 'Barcelona', '932918801', 'imss@bcn.cat', 'f7dc002932b2e89a92de00aa0fcd9556863401c5', 'R7L9lTINvWfPUBXOvlKbM7XsUYJfpaVWVZt1NZew4gZjQ9yWlAmxxPa0fNH05gI94zNDBgYEaiCDy4HzPtiTDPOLaPEXmhVaW1s7HoP9mwUUhBMU1XalN2QFGYwuFUGm', 12, 7, 1),
(76, 'ES-08-CPS-001', 'ES', '08', 'CPS', '001', 'EAIA CENTRAL - Equip Atenció Infancia i Adolescencia', 'Valencia', '344', '08009', 'Barcelona', '934132757', 'eaia@bcn.cat', '76526a2be98e34f15a4589403798805edac27c37', 'MNxqs4E13CAOAOmoIIUMRiX3GRVNxNKB1c2wWhK61xbiNCWXOXqTg4IlkCxdbiVpyL7KBi1xVWM8q9UpjnYexL8tJy7jfLJVQv7Rw2zjMlZtFBaN9ChYxAtsXvfqFI3u', 12, 8, 1),
(77, 'ES-08-CPS-002', 'ES', '08', 'CPS', '002', 'UDEPMI - Unitat de detecció i prevenció del maltractament infantil', 'Avgda. Paral.lel', '52', '08801', 'Barcelona', '934831000', 'dgaia.tsf@gencat.cat', '34f513d32b139716d46a00168d8ba533b3c42dc8', '9bjsN2nBQFkWmByILmFa18tIaeYUq1mhsvj2YExFTkykWx8uUEHvS0lWW2Ela9UmbhuNkYuwnYXfsKC53DcHVnqa1GjwUApAGxQL95kN0ZEL4cmSLpYhyjfIbgPUFCqJ', 12, 8, 1),
(78, 'ES-08-CPS-003', 'ES', '08', 'CPS', '003', 'DGAIA - Direcció General d\'Atenció a la Infància i l\'Adolescència', 'Avgda. Paral.lel', '52', '08801', 'Barcelona', '934831000', 'dgaia.tsf@gencat.cat', 'f3314af6996ebc59b37fedc2a448bddbea25e95a', 'kv7qroitIFwbqhBRM06GyTrFmbiYX07T9ardQ8qud3r5vZMpED8hNieZsr4DYeDa4L37rWRDHXOymDoSEcb9YcwqicLgbAb4icwPZo0lYFYnTS1HZ2UD7EzxLmMoFQ88', 12, 8, 1),
(79, 'ES-08-CPS-004', 'ES', '08', 'CPS', '004', 'EVAMI - Equips de valoració de maltractaments infantils', 'Avgda. Paral.lel', '52', '08801', 'Barcelona', '934831000', 'dgaia.tsf@gencat.cat', 'eda23b7beebb049c0f8ee526b74d929cd6fd56af', 'PzfA9dfFzSwTK3juQXFkQSWyVQf9P8BsrzXduLiqXljIsfEubfTUHose38bl7YsJz2P1M4KQWU7VT9ouRug732SMhX3UGIq6lwsQUpOjQB8i3qDEA7qC6gEeqyr1VpZI', 12, 8, 1),
(80, 'ES-08-PHC-001', 'ES', '08', 'PHC', '001', 'CATSALUT', 'Travessera de les Corts', '131-159', '08028', 'Barcelona', '934038585', 'atenciociutadana@catsalut.cat', '03b37779bf39a5e4030ce6b81a9810f199a9327c', 'vo0WIIF0Wq0w38sK1Nc92uFVg6BFLqnz8raZfJWquCH4nwsRuOtPso9swUzygip2OWxqubLEh3R3yNFLu8WuC2QujHYPQshDAbbdRxvbcnuyRXL7w7GZcCQsP77Y0Gvj', 12, 2, 1),
(81, 'ES-08-POL-001', 'ES', '08', 'POL', '001', 'Mossos d\'Esquadra', 'Passeig de Torres i Bages', '145', '08030', 'Barcelona', '833618800', 'mossos@gencat.cat', 'aaed640540a9436a84c517012340ce94e72aadbe', '29qfKBzAxGQGLV7gGeqaPjo9GxnCY7XRxjleR2JxKVbdY5pPQI8W8v8mv8oownH7AC57thJeTSqvCb3SFB8ir0BvxNSkviL69x6pHoX1BE0jshGTF6eWdbxaaqIdWmCT', 12, 9, 1),
(82, 'ES-08-POL-002', 'ES', '08', 'POL', '002', 'Mossos d\'Esquadra - GAV (Grup Atenció Victima) Violencia Doméstica', 'Passeig de Torres i Bages', '145', '08030', 'Barcelona', '833618800', 'mossos@gencat.cat', 'e7c60ed60e38ebaba82961622c6e3296c643425c', 'kkEj1cTfWMIy7OjP43QAeZWqYll8ctU1vhnYW4kRVntLqG2R91f9eNop7Dy02slsdIAvV3kdMF2SAkaEdsZZKP4xzblFu9LCndZwPKeKOgRFTdXLbeAH3Xm4hhWJgkeZ', 12, 9, 1),
(83, 'ES-08-IAU-001', 'ES', '08', 'IAU', '001', 'SINDIC de GREUGES - El defensor\r\nd\'infants i adolescents', 'Passeig de Lluís Companys', '7', '08003', 'Barcelona', '933018075', 'sindic@sindic.cat', 'eba2567085bbf37db3fd01aaa61e2fbf6a3017e5', 'yMrZbKPD4DiH5z52fzd6KqrPQ12JDyuzuUguBNmZAwb1FZ1qLieKVGuuzr28xVjnpsLnwl4GDuh9Sl7qDrG3KSLlQRX7EkepqGaUaELKiWc1wnBbr1WFTZ2ZuZ4SlgZi', 12, 6, 1),
(84, 'ES-08-JUD-001', 'ES', '08', 'JUD', '001', 'JUSTICIA - Jutjats de Menors', 'Gran Via de les Corts Catalanes', '111', '08075', 'Barcelona', '935549101', 'justicia.menors@gencat.cat', '33fd0dd52af75488877e68d7ee3887549e496d7c', 'tn7jAXJdCmodzySut6cclaGQM0sPFUXW1Kw5VzAcn9Oai0afKRAlwLRxs66TnC5q8OTGePT98l2MCTwWI8Dht2toKahcHvoLLulTu1dusC6YUpXUKimRLWS0XCPStErD', 12, 1, 1),
(85, 'ES-08-PES-001', 'ES', '08', 'PES', '001', 'EDUCACIÓ - Sub-direcció General d\'Educació Inclusiva', 'Via Augusta', '202-226', '08021', 'Barcelona', '934006900', 'educacio@gencat.cat', 'b706e6b0a83ab42a245eece5d8761de8de7f0370', '4hliop8SXFf9tSmEmf4crVcYhWnas5uYCM2uUVZfPnowtxwnuBKgSgJ1VPh113dIycIoZoUhKykO0nd8MfkFVjYN5TXPUBbk4IeUIukXrurTB6nswqxUrxYYXWVWy5Xo', 12, 16, 1),
(86, 'ES-08-PES-002', 'ES', '08', 'PES', '002', 'EDUCACIÓ - Inspecció educació (BCN ciutat)', 'Plaça Urquinaona', '6', '08010', 'Barcelona', '935511000', 'educacio@gencat.cat', '776a7b308103f6621dd609b2ab632265f6b1f427', '2LoZAeBH0J3kXe7zH40aSxOVE7j2ZGJpAGmtMAoI89EugmUnjj4RBWVOLxvxuifjtRCE4rjuOJSbbdhEfbRE0NSkC4ECLdnB9Ry01Ss9yqzrSgXtDGFme4R5lL3b0GtT', 12, 16, 1),
(87, 'ES-08-PES-003', 'ES', '08', 'PES', '003', 'EDUCACIÓ - EAP (Equips d\'Atenció Psicopedagògica)', 'Mallorca', '219', '08008', 'Barcelona', '935545283', 'educacio@gencat.cat', '2d20c7996c9acb80e9a85aec9561533f30791d51', 'KJG7GXJzvL4fNhzddjgvHiUx6f3eNddQ8vceQiKJTt0Kl0N3eFFctHKLeveGopq8zuvZt208KyYxgXv1s6rZ1XLswcw97H96anK23HXCjdzCPMi8gzfnDHOHD8lmdIVT', 12, 16, 1),
(88, 'ES-08-MHS-001', 'ES', '08', 'MHS', '001', 'CATSALUT - Centres de Salut Mental Infantil i Juvenil (Barcelona) Dreta Eixample', 'Passeig Vilaret', '44-46', '08013', 'Barcelona', '934334717', 'catsalut@gencat.cat', '0534e17ffb552f5b2260f96d201209c2fe10cc89', 'k41AlWT5CAoias7m5LxDTDaRVXds6maYSIneskFrNWoYAvibgLhlYhfp3AeFhWEnG7KWKd6CeFJoe3ff4jwtaVLBZUw97XPGbBdOlGImJ7H1533BGidUBcRoUBb5mJ65', 12, 5, 1),
(89, 'ES-08-SWS-002', 'ES', '08', 'SWS', '002', 'ECEIA - Serveis Socials Ajuntament de Barcelona', 'Valencia', '344', '08009', 'Barcelona', '932918801', 'imss@bcn.cat', '6364e62011d03dab22bf35f419f582c52f3afa71', '78Wq8Tu9guGRV0mRxLMAS0EQGKTubUyUCX2JNggnVUkaGTRAqtdjsUEuy3OYmonRnI2z2HmtnTBLeZDnGrFk810MMpCFnVVGJGuVGBKHUxekpIg8B6q0XYw5zpCrLiR4', 12, 7, 1),
(90, 'ES-08-SWS-003', 'ES', '08', 'SWS', '003', 'EDEIAR - Serveis Socials Ajuntament de Barcelona', 'Valencia', '344', '08009', 'Barcelona', '932918801', 'imss@bcn.cat', '8f39d9e965d5a62bd16438b3b04b7364a86cc0f0', 'fGaZNJUnphDv7iVshmWc6Q0XLIKg6tfqsDPuFnK1nUdqwGZQmCmQyeh0zGJeRtNigJQmiyCO93ZKFKfpHxV4IUuKabsVF2x0WoQ28nJakcHagQgTo0s4qDbBKxwrb3QI', 12, 7, 1),
(91, 'ES-08-CPS-005', 'ES', '08', 'CPS', '005', 'EAIA GOTIC - Equip Atenció Infancia i Adolescencia', 'Carrer de Miralles', '1', '08003', 'Barcelona', '932562020', 'eaia@bcn.cat', 'cc88dd105f324dbc182e594b654270ce21023a92', '73lN77kzbdjW3hOJmenZZJ1t665e5V1dR2VvOhizszKMtq9m40dpK6bCFa9JZMvE1PNj8Cc6aQ2QfXMy5kcm05CXUNLIoage7lII7lKTgLV3QU7Y50dNoosneLrW1NHR', 12, 8, 1),
(92, 'ES-08-CPS-006', 'ES', '08', 'CPS', '006', 'EAIA CASC ANTIC - Equip Atenció Infancia i Adolescencia', 'Comerç', '5', '08003', 'Barcelona', '932515049', 'eaia@bcn.cat', '8761d57e7ff7ce642087bd23f94b82733a769785', 'REcBVHX7w2C8QCWMb3I6Y8f29Qn3B393e9zCP4hNtNIlc2FEJzyKvRaf2CfxqMIDBpR8Kw0SSM990JDsovcCDEyLkFd3EPFOHlpZAgI42tpNMIU7lwt2CQVJrtwXDEfS', 12, 8, 1),
(93, 'ES-08-CPS-007', 'ES', '08', 'CPS', '007', 'EAIA RAVAL NORD - Equip Atenció Infancia i Adolescencia', 'Nou de la Rambla', '45', '08001', 'Barcelona', '932564860', 'eaia@bcn.cat', '6624ccb33eb3d750665c2e0f12992ef44d471722', '5MN1OOHwXM2SMmJNTnBH7dwa1mcT7iuSBDYWlHV59Kej09EboDhTIfsnb8LVwwL8RanUeGU0GdidF2OqAsNyH9BzF2Ox9olzyzOShRO1vsqPlVWiydRpy9nkk1RC4BEt', 12, 8, 1),
(94, 'ES-08-CPS-008', 'ES', '08', 'CPS', '008', 'EAIA RAVAL SUD - Equip Atenció Infancia i Adolescencia', 'Nou de la Rambla', '45', '08001', 'Barcelona', '932564860', 'eaia@bcn.cat', 'f04e5641df49e537169ebf31722611422c7a7316', 'E854KiduocjJZCfxImDNlwbg2k4Q0WPot1BS4XGHJSJADwB0WpiwHmqIzAbxlIVPq4uHm9iFNVJDvvpxEjq7fVTeNJJKARsHDt9Fe6Z9oeizkyq02oPIvqEzYmr8Re0b', 12, 8, 1),
(95, 'BG-BG-10-SWS-001', 'BG', '10', 'SWS', '001', 'ОДЗ', 'Иван Михайлов', '34', '2900', 'Кюстендил', '+359 36 13 20', 'v_stancheva@abv.bg', '54297e640c14bb3ddb7f48eba3ee281f9f30b7f8', 'mmUloRTi9jqgwysO13iavFw0MbKgwlHbu4SBIMz6ZI5FQSYwDvw5Tltwt8XQqQ6ujsaJhPLlnWWwpSq3hE6C5ynLu46MNSP7WEppZLMqPderve5BcpuKKoMgT6wO4v06', 4, 7, 1),
(96, 'CY-01-NGO-001', 'CY', '01', 'NGO', '001', '\'Hope For Children\' CRC Policy Center', 'Limassol Avenue', '75', '2121', 'Nicosia', '22103234', 'mavrou.c@uncrcpc.org', '58645955bfcbf22da2df0729359a91ffa00e49dd', 'EvC45s1iyaSikcoH9rGgZVrNPvnygAG3ThyYkT35sSRUEOCnZz7iOKEIQKUUMTCzxXn08R4iAiAUrtLy3ZPUlxWlfYHu2fFRh00ROrixzi1MNVjlMZALsRmnAYH8MqdT', 13, 12, 1),
(97, 'CY-01-NGO-002', 'CY', '01', 'NGO', '002', '\' Hope for Children\' CRC Policy Cebter', '40, Nikis Avenue Nicosia', '40', '1086', 'Nicosia', '+35796554421', 'georgiou.r@uncrcpc.org', '0723163b05e6d51df570088d7bde7ba01488b98e', 'oBXAleBCrWBAXetSz55TJVuzag9eyTHi0xhU3eFWNRLOrYLE5CqeDsOH7zElkQqCRsC7fN8Ht0RhekiTpncOVCWvcjYU2WJuj4xO5TZen1dnY7irQGRBDFYPL1UjpeEV', 13, 12, 1);

CREATE TABLE `u_country` (
  `id` int(11) NOT NULL,
  `country` varchar(30) NOT NULL,
  `code` varchar(2) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `u_country` (`id`, `country`, `code`) VALUES
(1, 'Greece', 'GR'),
(2, 'Belgium', 'BE'),
(3, 'Switzerland', 'CH'),
(4, 'Bulgaria', 'BG'),
(5, 'Germany', 'DE'),
(6, 'France', 'FR'),
(7, 'Italy', 'IT'),
(8, 'Romania', 'RO'),
(12, 'Spain', 'ES'),
(13, 'Cyprus', 'CY');

CREATE TABLE `u_languages` (
  `id` int(11) NOT NULL,
  `language` varchar(40) NOT NULL,
  `code` varchar(5) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `u_languages` (`id`, `language`, `code`) VALUES
(1, 'Greek', 'el_GR'),
(2, 'English', 'en_GB'),
(3, 'Italian', 'it_IT'),
(4, 'Romanian', 'ro_RO'),
(5, 'Flemish (Belgian-Dutch)', 'nl_BE'),
(6, 'French', 'fr_FR'),
(7, 'Bulgarian', 'bg_BG'),
(8, 'German', 'de_DE'),
(9, 'Català', 'es_ES'),
(13, 'Greek Cyprus', 'el_CY');

CREATE TABLE `u_occupations` (
  `id` int(11) NOT NULL,
  `code` varchar(5) NOT NULL,
  `occupation` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `u_occupations` (`id`, `code`, `occupation`) VALUES
(1, '11', 'Chief executives, senior officials and legislators'),
(2, '111', 'Legislators and senior officials'),
(3, '1111', 'Legislators'),
(4, '1112', 'Senior government officials'),
(5, '1113', 'Traditional chiefs and heads of village'),
(6, '1114', 'Senior officials of special-interest organizations'),
(7, '112', 'Managing directors and chief executives'),
(8, '1120', 'Managing directors and chief executives'),
(9, '12', 'Administrative and commercial managers'),
(10, '121', 'Business services and administration managers'),
(11, '1211', 'Finance managers'),
(12, '1212', 'Human resource managers'),
(13, '1213', 'Policy and planning managers'),
(14, '1219', 'Business services and administration managers not elsewhere classified'),
(15, '122', 'Sales, marketing and development managers'),
(16, '1221', 'Sales and marketing managers'),
(17, '1222', 'Advertising and public relations managers'),
(18, '1223', 'Research and development managers'),
(19, '13', 'Production and specialised services managers'),
(20, '131', 'Production managers in agriculture, forestry and fisheries'),
(21, '1311', 'Agricultural and forestry production managers'),
(22, '1312', 'Aquaculture and fisheries production managers'),
(23, '132', 'Manufacturing, mining, construction, and distribution managers'),
(24, '1321', 'Manufacturing managers'),
(25, '1322', 'Mining managers'),
(26, '1323', 'Construction managers'),
(27, '1324', 'Supply, distribution and related managers'),
(28, '133', 'Information and communications technology service managers'),
(29, '1330', 'Information and communications technology service managers'),
(30, '134', 'Professional services managers'),
(31, '1341', 'Child care services managers'),
(32, '1342', 'Health services managers'),
(33, '1343', 'Aged care services managers'),
(34, '1344', 'Social welfare managers'),
(35, '1345', 'Education managers'),
(36, '1346', 'Financial and insurance services branch managers'),
(37, '1349', 'Professional services managers not elsewhere classified'),
(38, '14', 'Hospitality, retail and other services managers'),
(39, '141', 'Hotel and restaurant managers'),
(40, '1411', 'Hotel managers'),
(41, '1412', 'Restaurant managers'),
(42, '142', 'Retail and wholesale trade managers'),
(43, '1420', 'Retail and wholesale trade managers'),
(44, '143', 'Other services managers'),
(45, '1431', 'Sports, recreation and cultural centre managers'),
(46, '1439', 'Services managers not elsewhere classified'),
(47, '2', 'Professionals'),
(48, '21', 'Science and engineering professionals'),
(49, '211', 'Physical and earth science professionals'),
(50, '2111', 'Physicists and astronomers'),
(51, '2112', 'Meteorologists'),
(52, '2113', 'Chemists'),
(53, '2114', 'Geologists and geophysicists'),
(54, '212', 'Mathematicians, actuaries and statisticians'),
(55, '2120', 'Mathematicians, actuaries and statisticians'),
(56, '213', 'Life science professionals'),
(57, '2131', 'Biologists, botanists, zoologists and related professionals'),
(58, '2132', 'Farming, forestry and fisheries advisers'),
(59, '2133', 'Environmental protection professionals'),
(60, '214', 'Engineering professionals (excluding electrotechnology)'),
(61, '2141', 'Industrial and production engineers'),
(62, '2142', 'Civil engineers'),
(63, '2143', 'Environmental engineers'),
(64, '2144', 'Mechanical engineers'),
(65, '2145', 'Chemical engineers'),
(66, '2146', 'Mining engineers, metallurgists and related professionals'),
(67, '2149', 'Engineering professionals not elsewhere classified'),
(68, '215', 'Electrotechnology engineers'),
(69, '2151', 'Electrical engineers'),
(70, '2152', 'Electronics engineers'),
(71, '2153', 'Telecommunications engineers'),
(72, '216', 'Architects, planners, surveyors and designers'),
(73, '2161', 'Building architects'),
(74, '2162', 'Landscape architects'),
(75, '2163', 'Product and garment designers'),
(76, '2164', 'Town and traffic planners'),
(77, '2165', 'Cartographers and surveyors'),
(78, '2166', 'Graphic and multimedia designers'),
(79, '22', 'Health professionals'),
(80, '221', 'Medical doctors'),
(81, '2211', 'Generalist medical practitioners '),
(82, '2212', 'Specialist medical practitioners '),
(83, '222', 'Nursing and midwifery professionals'),
(84, '2221', 'Nursing professionals'),
(85, '2222', 'Midwifery professionals'),
(86, '223', 'Traditional and complementary medicine professionals'),
(87, '2230', 'Traditional and complementary medicine professionals'),
(88, '224', 'Paramedical practitioners'),
(89, '2240', 'Paramedical practitioners'),
(90, '225', 'Veterinarians'),
(91, '2250', 'Veterinarians'),
(92, '226', 'Other health professionals'),
(93, '2261', 'Dentists'),
(94, '2262', 'Pharmacists'),
(95, '2263', 'Environmental and occupational health and hygiene professionals'),
(96, '2264', 'Physiotherapists '),
(97, '2265', 'Dieticians and nutritionists'),
(98, '2266', 'Audiologists and speech therapists'),
(99, '2267', 'Optometrists and ophthalmic opticians'),
(100, '2269', 'Health professionals not elsewhere classified'),
(101, '23', 'Teaching professionals'),
(102, '231', 'University and higher education teachers'),
(103, '2310', 'University and higher education teachers'),
(104, '232', 'Vocational education teachers'),
(105, '2320', 'Vocational education teachers'),
(106, '233', 'Secondary education teachers'),
(107, '2330', 'Secondary education teachers'),
(108, '234', 'Primary school and early childhood teachers'),
(109, '2341', 'Primary school teachers'),
(110, '2342', 'Early childhood educators'),
(111, '235', 'Other teaching professionals'),
(112, '2351', 'Education methods specialists'),
(113, '2352', 'Special needs teachers'),
(114, '2353', 'Other language teachers'),
(115, '2354', 'Other music teachers'),
(116, '2355', 'Other arts teachers'),
(117, '2356', 'Information technology trainers'),
(118, '2359', 'Teaching professionals not elsewhere classified'),
(119, '24', 'Business and administration professionals'),
(120, '241', 'Finance professionals'),
(121, '2411', 'Accountants'),
(122, '2412', 'Financial and investment advisers'),
(123, '2413', 'Financial analysts'),
(124, '242', 'Administration professionals'),
(125, '2421', 'Management and organization analysts'),
(126, '2422', 'Policy administration professionals'),
(127, '2423', 'Personnel and careers professionals'),
(128, '2424', 'Training and staff development professionals'),
(129, '243', 'Sales, marketing and public relations professionals'),
(130, '2431', 'Advertising and marketing professionals'),
(131, '2432', 'Public relations professionals'),
(132, '2433', 'Technical and medical sales professionals (excluding ICT)'),
(133, '2434', 'Information and communications technology sales professionals'),
(134, '25', 'Information and communications technology professionals'),
(135, '251', 'Software and applications developers and analysts'),
(136, '2511', 'Systems analysts'),
(137, '2512', 'Software developers'),
(138, '2513', 'Web and multimedia developers'),
(139, '2514', 'Applications programmers'),
(140, '2519', 'Software and applications developers and analysts not elsewhere classified'),
(141, '252', 'Database and network professionals'),
(142, '2521', 'Database designers and administrators'),
(143, '2522', 'Systems administrators'),
(144, '2523', 'Computer network professionals'),
(145, '2529', 'Database and network professionals not elsewhere classified'),
(146, '26', 'Legal, social and cultural professionals'),
(147, '261', 'Legal professionals'),
(148, '2611', 'Lawyers'),
(149, '2612', 'Judges'),
(150, '2619', 'Legal professionals not elsewhere classified'),
(151, '262', 'Librarians, archivists and curators '),
(152, '2621', 'Archivists and curators'),
(153, '2622', 'Librarians and related information professionals'),
(154, '263', 'Social and religious professionals'),
(155, '2631', 'Economists'),
(156, '2632', 'Sociologists, anthropologists and related professionals'),
(157, '2633', 'Philosophers, historians and political scientists'),
(158, '2634', 'Psychologists'),
(159, '2635', 'Social work and counselling professionals'),
(160, '2636', 'Religious professionals'),
(161, '264', 'Authors, journalists and linguists'),
(162, '2641', 'Authors and related writers'),
(163, '2642', 'Journalists'),
(164, '2643', 'Translators, interpreters and other linguists'),
(165, '265', 'Creative and performing artists'),
(166, '2651', 'Visual artists'),
(167, '2652', 'Musicians, singers and composers'),
(168, '2653', 'Dancers and choreographers'),
(169, '2654', 'Film, stage and related directors and producers'),
(170, '2655', 'Actors'),
(171, '2656', 'Announcers on radio, television and other media'),
(172, '2659', 'Creative and performing artists not elsewhere classified'),
(173, '3', 'Technicians and associate professionals'),
(174, '31', 'Science and engineering associate professionals'),
(175, '311', 'Physical and engineering science technicians'),
(176, '3111', 'Chemical and physical science technicians'),
(177, '3112', 'Civil engineering technicians'),
(178, '3113', 'Electrical engineering technicians'),
(179, '3114', 'Electronics engineering technicians'),
(180, '3115', 'Mechanical engineering technicians'),
(181, '3116', 'Chemical engineering technicians'),
(182, '3117', 'Mining and metallurgical technicians'),
(183, '3118', 'Draughtspersons'),
(184, '3119', 'Physical and engineering science technicians not elsewhere classified'),
(185, '312', 'Mining, manufacturing and construction supervisors'),
(186, '3121', 'Mining supervisors'),
(187, '3122', 'Manufacturing supervisors'),
(188, '3123', 'Construction supervisors'),
(189, '313', 'Process control technicians'),
(190, '3131', 'Power production plant operators'),
(191, '3132', 'Incinerator and water treatment plant operators'),
(192, '3133', 'Chemical processing plant controllers'),
(193, '3134', 'Petroleum and natural gas refining plant operators'),
(194, '3135', 'Metal production process controllers'),
(195, '3139', 'Process control technicians not elsewhere classified'),
(196, '314', 'Life science technicians and related associate professionals'),
(197, '3141', 'Life science technicians (excluding medical)'),
(198, '3142', 'Agricultural technicians'),
(199, '3143', 'Forestry technicians'),
(200, '315', 'Ship and aircraft controllers and technicians'),
(201, '3151', 'Ships\' engineers'),
(202, '3152', 'Ships\' deck officers and pilots'),
(203, '3153', 'Aircraft pilots and related associate professionals'),
(204, '3154', 'Air traffic controllers'),
(205, '3155', 'Air traffic safety electronics technicians'),
(206, '32', 'Health associate professionals'),
(207, '321', 'Medical and pharmaceutical technicians'),
(208, '3211', 'Medical imaging and therapeutic equipment technicians'),
(209, '3212', 'Medical and pathology laboratory technicians '),
(210, '3213', 'Pharmaceutical technicians and assistants'),
(211, '3214', 'Medical and dental prosthetic technicians'),
(212, '322', 'Nursing and midwifery associate professionals'),
(213, '3221', 'Nursing associate professionals'),
(214, '3222', 'Midwifery associate professionals'),
(215, '323', 'Traditional and complementary medicine associate professionals'),
(216, '3230', 'Traditional and complementary medicine associate professionals'),
(217, '324', 'Veterinary technicians and assistants'),
(218, '3240', 'Veterinary technicians and assistants'),
(219, '325', 'Other health associate professionals'),
(220, '3251', 'Dental assistants and therapists'),
(221, '3252', 'Medical records and health information technicians'),
(222, '3253', 'Community health workers'),
(223, '3254', 'Dispensing opticians'),
(224, '3255', 'Physiotherapy technicians and assistants'),
(225, '3256', 'Medical assistants'),
(226, '3257', 'Environmental and occupational health inspectors and associates'),
(227, '3258', 'Ambulance workers'),
(228, '3259', 'Health associate professionals not elsewhere classified'),
(229, '33', 'Business and administration associate professionals'),
(230, '331', 'Financial and mathematical associate professionals'),
(231, '3311', 'Securities and finance dealers and brokers'),
(232, '3312', 'Credit and loans officers'),
(233, '3313', 'Accounting associate professionals'),
(234, '3314', 'Statistical, mathematical and related associate professionals'),
(235, '3315', 'Valuers and loss assessors'),
(236, '332', 'Sales and purchasing agents and brokers'),
(237, '3321', 'Insurance representatives'),
(238, '3322', 'Commercial sales representatives'),
(239, '3323', 'Buyers'),
(240, '3324', 'Trade brokers'),
(241, '333', 'Business services agents'),
(242, '3331', 'Clearing and forwarding agents'),
(243, '3332', 'Conference and event planners'),
(244, '3333', 'Employment agents and contractors'),
(245, '3334', 'Real estate agents and property managers'),
(246, '3339', 'Business services agents not elsewhere classified'),
(247, '334', 'Administrative and specialised secretaries'),
(248, '3341', 'Office supervisors'),
(249, '3342', 'Legal secretaries'),
(250, '3343', 'Administrative and executive secretaries'),
(251, '3344', 'Medical secretaries'),
(252, '335', 'Regulatory government associate professionals'),
(253, '3351', 'Customs and border inspectors'),
(254, '3352', 'Government tax and excise officials'),
(255, '3353', 'Government social benefits officials'),
(256, '3354', 'Government licensing officials'),
(257, '3355', 'Police inspectors and detectives'),
(258, '3359', 'Regulatory government associate professionals not elsewhere classified'),
(259, '34', 'Legal, social, cultural and related associate professionals'),
(260, '341', 'Legal, social and religious associate professionals'),
(261, '3411', 'Police inspectors and detectives'),
(262, '3412', 'Social work associate professionals'),
(263, '3413', 'Religious associate professionals'),
(264, '342', 'Sports and fitness workers'),
(265, '3421', 'Athletes and sports players'),
(266, '3422', 'Sports coaches, instructors and officials'),
(267, '3423', 'Fitness and recreation instructors and program leaders'),
(268, '343', 'Artistic, cultural and culinary associate professionals'),
(269, '3431', 'Photographers'),
(270, '3432', 'Interior designers and decorators'),
(271, '3433', 'Gallery, museum and library technicians'),
(272, '3434', 'Chefs'),
(273, '3435', 'Other artistic and cultural associate professionals'),
(274, '35', 'Information and communications technicians'),
(275, '351', 'Information and communications technology operations and user support technicians'),
(276, '3511', 'Information and communications technology operations technicians'),
(277, '3512', 'Information and communications technology user support technicians'),
(278, '3513', 'Computer network and systems technicians'),
(279, '3514', 'Web technicians'),
(280, '352', 'Telecommunications and broadcasting technicians'),
(281, '3521', 'Broadcasting and audio-visual technicians'),
(282, '3522', 'Telecommunications engineering technicians'),
(283, '4', 'Clerical support workers'),
(284, '41', 'General and keyboard clerks'),
(285, '411', 'General office clerks'),
(286, '4110', 'General office clerks'),
(287, '412', 'Secretaries (general)'),
(288, '4120', 'Secretaries (general)'),
(289, '413', 'Keyboard operators'),
(290, '4131', 'Typists and word processing operators'),
(291, '4132', 'Data entry clerks'),
(292, '42', 'Customer services clerks'),
(293, '421', 'Tellers, money collectors and related clerks'),
(294, '4211', 'Bank tellers and related clerks'),
(295, '4212', 'Bookmakers, croupiers and related gaming workers'),
(296, '4213', 'Pawnbrokers and money-lenders'),
(297, '4214', 'Debt-collectors and related workers'),
(298, '422', 'Client information workers'),
(299, '4221', 'Travel consultants and clerks'),
(300, '4222', 'Contact centre information clerks'),
(301, '4223', 'Telephone switchboard operators'),
(302, '4224', 'Hotel receptionists'),
(303, '4225', 'Enquiry clerks'),
(304, '4226', 'Receptionists (general)'),
(305, '4227', 'Survey and market research interviewers'),
(306, '4229', 'Client information workers not elsewhere classified'),
(307, '43', 'Numerical and material recording clerks'),
(308, '431', 'Numerical clerks'),
(309, '4311', 'Accounting and bookkeeping clerks'),
(310, '4312', 'Statistical, finance and insurance clerks'),
(311, '4313', 'Payroll clerks'),
(312, '432', 'Material-recording and transport clerks'),
(313, '4321', 'Stock clerks'),
(314, '4322', 'Production clerks'),
(315, '4323', 'Transport clerks'),
(316, '44', 'Other clerical support workers'),
(317, '441', 'Other clerical support workers'),
(318, '4411', 'Library clerks'),
(319, '4412', 'Mail carriers and sorting clerks'),
(320, '4413', 'Coding, proof-reading and related clerks'),
(321, '4414', 'Scribes and related workers'),
(322, '4415', 'Filing and copying clerks'),
(323, '4416', 'Personnel clerks'),
(324, '4419', 'Clerical support workers not elsewhere classified'),
(325, '5', 'Service and sales workers'),
(326, '51', 'Personal service workers'),
(327, '511', 'Travel attendants, conductors and guides'),
(328, '5111', 'Travel attendants and travel stewards'),
(329, '5112', 'Transport conductors'),
(330, '5113', 'Travel guides'),
(331, '512', 'Cooks'),
(332, '5120', 'Cooks'),
(333, '513', 'Waiters and bartenders'),
(334, '5131', 'Waiters'),
(335, '5132', 'Bartenders'),
(336, '514', 'Hairdressers, beauticians and related workers'),
(337, '5141', 'Hairdressers'),
(338, '5142', 'Beauticians and related workers'),
(339, '515', 'Building and housekeeping supervisors'),
(340, '5151', 'Cleaning and housekeeping supervisors in offices, hotels and other establishments'),
(341, '5152', 'Domestic housekeepers'),
(342, '5153', 'Building caretakers'),
(343, '516', 'Other personal services workers'),
(344, '5161', 'Astrologers, fortune-tellers and related workers'),
(345, '5162', 'Companions and valets'),
(346, '5163', 'Undertakers and embalmers'),
(347, '5164', 'Pet groomers and animal care workers'),
(348, '5165', 'Driving instructors'),
(349, '5169', 'Personal services workers not elsewhere classified'),
(350, '52', 'Sales workers'),
(351, '521', 'Street and market salespersons'),
(352, '5211', 'Stall and market salespersons'),
(353, '5212', 'Street food salespersons'),
(354, '522', 'Shop salespersons '),
(355, '5221', 'Shop keepers'),
(356, '5222', 'Shop supervisors'),
(357, '5223', 'Shop sales assistants'),
(358, '523', 'Cashiers and ticket clerks'),
(359, '5230', 'Cashiers and ticket clerks'),
(360, '524', 'Other sales workers'),
(361, '5241', 'Fashion and other models'),
(362, '5242', 'Sales demonstrators'),
(363, '5243', 'Door to door salespersons'),
(364, '5244', 'Contact centre salespersons'),
(365, '5245', 'Service station attendants'),
(366, '5246', 'Food service counter attendants'),
(367, '5249', 'Sales workers not elsewhere classified'),
(368, '53', 'Personal care workers'),
(369, '531', 'Child care workers and teachers\' aides'),
(370, '5311', 'Child care workers'),
(371, '5312', 'Teachers\' aides'),
(372, '532', 'Personal care workers in health services'),
(373, '5321', 'Health care assistants'),
(374, '5322', 'Home-based personal care workers'),
(375, '5329', 'Personal care workers in health services not elsewhere classified'),
(376, '54', 'Protective services workers'),
(377, '541', 'Protective services workers'),
(378, '5411', 'Fire-fighters'),
(379, '5412', 'Police officers'),
(380, '5413', 'Prison guards'),
(381, '5414', 'Security guards'),
(382, '5419', 'Protective services workers not elsewhere classified'),
(383, '6', 'Skilled agricultural, forestry and fishery workers'),
(384, '61', 'Market-oriented skilled agricultural workers'),
(385, '611', 'Market gardeners and crop growers'),
(386, '6111', 'Field crop and vegetable growers'),
(387, '6112', 'Tree and shrub crop growers'),
(388, '6113', 'Gardeners, horticultural and nursery growers'),
(389, '6114', 'Mixed crop growers'),
(390, '612', 'Animal producers'),
(391, '6121', 'Livestock and dairy producers'),
(392, '6122', 'Poultry producers'),
(393, '6123', 'Apiarists and sericulturists'),
(394, '6129', 'Animal producers not elsewhere classified'),
(395, '613', 'Mixed crop and animal producers'),
(396, '6130', 'Mixed crop and animal producers'),
(397, '62', 'Market-oriented skilled forestry, fishery and hunting workers'),
(398, '621', 'Forestry and related workers'),
(399, '6210', 'Forestry and related workers'),
(400, '622', 'Fishery workers, hunters and trappers'),
(401, '6221', 'Aquaculture workers'),
(402, '6222', 'Inland and coastal waters fishery workers'),
(403, '6223', 'Deep-sea fishery workers'),
(404, '6224', 'Hunters and trappers'),
(405, '63', 'Subsistence farmers, fishers, hunters and gatherers'),
(406, '631', 'Subsistence crop farmers'),
(407, '6310', 'Subsistence crop farmers'),
(408, '632', 'Subsistence livestock farmers'),
(409, '6320', 'Subsistence livestock farmers'),
(410, '633', 'Subsistence mixed crop and livestock farmers'),
(411, '6330', 'Subsistence mixed crop and livestock farmers'),
(412, '634', 'Subsistence fishers, hunters, trappers and gatherers'),
(413, '6340', 'Subsistence fishers, hunters, trappers and gatherers'),
(414, '7', 'Craft and related trades workers'),
(415, '71', 'Building and related trades workers, excluding electricians'),
(416, '711', 'Building frame and related trades workers'),
(417, '7111', 'House builders'),
(418, '7112', 'Bricklayers and related workers'),
(419, '7113', 'Stonemasons, stone cutters, splitters and carvers'),
(420, '7114', 'Concrete placers, concrete finishers and related workers'),
(421, '7115', 'Carpenters and joiners'),
(422, '7119', 'Building frame and related trades workers not elsewhere classified'),
(423, '712', 'Building finishers and related trades workers'),
(424, '7121', 'Roofers'),
(425, '7122', 'Floor layers and tile setters'),
(426, '7123', 'Plasterers'),
(427, '7124', 'Insulation workers'),
(428, '7125', 'Glaziers'),
(429, '7126', 'Plumbers and pipe fitters'),
(430, '7127', 'Air conditioning and refrigeration mechanics'),
(431, '713', 'Painters, building structure cleaners and related trades workers'),
(432, '7131', 'Painters and related workers'),
(433, '7132', 'Spray painters and varnishers'),
(434, '7133', 'Building structure cleaners'),
(435, '72', 'Metal, machinery and related trades workers'),
(436, '721', 'Sheet and structural metal workers, moulders and welders, and related workers'),
(437, '7211', 'Metal moulders and coremakers'),
(438, '7212', 'Welders and flamecutters'),
(439, '7213', 'Sheet-metal workers'),
(440, '7214', 'Structural-metal preparers and erectors'),
(441, '7215', 'Riggers and cable splicers'),
(442, '722', 'Blacksmiths, toolmakers and related trades workers'),
(443, '7221', 'Blacksmiths, hammersmiths and forging press workers'),
(444, '7222', 'Toolmakers and related workers'),
(445, '7223', 'Metal working machine tool setters and operators'),
(446, '7224', 'Metal polishers, wheel grinders and tool sharpeners'),
(447, '723', 'Machinery mechanics and repairers'),
(448, '7231', 'Motor vehicle mechanics and repairers'),
(449, '7232', 'Aircraft engine mechanics and repairers'),
(450, '7233', 'Agricultural and industrial machinery mechanics and repairers'),
(451, '7234', 'Bicycle and related repairers'),
(452, '73', 'Handicraft and printing workers'),
(453, '731', 'Handicraft workers'),
(454, '7311', 'Precision-instrument makers and repairers'),
(455, '7312', 'Musical instrument makers and tuners'),
(456, '7313', 'Jewellery and precious-metal workers'),
(457, '7314', 'Potters and related workers'),
(458, '7315', 'Glass makers, cutters, grinders and finishers'),
(459, '7316', 'Sign writers, decorative painters, engravers and etchers'),
(460, '7317', 'Handicraft workers in wood, basketry and related materials'),
(461, '7318', 'Handicraft workers in textile, leather and related materials'),
(462, '7319', 'Handicraft workers not elsewhere classified'),
(463, '732', 'Printing trades workers'),
(464, '7321', 'Pre-press technicians'),
(465, '7322', 'Printers '),
(466, '7323', 'Print finishing and binding workers'),
(467, '74', 'Electrical and electronic trades workers'),
(468, '741', 'Electrical equipment installers and repairers'),
(469, '7411', 'Building and related electricians'),
(470, '7412', 'Electrical mechanics and fitters'),
(471, '7413', 'Electrical line installers and repairers '),
(472, '742', 'Electronics and telecommunications installers and repairers'),
(473, '7421', 'Electronics mechanics and servicers'),
(474, '7422', 'Information and communications technology installers and servicers'),
(475, '75', 'Food processing, wood working, garment and other craft and related trades workers'),
(476, '751', 'Food processing and related trades workers'),
(477, '7511', 'Butchers, fishmongers and related food preparers'),
(478, '7512', 'Bakers, pastry-cooks and confectionery makers'),
(479, '7513', 'Dairy-products makers'),
(480, '7514', 'Fruit, vegetable and related preservers'),
(481, '7515', 'Food and beverage tasters and graders'),
(482, '7516', 'Tobacco preparers and tobacco products makers'),
(483, '752', 'Wood treaters, cabinet-makers and related trades workers'),
(484, '7521', 'Wood treaters'),
(485, '7522', 'Cabinet-makers and related workers'),
(486, '7523', 'Woodworking-machine tool setters and operators'),
(487, '753', 'Garment and related trades workers'),
(488, '7531', 'Tailors, dressmakers, furriers and hatters'),
(489, '7532', 'Garment and related pattern-makers and cutters'),
(490, '7533', 'Sewing, embroidery and related workers'),
(491, '7534', 'Upholsterers and related workers'),
(492, '7535', 'Pelt dressers, tanners and fellmongers'),
(493, '7536', 'Shoemakers and related workers'),
(494, '754', 'Other craft and related workers'),
(495, '7541', 'Underwater divers'),
(496, '7542', 'Shotfirers and blasters'),
(497, '7543', 'Product graders and testers (excluding foods and beverages)'),
(498, '7544', 'Fumigators and other pest and weed controllers'),
(499, '7549', 'Craft and related workers not elsewhere classified'),
(500, '8', 'Plant and machine operators, and assemblers'),
(501, '81', 'Stationary plant and machine operators'),
(502, '811', 'Mining and mineral processing plant operators'),
(503, '8111', 'Miners and quarriers'),
(504, '8112', 'Mineral and stone processing plant operators'),
(505, '8113', 'Well drillers and borers and related workers'),
(506, '8114', 'Cement, stone and other mineral products machine operators'),
(507, '812', 'Metal processing and finishing plant operators'),
(508, '8121', 'Metal processing plant operators'),
(509, '8122', 'Metal finishing, plating and coating machine operators'),
(510, '813', 'Chemical and photographic products plant and machine operators'),
(511, '8131', 'Chemical products plant and machine operators'),
(512, '8132', 'Photographic products machine operators'),
(513, '814', 'Rubber, plastic and paper products machine operators'),
(514, '8141', 'Rubber products machine operators'),
(515, '8142', 'Plastic products machine operators'),
(516, '8143', 'Paper products machine operators'),
(517, '815', 'Textile, fur and leather products machine operators'),
(518, '8151', 'Fibre preparing, spinning and winding machine operators'),
(519, '8152', 'Weaving and knitting machine operators'),
(520, '8153', 'Sewing machine operators'),
(521, '8154', 'Bleaching, dyeing and fabric cleaning machine operators'),
(522, '8155', 'Fur and leather preparing machine operators'),
(523, '8156', 'Shoemaking and related machine operators'),
(524, '8157', 'Laundry machine operators'),
(525, '8159', 'Textile, fur and leather products machine operators not elsewhere classified'),
(526, '816', 'Food and related products machine operators'),
(527, '8160', 'Food and related products machine operators'),
(528, '817', 'Wood processing and papermaking plant operators'),
(529, '8171', 'Pulp and papermaking plant operators'),
(530, '8172', 'Wood processing plant operators'),
(531, '818', 'Other stationary plant and machine operators'),
(532, '8181', 'Glass and ceramics plant operators'),
(533, '8182', 'Steam engine and boiler operators'),
(534, '8183', 'Packing, bottling and labelling machine operators'),
(535, '8189', 'Stationary plant and machine operators not elsewhere classified'),
(536, '82', 'Assemblers'),
(537, '821', 'Assemblers'),
(538, '8211', 'Mechanical machinery assemblers'),
(539, '8212', 'Electrical and electronic equipment assemblers'),
(540, '8219', 'Assemblers not elsewhere classified'),
(541, '83', 'Drivers and mobile plant operators'),
(542, '831', 'Locomotive engine drivers and related workers'),
(543, '8311', 'Locomotive engine drivers'),
(544, '8312', 'Railway brake, signal and switch operators'),
(545, '832', 'Car, van and motorcycle drivers'),
(546, '8321', 'Motorcycle drivers'),
(547, '8322', 'Car, taxi and van drivers'),
(548, '833', 'Heavy truck and bus drivers'),
(549, '8331', 'Bus and tram drivers'),
(550, '8332', 'Heavy truck and lorry drivers'),
(551, '834', 'Mobile plant operators'),
(552, '8341', 'Mobile farm and forestry plant operators'),
(553, '8342', 'Earthmoving and related plant operators'),
(554, '8343', 'Crane, hoist and related plant operators'),
(555, '8344', 'Lifting truck operators'),
(556, '835', 'Ships\' deck crews and related workers'),
(557, '8350', 'Ships\' deck crews and related workers'),
(558, '9', 'Elementary occupations'),
(559, '91', 'Cleaners and helpers'),
(560, '911', 'Domestic, hotel and office cleaners and helpers'),
(561, '9111', 'Domestic cleaners and helpers'),
(562, '9112', 'Cleaners and helpers in offices, hotels and other establishments'),
(563, '912', 'Vehicle, window, laundry and other hand cleaning workers'),
(564, '9121', 'Hand launderers and pressers'),
(565, '9122', 'Vehicle cleaners'),
(566, '9123', 'Window cleaners'),
(567, '9129', 'Other cleaning workers'),
(568, '92', 'Agricultural, forestry and fishery labourers'),
(569, '921', 'Agricultural, forestry and fishery labourers'),
(570, '9211', 'Crop farm labourers'),
(571, '9212', 'Livestock farm labourers'),
(572, '9213', 'Mixed crop and livestock farm labourers'),
(573, '9214', 'Garden and horticultural labourers'),
(574, '9215', 'Forestry labourers'),
(575, '9216', 'Fishery and aquaculture labourers'),
(576, '93', 'Labourers in mining, construction, manufacturing and transport'),
(577, '931', 'Mining and construction labourers'),
(578, '9311', 'Mining and quarrying labourers'),
(579, '9312', 'Civil engineering labourers'),
(580, '9313', 'Building construction labourers'),
(581, '932', 'Manufacturing labourers'),
(582, '9321', 'Hand packers'),
(583, '9329', 'Manufacturing labourers not elsewhere classified'),
(584, '933', 'Transport and storage labourers'),
(585, '9331', 'Hand and pedal vehicle drivers'),
(586, '9332', 'Drivers of animal-drawn vehicles and machinery'),
(587, '9333', 'Freight handlers'),
(588, '9334', 'Shelf fillers'),
(589, '94', 'Food preparation assistants'),
(590, '941', 'Food preparation assistants'),
(591, '9411', 'Fast food preparers'),
(592, '9412', 'Kitchen helpers'),
(593, '95', 'Street and related sales and service workers'),
(594, '951', 'Street and related service workers'),
(595, '9510', 'Street and related service workers'),
(596, '952', 'Street vendors (excluding food)'),
(597, '9520', 'Street vendors (excluding food)'),
(598, '96', 'Refuse workers and other elementary workers'),
(599, '961', 'Refuse workers'),
(600, '9611', 'Garbage and recycling collectors'),
(601, '9612', 'Refuse sorters'),
(602, '9613', 'Sweepers and related labourers'),
(603, '962', 'Other elementary workers'),
(604, '9621', 'Messengers, package deliverers and luggage porters'),
(605, '9622', 'Odd job persons'),
(606, '9623', 'Meter readers and vending-machine collectors'),
(607, '9624', 'Water and firewood collectors'),
(608, '9629', 'Elementary workers not elsewhere classified'),
(609, '0', 'Armed forces occupations'),
(610, '01', 'Commissioned armed forces officers'),
(611, '011', 'Commissioned armed forces officers'),
(612, '0110', 'Commissioned armed forces officers'),
(613, '02', 'Non-commissioned armed forces officers'),
(614, '021', 'Non-commissioned armed forces officers'),
(615, '0210', 'Non-commissioned armed forces officers'),
(616, '03', 'Armed forces occupations, other ranks'),
(617, '031', 'Armed forces occupations, other ranks'),
(618, '0310', 'Armed forces occupations, other ranks'),
(619, '', '');

CREATE TABLE `u_organization_service_type` (
  `id` int(11) NOT NULL,
  `name` varchar(40) NOT NULL,
  `code` varchar(3) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `u_organization_service_type` (`id`, `name`, `code`) VALUES
(1, 'Judicial Services (JUD)', 'JUD'),
(2, 'Primary Health Care Services (PHC)', 'PHC'),
(3, 'Secondary Health Care Services (SHC)', 'SHC'),
(4, 'Tertiary Health Care Services (THC)', 'THC'),
(5, 'Mental Health Services (MHS)', 'MHS'),
(6, 'Independent Authorities (IAU)', 'IAU'),
(7, 'Social Welfare Services (SWS)', 'SWS'),
(8, 'Child Protection Services (CPS)', 'CPS'),
(9, 'Police (POL)', 'POL'),
(10, 'Law Enforcement related Services (LES)', 'LES'),
(11, 'Community Organizations (COM)', 'COM'),
(12, 'Non-Governmental Organization (NGO)', 'NGO'),
(13, 'Existing Registries (RSS)', 'RSS'),
(14, 'Research Organizations (ROI)', 'ROI'),
(15, 'Preschool Educational Facilities (PEF)', 'PEF'),
(16, 'Primary Educational Services (PES)', 'PES'),
(17, 'Secondary Educational Services (SES)', 'SES'),
(18, 'Vocational Educational Services (VES)', 'VES'),
(19, 'Other related Services (ORS)', 'ORS'),
(20, 'Social and Medical Services (SMS)', 'SMS');

CREATE TABLE `u_region` (
  `id` int(11) NOT NULL,
  `region` varchar(30) NOT NULL,
  `code` varchar(3) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `u_region` (`id`, `region`, `code`) VALUES
(1, 'Attiki', 'ATT');

CREATE TABLE `u_translate` (
  `id` int(11) NOT NULL,
  `text_en` varchar(2000) NOT NULL,
  `text_trans` varchar(2000) DEFAULT NULL,
  `language_id` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `u_translate` (`id`, `text_en`, `text_trans`, `language_id`) VALUES
(1, 'ENTER Username', 'ENTER Username', 2),
(2, 'ENTER Password', 'ENTER Password', 2),
(3, 'Log in', 'Log in', 2),
(4, 'MEMO: Meaning of Symbols & Colors', 'MEMO: Meaning of Symbols & Colors', 2),
(5, 'Auto-Completed variable', 'Auto-Completed variable', 2),
(6, 'Variable already recorded by the Operator', 'Variable already recorded by the Operator', 2),
(7, 'Single selection (mutually exclusive codes)', 'Single selection (mutually exclusive codes)', 2),
(8, 'Multiple selection (select as many as applicable)', 'Multiple selection (select as many as applicable)', 2),
(9, 'Open list of sub-codes (drop-down menu)', 'Open list of sub-codes (drop-down menu)', 2),
(10, 'Close list of sub-codes (drop-down menu)', 'Close list of sub-codes (drop-down menu)', 2),
(11, 'Instruction to Operator', 'Instruction to Operator', 2),
(12, 'Recorded Variable’s Name', 'Recorded Variable’s Name', 2),
(13, 'Codes of Recorded variable', 'Codes of Recorded variable', 2),
(14, 'Note to Operator for the recording', 'Note to Operator for the recording', 2),
(15, 'Note to Operator for system’s operations', 'Note to Operator for system’s operations', 2),
(16, 'Automated process (filters etc.)', 'Automated process (filters etc.)', 2),
(17, 'ALREADY EXISTING ID (can appear in CHILD’S ID AND in INCIDENT ID)', 'ALREADY EXISTING ID (can appear in CHILD’S ID AND in INCIDENT ID)', 2),
(18, 'Skip', 'Skip', 2),
(19, 'Start Page', 'Start Page', 2),
(20, 'Operator\'s Panel', 'Operator\'s Panel', 2),
(21, 'my account', 'my account', 2),
(22, 'Contact Details', 'Contact Details', 2),
(23, 'Change Password', 'Change Password', 2),
(24, 'my previous cases', 'my previous cases', 2),
(25, 'List of incidents', 'List of incidents', 2),
(26, 'List of Children’s ID', 'List of Children’s ID', 2),
(27, 'my current cases', 'my current cases', 2),
(28, 'List of temporary Child\'s ID', 'List of temporary Child\'s ID', 2),
(29, 'Information ', 'Information ', 2),
(30, 'New Incident', 'New Incident', 2),
(31, 'My Profile', 'My Profile', 2),
(32, 'Change Pass', 'Change Pass', 2),
(33, 'List of Child\'s ID', 'List of Child\'s ID', 2),
(34, 'Log out!', 'Log out!', 2),
(35, 'Welcome', 'Welcome', 2),
(36, 'New ', 'New ', 2),
(37, 'Record Progress', 'Record Progress', 2),
(38, 'Agency\'s ID', 'Agency\'s ID', 2),
(39, 'Operator\'s ID', 'Operator\'s ID', 2),
(40, 'Child\'s ID', 'Child\'s ID', 2),
(41, 'Date of Record', 'Date of Record', 2),
(42, 'Incident\'s ID', 'Incident\'s ID', 2),
(43, 'Date of Incident', 'Date of Incident', 2),
(44, 'Source of Information', 'Source of Information', 2),
(45, 'Forms of Maltreatment', 'Forms of Maltreatment', 2),
(46, 'Place of Incident', 'Place of Incident', 2),
(47, 'Child\'s Sex', 'Child\'s Sex', 2),
(48, 'Child\'s DoB', 'Child\'s DoB', 2),
(49, 'Child\'s Citizenship Status', 'Child\'s Citizenship Status', 2),
(50, 'Family Composition', 'Family Composition', 2),
(51, 'CGs Relationship to Child', 'CGs Relationship to Child', 2),
(52, 'Caregiver(s)\' Sex', 'Caregiver(s)\' Sex', 2),
(53, 'Caregiver(s)\' DoB', 'Caregiver(s)\' DoB', 2),
(54, 'Institutional Response', 'Institutional Response', 2),
(55, 'Referral(s) to Services', 'Referral(s) to Services', 2),
(56, 'Agencys\'s ID', 'Agencys\'s ID', 2),
(57, 'Identity Confirmation', 'Identity Confirmation', 2),
(58, 'TIP', 'TIP', 2),
(59, 'If the above information needs update, please contact the CAN-MDS Administration Office.', 'If the above information needs update, please contact the CAN-MDS Administration Office.', 2),
(60, 'Date & Type of Incident', 'Date & Type of Incident', 2),
(61, 'Incident ID', 'Incident ID', 2),
(62, 'Type Of Record', 'Type Of Record', 2),
(63, 'Type Of Incident', 'Type Of Incident', 2),
(64, 'Notifications', 'Notifications', 2),
(65, 'Subject', 'Subject', 2),
(66, 'Message', 'Message', 2),
(67, 'Replace ID', 'Replace ID', 2),
(68, 'WELCOME TO CAN-MDS', 'WELCOME TO CAN-MDS', 2),
(69, 'To proceed with the record, please follow the CAN-MDS Operations’ Protocol.', 'To proceed with the record, please follow the CAN-MDS Operations’ Protocol.', 2),
(70, 'If you need more information, please use the CAN-MDS Guide for Operators.', 'If you need more information, please use the CAN-MDS Guide for Operators.', 2),
(71, 'Continue with the record', 'Continue with the record', 2),
(72, 'Please, insert Child’s ID provided to you by the Administrator', 'Please, insert Child’s ID provided to you by the Administrator', 2),
(73, 'NOT KNOW CHILD\'S ID', 'NOT KNOW CHILD\'S ID', 2),
(74, 'The Child’s ID you provided is referred to an', 'The Child’s ID you provided is referred to an', 2),
(75, 'UNKNOWN CHILD', 'UNKNOWN CHILD', 2),
(76, 'NEW CHILD RECORD', 'NEW CHILD RECORD', 2),
(77, 'NEW INCIDENT RECORD', 'NEW INCIDENT RECORD', 2),
(78, 'You are going to proceed with the record of a new case of (alleged) child maltreatment.', 'You are going to proceed with the record of a new case of (alleged) child maltreatment.', 2),
(79, 'Please proceed with recording of', 'Please proceed with recording of', 2),
(80, '-incident related variables', '-incident related variables', 2),
(81, '-child related variables', '-child related variables', 2),
(82, '-family related variables', '-family related variables', 2),
(83, '-services related variables', '-services related variables', 2),
(84, 'Please record the referred Date of Incident', 'Please record the referred Date of Incident', 2),
(85, 'Unknown', 'Unknown', 2),
(86, 'A \"distinct\" event took place – Not continuous maltreatment', 'A \"distinct\" event took place – Not continuous maltreatment', 2),
(87, 'YYYY', 'YYYY', 2),
(88, 'MM', 'MM', 2),
(89, 'DD', 'DD', 2),
(90, 'Continuous maltreatment – including \"distinct event(s)\"', 'Continuous maltreatment – including \"distinct event(s)\"', 2),
(91, 'start date', 'start date', 2),
(92, 'duration', 'duration', 2),
(93, 'Years', 'Years', 2),
(94, 'Months', 'Months', 2),
(95, 'Days', 'Days', 2),
(96, 'During the last 12 months', 'During the last 12 months', 2),
(97, 'Before the last 12 months', 'Before the last 12 months', 2),
(98, 'Lifelong', 'Lifelong', 2),
(99, 'Last known CM incident date', 'Last known CM incident date', 2),
(100, 'Continuous maltreatment - No \"distinct event\" took place', 'Continuous maltreatment - No \"distinct event\" took place', 2),
(101, 'GO -> R4', 'GO -> R4', 2),
(102, 'Click to open sub-list', 'Click to open sub-list', 2),
(103, 'Complete as precisely as possible YYYY-MM-DD', 'Complete as precisely as possible YYYY-MM-DD', 2),
(104, 'Neglect/other abuse taking place over a longer period', 'Neglect/other abuse taking place over a longer period', 2),
(105, 'Check ONE in the sub-list', 'Check ONE in the sub-list', 2),
(106, 'Click to close sub-list', 'Click to close sub-list', 2),
(107, 'approximately', 'approximately', 2),
(108, 'or less', 'or less', 2),
(109, 'Wrong date', 'Wrong date', 2),
(110, 'year', 'year', 2),
(111, 'month', 'month', 2),
(112, 'day', 'day', 2),
(113, 'One day', 'One day', 2),
(114, 'Please record the Source of Information', 'Please record the Source of Information', 2),
(115, 'Unspecified', 'Unspecified', 2),
(116, 'Identified (via routine screening)', 'Identified (via routine screening)', 2),
(117, 'Child (alleged) victim', 'Child (alleged) victim', 2),
(118, 'Parent /foster parent/ parent’s partner/ care provider', 'Parent /foster parent/ parent’s partner/ care provider', 2),
(119, 'Relative (siblings, grandparents, etc.) living with the child', 'Relative (siblings, grandparents, etc.) living with the child', 2),
(120, 'Relative (siblings, grandparents, etc.) not living with the child', 'Relative (siblings, grandparents, etc.) not living with the child', 2),
(121, 'Friend / Neighbor', 'Friend / Neighbor', 2),
(122, 'Self-reported as (alleged) perpetrator', 'Self-reported as (alleged) perpetrator', 2),
(123, 'School /preschool /kindergarten personnel', 'School /preschool /kindergarten personnel', 2),
(124, 'Leisure activity staff (e.g., scout leader, clergy, sport coach)', 'Leisure activity staff (e.g., scout leader, clergy, sport coach)', 2),
(125, 'Anonymous reporter', 'Anonymous reporter', 2),
(126, 'Personnel working in Child day care services', 'Personnel working in Child day care services', 2),
(127, 'Personnel working in Social Services/ Public–Central/Local', 'Personnel working in Social Services/ Public–Central/Local', 2),
(128, 'Personnel working in Health services', 'Personnel working in Health services', 2),
(129, 'Personnel working in Mental Health Services', 'Personnel working in Mental Health Services', 2),
(130, 'Personnel working in Ordinary/Juvenile Court and related services', 'Personnel working in Ordinary/Juvenile Court and related services', 2),
(131, 'Personnel working in Police /low enforcement', 'Personnel working in Police /low enforcement', 2),
(132, 'Personnel working in Helpline', 'Personnel working in Helpline', 2),
(133, 'Personnel working in Community agency including agencies working against DV', 'Personnel working in Community agency including agencies working against DV', 2),
(134, 'Personnel working in Ombudsman', 'Personnel working in Ombudsman', 2),
(135, 'Personnel working in NGOs/associations', 'Personnel working in NGOs/associations', 2),
(136, 'Personnel working in services for people with disabilities', 'Personnel working in services for people with disabilities', 2),
(137, 'Other', 'Other', 2),
(138, 'GO -> I3', 'GO -> I3', 2),
(139, 'Check ONE from the list', 'Check ONE from the list', 2),
(140, 'Please record the Form(s) of Maltreatment', 'Please record the Form(s) of Maltreatment', 2),
(141, 'Form(s) of Maltreatment', 'Form(s) of Maltreatment', 2),
(142, 'Expand/Collapse list', 'Expand/Collapse list', 2),
(143, 'Check as many as applicable. By selecting from child menu, broad categories are auto-selected.', 'Check as many as applicable. By selecting from child menu, broad categories are auto-selected.', 2),
(144, 'Please provide as detailed as possible information (by using sub-menus).', 'Please provide as detailed as possible information (by using sub-menus).', 2),
(145, 'Acts Committed', 'Acts Committed', 2),
(146, 'Violent acts against self /Self-harm actions', 'Violent acts against self /Self-harm actions', 2),
(147, 'Eating disorder', 'Eating disorder', 2),
(148, 'Substance use/ abuse', 'Substance use/ abuse', 2),
(149, 'Runaway', 'Runaway', 2),
(150, 'Self-inflicted injuries', 'Self-inflicted injuries', 2),
(151, 'Suicidal thoughts', 'Suicidal thoughts', 2),
(152, 'Suicide attempt', 'Suicide attempt', 2),
(153, 'Actual suicide', 'Actual suicide', 2),
(154, 'Other self-harm action (unspecified)', 'Other self-harm action (unspecified)', 2),
(155, 'Physical violence acts committed [with or without injury]', 'Physical violence acts committed [with or without injury]', 2),
(156, 'Physical violent acts/ corporal punishment/ “disciplines”', 'Physical violent acts/ corporal punishment/ “disciplines”', 2),
(157, 'Slapping', 'Slapping', 2),
(158, 'Smacking', 'Smacking', 2),
(159, 'Spanking', 'Spanking', 2),
(160, 'Pinching', 'Pinching', 2),
(161, 'Twisting ear(s)', 'Twisting ear(s)', 2),
(162, 'Pulling hair', 'Pulling hair', 2),
(163, 'Hitting with an object', 'Hitting with an object', 2),
(164, 'Beating', 'Beating', 2),
(165, 'Tying up or tying to something /restraining to cloth sacks', 'Tying up or tying to something /restraining to cloth sacks', 2),
(166, 'Locking up', 'Locking up', 2),
(167, 'Leaving child to lie in their own excrement', 'Leaving child to lie in their own excrement', 2),
(168, 'Pushing', 'Pushing', 2),
(169, 'Throwing', 'Throwing', 2),
(170, 'Shaking', 'Shaking', 2),
(171, 'Grabbing', 'Grabbing', 2),
(172, 'Choking', 'Choking', 2),
(173, 'Squeezing neck', 'Squeezing neck', 2),
(174, 'Kicking', 'Kicking', 2),
(175, 'Hitting on head (with hand or against the wall)', 'Hitting on head (with hand or against the wall)', 2),
(176, 'Boxing ear', 'Boxing ear', 2),
(177, 'Scratching', 'Scratching', 2),
(178, 'Biting', 'Biting', 2),
(179, 'Burning', 'Burning', 2),
(180, 'Scalding', 'Scalding', 2),
(181, 'Violent acts known also as harmful practices', 'Violent acts known also as harmful practices', 2),
(182, 'Hitting on the soles of the feet', 'Hitting on the soles of the feet', 2),
(183, 'Forcing to ingest spicy food', 'Forcing to ingest spicy food', 2),
(184, 'Forced feeding', 'Forced feeding', 2),
(185, 'Forcing children to stay in uncomfortable positions', 'Forcing children to stay in uncomfortable positions', 2),
(186, 'Binding', 'Binding', 2),
(187, 'Inflicting scars/ scarring', 'Inflicting scars/ scarring', 2),
(188, 'Teeth extraction as punishment', 'Teeth extraction as punishment', 2),
(189, 'Branding', 'Branding', 2),
(190, 'Fattening', 'Fattening', 2),
(191, '“Retribution” acts of violence', '“Retribution” acts of violence', 2),
(192, 'Virginity testing (inspecting girls’ genitalia)', 'Virginity testing (inspecting girls’ genitalia)', 2),
(193, 'Forced circumcision', 'Forced circumcision', 2),
(194, 'Female genital mutilation', 'Female genital mutilation', 2),
(195, 'Uvulectomy', 'Uvulectomy', 2),
(196, 'Forced marriage and early marriage', 'Forced marriage and early marriage', 2),
(197, 'Violent and degrading initiation rites / “hazing”', 'Violent and degrading initiation rites / “hazing”', 2),
(198, 'Practices as “exorcism” after accusations of “witchcraft”', 'Practices as “exorcism” after accusations of “witchcraft”', 2),
(199, 'Forced sterilization, particularly girls', 'Forced sterilization, particularly girls', 2),
(200, 'Violence in the guise of treatment', 'Violence in the guise of treatment', 2),
(201, 'Deliberate infliction of disabilities for exploiting/begging', 'Deliberate infliction of disabilities for exploiting/begging', 2),
(202, 'Acts of life threatening maltreatment', 'Acts of life threatening maltreatment', 2),
(203, 'Administering unnecessary invasive medical procedures', 'Administering unnecessary invasive medical procedures', 2),
(204, 'Administering non prescribed substances', 'Administering non prescribed substances', 2),
(205, 'Child has been given poison', 'Child has been given poison', 2),
(206, 'Threatening with a knife (also psychological abuse)', 'Threatening with a knife (also psychological abuse)', 2),
(207, 'Threatening with a gun (also psychological abuse)', 'Threatening with a gun (also psychological abuse)', 2),
(208, 'Stabbing', 'Stabbing', 2),
(209, 'Shooting', 'Shooting', 2),
(210, 'Dowry-related violence/death (also harmful practice)', 'Dowry-related violence/death (also harmful practice)', 2),
(211, '“Honour” crimes (also harmful practice)', '“Honour” crimes (also harmful practice)', 2),
(212, 'Abduction-related acts', 'Abduction-related acts', 2),
(213, 'Non-family abduction', 'Non-family abduction', 2),
(214, 'Family abduction', 'Family abduction', 2),
(215, 'Institutional and system violations of child rights', 'Institutional and system violations of child rights', 2),
(216, 'Caning', 'Caning', 2),
(217, 'Flogging', 'Flogging', 2),
(218, 'Stoning', 'Stoning', 2),
(219, 'Torture (all forms)', 'Torture (all forms)', 2),
(220, 'Amputations', 'Amputations', 2),
(221, 'Imposing of death sentence for crimes committed', 'Imposing of death sentence for crimes committed', 2),
(222, 'Other described physical acts', 'Other described physical acts', 2),
(223, 'No specific information for reported/suspected physical violence', 'No specific information for reported/suspected physical violence', 2),
(224, 'Sexual violence acts committed [with or without injury]', 'Sexual violence acts committed [with or without injury]', 2),
(225, 'Sexual violence acts', 'Sexual violence acts', 2),
(226, 'Acts involving penetration (intrusion)', 'Acts involving penetration (intrusion)', 2),
(227, 'Without force', 'Without force', 2),
(228, 'anus', 'anus', 2),
(229, 'vulva', 'vulva', 2),
(230, 'mouth', 'mouth', 2),
(231, 'Involving use of force', 'Involving use of force', 2),
(232, 'Attempted sexual abuse (not involving penetration)', 'Attempted sexual abuse (not involving penetration)', 2),
(233, 'with physical contact', 'with physical contact', 2),
(234, 'without physical contact', 'without physical contact', 2),
(235, 'Threatened sexual abuse', 'Threatened sexual abuse', 2),
(236, 'Touching/fondling genitals', 'Touching/fondling genitals', 2),
(237, 'Showing genitals to child', 'Showing genitals to child', 2),
(238, 'Sexual harassment', 'Sexual harassment', 2),
(239, 'Voyeurism /spying on the children intimate behaviours', 'Voyeurism /spying on the children intimate behaviours', 2),
(240, 'Providing sexually explicit materials', 'Providing sexually explicit materials', 2),
(241, 'Forced exposure to pornography', 'Forced exposure to pornography', 2),
(242, 'Forcing to witness sexual violence against mother', 'Forcing to witness sexual violence against mother', 2),
(243, 'Sexual “luring” (via ICT)', 'Sexual “luring” (via ICT)', 2),
(244, 'Online sexual stalking /harassment', 'Online sexual stalking /harassment', 2),
(245, 'Other Sexual violence acts', 'Other Sexual violence acts', 2),
(246, 'Sexual exploitation acts', 'Sexual exploitation acts', 2),
(247, 'Child prostitution', 'Child prostitution', 2),
(248, 'Use of children in commercial sexual exploitation', 'Use of children in commercial sexual exploitation', 2),
(249, 'Sexual exploitation in travel and tourism', 'Sexual exploitation in travel and tourism', 2),
(250, 'Sexual slavery', 'Sexual slavery', 2),
(251, 'Sale of children for sexual purposes', 'Sale of children for sexual purposes', 2),
(252, 'Trafficking (within and between countries)', 'Trafficking (within and between countries)', 2),
(253, 'Involvement in pornography', 'Involvement in pornography', 2),
(254, 'Other sexual exploitation acts (unspecified)', 'Other sexual exploitation acts (unspecified)', 2),
(255, 'No specific information for reported/suspected sexual violence', 'No specific information for reported/suspected sexual violence', 2),
(256, 'Psychological violence acts committed [with or without injury]', 'Psychological violence acts committed [with or without injury]', 2),
(257, 'Violent acts with or without obvious consequences', 'Violent acts with or without obvious consequences', 2),
(258, 'Bullying/ Psychological bullying and hazing', 'Bullying/ Psychological bullying and hazing', 2),
(259, 'by other children', 'by other children', 2),
(260, 'by adults', 'by adults', 2),
(261, 'Homophobic bullying /related to sexual orientation', 'Homophobic bullying /related to sexual orientation', 2),
(262, 'Cyber bullying (via ICTs / mobile phones /Internet)', 'Cyber bullying (via ICTs / mobile phones /Internet)', 2),
(263, 'Ignoring and favoritism', 'Ignoring and favoritism', 2),
(264, 'Denying emotional responsiveness', 'Denying emotional responsiveness', 2),
(265, 'Over protection', 'Over protection', 2),
(266, 'Isolation (social)', 'Isolation (social)', 2),
(267, 'Close confinement (tying/binding)', 'Close confinement (tying/binding)', 2),
(268, 'Placement in solitary confinement', 'Placement in solitary confinement', 2),
(269, 'Degrading /inhuman conditions of detention', 'Degrading /inhuman conditions of detention', 2),
(270, 'Humiliation /Insults, name-calling, belittling, ridiculing', 'Humiliation /Insults, name-calling, belittling, ridiculing', 2),
(271, 'Humiliation via ICT', 'Humiliation via ICT', 2),
(272, 'Rejection and Spurning', 'Rejection and Spurning', 2),
(273, 'Verbal assaults', 'Verbal assaults', 2),
(274, 'Terrorization / Scaring', 'Terrorization / Scaring', 2),
(275, 'Threats of sexual violence (with or without contact)', 'Threats of sexual violence (with or without contact)', 2),
(276, 'Threats of other maltreatment', 'Threats of other maltreatment', 2),
(277, 'Other related acts hurting child’s feelings', 'Other related acts hurting child’s feelings', 2),
(278, 'Exploitation related psychological violent acts', 'Exploitation related psychological violent acts', 2),
(279, 'Exploiting and corrupting', 'Exploiting and corrupting', 2),
(280, 'Labour/economic exploitation', 'Labour/economic exploitation', 2),
(281, 'Forcing to undertake adult\'s responsibilities/parent’s role', 'Forcing to undertake adult\'s responsibilities/parent’s role', 2),
(282, 'Forcing to begging', 'Forcing to begging', 2),
(283, 'Forcing to participate in religious ritual', 'Forcing to participate in religious ritual', 2),
(284, 'Forcing to participate in a violent political event', 'Forcing to participate in a violent political event', 2),
(285, 'No specific info for reported/suspected exploitation acts', 'No specific info for reported/suspected exploitation acts', 2),
(286, 'Exposure related psychological violent acts', 'Exposure related psychological violent acts', 2),
(287, 'Exposure to any kind of violence in the family / DV', 'Exposure to any kind of violence in the family / DV', 2),
(288, 'Exposure to violence against other children', 'Exposure to violence against other children', 2),
(289, 'Exposure to intimate partner violence', 'Exposure to intimate partner violence', 2),
(290, 'Exposure to violence against other adults', 'Exposure to violence against other adults', 2),
(291, 'Exposition to the homicide of a significant person', 'Exposition to the homicide of a significant person', 2),
(292, 'Exposure to a violent environment outside the family', 'Exposure to a violent environment outside the family', 2),
(293, 'Exposure to violence via electronic means', 'Exposure to violence via electronic means', 2),
(294, 'information and communication technologies', 'information and communication technologies', 2),
(295, 'in the mass media', 'in the mass media', 2),
(296, 'No specific info for reported/suspected related exposure', 'No specific info for reported/suspected related exposure', 2),
(297, 'No specific info for reported/suspected psych/l abuse violent acts', 'No specific info for reported/suspected psych/l abuse violent acts', 2),
(298, 'Omissions', 'Omissions', 2),
(299, 'Omissions in child’s care / Neglect', 'Omissions in child’s care / Neglect', 2),
(300, 'Emotional neglect related omissions', 'Emotional neglect related omissions', 2),
(301, 'Persistent ignoring of the child’s emotional needs/ Chronic inattention to the child', 'Persistent ignoring of the child’s emotional needs/ Chronic inattention to the child', 2),
(302, 'Psychologically “unavailable” caregivers', 'Psychologically “unavailable” caregivers', 2),
(303, 'Inappropriately advanced expectations (def.  According to child’s characteristics)', 'Inappropriately advanced expectations (def.  According to child’s characteristics)', 2),
(304, 'No specific information for omissions related to emotional neglect', 'No specific information for omissions related to emotional neglect', 2),
(305, 'Physical neglect related omissions', 'Physical neglect related omissions', 2),
(306, 'Inadequate / inappropriate nutrition', 'Inadequate / inappropriate nutrition', 2),
(307, 'Inadequate / inappropriate personal hygiene', 'Inadequate / inappropriate personal hygiene', 2),
(308, 'Inadequate / inappropriate clothing', 'Inadequate / inappropriate clothing', 2),
(309, 'Inadequate / inappropriate shelter', 'Inadequate / inappropriate shelter', 2),
(310, 'No specific information for omissions related child’s physical needs', 'No specific information for omissions related child’s physical needs', 2),
(311, 'Medical neglect related omissions', 'Medical neglect related omissions', 2),
(312, 'Refusal to provide preventive health care (vaccinations, vision, and dental care)', 'Refusal to provide preventive health care (vaccinations, vision, and dental care)', 2),
(313, 'Refusal to allow /provide needed medical care for diagnosed health condition/ impairment', 'Refusal to allow /provide needed medical care for diagnosed health condition/ impairment', 2),
(314, 'Unjustified delay to seek needed care', 'Unjustified delay to seek needed care', 2),
(315, 'Failure to provide with basic medical care', 'Failure to provide with basic medical care', 2),
(316, 'Withholding essential medical care', 'Withholding essential medical care', 2),
(317, 'No specific information for omissions related child’s medical needs', 'No specific information for omissions related child’s medical needs', 2),
(318, 'Educational neglect related omissions', 'Educational neglect related omissions', 2),
(319, 'Persistent failure to register child at the school', 'Persistent failure to register child at the school', 2),
(320, 'Has not attended school at all', 'Has not attended school at all', 2),
(321, 'Dropped out', 'Dropped out', 2),
(322, 'Persistent failure to enrol at the school resulting to irregular school attendance', 'Persistent failure to enrol at the school resulting to irregular school attendance', 2),
(323, 'compulsory school', 'compulsory school', 2),
(324, 'non compulsory (ECEC)', 'non compulsory (ECEC)', 2),
(325, 'Chronic truancy', 'Chronic truancy', 2),
(326, 'Refusal to attend special educational needs', 'Refusal to attend special educational needs', 2),
(327, 'Refusal to allow needed attention to special educational needs', 'Refusal to allow needed attention to special educational needs', 2),
(328, 'Refusal to provide needed attention to special educational needs', 'Refusal to provide needed attention to special educational needs', 2),
(329, 'No specific information for omissions related child’s educational needs', 'No specific information for omissions related child’s educational needs', 2),
(330, 'Risk exposure related omissions', 'Risk exposure related omissions', 2),
(331, 'Exposure to hazardous/ dangerous environments', 'Exposure to hazardous/ dangerous environments', 2),
(332, 'Inside household', 'Inside household', 2),
(333, 'Outside home', 'Outside home', 2),
(334, 'Exposure to substances use/misuse by others', 'Exposure to substances use/misuse by others', 2),
(335, 'Alcohol', 'Alcohol', 2),
(336, 'Drugs', 'Drugs', 2),
(337, 'Other substances', 'Other substances', 2),
(338, 'No specific information for reported/ suspected omissions for exposure to risks', 'No specific information for reported/ suspected omissions for exposure to risks', 2),
(339, 'Supervision related omissions', 'Supervision related omissions', 2),
(340, 'Inadequate/ lack of supervision resulting in physical harm', 'Inadequate/ lack of supervision resulting in physical harm', 2),
(341, 'Persisted lack of supervision concerning substance use/misuse by the child', 'Persisted lack of supervision concerning substance use/misuse by the child', 2),
(342, 'No specific information for omissions related to the child’s supervision', 'No specific information for omissions related to the child’s supervision', 2),
(343, 'Refusal of custody/abandonment', 'Refusal of custody/abandonment', 2),
(344, 'Unstable custody arrangements', 'Unstable custody arrangements', 2),
(345, 'Illegal transfers of custody', 'Illegal transfers of custody', 2),
(346, 'Refusal of custody', 'Refusal of custody', 2),
(347, 'Abandonment (primary caregiver(s) runaway / migrate and leave the children behind)', 'Abandonment (primary caregiver(s) runaway / migrate and leave the children behind)', 2),
(348, 'children out of wedlock', 'children out of wedlock', 2),
(349, 'children with disabilities', 'children with disabilities', 2),
(350, 'No specific information for omissions related child’s refusal of custody', 'No specific information for omissions related child’s refusal of custody', 2),
(351, 'Please record the Place of Incident', 'Please record the Place of Incident', 2),
(352, 'Unknown/ Unspecified place', 'Unknown/ Unspecified place', 2),
(353, 'Home/ Family', 'Home/ Family', 2),
(354, 'Home/ Relatives', 'Home/ Relatives', 2),
(355, 'Home/ Friends', 'Home/ Friends', 2),
(356, 'Child care institution (residential care)', 'Child care institution (residential care)', 2),
(357, 'Child care institution (day care)', 'Child care institution (day care)', 2),
(358, 'Detention or correctional institution', 'Detention or correctional institution', 2),
(359, 'Leisure/ Playground/ Recreational area', 'Leisure/ Playground/ Recreational area', 2),
(360, 'Sports-athletics', 'Sports-athletics', 2),
(361, 'School', 'School', 2),
(362, 'Educational institution', 'Educational institution', 2),
(363, 'Medical Services', 'Medical Services', 2),
(364, 'Public transportation', 'Public transportation', 2),
(365, 'Public place/ street, commercial & surrounding area', 'Public place/ street, commercial & surrounding area', 2),
(366, 'Other place', 'Other place', 2),
(367, 'GO -> C2', 'GO -> C2', 2),
(368, 'Click as many as applicable', 'Click as many as applicable', 2),
(369, 'Please record Child’s Sex, Date of Birth and Citizenship Status', 'Please record Child’s Sex, Date of Birth and Citizenship Status', 2),
(370, 'Male', 'Male', 2),
(371, 'Female', 'Female', 2),
(372, 'Not known', 'Not known', 2),
(373, 'Check ONE from the list below', 'Check ONE from the list below', 2),
(374, 'Child’s Date of Birth', 'Child’s Date of Birth', 2),
(375, '<18 years old (if no year is known)', '<18 years old (if no year is known)', 2),
(376, '<18 years old', '<18 years old', 2),
(377, '>18 (\"minor\" according to legislation)', '>18 (\"minor\" according to legislation)', 2),
(378, '>18 years old', '>18 years old', 2),
(379, 'Unborn', 'Unborn', 2),
(380, 'Please record the full date of birth:', 'Please record the full date of birth:', 2),
(381, 'YYYY-MM-DD', 'YYYY-MM-DD', 2),
(382, 'If DD is unknown:', 'If DD is unknown:', 2),
(383, 'YYYY-MM', 'YYYY-MM', 2),
(384, 'If MM-DD are unknown:', 'If MM-DD are unknown:', 2),
(385, 'If YYYY-MM-DD are unknown AND the alleged victim is a child:', 'If YYYY-MM-DD are unknown AND the alleged victim is a child:', 2),
(386, '<18', '<18', 2),
(387, 'Citizenship Status', 'Citizenship Status', 2),
(388, 'Not a citizen', 'Not a citizen', 2),
(389, 'Citizen', 'Citizen', 2),
(390, 'with ID', 'with ID', 2),
(391, 'Citizen with ID', 'Citizen with ID', 2),
(392, 'without ID', 'without ID', 2),
(393, 'Citizen without ID', 'Citizen without ID', 2),
(394, 'Unaccompanied foreign child or refugee', 'Unaccompanied foreign child or refugee', 2),
(395, 'Check ONE from the list below. If the child is “Citizen”, please define in sub-list', 'Check ONE from the list below. If the child is “Citizen”, please define in sub-list', 2),
(396, 'Please record Family Composition and indicate up to two Primary Caregivers', 'Please record Family Composition and indicate up to two Primary Caregivers', 2),
(397, 'A: Type of Family', 'A: Type of Family', 2),
(398, 'Boarder(s) (child lives in residential/institutional care)', 'Boarder(s) (child lives in residential/institutional care)', 2),
(399, 'Child lives with his/her family (including biological/ adoptive)', 'Child lives with his/her family (including biological/ adoptive)', 2),
(400, 'Child lives in a foster family', 'Child lives in a foster family', 2),
(401, 'Child lives in a re-composed family', 'Child lives in a re-composed family', 2),
(402, 'Child lives in a family other than its family/ foster family', 'Child lives in a family other than its family/ foster family', 2),
(403, 'Relatives’ family', 'Relatives’ family', 2),
(404, 'Child lives in a family other than its family/ foster family - Relatives’ family', 'Child lives in a family other than its family/ foster family - Relatives’ family', 2),
(405, 'Friends’ family', 'Friends’ family', 2),
(406, 'Child lives in a family other than its family/ foster family - Friends’ family', 'Child lives in a family other than its family/ foster family - Friends’ family', 2),
(407, 'SKIP “B”; GO -> F3', 'SKIP “B”; GO -> F3', 2),
(408, 'If you DON\'T chose Boarder(s) -> B: Members of Family', 'If you DON\'T chose Boarder(s) -> B: Members of Family', 2),
(409, 'B: Member(s) of Family', 'B: Member(s) of Family', 2),
(410, 'Number', 'Number', 2),
(411, 'Primary caregiver(s)', 'Primary caregiver(s)', 2),
(412, 'Parent(s)', 'Parent(s)', 2),
(413, 'Step Parent(s)', 'Step Parent(s)', 2),
(414, 'Parent(s)’ partner(s)', 'Parent(s)’ partner(s)', 2),
(415, 'Sibling(s)', 'Sibling(s)', 2),
(416, 'Younger than the (alleged) victim', 'Younger than the (alleged) victim', 2),
(417, 'Older than the (alleged) victim (<18)', 'Older than the (alleged) victim (<18)', 2),
(418, 'Older than the (alleged) victim (>18)', 'Older than the (alleged) victim (>18)', 2),
(419, 'Grandparent(s)', 'Grandparent(s)', 2),
(420, 'Other relative(s)', 'Other relative(s)', 2),
(421, 'Blood relatives', 'Blood relatives', 2),
(422, '<18 [child(ren)]', '<18 [child(ren)]', 2),
(423, '>18 [adult(s)]', '>18 [adult(s)]', 2),
(424, 'By law relatives', 'By law relatives', 2),
(425, 'Family friend(s)', 'Family friend(s)', 2),
(426, 'Other not-related household members', 'Other not-related household members', 2),
(427, 'Please indicate up to 2 child’s primary caregiver(s) (you can uncheck)', 'Please indicate up to 2 child’s primary caregiver(s) (you can uncheck)', 2),
(428, 'members', 'members', 2),
(429, 'member family', 'member family', 2),
(430, 'Please record Caregiver(s) Relationship to Child, Sex and Date of Birth', 'Please record Caregiver(s) Relationship to Child, Sex and Date of Birth', 2),
(431, 'Relationship to Child', 'Relationship to Child', 2),
(432, '1st Caregiver', '1st Caregiver', 2),
(433, 'Professional Caregiver', 'Professional Caregiver', 2),
(434, 'Temporary caregiver/Other', 'Temporary caregiver/Other', 2),
(435, 'Unknown relationship', 'Unknown relationship', 2),
(436, 'Check ONE per Caregiver', 'Check ONE per Caregiver', 2),
(437, 'Caregiver(s) Sex', 'Caregiver(s) Sex', 2),
(438, 'Caregiver(s) DoB', 'Caregiver(s) DoB', 2),
(439, 'YY', 'YY', 2),
(440, '\'s', '\'s', 2),
(441, 'YY-MM-DD', 'YY-MM-DD', 2),
(442, 'If YYYY-MM-DD are unknown then record the decade:', 'If YYYY-MM-DD are unknown then record the decade:', 2),
(443, 'If DECADE is unknown, then:', 'If DECADE is unknown, then:', 2),
(444, 'Please record any Institutional Response', 'Please record any Institutional Response', 2),
(445, 'No response was required DUE TO CHILD’S DEATH', 'No response was required DUE TO CHILD’S DEATH', 2),
(446, 'No Response', 'No Response', 2),
(447, 'Yes', 'Yes', 2),
(448, 'Immediate intervention(s)', 'Immediate intervention(s)', 2),
(449, 'Physical Medical exam(s)', 'Physical Medical exam(s)', 2),
(450, 'Mental Health exam(s)', 'Mental Health exam(s)', 2),
(451, 'Forensic evaluation initiated', 'Forensic evaluation initiated', 2),
(452, 'Child protection /welfare services assessment', 'Child protection /welfare services assessment', 2),
(453, 'Police intervention', 'Police intervention', 2),
(454, 'Action taken -NO COURT INVOLVEMENT', 'Action taken -NO COURT INVOLVEMENT', 2),
(455, 'Child remains in family with planned intervention', 'Child remains in family with planned intervention', 2),
(456, 'Emergency placement', 'Emergency placement', 2),
(457, 'Supportive intervention for current caregiver(s)', 'Supportive intervention for current caregiver(s)', 2),
(458, 'Mother/child shelter with parent and child together', 'Mother/child shelter with parent and child together', 2),
(459, 'Police emergency protection procedures', 'Police emergency protection procedures', 2),
(460, 'CPS/welfare services emergency protection procedures', 'CPS/welfare services emergency protection procedures', 2),
(461, 'Referral to child protection /welfare services', 'Referral to child protection /welfare services', 2),
(462, 'Action taken -COURT or EQUIVALENT AUTHORITY TO THE COURT INVOLVEMENT', 'Action taken -COURT or EQUIVALENT AUTHORITY TO THE COURT INVOLVEMENT', 2),
(463, '(Family) Court measures initiated', '(Family) Court measures initiated', 2),
(464, 'Action to protect victim by court order(s)', 'Action to protect victim by court order(s)', 2),
(465, 'Action to remove parent(s)’ rights', 'Action to remove parent(s)’ rights', 2),
(466, 'Expulsion of (alleged) abuser from home', 'Expulsion of (alleged) abuser from home', 2),
(467, 'Action to prosecute perpetrator(s)', 'Action to prosecute perpetrator(s)', 2),
(468, 'Out of home placement', 'Out of home placement', 2),
(469, 'Kinship Care (relatives/extended family)', 'Kinship Care (relatives/extended family)', 2),
(470, 'Foster Care', 'Foster Care', 2),
(471, 'Children’s Home Institution', 'Children’s Home Institution', 2),
(472, 'Adoption with parents’ agreement', 'Adoption with parents’ agreement', 2),
(473, 'Adoption by court order', 'Adoption by court order', 2),
(474, 'GO -> S2', 'GO -> S2', 2),
(475, 'Check below as many as applicable', 'Check below as many as applicable', 2),
(476, 'Please record any Referral(s) made to Services by you/your agency', 'Please record any Referral(s) made to Services by you/your agency', 2),
(477, 'None', 'None', 2),
(478, 'Judicial Services', 'Judicial Services', 2),
(479, 'for child ONLY', 'for child ONLY', 2),
(480, 'for caregiver(s) ONLY', 'for caregiver(s) ONLY', 2),
(481, 'for child AND family', 'for child AND family', 2),
(482, 'Mental Health Services', 'Mental Health Services', 2),
(483, 'Independent Authorities', 'Independent Authorities', 2),
(484, 'Social Welfare Services', 'Social Welfare Services', 2),
(485, 'Law Enforcement related Services', 'Law Enforcement related Services', 2),
(486, 'Community Organizations and NGOs', 'Community Organizations and NGOs', 2),
(487, 'Existing Registries and Research Organizations', 'Existing Registries and Research Organizations', 2),
(488, 'Educational Services', 'Educational Services', 2),
(489, 'Other related Services', 'Other related Services', 2),
(490, 'End of Record', 'End of Record', 2),
(491, 'CHECK RECORD OPTIONS', 'CHECK RECORD OPTIONS', 2),
(492, 'Please check the record options', 'Please check the record options', 2),
(493, 'You can make any changes by navigating throught the right panel!', 'You can make any changes by navigating throught the right panel!', 2),
(494, 'Incident', 'Incident', 2),
(495, 'ID', 'ID', 2),
(496, 'Sex', 'Sex', 2),
(497, 'Date of birth', 'Date of birth', 2),
(498, 'Family and Caregiver(s)', 'Family and Caregiver(s)', 2),
(499, 'Services', 'Services', 2),
(500, 'Submit Record', 'Submit Record', 2),
(501, 'Loading', 'Loading', 2),
(502, 'RECORD COMPLETED', 'RECORD COMPLETED', 2),
(503, 'Display/print the record', 'Display/print the record', 2),
(504, 'Report', 'Report', 2),
(505, 'RECORD', 'RECORD', 2),
(506, 'Agency', 'Agency', 2),
(507, 'Information provided by', 'Information provided by', 2),
(508, 'Age at the date of incident', 'Age at the date of incident', 2),
(509, 'Age at the date of recording', 'Age at the date of recording', 2),
(510, 'Type of family', 'Type of family', 2),
(511, 'Family\'s member(s)', 'Family\'s member(s)', 2),
(512, '1st', '1st', 2),
(513, 'born', 'born', 2),
(514, '2nd', '2nd', 2),
(515, 'Back', 'Back', 2),
(516, 'KNOWN CHILD', 'KNOWN CHILD', 2),
(517, 'EXISTING CHILD RECORD', 'EXISTING CHILD RECORD', 2),
(518, 'You are going to proceed with the record of a new CM incident for  the child', 'You are going to proceed with the record of a new CM incident for  the child', 2),
(519, 'Please proceed with checking of', 'Please proceed with checking of', 2),
(520, 'TIP: Update –if needed', 'TIP: Update –if needed', 2),
(521, 'Known Incidents', 'Known Incidents', 2),
(522, 'The incident you are trying to record might already exist!', 'The incident you are trying to record might already exist!', 2),
(523, 'Please check the incident record(s) below', 'Please check the incident record(s) below', 2),
(524, 'for Child\'s ID:', 'for Child\'s ID:', 2),
(525, 'and Date of Incident:', 'and Date of Incident:', 2),
(526, 'Date-Time of Record', 'Date-Time of Record', 2),
(527, 'Display', 'Display', 2),
(528, 'Add new incident', 'Add new incident', 2),
(529, 'ENTER Username', 'ΕΙΣΑΓΕΤΕ Username', 1),
(530, 'ENTER Password', 'ΕΙΣΑΓΕΤΕ Password', 1),
(531, 'Log in', 'Είσοδος', 1),
(532, 'MEMO: Meaning of Symbols & Colors', 'ΥΠΟΜΝΗΜΑ: Επεξήγηση Συμβόλων και Χρωματικής Κωδικοποίησης', 1),
(533, 'Auto-Completed variable', 'Η απαραίτητη πληροφορία έχει ήδη συμπληρωθεί από το Σύστημα', 1),
(534, 'Variable already recorded by the Operator', 'Η απαραίτητη πληροφορία έχει ήδη καταγραφεί από τον/την Χρήστη/-στρια', 1),
(535, 'Single selection (mutually exclusive codes)', 'ΜΟΝΑΔΙΚΗ επιλογή (οι διαθέσιμες εναλλακτικές είναι αμοιβαία αποκλειόμενες)', 1),
(536, 'Multiple selection (select as many as applicable)', 'ΠΟΛΛΑΠΛΗ επιλογή (από τις διαθέσιμες εναλλακτικές επιλέγονται όλες όσες ισχύουν)', 1),
(537, 'Open list of sub-codes (drop-down menu)', 'Ανάπτυξη λίστας (αναδυόμενη λίστα)', 1),
(538, 'Close list of sub-codes (drop-down menu)', 'Σύμπτυξη λίστας (αναδυόμενη λίστα)', 1),
(539, 'Instruction to Operator', 'Οδηγία προς τον/την Χρήστη/-στρια', 1),
(540, 'Recorded Variable’s Name', 'Όνομα Στοιχείου Δεδομένων', 1),
(541, 'Codes of Recorded variable', 'Κωδικός Στοιχείου Δεδομένων', 1),
(542, 'Note to Operator for the recording', 'Σημείωση αναφορικά με την καταγραφή', 1),
(543, 'Note to Operator for system’s operations', 'Σημείωση αναφορικά με τη λειτουργία του συστήματος', 1),
(544, 'Automated process (filters etc.)', 'Αυτοματοποιημένη διαδικασία (φίλτρα κ.λπ.)', 1),
(545, 'ALREADY EXISTING ID (can appear in CHILD’S ID AND in INCIDENT ID)', 'ΗΔΗ ΥΠΑΡΧΟΝ ID (αναγνωριστικό). Μπορεί να εμφανιστεί στα πεδία ID Παιδιού και ID Περιστατικού', 1),
(546, 'Skip', 'Συνέχεια', 1),
(547, 'Start Page', 'Αρχική Σελίδα', 1),
(548, 'Operator\'s Panel', 'Εργαλεία Διαχείρισης', 1),
(549, 'my account', 'ο λογαριασμός μου', 1),
(550, 'Contact Details', 'Στοιχεία Επικοινωνίας', 1),
(551, 'Change Password', 'Αλλαγή κωδικού πρόσβασης', 1),
(552, 'my previous cases', 'παλιότερα περιστατικά', 1),
(553, 'List of incidents', 'Λίστα Περιστατικών', 1),
(554, 'List of Children’s ID', 'Λίστα Αναγνωριστικών (IDs) Παιδιών', 1),
(555, 'my current cases', 'τρέχοντα περιστατικά', 1),
(556, 'List of temporary Child\'s ID', 'Λίστα προσωρινών αναγνωριστικών (IDs)', 1),
(557, 'Information ', 'Ειδοποιήσεις', 1),
(558, 'New Incident', 'Νέο Περιστατικό', 1),
(559, 'My Profile', 'Ο λογαριασμός μου', 1),
(560, 'Change Pass', 'Αλλαγή κωδικού πρόσβασης', 1),
(561, 'List of Child\'s ID', 'Λίστα αναγνωριστικών παιδιών (IDs)', 1),
(562, 'Log out!', 'Αποσύνδεση!', 1),
(563, 'Welcome', 'Καλώς ήλθατε', 1),
(564, 'New ', 'Νέο', 1),
(565, 'Record Progress', 'Πρόοδος Καταγραφής', 1),
(566, 'Agency\'s ID', 'ID Φορέα', 1),
(567, 'Operator\'s ID', 'Αναγνωριστικό (ID) Χρήστη/-στριας', 1),
(568, 'Child\'s ID', 'ID Παιδιού', 1),
(569, 'Date of Record', 'Ημερομηνία Καταγραφής', 1),
(570, 'Incident\'s ID', 'ID Περιστατικού', 1),
(571, 'Date of Incident', 'Ημερομηνία περιστατικού', 1),
(572, 'Source of Information', 'Πηγή πληροφοριών', 1),
(573, 'Forms of Maltreatment', 'Μορφή/-ες Κακομεταχείρισης', 1),
(574, 'Place of Incident', 'Χώρος στον οποίο έλαβε χώρα το Περιστατικό', 1),
(575, 'Child\'s Sex', 'Φύλο παιδιού', 1),
(576, 'Child\'s DoB', 'Ημερομηνία γέννησης παιδιού', 1),
(577, 'Child\'s Citizenship Status', 'Υπηκοότητα', 1),
(578, 'Family Composition', 'Σύνθεση Οικογένειας', 1),
(579, 'CGs Relationship to Child', 'Σχέση Φροντιστή με παιδί', 1),
(580, 'Caregiver(s)\' Sex', 'Φύλο Φροντιστή/-στριας', 1),
(581, 'Caregiver(s)\' DoB', 'Ημερομηνία γέννησης φροντιστή', 1),
(582, 'Institutional Response', 'Απόκριση του Φορέα', 1),
(583, 'Referral(s) to Services', 'Παραπομπές σε άλλες υπηρεσίες', 1),
(584, 'Agencys\'s ID', 'ID Φορέα', 1),
(585, 'Identity Confirmation', 'Επιβεβαίωση στοιχείων Χρήστη/-στριας', 1),
(586, 'TIP', 'Χρήσιμη Συμβουλή!', 1),
(587, 'If the above information needs update, please contact the CAN-MDS Administration Office.', 'Εάν τα παραπάνω στοιχεία χρειάζονται ενημέρωση, παρακαλούμε επικοινωνήστε με τον Εθνικό Διαχειριστή του CAN-MDS (info@can-via-mds.eu)', 1),
(588, 'Date & Type of Incident', 'Ημερομηνία & Τύπος Περιστατικού', 1),
(589, 'Incident ID', 'Αναγνωριστικό (ID) Περιστατικού', 1),
(590, 'Type Of Record', 'Τύπος Καταγραφής', 1),
(591, 'Type Of Incident', 'Τύπος Περιστατικού', 1),
(592, 'Notifications', 'Ειδοποιήσεις', 1),
(593, 'Subject', 'Θέμα', 1),
(594, 'Message', 'Μήνυμα', 1),
(595, 'Replace ID', 'Αντικατάσταση Προσωρινού Αναγνωριστικού (ID)', 1),
(596, 'WELCOME TO CAN-MDS', 'ΚΑΛΩΣ ΗΡΘΑΤΕ ΣΤΟ CAN-MDS', 1),
(597, 'To proceed with the record, please follow the CAN-MDS Operations’ Protocol.', 'Για να προχωρήσετε με την καταγραφή, συμβουλευτείτε το βήμα-προς-βήμα Πρωτόκολλο Διαδικασιών Καταγραφής.', 1),
(598, 'If you need more information, please use the CAN-MDS Guide for Operators.', 'Για περισσότερες πληροφορίες όσον αφορά τις κωδικοποιημένες απαντήσεις, απευθυνθείτε στον Οδηγό CAN-MDS για τον/την Χρήστη/-στρια.', 1),
(599, 'Continue with the record', 'Συνεχίστε με την καταγραφή', 1),
(600, 'Please, insert Child’s ID provided to you by the Administrator', 'Παρακαλώ εισάγετε τον αναγνωριστικό κωδικό (ID) του Παιδιού που σας δόθηκε από τον Διαχειριστή του συστήματος', 1),
(601, 'NOT KNOW CHILD\'S ID', 'ΠΡΟΣΩΡΙΝΟ ID ΠΑΙΔΙΟΥ', 1),
(602, 'The Child’s ID you provided is referred to an', 'To αναγνωριστικό (ID) του παιδιού που καταχωρήσατε αναφέρεται σε', 1),
(603, 'UNKNOWN CHILD', 'ΑΓΝΩΣΤΗ ΠΕΡΙΠΤΩΣΗ (ΠΑΙΔΙ χωρίς προηγούμενη καταγραφή)', 1),
(604, 'NEW CHILD RECORD', 'ΚΑΤΑΓΡΑΦΗ ΝΕΑΣ ΠΕΡΙΠΤΩΣΗΣ (ΠΑΙΔΙΟΥ χωρίς προηγούμενη καταγραφή)', 1),
(605, 'NEW INCIDENT RECORD', 'ΚΑΤΑΓΡΑΦΗ ΝΕΟΥ ΠΕΡΙΣΤΑΤΙΚΟΥ', 1),
(606, 'You are going to proceed with the record of a new case of (alleged) child maltreatment.', 'Πρόκειται να προχωρήσετε στην καταγραφή νέας περίπτωσης παιδιού (πιθανού)-θύματος κακομεταχείρισης', 1),
(607, 'Please proceed with recording of', 'Συνεχίστε καταγράφοντας τα παρακάτω', 1),
(608, '-incident related variables', '-στοιχεία δεδομένων που σχετίζονται με το περιστατικό', 1),
(609, '-child related variables', '-στοιχεία δεδομένων που σχετίζονται με το παιδί', 1),
(610, '-family related variables', '-στοιχεία δεδομένων που σχετίζονται με την οικογένεια', 1),
(611, '-services related variables', '-στοιχεία δεδομένων που σχετίζονται με τις υπηρεσίες', 1),
(612, 'Please record the referred Date of Incident', 'Παρακαλώ καταγράψτε την (αναφερόμενη) ημερομηνία κατά την οποία έλαβε χώρα το περιστατικό', 1),
(613, 'Unknown', 'Άγνωστο', 1),
(614, 'A \"distinct\" event took place – Not continuous maltreatment', 'Ένα \"διακριτό\" περιστατικό έλαβε χώρα - Δεν αναφέρεται συνεχής κακομεταχείριση', 1),
(615, 'YYYY', 'ΕΕΕΕ', 1),
(616, 'MM', 'ΜΜ', 1),
(617, 'DD', 'ΗΗ', 1),
(618, 'Continuous maltreatment – including \"distinct event(s)\"', 'Συνεχής κακομεταχείριση - Αναφέρονται και \"διακριτά περιστατικά\"', 1),
(619, 'start date', 'ημερομηνία έναρξης', 1),
(620, 'duration', 'διάρκεια', 1),
(621, 'Years', 'Έτη', 1),
(622, 'Months', 'Μήνες', 1),
(623, 'Days', 'Ημέρες', 1),
(624, 'During the last 12 months', 'Κατά τη διάρκεια των τελευταίων 12 μηνών', 1),
(625, 'Before the last 12 months', 'Πριν τους 12 τελευταίους μήνες', 1),
(626, 'Lifelong', 'Σε όλη τη διάρκεια της ζωής του παιδιού', 1),
(627, 'Last known CM incident date', 'Ημερομηνία πιο πρόσφατου περιστατικού', 1),
(628, 'Continuous maltreatment - No \"distinct event\" took place', 'Συνεχής κακομεταχείριση - Δεν αναφέρονται \"διακριτά περιστατικά\"', 1),
(629, 'GO -> R4', 'Μετάβαση --> R4', 1),
(630, 'Click to open sub-list', 'Πατήστε εδώ για να ανοίξετε τη λίστα', 1),
(631, 'Complete as precisely as possible YYYY-MM-DD', 'Συμπληρώστε ΕΕΕΕ-ΜΜ-ΗΗ', 1),
(632, 'Neglect/other abuse taking place over a longer period', 'Παραμέληση/άλλη κακοποίηση που λαμβάνει χώρα για μεγάλο χρονικό διάστημα', 1),
(633, 'Check ONE in the sub-list', 'Επιλέξτε ΕΝΑ από τη λίστα που ακολουθεί', 1),
(634, 'Click to close sub-list', 'Σύμπτυξη λίστας', 1),
(635, 'approximately', 'περίπου', 1),
(636, 'or less', 'ή λιγότερο', 1),
(637, 'Wrong date', 'Λανθασμένη ημερομηνία', 1),
(638, 'year', 'έτος', 1),
(639, 'month', 'μήνας', 1),
(640, 'day', 'ημέρα', 1),
(641, 'One day', 'Μία ημέρα', 1),
(642, 'Please record the Source of Information', 'Παρακαλώ καταγράψτε την πηγή των πληροφοριών για το συγκεκριμένο περιστατικό', 1),
(643, 'Unspecified', 'απροσδιόριστο', 1),
(644, 'Identified (via routine screening)', 'Ανιχνεύτηκε από τον/την επαγγελματία του Φορέα που καταγράφει', 1),
(645, 'Child (alleged) victim', 'Το ίδιο το παιδί (αυτο-αναφερόμενο ως) θύμα', 1),
(646, 'Parent /foster parent/ parent’s partner/ care provider', 'Γονέας/ θετός γονέας/ σύντροφος γονέα/ φροντιστής/-στρια', 1),
(647, 'Relative (siblings, grandparents, etc.) living with the child', 'Συγγενικό πρόσωπο (αδελφός/-ή, παππούς/γιαγιά, κλπ) που ζει στο ίδιο σπίτι με το παιδί', 1),
(648, 'Relative (siblings, grandparents, etc.) not living with the child', 'Συγγενικό πρόσωπο (αδελφός/-ή, παππούς/γιαγιά, κλπ) που ΔΕΝ ζει στο ίδιο σπίτι με το παιδί', 1),
(649, 'Friend / Neighbor', 'Φίλος/-η του παιδιού/ της οικογένειας/ Γείτονας/-ισσα', 1),
(650, 'Self-reported as (alleged) perpetrator', 'Ο/η (αυτο-προσδιοριζόμενος/-η) ως δράστης/-στρια της κακομεταχείρισης του παιδιού', 1),
(651, 'School /preschool /kindergarten personnel', 'Επαγγελματίας/ Εργαζόμενος/-η του σχολείου/ νηπιαγωγείου/ άλλης δομής προσχολικής αγωγής', 1),
(652, 'Leisure activity staff (e.g., scout leader, clergy, sport coach)', 'Υπεύθυνος/-η για ψυχαγωγικές ή άλλες δραστηριότητες (όπως αρχηγός προσκόπων, κληρικός, προπονητής/-τρια)', 1),
(653, 'Anonymous reporter', 'Ανώνυμη πηγή (το άτομο που παρέχει τις πληροφορίες θέλει να διατηρήσει την ανωνυμία του)', 1),
(654, 'Personnel working in Child day care services', 'Επαγγελματίας/ Εργαζόμενος/-η σε υπηρεσία/φορέα ημερήσιας φροντίδας παιδιών', 1),
(655, 'Personnel working in Social Services/ Public–Central/Local', 'Επαγγελματίας/ Εργαζόμενος/-η σε Κοινωνική Υπηρεσία Δημόσιου Τομέα (κεντρική ή τοπική)', 1),
(656, 'Personnel working in Health services', 'Επαγγελματίας/ Εργαζόμενος/-η σε υπηρεσία/ οργανισμό/ φορέα Υγείας', 1),
(657, 'Personnel working in Mental Health Services', 'Επαγγελματίας/ Εργαζόμενος/-η σε υπηρεσία/ οργανισμό/ φορέα Ψυχικής Υγείας', 1),
(658, 'Personnel working in Ordinary/Juvenile Court and related services', 'Επαγγελματίας/ Εργαζόμενος/-η σε υπηρεσία του Υπουργείου Δικαιοσύνης και συναφείς υπηρεσίες', 1),
(659, 'Personnel working in Police /low enforcement', 'Επαγγελματίας/ Εργαζόμενος/-η σε υπηρεσία/ τμήμα της Αστυνομίας', 1),
(660, 'Personnel working in Helpline', 'Επαγγελματίας/ Εργαζόμενος/-η σε τηλεφωνκή γραμμή βοήθειας', 1),
(661, 'Personnel working in Community agency including agencies working against DV', 'Επαγγελματίας/ Εργαζόμενος/-η σε κοινοτικό φορέα/ υπηρεσία για ενδοοικογενειακή βία', 1),
(662, 'Personnel working in Ombudsman', 'Επαγγελματίας/ Εργαζόμενος/-η στο Συνήγορο του Πολίτη ή/και στον Κύκλο Δικαιωμάτων του Παιδιού', 1),
(663, 'Personnel working in NGOs/associations', 'Επαγγελματίας/ Εργαζόμενος/-η σε μη κυβερνητικό οργανισμό', 1),
(664, 'Personnel working in services for people with disabilities', 'Επαγγελματίας/ Εργαζόμενος/-η σε υπηρεσία/φορέα για άτομα με ειδικές ανάγκες', 1),
(665, 'Other', 'Άλλο', 1),
(666, 'GO -> I3', 'Μετάβαση -> Ι3', 1),
(667, 'Check ONE from the list', 'Επιλέξτε ΕΝΑ από τη λίστα που ακολουθεί', 1),
(668, 'Please record the Form(s) of Maltreatment', 'Παρακαλώ καταγράψτε κάθε αναφερόμενη/-ες μορφή/-ές κακομεταχείρισης', 1),
(669, 'Form(s) of Maltreatment', 'Μορφή/-ές κακοποίησης', 1);
INSERT INTO `u_translate` (`id`, `text_en`, `text_trans`, `language_id`) VALUES
(670, 'Expand/Collapse list', 'Ανάπτυξη / Σύμπτυξη Λίστας', 1),
(671, 'Check as many as applicable. By selecting from child menu, broad categories are auto-selected.', 'Από τη λίστα που ακολουθεί επιλέξτε όλα όσα ισχύουν. Η επιλογή με βάση τις υποκατηγορίες αυτόματα οδηγεί στην επιλογή των γενικότερων κατηγοριών.', 1),
(672, 'Please provide as detailed as possible information (by using sub-menus).', 'Παρακαλώ συμπληρώστε όσο το δυνατό πιο ακριβείς πληροφορίες χρησιμοποιώντας τις λίστες που ακολουθούν.', 1),
(673, 'Acts Committed', 'Βίαιες Πράξεις', 1),
(674, 'Violent acts against self /Self-harm actions', 'Άσκηση βίας κατά εαυτού/ Αυτο-τραυματισμός', 1),
(675, 'Eating disorder', 'διατροφική διαταραχή', 1),
(676, 'Substance use/ abuse', 'Χρήση/κατάχρηση ουσιών', 1),
(677, 'Runaway', 'Φυγή (από το σπίτι/ τη στέγη που ζει)', 1),
(678, 'Self-inflicted injuries', 'Αυτο-τραυματισμός', 1),
(679, 'Suicidal thoughts', 'Αυτοκτονικές σκέψεις', 1),
(680, 'Suicide attempt', 'Απόπειρα αυτοκτονίας', 1),
(681, 'Actual suicide', 'Αυτοκτονία', 1),
(682, 'Other self-harm action (unspecified)', 'Άλλη (αδιευκρίνιστη) πράξη αυτο-τραυματισμού', 1),
(683, 'Physical violence acts committed [with or without injury]', 'Άσκηση σωματικής βίας (με ή χωρίς τραυματισμό)', 1),
(684, 'Physical violent acts/ corporal punishment/ “disciplines”', 'Άσκηση σωματικής βίας/ σωματική τιμωρία', 1),
(685, 'Slapping', 'Χαστούκισμα', 1),
(686, 'Smacking', 'Σκαμπίλισμα', 1),
(687, 'Spanking', 'Ράπισμα στα οπίσθια', 1),
(688, 'Pinching', 'Τσίμπημα', 1),
(689, 'Twisting ear(s)', 'Τράβηγμα /Στρίψιμο αφτιών', 1),
(690, 'Pulling hair', 'Τράβηγμα μαλλιών', 1),
(691, 'Hitting with an object', 'Χτύπημα με αντικείμενο', 1),
(692, 'Beating', 'Ξυλοδαρμός', 1),
(693, 'Tying up or tying to something /restraining to cloth sacks', 'Δέσιμο του παιδιού πάνω σε κάτι/ περιορισμός με \"ειδικά\" ρούχα', 1),
(694, 'Locking up', 'Κλείδωμα σε δωμάτιο/ άλλο χώρο', 1),
(695, 'Leaving child to lie in their own excrement', 'Παράτημα του παιδιού στα περιττώματά του', 1),
(696, 'Pushing', 'Σπρώξιμο', 1),
(697, 'Throwing', 'Πέταγμα', 1),
(698, 'Shaking', 'Ταρακούνημα', 1),
(699, 'Grabbing', 'Άρπαγμα', 1),
(700, 'Choking', 'Στραγγάλισμα', 1),
(701, 'Squeezing neck', 'Πίεση στο σβέρκο', 1),
(702, 'Kicking', 'Κλώτσημα', 1),
(703, 'Hitting on head (with hand or against the wall)', 'Χτύπημα εστιασμένο στο κεφάλι (με το χέρι/ στον τοίχο)', 1),
(704, 'Boxing ear', 'Γροθιά στο αφτί', 1),
(705, 'Scratching', 'Γρατσούνισμα', 1),
(706, 'Biting', 'Δάγκωμα', 1),
(707, 'Burning', 'Κάψιμο', 1),
(708, 'Scalding', 'Ζεμάτισμα', 1),
(709, 'Violent acts known also as harmful practices', 'Βίαιες πράξεις που συνιστούν γνωστές επιβλαβείς πρακτικές', 1),
(710, 'Hitting on the soles of the feet', 'Χτύπημα στα πέλματα των ποδιών', 1),
(711, 'Forcing to ingest spicy food', 'Εξαναγκασμός του παιδιού σε κατάποση καυτερού φαγητού', 1),
(712, 'Forced feeding', 'Εξαναγκασμός του παιδιού σε φαγητό', 1),
(713, 'Forcing children to stay in uncomfortable positions', 'Εξαναγκασμός του παιδιού σε άβολη/επώδυνη στάση', 1),
(714, 'Binding', 'Δέσιμο με αλυσίδες/λουριά', 1),
(715, 'Inflicting scars/ scarring', 'Εκκούσια πρόκληση σημαδιού/ ουλής', 1),
(716, 'Teeth extraction as punishment', 'Εξαγωγή δοντιού ως τιμωρία', 1),
(717, 'Branding', 'Στιγματισμός/ πυροσφράγισμα/ \"μαρκάρισμα\"', 1),
(718, 'Fattening', 'Εκκούσια πάχυνση του παιδιού', 1),
(719, '“Retribution” acts of violence', 'Άσκηση σωματικής βίας ως \"τιμωρία\"', 1),
(720, 'Virginity testing (inspecting girls’ genitalia)', 'Εξαναγκασμός κοριτσιού σε \"έλεγχο παρθενίας\"', 1),
(721, 'Forced circumcision', 'Εξαναγκασμός αγοριού σε περιτομή', 1),
(722, 'Female genital mutilation', 'Κλειτεριδεκτομή', 1),
(723, 'Uvulectomy', 'Αφαίρεση σταφυλής', 1),
(724, 'Forced marriage and early marriage', 'Εξαναγκασμός σε γάμο/ πρώιμος γάμος', 1),
(725, 'Violent and degrading initiation rites / “hazing”', 'Εξαναγκασμός σε εξευτελιστική τελετή μύησης/ \"καψόνι\"', 1),
(726, 'Practices as “exorcism” after accusations of “witchcraft”', 'Εφαρμογή πρακτικών όπως εξορκισμού μετά από κατηγορίες όπως δαιμονισμού', 1),
(727, 'Forced sterilization, particularly girls', 'Εξαναγκασμός σε στείρωση', 1),
(728, 'Violence in the guise of treatment', 'Άσκηση βίας με πρόφαση θεραπεία', 1),
(729, 'Deliberate infliction of disabilities for exploiting/begging', 'Εκκούσια πρόκληση αναπηρίας στο παιδί για εκμετάλλευση/ όπως επαιτεία', 1),
(730, 'Acts of life threatening maltreatment', 'Κακομεταχείριση απειλητική για τη ζωή του παιδιού (με πρόθεση)', 1),
(731, 'Administering unnecessary invasive medical procedures', 'Χορήγηση περιττών επεμβατικών ιατρικών πράξεων', 1),
(732, 'Administering non prescribed substances', 'Χορήγηση ακατάλληλων μη-συνταγογραφημένων φαρμακευτικών ουσιών', 1),
(733, 'Child has been given poison', 'Δηλητηρίαση (με πρόθεση)', 1),
(734, 'Threatening with a knife (also psychological abuse)', 'Απειλή με ένα μαχαίρι', 1),
(735, 'Threatening with a gun (also psychological abuse)', 'Απειλή με όπλο', 1),
(736, 'Stabbing', 'Μαχαίρωμα', 1),
(737, 'Shooting', 'Πυροβολισμός', 1),
(738, 'Dowry-related violence/death (also harmful practice)', 'Άσκηση βίας που σχετίζεται με απόδοση προίκας', 1),
(739, '“Honour” crimes (also harmful practice)', 'Άσκηση βίας στο πλαίσιο \"εγκλήματος τιμής\"', 1),
(740, 'Abduction-related acts', 'Πράξη που σχετίζεται με απαγωγή', 1),
(741, 'Non-family abduction', 'Απαγωγή από τρίτους (όχι από μέλος/-η της οικογένειας)', 1),
(742, 'Family abduction', 'Απαγωγή από μέλος/-η της οικογένειας', 1),
(743, 'Institutional and system violations of child rights', 'Θεσμική ή/και συστημική παραβίαση των δικαιωμάτων του παιδιού', 1),
(744, 'Caning', 'Ράβδισμα', 1),
(745, 'Flogging', 'Μαστίγωμα', 1),
(746, 'Stoning', 'Λιθοβολισμός', 1),
(747, 'Torture (all forms)', 'Υποβολή σε (κάθε μορφής) βασανιστήριο', 1),
(748, 'Amputations', 'Ακρωτηριασμός', 1),
(749, 'Imposing of death sentence for crimes committed', 'Επιβολή θανατικής ποινής για έγκλημα που διαπράχθηκε από το παιδί', 1),
(750, 'Other described physical acts', 'Άλλες αναφερόμενες πράξεις σωματικής βίας', 1),
(751, 'No specific information for reported/suspected physical violence', 'Μη ακριβείς πληροφορίες για αναφερόμενες πράξεις σωματικής βίας', 1),
(752, 'Sexual violence acts committed [with or without injury]', 'Άσκηση σεξουαλικής βίας (με ή χωρίς τραυματισμό)', 1),
(753, 'Sexual violence acts', 'Άσκηση σεξουαλικής βίας', 1),
(754, 'Acts involving penetration (intrusion)', 'Σεξουαλική παραβίαση (με διείσδυση)', 1),
(755, 'Without force', 'χωρίς εξαναγκασμό', 1),
(756, 'anus', 'πρωκτική', 1),
(757, 'vulva', 'κολπική', 1),
(758, 'mouth', 'στοματική', 1),
(759, 'Involving use of force', 'με εξαναγκασμό', 1),
(760, 'Attempted sexual abuse (not involving penetration)', 'Απόπειρα σεξουαλικής παραβίασης (χωρίς διείσδυση)', 1),
(761, 'with physical contact', 'με φυσική επαφή', 1),
(762, 'without physical contact', 'χωρίς φυσική επαφή', 1),
(763, 'Threatened sexual abuse', 'Απειλή σεξουαλικής κακοποίησης', 1),
(764, 'Touching/fondling genitals', 'Άγγιγμα γεννητικών οργάνων/ Θωπεία', 1),
(765, 'Showing genitals to child', 'Επίδειξη γεννητικών οργάνων στο παιδί', 1),
(766, 'Sexual harassment', 'Σεξουαλική παρενόχληση', 1),
(767, 'Voyeurism /spying on the children intimate behaviours', 'Παρακολούθηση του παιδιού σε ιδιωτικές στιγμές/ Ηδονοβλεψία', 1),
(768, 'Providing sexually explicit materials', 'Παροχή πορνογραφικού υλικού στο παιδί', 1),
(769, 'Forced exposure to pornography', 'Εξαναγκασμός του παιδιού σε παρακολούθηση πορνογραφικού υλικού', 1),
(770, 'Forcing to witness sexual violence against mother', 'Εξαναγκασμός του παιδιού να είναι παρόν κατά τη σεξουαλική κακοποίηση της μητέρας', 1),
(771, 'Sexual “luring” (via ICT)', 'Σεξουαλική παρακίνηση/ \"δελεασμός\" (μέσω διαδικτύου/ τηλεφώνου)', 1),
(772, 'Online sexual stalking /harassment', 'Ηλεκτρονική σεξουαλική καταδίωξη / παρενόχληση', 1),
(773, 'Other Sexual violence acts', 'Άλλες πράξεις σεξουαλικής βίας', 1),
(774, 'Sexual exploitation acts', 'Πράξεις σεξουαλικής εκμετάλλευσης', 1),
(775, 'Child prostitution', 'Εξαναγκασμός του παιδιού σε πορνεία', 1),
(776, 'Use of children in commercial sexual exploitation', 'Σεξουαλική εκμετάλλευση του παιδιού για εμπορικούς λόγους', 1),
(777, 'Sexual exploitation in travel and tourism', 'Σεξουαλική εκμετάλλευση του παιδιού στο πλαίσιο σεξουαλικού τουρισμού', 1),
(778, 'Sexual slavery', 'Σεξουαλική δουλεία', 1),
(779, 'Sale of children for sexual purposes', 'Πώληση του παιδιού για σεξουαλικούς σκοπούς', 1),
(780, 'Trafficking (within and between countries)', 'Εμπορία (εντός της χώρας ή/και μεταξύ χωρών)', 1),
(781, 'Involvement in pornography', 'Εμπλοκή του παιδιού σε πορνογραφία', 1),
(782, 'Other sexual exploitation acts (unspecified)', 'Άλλη μη προσδιορισμένη πράξη σεξουαλικής εκμετάλλευσης', 1),
(783, 'No specific information for reported/suspected sexual violence', 'Μη ακριβείς πληροφορίες για αναφερόμενες πράξεις σεξουαλικής βίας', 1),
(784, 'Psychological violence acts committed [with or without injury]', 'Πράξεις ψυχολογικής κακοποίησης (με ή χωρίς τραυματισμό)', 1),
(785, 'Violent acts with or without obvious consequences', 'Βίαιες πράξεις κατά του παιδιού με ή χωρίς εμφανείς συνέπειες', 1),
(786, 'Bullying/ Psychological bullying and hazing', 'Εκφοβισμός του παιδιού', 1),
(787, 'by other children', 'από άλλο/-α παιδί/-ιά', 1),
(788, 'by adults', 'από ενήλικο/-α άτομο/-α', 1),
(789, 'Homophobic bullying /related to sexual orientation', 'Εκφοβισμός που σχετίζεται με τον σεξουαλικό προσανατολισμό του παιδιού/ Ομοφοβικός εκφοβισμός', 1),
(790, 'Cyber bullying (via ICTs / mobile phones /Internet)', 'Κυβερνο-εκφοβισμός (μέσω τηλεφώνου/ Διαδικτύου)', 1),
(791, 'Ignoring and favoritism', 'Αδιαφορία για το παιδί', 1),
(792, 'Denying emotional responsiveness', 'Άρνηση συναισθηματικής απόκρισης', 1),
(793, 'Over protection', 'Υπερπροστατευτισμός', 1),
(794, 'Isolation (social)', 'Κοινωνική απομόνωση', 1),
(795, 'Close confinement (tying/binding)', 'Εγκλεισμός (δέσιμο/ περιορισμός)', 1),
(796, 'Placement in solitary confinement', 'Εγκλεισμός σε απομόνωση (απομονωμένο χώρο)', 1),
(797, 'Degrading /inhuman conditions of detention', 'Ταπεινωτικές/ απάνθρωπες συνθήκες κράτησης', 1),
(798, 'Humiliation /Insults, name-calling, belittling, ridiculing', 'Ταπείνωση/ προσβολές/ γελειοποίηση', 1),
(799, 'Humiliation via ICT', 'Ταπείνωση /γελειοποίηση μέσω διαδικτύου/ τηλεφώνου', 1),
(800, 'Rejection and Spurning', 'Απόρριψη', 1),
(801, 'Verbal assaults', 'Λεκτική επίθεση', 1),
(802, 'Terrorization / Scaring', 'Τρομοκράτηση', 1),
(803, 'Threats of sexual violence (with or without contact)', 'Απειλή άσκησης σεξουαλικής βίας (με ή χωρίς σωματική επαφή)', 1),
(804, 'Threats of other maltreatment', 'Απειλή άσκησης άλλης μορφής κακομεταχείρισης', 1),
(805, 'Other related acts hurting child’s feelings', 'Άλλη σχετική πράξη που επηρεάζει αρνητικά τη συναισθηματική κατάσταση του παιδιού', 1),
(806, 'Exploitation related psychological violent acts', 'Ψυχολογική κακοποίηση μέσα από πράξεις που σχετίζονται με την εκμετάλλευση του παιδιού', 1),
(807, 'Exploiting and corrupting', 'Εκμετάλλευση και διαφθορά', 1),
(808, 'Labour/economic exploitation', 'Εργασιακή/οικονομική εκμετάλλευση', 1),
(809, 'Forcing to undertake adult\'s responsibilities/parent’s role', 'Εξαναγκασμός του παιδιού να αναλαμβάνει ευθύνες ενήλικα', 1),
(810, 'Forcing to begging', 'Εξαναγκασμός του παιδιού να επαιτεί', 1),
(811, 'Forcing to participate in religious ritual', 'Εξαναγκασμός του παιδιού να συμμετέχει σε βίαιες θρησκευτικές τελετουργίες', 1),
(812, 'Forcing to participate in a violent political event', 'Εξαναγκασμός του παιδιού να συμμετέχει σε βίαια πολιτικά γεγονότα', 1),
(813, 'No specific info for reported/suspected exploitation acts', 'Μη ακριβείς πληροφορίες για αναφερόμενες πράξεις εκμετάλλευσης του παιδιού', 1),
(814, 'Exposure related psychological violent acts', 'Ψυχολογική κακοποίηση μέσω έκθεσης του παιδιού σε βίαιες πράξεις', 1),
(815, 'Exposure to any kind of violence in the family / DV', 'Έκθεση σε οποιοδήποτε τύπο βίας στην οικογένεια/ ενδοοικογενειακή βία', 1),
(816, 'Exposure to violence against other children', 'Έκθεση σε άσκηση βίας εναντίον άλλου παιδιού', 1),
(817, 'Exposure to intimate partner violence', 'Έκθεση σε βία μεταξύ ερωτικών συντρόφων', 1),
(818, 'Exposure to violence against other adults', 'Έκθεση σε βία εναντίον ενήλικου ατόμου', 1),
(819, 'Exposition to the homicide of a significant person', 'Έκθεση σε δολοφονία προσώπου', 1),
(820, 'Exposure to a violent environment outside the family', 'Έκθεση σε βίαιο περιβάλλον εκτός οικογένειας', 1),
(821, 'Exposure to violence via electronic means', 'Έκθεση σε βία μέσω ηλεκτρονικών μέσων', 1),
(822, 'information and communication technologies', 'τεχνολογίες ενημέρωσης και επικοινωνίας', 1),
(823, 'in the mass media', 'στα μέσα μαζικής ενημέρωσης', 1),
(824, 'No specific info for reported/suspected related exposure', 'Μη ακριβείς πληροφορίες για αναφερόμενες πράξεις σχετικές με έκθεση του παιδιού', 1),
(825, 'No specific info for reported/suspected psych/l abuse violent acts', 'Μη ακριβείς πληροφορίες για αναφερόμενες πράξεις ψυχολογικής κακοποίησης του παιδιού', 1),
(826, 'Omissions', 'Παραλείψεις', 1),
(827, 'Omissions in child’s care / Neglect', 'Παραλείψεις στη φροντίδα του παιδιού/ Παραμέληση', 1),
(828, 'Emotional neglect related omissions', 'Παραλείψεις όσον αφορά τις συναισθηματικές ανάγκες του παιδιού', 1),
(829, 'Persistent ignoring of the child’s emotional needs/ Chronic inattention to the child', 'Χρόνια αδιαφορία για τις συναισθηματικές ανάγκες του παιδιού', 1),
(830, 'Psychologically “unavailable” caregivers', 'Συναισθηματικά \"μη-διαθέσιμοι\" φροντιστές/-στριες', 1),
(831, 'Inappropriately advanced expectations (def.  According to child’s characteristics)', 'Υπερβολικές προσδοκίες από το παιδί σε σχέση με τα ιδιαίτερα χαρακτηριστικά του', 1),
(832, 'No specific information for omissions related to emotional neglect', 'Μη ακριβείς πληροφορίες για παραλείψεις που σχετίζονται με συναισθηματική παραμέληση', 1),
(833, 'Physical neglect related omissions', 'Παραλείψεις σχετικές με φυσική παραμέληση του παιδιού', 1),
(834, 'Inadequate / inappropriate nutrition', 'Ανεπαρκής/ ακατάλληλη διατροφή', 1),
(835, 'Inadequate / inappropriate personal hygiene', 'Ανεπαρκής/ ακατάλληλη προσωπική υγιεινή', 1),
(836, 'Inadequate / inappropriate clothing', 'Ανεπαρκής/ ακατάλληλη ένδυση', 1),
(837, 'Inadequate / inappropriate shelter', 'Ανεπαρκής/ ακατάλληλη στέγαση', 1),
(838, 'No specific information for omissions related child’s physical needs', 'Μη ακριβείς πληροφορίες για παραλείψεις που σχετίζονται με φυσική παραμέληση', 1),
(839, 'Medical neglect related omissions', 'Παραλείψεις που σχετίζονται με παραμέληση υγείας και φροντίδας υγείας', 1),
(840, 'Refusal to provide preventive health care (vaccinations, vision, and dental care)', 'Άρνηση παροχής προληπτικής φροντίδας υγείας (εμβολιασμοί, έλεγχος όρασης, στοματική υγιεινή)', 1),
(841, 'Refusal to allow /provide needed medical care for diagnosed health condition/ impairment', 'Άρνηση παροχής ή συγκατάθεσης για παροχή απαραίτητης φροντίδας υγείας για διαγνωσμένες ασθένειες/αναπηρίες', 1),
(842, 'Unjustified delay to seek needed care', 'Αδικαιολόγητη καθυστέρηση στην αναζήτηση ιατρικής φροντίδας', 1),
(843, 'Failure to provide with basic medical care', 'Αποτυχία παροχής βασικής ιατρικής φροντίδας', 1),
(844, 'Withholding essential medical care', 'Καθυστέρηση ή μη παροχή ζωτικής φροντίδας υγείας', 1),
(845, 'No specific information for omissions related child’s medical needs', 'Μη ακριβείς πληροφορίες για παραλείψεις που σχετίζονται με θέματα υγείας του παιδιού', 1),
(846, 'Educational neglect related omissions', 'Παραλείψεις που σχετίζονται με την εκπαίδευση/ εκπαιδευτική παραμέληση', 1),
(847, 'Persistent failure to register child at the school', 'Μη-εγγραφή του παιδιού στο σχολείο', 1),
(848, 'Has not attended school at all', 'Το παιδί δεν έχει πάει ποτέ στο σχολείο (ενώ θα έπρεπε)', 1),
(849, 'Dropped out', 'Το παιδί έχει σταματήσει τη φοίτηση (ενώ δεν θα έπρεπε)', 1),
(850, 'Persistent failure to enrol at the school resulting to irregular school attendance', 'Μη συστηματική φοίτηση/ περιστασιακή παρακολούθηση του σχολειου', 1),
(851, 'compulsory school', 'υποχρεωτική εκπαίδευση', 1),
(852, 'non compulsory (ECEC)', 'προσχολική εκπαίδευση', 1),
(853, 'Chronic truancy', 'Συνεχή σκασιαρχεία', 1),
(854, 'Refusal to attend special educational needs', 'Άρνηση αποδοχής ειδικών εκπαιδευτικών αναγκών του παιδιού', 1),
(855, 'Refusal to allow needed attention to special educational needs', 'Άρνηση συγκατάθεσης για φροντίδα ειδικών εκπαιδευτικών αναγκών του παιδιού', 1),
(856, 'Refusal to provide needed attention to special educational needs', 'Άρνηση παροχής αναγκαίας φροντίδας για ειδικές εκπαιδευτικές ανάγκες του παιδιού', 1),
(857, 'No specific information for omissions related child’s educational needs', 'Μη ακριβείς πληροφορίες για παραλείψεις που σχετίζονται με τις εκπαιδευτικές ανάγκες του παιδιού', 1),
(858, 'Risk exposure related omissions', 'Παραλείψεις που σχετίζονται με την έκθεση του παιδιού σε κίνδυνο', 1),
(859, 'Exposure to hazardous/ dangerous environments', 'Έκθεση σε επικίνδυνα περιβάλλοντα', 1),
(860, 'Inside household', 'Μέσα στο σπίτι', 1),
(861, 'Outside home', 'Εκτός οικιακού περιβάλλοντος', 1),
(862, 'Exposure to substances use/misuse by others', 'Έκθεση σε χρήση ουσιών από τρίτους', 1),
(863, 'Alcohol', 'Αλκοόλ', 1),
(864, 'Drugs', 'Ναρκωτικές ουσίες', 1),
(865, 'Other substances', 'Άλλες ουσίες', 1),
(866, 'No specific information for reported/ suspected omissions for exposure to risks', 'Μη ακριβείς πληροφορίες για αναφερόμενες παραλείψεις σχετικές με έκθεση του παιδιού σε κίνδυνο', 1),
(867, 'Supervision related omissions', 'Παραλείψεις που σχετίζονται με πλημμελή φύλαξη του παιδιού', 1),
(868, 'Inadequate/ lack of supervision resulting in physical harm', 'Ανεπαρκής ή/και παντελής απουσία φύλαξης του παιδιού που καταλήγει σε σωματική βλάβη', 1),
(869, 'Persisted lack of supervision concerning substance use/misuse by the child', 'Ανεπαρκής εποπτεία όσον αφορά τη χρήση ουσιών από το παιδί', 1),
(870, 'No specific information for omissions related to the child’s supervision', 'Μη ακριβείς πληροφορίες για παραλείψεις που σχετίζονται με την φύλαξη του παιδιού', 1),
(871, 'Refusal of custody/abandonment', 'Άρνηση κηδεμονίας/ Εγκατάλειψη', 1),
(872, 'Unstable custody arrangements', 'Ασταθές πρόγραμμα φύλαξης του παιδιού', 1),
(873, 'Illegal transfers of custody', 'Παράνομη μεταβίβαση κηδεμονίας', 1),
(874, 'Refusal of custody', 'Άρνηση κηδεμονίας', 1),
(875, 'Abandonment (primary caregiver(s) runaway / migrate and leave the children behind)', 'Εγκατάλειψη (βασικοί φροντιστές/-στριες φεύγουν μακριά/ μεταναστεύουν και εγκαταλείπουν το παιδί)', 1),
(876, 'children out of wedlock', 'παιδί εκτός γάμου', 1),
(877, 'children with disabilities', 'παιδί με αναπηρία', 1),
(878, 'No specific information for omissions related child’s refusal of custody', 'Μη ακριβείς πληροφορίες για παραλείψεις που σχετίζονται με την κηδεμονία του παιδιού', 1),
(879, 'Please record the Place of Incident', 'Παρακαλώ καταγράψτε το χώρο όπου αναφέρεται ότι έλαβε χώρα το περιστατικό', 1),
(880, 'Unknown/ Unspecified place', 'Απροσδιόριστο', 1),
(881, 'Home/ Family', 'Στο σπίτι του παιδιού', 1),
(882, 'Home/ Relatives', 'Σε σπίτι συγγενών', 1),
(883, 'Home/ Friends', 'Σε φιλικό σπίτι', 1),
(884, 'Child care institution (residential care)', 'Σε ίδρυμα κλειστής φιλοξενίας/ στέγη παιδιού', 1),
(885, 'Child care institution (day care)', 'Σε παιδικό σταθμό ή ανάλογη δομή ημερήσιας φροντίδας παιδιών', 1),
(886, 'Detention or correctional institution', 'Σε κατάστημα κράτησης ή παρόμοιο χώρο', 1),
(887, 'Leisure/ Playground/ Recreational area', 'Σε παιδική χαρά/ άλλο χώρο αναψυχής', 1),
(888, 'Sports-athletics', 'Σε γυμναστήριο/ άλλες αθλητικές εγκαταστάσεις', 1),
(889, 'School', 'Στο σχολείο', 1),
(890, 'Educational institution', 'Σε εκπαιδευτική δομή άλλη από σχολείο (π.χ. φροντιστήριο)', 1),
(891, 'Medical Services', 'Υπηρεσία παροχής φροντίδας Υγείας', 1),
(892, 'Public transportation', 'Σε μέσο μαζικής μεταφοράς', 1),
(893, 'Public place/ street, commercial & surrounding area', 'Σε εμπορική περιοχή/ δρόμο ή άλλο δημόσιο χώρο', 1),
(894, 'Other place', 'Αλλού', 1),
(895, 'GO -> C2', 'Μετάβαση -> C2', 1),
(896, 'Click as many as applicable', 'Επιλέξτε όλα όσα ισχύουν', 1),
(897, 'Please record Child’s Sex, Date of Birth and Citizenship Status', 'Καταγράψτε φύλο, ημερομηνία γέννησης και κατάσταση υπηκοότητας του παιδιού', 1),
(898, 'Male', 'Άρρεν', 1),
(899, 'Female', 'Θήλυ', 1),
(900, 'Not known', 'Άγνωστο', 1),
(901, 'Check ONE from the list below', 'Επιλέξτε ΕΝΑ από τη λίστα που ακολουθεί', 1),
(902, 'Child’s Date of Birth', 'Ημερομηνία γέννησης του παιδιού', 1),
(903, '<18 years old (if no year is known)', '<18 χρονών (εάν το έτος γέννησης δεν είναι γνωστό)', 1),
(904, '<18 years old', '<18 χρονών', 1),
(905, '>18 (\"minor\" according to legislation)', '>18 χρονών (αλλά \"ανήλικο\" άτομο σύμφωνα με το νόμο)', 1),
(906, '>18 years old', '>18 χρονών', 1),
(907, 'Unborn', 'Αγέννητο', 1),
(908, 'Please record the full date of birth:', 'Παρακαλώ συμπληρώστε την ημερομηνία γέννησης:', 1),
(909, 'YYYY-MM-DD', 'ΕΕΕΕ-ΜΜ-ΗΗ', 1),
(910, 'If DD is unknown:', 'Εάν η ημέρα (ΗΗ) δεν είναι γνωστή:', 1),
(911, 'YYYY-MM', 'ΕΕΕΕ-ΜΜ', 1),
(912, 'If MM-DD are unknown:', 'Εάν ο μήνας (ΜΜ) και η ημέρα (ΗΗ) δεν είναι γνωστά:', 1),
(913, 'If YYYY-MM-DD are unknown AND the alleged victim is a child:', 'Εάν ΕΕΕΕ-ΜΜ-ΗΗ δεν είναι γνωστά και το φερόμενο θύμα είναι ανήλικο:', 1),
(914, '<18', '<18', 1),
(915, 'Citizenship Status', 'Υπηκοότητα', 1),
(916, 'Not a citizen', 'Χωρίς υπηκοότητα', 1),
(917, 'Citizen', 'Υπήκοος', 1),
(918, 'with ID', 'με επίσημη αναγνώριση', 1),
(919, 'Citizen with ID', 'Υπήκοος με επίσημη αναγνώριση', 1),
(920, 'without ID', 'χωρίς επίσημη αναγνώριση', 1),
(921, 'Citizen without ID', 'Υπήκοος χωρίς επίσημη αναγνώριση', 1),
(922, 'Unaccompanied foreign child or refugee', 'Ασυνόδευτο αλλοδαπό παιδί ή πρόσφυγας', 1),
(923, 'Check ONE from the list below. If the child is “Citizen”, please define in sub-list', 'Επιλέξτε ΕΝΑ από τη λίστα που ακολουθεί. Εάν το παιδί έχει υπηκοότητα, παρακαλώ προσδιορίστε:', 1),
(924, 'Please record Family Composition and indicate up to two Primary Caregivers', 'Καταγράψτε τη σύνθεση της οικογένειας & υποδείξτε μέχρι 2 ενήλικα άτομα ως βασικούς/-ές φροντιστές/-στριες ΟΤΑΝ ΣΥΝΕΒΗ ΤΟ ΠΕΡΙΣΤΑΤΙΚΟ', 1),
(925, 'A: Type of Family', 'Α. Τύπος οικογένειας', 1),
(926, 'Boarder(s) (child lives in residential/institutional care)', 'Το παιδί ζει σε ίδρυμα κλειστής προτασίας (οικότροφος)', 1),
(927, 'Child lives with his/her family (including biological/ adoptive)', 'Το παιδί ζει με την οικογένειά του (βιολογική ή θετή)', 1),
(928, 'Child lives in a foster family', 'Το παιδί ζει σε ανάδοχη οικογένεια', 1),
(929, 'Child lives in a re-composed family', 'Το παιδί ζει σε οικογένεια με γονιό που ξαναπαντρεύτηκε', 1),
(930, 'Child lives in a family other than its family/ foster family', 'Το παιδί ζει σε οικογένεια άλλη από την οικογένειά του ή ανάδοχη οικογένεια', 1),
(931, 'Relatives’ family', 'σε συγγενική οικογένεια', 1),
(932, 'Child lives in a family other than its family/ foster family - Relatives’ family', 'Το παιδί ζει σε οικογένεια άλλη από την οικογένειά του ή ανάδοχη οικογένεια - σε συγγενική οικογένεια', 1),
(933, 'Friends’ family', 'σε φιλική οικογένεια', 1),
(934, 'Child lives in a family other than its family/ foster family - Friends’ family', 'Το παιδί ζει σε οικογένεια άλλη από την οικογένειά του ή ανάδοχη οικογένεια - σε φιλική οικογένεια', 1),
(935, 'SKIP “B”; GO -> F3', 'Μετάβαση -->F3', 1),
(936, 'If you DON\'T chose Boarder(s) -> B: Members of Family', 'Εάν ΔΕΝ επιλέξετε \"Οικότροφος\", προχωρήστε στη συμπλήρωση του \"Β: Μέλη της Οικογένειας\"', 1),
(937, 'B: Member(s) of Family', 'Β: Μέλη της Οικογένειας', 1),
(938, 'Number', 'Αριθμός', 1),
(939, 'Primary caregiver(s)', 'Ενήλικα άτομα-Βασικοί Φροντιστές/-τριες του παιδιού ΟΤΑΝ ΣΥΝΕΒΗ ΤΟ ΠΕΡΙΣΤΑΤΙΚΟ', 1),
(940, 'Parent(s)', 'Γονέας/-είς', 1),
(941, 'Step Parent(s)', 'Θετός/-οί Γονέας/-είς', 1),
(942, 'Parent(s)’ partner(s)', 'Σύντροφος/-οι Γονέα/-έων', 1),
(943, 'Sibling(s)', 'Αδέλφια', 1),
(944, 'Younger than the (alleged) victim', 'Νεώτερο από το παιδί (αναφερόμενο ως) θύμα', 1),
(945, 'Older than the (alleged) victim (<18)', 'Μεγαλύτερο από το παιδί (αναφερόμενο ως) θύμα (<18)', 1),
(946, 'Older than the (alleged) victim (>18)', 'Μεγαλύτερο από το παιδί (αναφερόμενο ως) θύμα (>18)', 1),
(947, 'Grandparent(s)', 'Παππούς/-ούδες-Γιαγιά/-δες', 1),
(948, 'Other relative(s)', 'Άλλος/-η/-οι συγγενής/-είς', 1),
(949, 'Blood relatives', 'Συγγενείς εξ αίματος', 1),
(950, '<18 [child(ren)]', '<18 (παιδί/-ιά)', 1),
(951, '>18 [adult(s)]', '>18 (ενήλικος/-η/-ες)', 1),
(952, 'By law relatives', 'Συγγενείς εξ αγχιστείας', 1),
(953, 'Family friend(s)', 'Οικογενειακός/-ή/-οί φίλος/-η/-οι/-ες', 1),
(954, 'Other not-related household members', 'Άλλο/-α μη συγγενικό/-ά άτομο/-α', 1),
(955, 'Please indicate up to 2 child’s primary caregiver(s) (you can uncheck)', 'Παρακαλώ υποδείξτε μέχρι και 2 βασικούς/-ές φρονιστές/-στριες ΟΤΑΝ ΣΥΝΕΒΗ ΤΟ ΠΕΡΙΣΤΑΤΙΚΟ (αν επιλέξετε λάθος, μπορείτε να απο-επιλέξετε)', 1),
(956, 'members', 'μέλη', 1),
(957, 'member family', 'μέλη στην οικογένεια', 1),
(958, 'Please record Caregiver(s) Relationship to Child, Sex and Date of Birth', 'Καταγράψτε για έως και 2 ενήλικα άτομα-βασικούς φροντιστές ΟΤΑΝ ΣΥΝΕΒΗ ΤΟ ΠΕΡΙΣΤΑΤΙΚΟ φύλο, ημερομηνία γέννησης και τη σχέση τους με το παιδί', 1),
(959, 'Relationship to Child', 'Σχέση με το παιδί', 1),
(960, '1st Caregiver', '1ος/-η Βασικός Φροντιστής/-στρια ΟΤΑΝ ΣΥΝΕΒΗ ΤΟ ΠΕΡΙΣΤΑΤΙΚΟ', 1),
(961, 'Professional Caregiver', 'Επαγγελματίας Φροντιστής/-στρια', 1),
(962, 'Temporary caregiver/Other', 'Προσωρινός/-ή Φροντιστής/-στρια/ Άλλο', 1),
(963, 'Unknown relationship', 'Άγνωστη σχέση', 1),
(964, 'Check ONE per Caregiver', 'Κάντε ΜΙΑ επιλογή ανά Φροντιστή', 1),
(965, 'Caregiver(s) Sex', 'Φύλο Φροντιστή/-στριας', 1),
(966, 'Caregiver(s) DoB', 'Ημερομηνία γέννησης Φροντιστή/-στριας', 1),
(967, 'YY', 'ΔΔ', 1),
(968, '\'s', '\'s', 1),
(969, 'YY-MM-DD', 'ΕΕ-ΜΜ-ΗΗ', 1),
(970, 'If YYYY-MM-DD are unknown then record the decade:', 'Εάν το έτος (ΕΕΕΕ), ο μήνας (ΜΜ) και η ημέρα (ΗΗ) δεν είναι γνωστά, συμπληρώστε δεκαετία (ΔΔ):', 1),
(971, 'If DECADE is unknown, then:', 'Εάν η δεκαετία (ΔΔ) δεν είναι γνωστή, τότε:', 1),
(972, 'Please record any Institutional Response', 'Παρακαλώ καταγράψτε τις ενέργειες που έγιναν από το Φορέα σας σε συνέχεια του συγκεκριμένου περιστατικού', 1),
(973, 'No response was required DUE TO CHILD’S DEATH', 'Δεν απαιτήθηκε καμία ενέργεια επειδή το παιδί απεβίωσε', 1),
(974, 'No Response', 'Καμία ενέργεια', 1),
(975, 'Yes', 'Ναι', 1),
(976, 'Immediate intervention(s)', 'Άμεσες παρεμβάσεις', 1),
(977, 'Physical Medical exam(s)', 'Ιατρική εξέταση του παιδιού', 1),
(978, 'Mental Health exam(s)', 'Ψυχιατρική εξέταση του παιδιού', 1),
(979, 'Forensic evaluation initiated', 'Ιατροδικαστική αξιολόγηση', 1),
(980, 'Child protection /welfare services assessment', 'Αξιολόγηση συνθηκών διαβίωσης', 1),
(981, 'Police intervention', 'Άμεση παρέμβαση Αστυνομίας', 1),
(982, 'Action taken -NO COURT INVOLVEMENT', 'Ενέργειες που πραγματοποιήθηκαν - ΧΩΡΙΣ ΑΝΑΜΙΞΗ ΔΙΚΑΣΤΙΚΩΝ ΑΡΧΩΝ', 1),
(983, 'Child remains in family with planned intervention', 'Παραμονή του παιδιού στην οικογένεια με προγραμματισμένη παρέμβαση', 1),
(984, 'Emergency placement', 'Απομάκρυνση του παιδιού από την οικογένεια και άμεση τοποθέτηση (σε δομή ή άλλη οικογένεια)', 1),
(985, 'Supportive intervention for current caregiver(s)', 'Υποστηρικτική παρέμβαση για τους/τις φροντιστές/-στριες', 1),
(986, 'Mother/child shelter with parent and child together', 'Φιλοξενία του παιδιού σε ξενώνα κακοποιημένων γυναικών μαζί με τη μητέρα', 1),
(987, 'Police emergency protection procedures', 'Λήψη άμεσων μέτρων προστασίας από την Αστυνομία (ασφαλιστικά μέτρα)', 1),
(988, 'CPS/welfare services emergency protection procedures', 'Άμεσες ενέργειες από Κοινωνική Υπηρεσία (ενημέρωση Εισαγγελέα για διερεύνηση)', 1),
(989, 'Referral to child protection /welfare services', 'Παραπομπή σε Υπηρεσία Παιδικής Προστασίας/ Πρόνοιας', 1),
(990, 'Action taken -COURT or EQUIVALENT AUTHORITY TO THE COURT INVOLVEMENT', 'Ενέργειες που πραγματοποιήθηκαν - ΜΕ ΑΝΑΜΙΞΗ ΔΙΚΑΣΤΙΚΩΝ Ή ΑΝΤΙΣΤΟΙΧΩΝ ΑΡΧΩΝ', 1),
(991, '(Family) Court measures initiated', 'Εκκίνηση διερεύνησης με Εισαγγελική εντολή', 1),
(992, 'Action to protect victim by court order(s)', 'Ενέργειες προστασίας θύματος με Εισαγγελική εντολή/ Δικαστική απόφαση', 1),
(993, 'Action to remove parent(s)’ rights', 'Ενέργειες για αφαίρεση γονικών δικαιωμάτων', 1),
(994, 'Expulsion of (alleged) abuser from home', 'Απομάκρυνση του/της δράστη/-στριας από το σπίτι με Δικαστική απόφαση', 1),
(995, 'Action to prosecute perpetrator(s)', 'Δίωξη του/της δράστη/-στριας', 1),
(996, 'Out of home placement', 'Τοποθέτηση του παιδιού εκτός οικογένειας', 1),
(997, 'Kinship Care (relatives/extended family)', 'Τοποθέτηση σε συγγενική φροντίδα (συγγενείς/ διευρυμένη οικογένεια)', 1),
(998, 'Foster Care', 'Τοποθέτηση σε ανάδοχη οικογένεια', 1),
(999, 'Children’s Home Institution', 'Τοποθέτηση σε στέγη/ ίδρυμα κλειστής φροντίδας', 1),
(1000, 'Adoption with parents’ agreement', 'Τεκνοθεσία με τη σύμφωνη γνώμη των γονέων/ κηδεμόνων', 1),
(1001, 'Adoption by court order', 'Τεκνοθεσία με Δικαστική απόφαση', 1),
(1002, 'GO -> S2', 'Μετάβαση -> S2', 1),
(1003, 'Check below as many as applicable', 'Παρακαλώ επιλέξτε όλα όσα ισχύουν', 1),
(1004, 'Please record any Referral(s) made to Services by you/your agency', 'Παρακαλώ καταγράψτε τις παραπομπές που έγιναν από εσάς ή/και τον Φορέα σας σε άλλες Υπηρεσίες', 1),
(1005, 'None', 'Δεν έγινε παραπομπή', 1),
(1006, 'Judicial Services', 'Υπηρεσίες Δικαιοσύνης', 1),
(1007, 'for child ONLY', 'ΜΟΝΟ για το παιδί', 1),
(1008, 'for caregiver(s) ONLY', 'ΜΟΝΟ για φροντιστές/-στριες', 1),
(1009, 'for child AND family', 'για το παιδί ΚΑΙ την οικογένεια', 1),
(1010, 'Mental Health Services', 'Υπηρεσίες Ψυχικής Υγείας', 1),
(1011, 'Independent Authorities', 'Ανεξάρτητη Αρχή', 1),
(1012, 'Social Welfare Services', 'Υπηρεσίες Κοινωνικής Πρόνοιας', 1),
(1013, 'Law Enforcement related Services', 'Υπηρεσίες Προστασίας των Πολιτών', 1),
(1014, 'Community Organizations and NGOs', 'Κοινοτικοί και Μη Κυβερνητικοί Οργανισμοί', 1),
(1015, 'Existing Registries and Research Organizations', 'Υπάρχοντα συστήματα καταγραφής και Ερευνητικοί Οργανισμοί', 1),
(1016, 'Educational Services', 'Υπηρεσίες Εκπαίδευσης', 1),
(1017, 'Other related Services', 'Άλλες σχετικές Υπηρεσίες', 1),
(1018, 'End of Record', 'Ολοκλήρωση καταγραφής περιστατικού', 1),
(1019, 'CHECK RECORD OPTIONS', 'ΕΛΕΓΧΟΣ ΚΑΤΑΓΡΑΦΗΣ ΠΡΙΝ ΤΗΝ ΥΠΟΒΟΛΗ', 1),
(1020, 'Please check the record options', 'Παρακαλώ ελέγξτε τις πληροφορίες που καταγράψατε', 1),
(1021, 'You can make any changes by navigating throught the right panel!', 'Χρησιμοποιήστε τη στήλη δεξιά ως πλοηγό για να δείτε τις πληροφορίες που έχετε καταγράψει και να κάνετε αλλαγές, εφόσον χρειάζεται!', 1),
(1022, 'Incident', 'Περιστατικό', 1),
(1023, 'ID', 'ID', 1),
(1024, 'Sex', 'Φύλο', 1),
(1025, 'Date of birth', 'Ημερομηνία γέννησης', 1),
(1026, 'Family and Caregiver(s)', 'Οικογένεια και Φροντιστές', 1),
(1027, 'Services', 'Υπηρεσίες', 1),
(1028, 'Submit Record', 'Υποβολή Καταγραφής', 1),
(1029, 'Loading', 'Ζεμάτισμα', 1),
(1030, 'RECORD COMPLETED', 'Η ΚΑΤΑΓΡΑΦΗ ΤΟΥ ΠΕΡΙΣΤΑΤΙΚΟΥ ΟΛΟΚΛΗΡΩΘΗΚΕ', 1),
(1031, 'Display/print the record', 'Εμφάνιση/ Εκτύπωση της καταγραφής αυτού του περιστατικού', 1),
(1032, 'Report', 'Αναφορά', 1),
(1033, 'RECORD', 'ΚΑΤΑΓΡΑΦΗ', 1),
(1034, 'Agency', 'Φορέας', 1),
(1035, 'Information provided by', 'Οι πληροφορίες παρασχέθηκαν από', 1),
(1036, 'Age at the date of incident', 'Ηλικία κατά την ημερομηνία που έλαβε χώρα το περιστατικό', 1),
(1037, 'Age at the date of recording', 'Ηλικία κατά την ημερομηνία καταγραφής', 1),
(1038, 'Type of family', 'Τύπος οικογένειας', 1),
(1039, 'Family\'s member(s)', 'Μέλη της οικογένειας', 1),
(1040, '1st', '1ο', 1),
(1041, 'born', 'γεννήθηκε', 1),
(1042, '2nd', '2ο', 1),
(1043, 'Back', 'Επιστροφή', 1),
(1044, 'KNOWN CHILD', 'ΗΔΗ ΓΝΩΣΤΗ ΠΕΡΙΠΤΩΣΗ (ΠΑΙΔΙ για το οποίο υπάρχει προηγούμενη καταγραφή)', 1),
(1045, 'EXISTING CHILD RECORD', 'ΗΔΗ ΚΑΤΑΧΩΡΗΜΕΝΟ ΠΑΙΔΙ', 1),
(1046, 'You are going to proceed with the record of a new CM incident for  the child', 'Πρόκειται να προχωρήσετε στην καταγραφή νέου περιστατικού (υποψίας) κακομεταχείρισης για το παιδί', 1),
(1047, 'Please proceed with checking of', 'Παρακαλώ προχωρήστε ελέγχοντας τα', 1),
(1048, 'TIP: Update –if needed', 'Χρήσιμη Συμβουλή: Εάν θεωρείτε ότι χρειάζεται, ενημερώστε την υπάρχουσα καταγραφή!', 1),
(1049, 'Known Incidents', 'Ήδη καταγεγραμμένα περιστατικά', 1),
(1050, 'The incident you are trying to record might already exist!', 'Το περιστατικό που προσπαθείτε να καταγράψετε μπορεί να υπάρχει ήδη!', 1),
(1051, 'Please check the incident record(s) below', 'Παρακαλώ ελέγξτε τα ήδη καταγεγραμμένα περιστατικά παρακάτω', 1),
(1052, 'for Child\'s ID:', 'για το ID του Παιδιού:', 1),
(1053, 'and Date of Incident:', 'και Ημερομηνία που έλαβε χώρα το Περιστατικό:', 1),
(1054, 'Date-Time of Record', 'Ημερομηνία και Ώρα Καταγραφής', 1),
(1055, 'Display', 'Εμφάνιση', 1),
(1056, 'Add new incident', 'Προσθήκη νέου περιστατικού', 1),
(1057, 'ENTER Username', 'inserire nome utente', 3),
(1058, 'ENTER Password', 'inserire password', 3),
(1059, 'Log in', 'accedere', 3),
(1060, 'MEMO: Meaning of Symbols & Colors', 'MEMO: significato dei simboli e dei colori', 3),
(1061, 'Auto-Completed variable', 'variabile autocompilata', 3),
(1062, 'Variable already recorded by the Operator', 'variabile già registrata dall\'operatore', 3),
(1063, 'Single selection (mutually exclusive codes)', 'selezione singola (i codici si escludono a vicenda)', 3),
(1064, 'Multiple selection (select as many as applicable)', 'selezione multipla (seleziona più di una variabile)', 3),
(1065, 'Open list of sub-codes (drop-down menu)', 'lista aperta di sottocodici (menu a cascata)', 3),
(1066, 'Close list of sub-codes (drop-down menu)', 'lista chiusa di sottocodici (menu a cascata)', 3),
(1067, 'Instruction to Operator', 'istruzioni per l\'operatore', 3),
(1068, 'Recorded Variable’s Name', 'variabile registrata', 3),
(1069, 'Codes of Recorded variable', 'codice della variabile registrato', 3),
(1070, 'Note to Operator for the recording', 'Nota per l\'Operatore per la registrazione', 3),
(1071, 'Note to Operator for system’s operations', 'Nota per l\'operatore sul funzionamento del sistema', 3),
(1072, 'Automated process (filters etc.)', 'procedimento automatizzato (filtri, ecc..)', 3),
(1073, 'ALREADY EXISTING ID (can appear in CHILD’S ID AND in INCIDENT ID)', 'Ientificativo già esistente (può apparire nell\'ID Minore e nell\'ID episodio)', 3),
(1074, 'Skip', 'saltare', 3),
(1075, 'Start Page', 'pagina iniziale', 3),
(1076, 'Operator\'s Panel', '', 3),
(1077, 'my account', '', 3),
(1078, 'Contact Details', '', 3),
(1079, 'Change Password', '', 3),
(1080, 'my previous cases', '', 3),
(1081, 'List of incidents', '', 3),
(1082, 'List of Children’s ID', '', 3),
(1083, 'my current cases', '', 3),
(1084, 'List of temporary Child\'s ID', '', 3),
(1085, 'Information ', '', 3),
(1086, 'New Incident', '', 3),
(1087, 'My Profile', '', 3),
(1088, 'Change Pass', '', 3),
(1089, 'List of Child\'s ID', '', 3),
(1090, 'Log out!', 'uscire', 3),
(1091, 'Welcome', 'Benvenuto', 3),
(1092, 'New ', '', 3),
(1093, 'Record Progress', 'stato della registrazione', 3),
(1094, 'Agency\'s ID', 'identificativo dell\'agenzia', 3),
(1095, 'Operator\'s ID', 'identificativo dell\'operatore', 3),
(1096, 'Child\'s ID', 'identificativo del minore', 3),
(1097, 'Date of Record', 'Data di registrazione', 3),
(1098, 'Incident\'s ID', 'identificativo dell\'episodio', 3),
(1099, 'Date of Incident', 'Data dell\'episodio', 3),
(1100, 'Source of Information', 'fonte di informazione', 3),
(1101, 'Forms of Maltreatment', 'forma di maltrattamento', 3),
(1102, 'Place of Incident', 'Luogo in cui si è verificato l\'episodio', 3),
(1103, 'Child\'s Sex', 'Sesso del Minore', 3),
(1104, 'Child\'s DoB', 'data di nascita del minore', 3),
(1105, 'Child\'s Citizenship Status', 'cittadinanza del minore', 3),
(1106, 'Family Composition', 'Composizione della famiglia', 3),
(1107, 'CGs Relationship to Child', 'relazione tra caregiver e minore', 3),
(1108, 'Caregiver(s)\' Sex', 'sesso del caregiver(s)', 3),
(1109, 'Caregiver(s)\' DoB', 'data di nascita del caregiver', 3),
(1110, 'Institutional Response', 'Risposta dell\'ente', 3),
(1111, 'Referral(s) to Services', 'Rinvio(i) ad altri servizi', 3),
(1112, 'Agencys\'s ID', 'Identificativo dell\' Ente', 3),
(1113, 'Identity Confirmation', 'Conferma la tua identità', 3),
(1114, 'TIP', 'Suggerimento', 3),
(1115, 'If the above information needs update, please contact the CAN-MDS Administration Office.', 'Se le informazioni sotto riportate non sono aggiornate, si prega di contattare l\'amministratore del Sistema CAN', 3),
(1116, 'Date & Type of Incident', '', 3),
(1117, 'Incident ID', 'Identificativo dell\'episodio', 3),
(1118, 'Type Of Record', '', 3),
(1119, 'Type Of Incident', '', 3),
(1120, 'Notifications', '', 3),
(1121, 'Subject', '', 3),
(1122, 'Message', '', 3),
(1123, 'Replace ID', '', 3),
(1124, 'WELCOME TO CAN-MDS', 'BENVENUTO nel DATA SET CAN', 3),
(1125, 'To proceed with the record, please follow the CAN-MDS Operations’ Protocol.', 'Per procedere con la registrazione segui il Protocollo del sistema CAN', 3),
(1126, 'If you need more information, please use the CAN-MDS Guide for Operators.', 'Se hai bisogno di maggiori informazioni consulta la Cuida per gli Operatori del sistema CAN', 3),
(1127, 'Continue with the record', 'proseguire con l\'inserimento', 3),
(1128, 'Please, insert Child’s ID provided to you by the Administrator', 'si prega di inserire l\'Identificativo Minore fornito dall\'Amministratore', 3),
(1129, 'NOT KNOW CHILD\'S ID', '', 3),
(1130, 'The Child’s ID you provided is referred to an', 'l\'identificativo del Minore fornito si riferisce a', 3),
(1131, 'UNKNOWN CHILD', 'MINORE SCONOSCIUTO', 3),
(1132, 'NEW CHILD RECORD', 'NUOVO MINORE', 3),
(1133, 'NEW INCIDENT RECORD', 'NUOVO EPISODIO', 3),
(1134, 'You are going to proceed with the record of a new case of (alleged) child maltreatment.', 'Sta per procedere alla registrazione di un nuovo caso di (sospetto) maltrattamento di minore', 3),
(1135, 'Please proceed with recording of', 'Si prega di procedere con la registrazione di:', 3),
(1136, '-incident related variables', 'Variabili connesse all\'episodio', 3),
(1137, '-child related variables', 'Variabili connesse al minore', 3),
(1138, '-family related variables', 'Variabili connesse alla famiglia', 3),
(1139, '-services related variables', 'Variabili connesse al servizio', 3),
(1140, 'Please record the referred Date of Incident', 'Si prega di registrare la data dell\'episodio segnalato', 3),
(1141, 'Unknown', 'Sconosciuto', 3),
(1142, 'A \"distinct\" event took place – Not continuous maltreatment', '', 3),
(1143, 'YYYY', 'AAAA', 3),
(1144, 'MM', 'MM', 3),
(1145, 'DD', 'GG', 3),
(1146, 'Continuous maltreatment – including \"distinct event(s)\"', '', 3),
(1147, 'start date', 'Data inizio', 3),
(1148, 'duration', 'Durata', 3),
(1149, 'Years', 'Anni', 3),
(1150, 'Months', 'Mesi', 3),
(1151, 'Days', 'Giorni', 3),
(1152, 'During the last 12 months', 'Negli ultimi 12 mesi', 3),
(1153, 'Before the last 12 months', 'Prima degli ultimi 12 mesi', 3),
(1154, 'Lifelong', 'Per tutta la vita', 3),
(1155, 'Last known CM incident date', 'Data dell\'ultimo episodio di maltrattamento conosciuto', 3),
(1156, 'Continuous maltreatment - No \"distinct event\" took place', '', 3),
(1157, 'GO -> R4', 'VAI -> R4', 3),
(1158, 'Click to open sub-list', 'Clicca per aprire la sottolista', 3),
(1159, 'Complete as precisely as possible YYYY-MM-DD', 'Completare il più precisamente possibile', 3),
(1160, 'Neglect/other abuse taking place over a longer period', 'Trascuratezza/altro maltrattamento che ha avuto luogo per un periodo maggiore', 3),
(1161, 'Check ONE in the sub-list', 'Selezionarne uno dalla sottolista', 3),
(1162, 'Click to close sub-list', 'Clicca per chiudere la sottolista', 3),
(1163, 'approximately', 'Approssimativamente', 3),
(1164, 'or less', 'Inferiore', 3),
(1165, 'Wrong date', 'Data errata', 3),
(1166, 'year', 'Anno', 3),
(1167, 'month', 'Mese', 3),
(1168, 'day', 'Giorno', 3),
(1169, 'One day', 'Un giorno', 3),
(1170, 'Please record the Source of Information', 'Si prega di registrare la fonte di informazione', 3),
(1171, 'Unspecified', 'non specificato', 3),
(1172, 'Identified (via routine screening)', 'identificato (tramite screening di routine)', 3),
(1173, 'Child (alleged) victim', 'minore presunta vittima', 3),
(1174, 'Parent /foster parent/ parent’s partner/ care provider', 'genitore/genitore affidatario/partner del genitore/prestatore di cure', 3),
(1175, 'Relative (siblings, grandparents, etc.) living with the child', 'Parente (fratello/i, sorella/e nonni,..) che convive con il minore', 3),
(1176, 'Relative (siblings, grandparents, etc.) not living with the child', 'Parenti (fratello/i, sorella/e nonni,..) che non convivono con il minore', 3),
(1177, 'Friend / Neighbor', 'amico/vicino', 3),
(1178, 'Self-reported as (alleged) perpetrator', 'autodenunciato quale  presunto autore del crimine', 3),
(1179, 'School /preschool /kindergarten personnel', 'personale della scuola/prescuola/asilo', 3),
(1180, 'Leisure activity staff (e.g., scout leader, clergy, sport coach)', 'staff delle attività ricreative (es. capo degli scout, allenatore sportivo, membro del clero', 3),
(1181, 'Anonymous reporter', 'anonimo', 3),
(1182, 'Personnel working in Child day care services', 'personale operante nei servizi educativi', 3),
(1183, 'Personnel working in Social Services/ Public–Central/Local', 'personale operante nei servizi sociali/pubblici-centrali/locali', 3),
(1184, 'Personnel working in Health services', 'personale operante nella sanità', 3),
(1185, 'Personnel working in Mental Health Services', 'personale operante nei servizi di salute mentale', 3),
(1186, 'Personnel working in Ordinary/Juvenile Court and related services', 'personale operante presso il tribunale ordinaio/minorile e servizi connessi', 3),
(1187, 'Personnel working in Police /low enforcement', 'personale operante nella polizia o nelle forze dell\'ordine', 3),
(1188, 'Personnel working in Helpline', 'personale operante presso Helpline', 3),
(1189, 'Personnel working in Community agency including agencies working against DV', 'personale operante presso enti comunitari, inclusi Enti attivi nella lotta alla violenza domestica.', 3),
(1190, 'Personnel working in Ombudsman', 'personale operante presso il difensore civico', 3),
(1191, 'Personnel working in NGOs/associations', 'personale operante presso le ONG/associazioni', 3),
(1192, 'Personnel working in services for people with disabilities', 'personale operante presso servizi per persone con disabilità', 3),
(1193, 'Other', 'altro', 3),
(1194, 'GO -> I3', 'VAI ->I3', 3),
(1195, 'Check ONE from the list', 'Selezionarne UNO dalla lista', 3),
(1196, 'Please record the Form(s) of Maltreatment', 'si prega di registrare la(e) forma(e) di maltrattamento', 3),
(1197, 'Form(s) of Maltreatment', 'Forma(e) di maltrattamento', 3),
(1198, 'Expand/Collapse list', 'menù a comparsa', 3),
(1199, 'Check as many as applicable. By selecting from child menu, broad categories are auto-selected.', 'Spuntare i tipi di maltrattamento/abuso. Selezionando dal menu \"Minore\\', 3),
(1200, 'Please provide as detailed as possible information (by using sub-menus).', 'Si prega di fornire informazioni il più possibile dettagliate (usando i sotto menù)', 3),
(1201, 'Acts Committed', 'atti commessi', 3),
(1202, 'Violent acts against self /Self-harm actions', 'atti di autolesionismo/autolesioni', 3),
(1203, 'Eating disorder', 'disordine alimentare', 3),
(1204, 'Substance use/ abuse', 'uso/abuso di sostanze', 3),
(1205, 'Runaway', 'in fuga da casa', 3),
(1206, 'Self-inflicted injuries', 'atti di autolesionismo', 3),
(1207, 'Suicidal thoughts', 'pensieri suicidi', 3),
(1208, 'Suicide attempt', 'tentato suicidio', 3),
(1209, 'Actual suicide', 'suicidio effettivo', 3),
(1210, 'Other self-harm action (unspecified)', 'Altra azione di autolesionismo (non specificata)', 3),
(1211, 'Physical violence acts committed [with or without injury]', 'Atti di violenza fisica commessi (con o senza lesioni)', 3),
(1212, 'Physical violent acts/ corporal punishment/ “disciplines”', 'Atti fisici violenti/punizioni corporali', 3),
(1213, 'Slapping', 'Schiaffeggiare', 3),
(1214, 'Smacking', 'Percuotere', 3),
(1215, 'Spanking', 'sculacciare', 3),
(1216, 'Pinching', 'pizzicottare', 3),
(1217, 'Twisting ear(s)', 'distorcere le orecchie', 3),
(1218, 'Pulling hair', 'tirare i capelli', 3),
(1219, 'Hitting with an object', 'colpire con un oggetto', 3),
(1220, 'Beating', 'percuotere', 3),
(1221, 'Tying up or tying to something /restraining to cloth sacks', 'legare o legare a qualcosa/immobilizzare in sacchi di tela', 3),
(1222, 'Locking up', 'rinchiudere', 3),
(1223, 'Leaving child to lie in their own excrement', 'abbandonare il minore disteso nei suoi escrementi', 3),
(1224, 'Pushing', 'spingere', 3),
(1225, 'Throwing', 'lanciare', 3),
(1226, 'Shaking', 'scuotere', 3),
(1227, 'Grabbing', 'stringere', 3),
(1228, 'Choking', 'strangolare', 3),
(1229, 'Squeezing neck', 'strizzare il collo', 3),
(1230, 'Kicking', 'dare un calcio', 3),
(1231, 'Hitting on head (with hand or against the wall)', 'colpire la testa (con la mano o contro il muro)', 3),
(1232, 'Boxing ear', 'schiaffeggiare sulle orecchie', 3),
(1233, 'Scratching', 'graffiare', 3),
(1234, 'Biting', 'mordere', 3),
(1235, 'Burning', 'bruciare', 3),
(1236, 'Scalding', 'ustionare', 3),
(1237, 'Violent acts known also as harmful practices', 'atti di violenza, altrimenti noti come pratiche dannose', 3),
(1238, 'Hitting on the soles of the feet', 'colpire sulle punte dei piedi', 3),
(1239, 'Forcing to ingest spicy food', 'costringere ad ingerire cibo piccante', 3),
(1240, 'Forced feeding', 'alimentazione forzata', 3),
(1241, 'Forcing children to stay in uncomfortable positions', 'costringere il minore ad adottare posizioni scomode', 3),
(1242, 'Binding', 'legare', 3),
(1243, 'Inflicting scars/ scarring', 'provocare cicatrici/ sfregiare', 3),
(1244, 'Teeth extraction as punishment', 'estrazione dei denti come atti punitivi', 3),
(1245, 'Branding', 'marchiare', 3),
(1246, 'Fattening', 'costringere a ingrassare', 3),
(1247, '“Retribution” acts of violence', 'atti di violenza punitivi', 3),
(1248, 'Virginity testing (inspecting girls’ genitalia)', 'Test di verginità (ispezioni genitali praticate sulle ragazze)', 3),
(1249, 'Forced circumcision', 'circoncisione forzata', 3),
(1250, 'Female genital mutilation', 'mutilazioni genitali femminili', 3),
(1251, 'Uvulectomy', 'asportazione dell\'ugola', 3),
(1252, 'Forced marriage and early marriage', 'matrimonio forzato e precoce', 3),
(1253, 'Violent and degrading initiation rites / “hazing”', 'Riti di iniziazione violenti e degradanti / atti di nonnismo', 3),
(1254, 'Practices as “exorcism” after accusations of “witchcraft”', 'pratiche quali l\'\"esorcismo\" a seguito di accuse di \"stregoneria\"', 3),
(1255, 'Forced sterilization, particularly girls', 'sterilizzazione forzata, in particolare per ragazze', 3),
(1256, 'Violence in the guise of treatment', 'violenza sotto forma di cure sanitarie', 3),
(1257, 'Deliberate infliction of disabilities for exploiting/begging', 'Procurare in maniera intenzionale menomazioni ai fini dello sfruttamento/ accattonaggio', 3),
(1258, 'Acts of life threatening maltreatment', 'atti intenzionali di maltrattamento ad esito letale', 3),
(1259, 'Administering unnecessary invasive medical procedures', 'attuare procedure mediche invasive non necessarie', 3),
(1260, 'Administering non prescribed substances', 'somministrare sostanze non prescritte', 3),
(1261, 'Child has been given poison', 'avvelenamento intenzionale', 3),
(1262, 'Threatening with a knife (also psychological abuse)', 'minacciare con un coltello (anche abuso psicologico)', 3),
(1263, 'Threatening with a gun (also psychological abuse)', 'minacciare con una pistola (anche abuso psicologico)', 3),
(1264, 'Stabbing', 'accoltellare', 3),
(1265, 'Shooting', 'sparare', 3),
(1266, 'Dowry-related violence/death (also harmful practice)', 'violenza/morte legata alla dote (anche pratica dannosa)', 3),
(1267, '“Honour” crimes (also harmful practice)', 'crimini d\'onore (anche pratica dannosa)', 3),
(1268, 'Abduction-related acts', 'atti relativi al sequestro', 3),
(1269, 'Non-family abduction', 'sequestro extra-familiare', 3),
(1270, 'Family abduction', 'sequestro familiare', 3),
(1271, 'Institutional and system violations of child rights', 'violazioni di  diritti del minore da parte di istituti o del sistema', 3),
(1272, 'Caning', 'bacchettare', 3),
(1273, 'Flogging', 'fustigare', 3),
(1274, 'Stoning', 'lapidare', 3),
(1275, 'Torture (all forms)', 'Tortura (di ogni tipo)', 3),
(1276, 'Amputations', 'amputare', 3),
(1277, 'Imposing of death sentence for crimes committed', 'condanna a morte per crimini commessi', 3),
(1278, 'Other described physical acts', 'altri atti di violenza fisica descritti', 3),
(1279, 'No specific information for reported/suspected physical violence', 'nessuna informazione specifica per registrata/sospetta violenza fisica', 3),
(1280, 'Sexual violence acts committed [with or without injury]', 'atti di violenza sessuale (provocando o meno lesioni)', 3),
(1281, 'Sexual violence acts', 'atti di violenza sessuale', 3),
(1282, 'Acts involving penetration (intrusion)', 'atti che implicano penetrazione (non consensuale)', 3),
(1283, 'Without force', 'senza violenza', 3),
(1284, 'anus', 'ano', 3),
(1285, 'vulva', 'vagina', 3),
(1286, 'mouth', 'bocca', 3),
(1287, 'Involving use of force', 'con uso della forza', 3),
(1288, 'Attempted sexual abuse (not involving penetration)', 'tentato abuso sessuale (senza penetrazione)', 3),
(1289, 'with physical contact', 'con contatto fisico', 3),
(1290, 'without physical contact', 'senza contatto fisico', 3),
(1291, 'Threatened sexual abuse', 'minaccia di abuso sessuale', 3),
(1292, 'Touching/fondling genitals', 'toccare/palpeggiare genitali', 3),
(1293, 'Showing genitals to child', 'mostrare genitali a minori', 3),
(1294, 'Sexual harassment', 'molestie sessuali', 3),
(1295, 'Voyeurism /spying on the children intimate behaviours', 'voyeurismo/ spiare i comportamenti intimi del minore', 3),
(1296, 'Providing sexually explicit materials', 'fornire materiale sessualmente esplicito', 3),
(1297, 'Forced exposure to pornography', 'esposizione forzata alla pornografia', 3),
(1298, 'Forcing to witness sexual violence against mother', 'costretto ad assistere alla violenza sessuale contro la propria madre', 3);
INSERT INTO `u_translate` (`id`, `text_en`, `text_trans`, `language_id`) VALUES
(1299, 'Sexual “luring” (via ICT)', 'adescamento sessuale (tramite TIC o tecnologie ICT)', 3),
(1300, 'Online sexual stalking /harassment', 'molestie sessuali online', 3),
(1301, 'Other Sexual violence acts', 'altri atti di violenza sessuale', 3),
(1302, 'Sexual exploitation acts', 'atti di sfruttamento sessuale', 3),
(1303, 'Child prostitution', 'prostituzione  minorile', 3),
(1304, 'Use of children in commercial sexual exploitation', 'sfruttamento sessuale di minori a scopo commerciale', 3),
(1305, 'Sexual exploitation in travel and tourism', 'sfruttamento sessuale nei viaggi e nel turismo', 3),
(1306, 'Sexual slavery', 'schiavitù sessuale', 3),
(1307, 'Sale of children for sexual purposes', 'vendita di minori per fini sessuali', 3),
(1308, 'Trafficking (within and between countries)', 'commercio di minori (all\'interno e fra nazioni)', 3),
(1309, 'Involvement in pornography', 'coinvolgimento in pornografia', 3),
(1310, 'Other sexual exploitation acts (unspecified)', 'altri atti di sfruttamento sessuale (non specificato)', 3),
(1311, 'No specific information for reported/suspected sexual violence', 'nessuna informazione specifica per riprortata/sospetta violenza sessuale', 3),
(1312, 'Psychological violence acts committed [with or without injury]', 'atti di violenza psicologica (con o senza lesioni)', 3),
(1313, 'Violent acts with or without obvious consequences', 'atti violenti con o senza evidenti conseguenze', 3),
(1314, 'Bullying/ Psychological bullying and hazing', 'bullismo/bullismo psicologico e nonnismo', 3),
(1315, 'by other children', 'da parte di altri minori', 3),
(1316, 'by adults', 'da parte di adulti', 3),
(1317, 'Homophobic bullying /related to sexual orientation', 'bullismo omofobico/relativo all\'orientamento sessuale', 3),
(1318, 'Cyber bullying (via ICTs / mobile phones /Internet)', 'cyberbullismo (tramite TIC o tecnologie dell\'informazionee della comunicazione / cellulari/internet)', 3),
(1319, 'Ignoring and favoritism', 'esclusione e favoritismi', 3),
(1320, 'Denying emotional responsiveness', 'negare la sensibilità emotiva', 3),
(1321, 'Over protection', 'iperprotezione/ipercura', 3),
(1322, 'Isolation (social)', 'isolamento (sociale)', 3),
(1323, 'Close confinement (tying/binding)', 'reclusione (con legatura)', 3),
(1324, 'Placement in solitary confinement', 'reclusione in isolamento', 3),
(1325, 'Degrading /inhuman conditions of detention', 'detenzione in condizioni disumane/degradanti', 3),
(1326, 'Humiliation /Insults, name-calling, belittling, ridiculing', 'umiliare/insultare/ridicolizzare', 3),
(1327, 'Humiliation via ICT', 'umiliare tramite TIC o tecnologie dell\'informazione e della comunicazione', 3),
(1328, 'Rejection and Spurning', 'ripudio e sdegno', 3),
(1329, 'Verbal assaults', 'Aggressioni verbali', 3),
(1330, 'Terrorization / Scaring', 'Spaventare', 3),
(1331, 'Threats of sexual violence (with or without contact)', 'Minacce di violenza sessuale (con o senza contatto)', 3),
(1332, 'Threats of other maltreatment', 'Minacce di altri maltrattamenti', 3),
(1333, 'Other related acts hurting child’s feelings', 'Altri atti che feriscono i sentimenti del bambino', 3),
(1334, 'Exploitation related psychological violent acts', 'Atti di violenza psicologica legati allo sfruttamento', 3),
(1335, 'Exploiting and corrupting', 'Sfruttamento e corruzione', 3),
(1336, 'Labour/economic exploitation', 'Sfruttamento lavorativo / economico', 3),
(1337, 'Forcing to undertake adult\'s responsibilities/parent’s role', 'Costringere il minore ad assumersi  responsabilità da adulto', 3),
(1338, 'Forcing to begging', 'Costringere il minore all\'accattonaggio', 3),
(1339, 'Forcing to participate in religious ritual', 'Partecipazione forzata a riti religiosi', 3),
(1340, 'Forcing to participate in a violent political event', 'Partecipazione forzata ad un atto politico violento', 3),
(1341, 'No specific info for reported/suspected exploitation acts', 'Nessuna informazione specifica per presunti/segnalati atti di sfruttamento', 3),
(1342, 'Exposure related psychological violent acts', 'Esposizione ad atti di violenza psicologica', 3),
(1343, 'Exposure to any kind of violence in the family / DV', 'Esposizione a qualsiasi atto di violenza in famiglia / a violenza domestica', 3),
(1344, 'Exposure to violence against other children', 'Assistere ad atti violenti commessi contro altri bambini', 3),
(1345, 'Exposure to intimate partner violence', 'Assistere ad atti di violenza domestica', 3),
(1346, 'Exposure to violence against other adults', 'Assistere ad atti violenti commessi contro adulti', 3),
(1347, 'Exposition to the homicide of a significant person', 'Assistere all\'omicidio di una persona cara', 3),
(1348, 'Exposure to a violent environment outside the family', 'Esposizione ad un ambiente violento fuori dal nucleo familiare', 3),
(1349, 'Exposure to violence via electronic means', 'Esposizione ad atti violenti tramite media tecnologici', 3),
(1350, 'information and communication technologies', 'Tecnologie dell\'informazione e della comunicazione', 3),
(1351, 'in the mass media', 'Nei mass media', 3),
(1352, 'No specific info for reported/suspected related exposure', 'Nessuna informazione specifica riguardo presunte/registrate minacce', 3),
(1353, 'No specific info for reported/suspected psych/l abuse violent acts', 'Nessuna informazione specifica riguardo presunti/registrati atti di abuso fisico', 3),
(1354, 'Omissions', 'Omissioni', 3),
(1355, 'Omissions in child’s care / Neglect', 'Omissioni nell\'assistenza al minore/trascuratezza', 3),
(1356, 'Emotional neglect related omissions', 'Omissioni connesse alla trascuratezza emozionale', 3),
(1357, 'Persistent ignoring of the child’s emotional needs/ Chronic inattention to the child', 'Persistente disattenzione verso i bisogni emozionali del minore/ noncuranza cronica nei confronti dei bisogni del minore', 3),
(1358, 'Psychologically “unavailable” caregivers', 'Caregiver \"non disponibile\" da un punto di vista psicologico', 3),
(1359, 'Inappropriately advanced expectations (def.  According to child’s characteristics)', 'Aspettative inappropriate rispetto alle caratteristiche del minore', 3),
(1360, 'No specific information for omissions related to emotional neglect', 'Nessuna informazione specifica circa le omissioni connesse alla trascuratezza emozionale del minore', 3),
(1361, 'Physical neglect related omissions', 'Omissioni connesse a trascuratezza fisica', 3),
(1362, 'Inadequate / inappropriate nutrition', 'alimentazione inadeguata/inappropriata', 3),
(1363, 'Inadequate / inappropriate personal hygiene', 'Igiene personale inadeguata/inappropriata', 3),
(1364, 'Inadequate / inappropriate clothing', 'Abbigliamento inadeguato/inappropriato', 3),
(1365, 'Inadequate / inappropriate shelter', 'alloggio  inadeguato/inappropriato', 3),
(1366, 'No specific information for omissions related child’s physical needs', 'Nessuna informazione specifica circa le omissioni connesse a bisogni fisici del minore', 3),
(1367, 'Medical neglect related omissions', 'Omissioni connesse alla trascuratezza sanitaria', 3),
(1368, 'Refusal to provide preventive health care (vaccinations, vision, and dental care)', 'Rifiuto di provvedere ad attività di prevenzione sanitaria (vaccinazioni, cure dentistiche od oculistiche..)', 3),
(1369, 'Refusal to allow /provide needed medical care for diagnosed health condition/ impairment', 'Rifiuto di consentire/fornire le necessarie cure mediche necessarie per problemi di di salute /difetti accertati', 3),
(1370, 'Unjustified delay to seek needed care', 'Ritardo non giustificato nel cercare le cure necessarie', 3),
(1371, 'Failure to provide with basic medical care', 'Inadempienza nel fornire cure mediche di base', 3),
(1372, 'Withholding essential medical care', 'Negare cure mediche necessarie', 3),
(1373, 'No specific information for omissions related child’s medical needs', 'Nessuna informazione specifica per omissioni connesse ai bisogni di cure mediche del minore', 3),
(1374, 'Educational neglect related omissions', 'Omissioni connesse a trascuratezza educativa', 3),
(1375, 'Persistent failure to register child at the school', 'Ripetuta mancata iscrizione del minore a scuola', 3),
(1376, 'Has not attended school at all', 'Evasione scolastica', 3),
(1377, 'Dropped out', 'Abbandono scolastico', 3),
(1378, 'Persistent failure to enrol at the school resulting to irregular school attendance', 'inadempimento dei doveri scolastici per  irregolare frequenza del minore', 3),
(1379, 'compulsory school', 'Nella scuola dell\'obbligo', 3),
(1380, 'non compulsory (ECEC)', 'Non obbligatorio', 3),
(1381, 'Chronic truancy', 'Ricorrente assenza ingiustificata', 3),
(1382, 'Refusal to attend special educational needs', 'rifiuto di prendersi cura di bisogni educativi speciali', 3),
(1383, 'Refusal to allow needed attention to special educational needs', 'rifiuto di consentire la necessaria attenzione a bisogni educativi speciali', 3),
(1384, 'Refusal to provide needed attention to special educational needs', 'rifiuto di fornire la necessaria attenzione a bisogni educativi speciali', 3),
(1385, 'No specific information for omissions related child’s educational needs', 'nessuna informazione specifica su atti omessi per bisogni educativi speciali del minore', 3),
(1386, 'Risk exposure related omissions', 'omissioniconnesse all\'esposizione al rischio', 3),
(1387, 'Exposure to hazardous/ dangerous environments', 'esposizione ad ambienti rischiosi/pericolosi', 3),
(1388, 'Inside household', 'in famiglia', 3),
(1389, 'Outside home', 'fuori casa', 3),
(1390, 'Exposure to substances use/misuse by others', 'esposizione all\'uso/abuso di sostanze da parte di altri', 3),
(1391, 'Alcohol', 'alcol', 3),
(1392, 'Drugs', 'stupefacenti', 3),
(1393, 'Other substances', 'altre sostanze', 3),
(1394, 'No specific information for reported/ suspected omissions for exposure to risks', 'nessuna informazione specifica circa le omissioni connesse a segnalate/presunte omissioni legate all\'esposizione al rischio', 3),
(1395, 'Supervision related omissions', 'omissioni connesse alla supervisione del minore', 3),
(1396, 'Inadequate/ lack of supervision resulting in physical harm', 'supervisione inadeguata/mancanza di supervisione controllo con conseguenti danni fisici', 3),
(1397, 'Persisted lack of supervision concerning substance use/misuse by the child', 'persistente mancanza di controllo riguardo all\'uso/abuso di sostanze da parte del minore', 3),
(1398, 'No specific information for omissions related to the child’s supervision', 'nessuna informazione specifica per omissioni connesse al controllo sul minore', 3),
(1399, 'Refusal of custody/abandonment', 'rifiuto di affidamento in custodia / abbandono', 3),
(1400, 'Unstable custody arrangements', 'accordi  instabili circa l\'affidamento in custodia', 3),
(1401, 'Illegal transfers of custody', 'trasferimenti illegali di custodia', 3),
(1402, 'Refusal of custody', 'rifiuto di affidamento in custodia', 3),
(1403, 'Abandonment (primary caregiver(s) runaway / migrate and leave the children behind)', 'abbandono di minore (per fuga/emigrazione del caregiver primario)', 3),
(1404, 'children out of wedlock', 'minore nato fuori dal matrimonio', 3),
(1405, 'children with disabilities', 'minore con disabilità', 3),
(1406, 'No specific information for omissions related child’s refusal of custody', 'nessuna informazione specifica sulle omissioni relative al rifiuto di custodia nei confronti del minore', 3),
(1407, 'Please record the Place of Incident', 'si prega di registrare il luogo in cui è avvenuto l\'episodio', 3),
(1408, 'Unknown/ Unspecified place', 'luogo sconosciuto/non specificato', 3),
(1409, 'Home/ Family', 'casa/famiglia', 3),
(1410, 'Home/ Relatives', 'casa/parenti', 3),
(1411, 'Home/ Friends', 'casa/amici', 3),
(1412, 'Child care institution (residential care)', 'istituti di assistenza all\'infanzia/assistenza residenziale', 3),
(1413, 'Child care institution (day care)', 'istituti di assistenza all\'infanzia/ assistenza semiresidenziale', 3),
(1414, 'Detention or correctional institution', 'detenzione o carcere minorile', 3),
(1415, 'Leisure/ Playground/ Recreational area', 'tempo libero/parco giochi/area ricreativa', 3),
(1416, 'Sports-athletics', 'sport-atletica', 3),
(1417, 'School', 'scuola', 3),
(1418, 'Educational institution', 'istituto di istruzione', 3),
(1419, 'Medical Services', 'servizi medico-sanitari', 3),
(1420, 'Public transportation', 'mezzi pubblici', 3),
(1421, 'Public place/ street, commercial & surrounding area', 'posti pubblici/strada, area commerciale, circondario', 3),
(1422, 'Other place', 'altro luogo', 3),
(1423, 'GO -> C2', 'VAI -> C2', 3),
(1424, 'Click as many as applicable', 'Seleziona anche più di una', 3),
(1425, 'Please record Child’s Sex, Date of Birth and Citizenship Status', 'Si prega di indicare il sesso del Minore,  la data di nascita e lo stato di cittadinanza', 3),
(1426, 'Male', 'Maschio', 3),
(1427, 'Female', 'Femmina', 3),
(1428, 'Not known', 'Sconosciuto', 3),
(1429, 'Check ONE from the list below', 'Selezionarne uno dalla lista qui sotto', 3),
(1430, 'Child’s Date of Birth', 'Data di nascita del Minore', 3),
(1431, '<18 years old (if no year is known)', '<18 anni (in mancanza di dati relativi all\'età)', 3),
(1432, '<18 years old', '<18 anni', 3),
(1433, '>18 (\"minor\" according to legislation)', '', 3),
(1434, '>18 years old', '>18 anni', 3),
(1435, 'Unborn', 'Non ancora nato', 3),
(1436, 'Please record the full date of birth:', 'Si prega di inserire la data di nascita completa:', 3),
(1437, 'YYYY-MM-DD', 'AAAA-MM-GG', 3),
(1438, 'If DD is unknown:', 'Se GG è sconosciuto:', 3),
(1439, 'YYYY-MM', 'AAAA-MM', 3),
(1440, 'If MM-DD are unknown:', 'Se MM-GG sono sconosciuti:', 3),
(1441, 'If YYYY-MM-DD are unknown AND the alleged victim is a child:', 'Se AAAA-MM-GG sono sconosciuti e la vittima presunta è un minore', 3),
(1442, '<18', '<18', 3),
(1443, 'Citizenship Status', 'Stato di cittadinanza', 3),
(1444, 'Not a citizen', 'Non possiede la cittadinanza', 3),
(1445, 'Citizen', 'Possiede la cittadinanza', 3),
(1446, 'with ID', 'Con documento di identità', 3),
(1447, 'Citizen with ID', 'Cittadino con documento di identità', 3),
(1448, 'without ID', 'Senza documento di identità', 3),
(1449, 'Citizen without ID', 'Cittadino senza carta di identità', 3),
(1450, 'Unaccompanied foreign child or refugee', '', 3),
(1451, 'Check ONE from the list below. If the child is “Citizen”, please define in sub-list', 'Selezionarne UNO dalla lista qui sotto. Se il minore è \"cittadino\" si prega di indicarlo nella sottolista', 3),
(1452, 'Please record Family Composition and indicate up to two Primary Caregivers', 'Si prega di indicare la composizione della famiglia e di indicare fino a due caregiver primari', 3),
(1453, 'A: Type of Family', 'A: tipo di famiglia', 3),
(1454, 'Boarder(s) (child lives in residential/institutional care)', 'ospite(i) (il minore vive in una residenza/istituto di accoglienza)', 3),
(1455, 'Child lives with his/her family (including biological/ adoptive)', 'Minore vive in famiglia (biologica/adottiva)', 3),
(1456, 'Child lives in a foster family', 'Minore vive in famiglia affidataria', 3),
(1457, 'Child lives in a re-composed family', 'Minore vive in una famiglia ricostituita', 3),
(1458, 'Child lives in a family other than its family/ foster family', 'Minore vive in una famiglia diversa dalla sua/famiglia affidataria', 3),
(1459, 'Relatives’ family', 'Parenti', 3),
(1460, 'Child lives in a family other than its family/ foster family - Relatives’ family', 'Minore vive in una famiglia diversa dalla sua/famiglia affidataria- famiglia di parenti', 3),
(1461, 'Friends’ family', 'Famiglia di amici', 3),
(1462, 'Child lives in a family other than its family/ foster family - Friends’ family', 'Minore vive in una famiglia diversa dalla sua/famiglia di amici', 3),
(1463, 'SKIP “B”; GO -> F3', 'SALTA \"B\" VAI-> F3', 3),
(1464, 'If you DON\'T chose Boarder(s) -> B: Members of Family', 'Se NON selezioni ospite(i) -> B: familiari', 3),
(1465, 'B: Member(s) of Family', 'B: Membro(i) della famiglia', 3),
(1466, 'Number', 'Numero', 3),
(1467, 'Primary caregiver(s)', 'Caregiver(s) primario(i)', 3),
(1468, 'Parent(s)', 'Genitori', 3),
(1469, 'Step Parent(s)', 'Genitori adottanti', 3),
(1470, 'Parent(s)’ partner(s)', 'Partner(s) del(i) genitore(i)', 3),
(1471, 'Sibling(s)', 'Fratello(i)/sorella(e)', 3),
(1472, 'Younger than the (alleged) victim', 'di età inferiore rispetto alla presunta vittima', 3),
(1473, 'Older than the (alleged) victim (<18)', 'di età maggiore della presunta vittima (<18)', 3),
(1474, 'Older than the (alleged) victim (>18)', 'di età maggiore della presunta vittima (>18)', 3),
(1475, 'Grandparent(s)', 'Nonni', 3),
(1476, 'Other relative(s)', 'Altri parenti', 3),
(1477, 'Blood relatives', 'Consanguinei', 3),
(1478, '<18 [child(ren)]', '<18 (minore(i))', 3),
(1479, '>18 [adult(s)]', '>18 (adulto(i))', 3),
(1480, 'By law relatives', 'Parenti acquisiti', 3),
(1481, 'Family friend(s)', 'Amico(i)  di famiglia', 3),
(1482, 'Other not-related household members', 'Altri, non legati al/ai familiari', 3),
(1483, 'Please indicate up to 2 child’s primary caregiver(s) (you can uncheck)', 'Si prega di indicare fino a 2 caregiver primari (si può deselezionare)', 3),
(1484, 'members', 'Membri', 3),
(1485, 'member family', 'Familiari', 3),
(1486, 'Please record Caregiver(s) Relationship to Child, Sex and Date of Birth', 'Si prega di specificare il tipo di relazione del caregiver con il Minore, il sesso e la data di nascita', 3),
(1487, 'Relationship to Child', 'Relazione con il Minore', 3),
(1488, '1st Caregiver', 'Caregiver principale', 3),
(1489, 'Professional Caregiver', 'caregiver in possesso di una formazione professionale specialistica', 3),
(1490, 'Temporary caregiver/Other', 'Caregiver temporaneo/altro', 3),
(1491, 'Unknown relationship', 'Relazione sconosciuta', 3),
(1492, 'Check ONE per Caregiver', 'Selezionarne UNO per caregiver', 3),
(1493, 'Caregiver(s) Sex', 'Sesso del(i) caregiver(s)', 3),
(1494, 'Caregiver(s) DoB', 'Data di nascita del(i) caregiver(s)', 3),
(1495, 'YY', 'AA', 3),
(1496, '\'s', '', 3),
(1497, 'YY-MM-DD', 'AA-MM-GG', 3),
(1498, 'If YYYY-MM-DD are unknown then record the decade:', 'Se AAAA-MM-GG sono sconosciuti inserisci la decade', 3),
(1499, 'If DECADE is unknown, then:', 'Se la decade è sconosciuta, allora:', 3),
(1500, 'Please record any Institutional Response', 'si prega di inserire ogni risposta istituzionale', 3),
(1501, 'No response was required DUE TO CHILD’S DEATH', 'non è necessaria alcuna risposta a causa della morte del minore', 3),
(1502, 'No Response', 'nessuna risposta', 3),
(1503, 'Yes', 'sì', 3),
(1504, 'Immediate intervention(s)', 'intervento(i) immediato(i)', 3),
(1505, 'Physical Medical exam(s)', 'visita medica', 3),
(1506, 'Mental Health exam(s)', 'valutazione psichiatrica', 3),
(1507, 'Forensic evaluation initiated', 'avvio di indagine forense', 3),
(1508, 'Child protection /welfare services assessment', 'Valutazione dei servizi di tutela dei minori / di assistenza sociale', 3),
(1509, 'Police intervention', 'intervento della polizia', 3),
(1510, 'Action taken -NO COURT INVOLVEMENT', 'avvio di procedimenti - nessun coinvolgimento del  tribunale', 3),
(1511, 'Child remains in family with planned intervention', 'minore rimasto in famiglia con intervento programmato', 3),
(1512, 'Emergency placement', 'collocazione di emergenza', 3),
(1513, 'Supportive intervention for current caregiver(s)', 'intervento di supporto per l\'attuale caregiver/gli attuali caregiver', 3),
(1514, 'Mother/child shelter with parent and child together', 'rifugio madre/bambino dove il genitore e il minore vivono assieme', 3),
(1515, 'Police emergency protection procedures', 'procedure di tutela di emergenza da parte della polizia', 3),
(1516, 'CPS/welfare services emergency protection procedures', 'procedure di protezione di emergenza da parte dei servizi di tutela dei minori / di assistenza sociale', 3),
(1517, 'Referral to child protection /welfare services', 'rinvio ai servizi di tutela/ di assistenza dei minori', 3),
(1518, 'Action taken -COURT or EQUIVALENT AUTHORITY TO THE COURT INVOLVEMENT', 'avvio di procedimenti-  coinvolgimento del  tribunale o autorità analoga', 3),
(1519, '(Family) Court measures initiated', 'avvio di procedimenti da parte del tribunale (dei minori)', 3),
(1520, 'Action to protect victim by court order(s)', 'disposizioni del tribunale per proteggere la vittima', 3),
(1521, 'Action to remove parent(s)’ rights', 'disposizioni per rimuovere la responsabilità genitoriale', 3),
(1522, 'Expulsion of (alleged) abuser from home', 'disposizione  del Tribunale di allontanamento da casa dell\'abusante', 3),
(1523, 'Action to prosecute perpetrator(s)', 'Disposizioni per perseguire i colpevoli', 3),
(1524, 'Out of home placement', 'collocazione fuori casa', 3),
(1525, 'Kinship Care (relatives/extended family)', 'minori cresciuti da soggetti con cui condividono diversi gradi di parentela (parenti/famiglia allargata)', 3),
(1526, 'Foster Care', 'Affidamento', 3),
(1527, 'Children’s Home Institution', 'residenze per minori', 3),
(1528, 'Adoption with parents’ agreement', 'adozione con il consenso dei genitori', 3),
(1529, 'Adoption by court order', 'adozione su ordine del Tribunale', 3),
(1530, 'GO -> S2', 'VAI -> S2', 3),
(1531, 'Check below as many as applicable', 'Spuntare le caselle sottostanti, anche più di una', 3),
(1532, 'Please record any Referral(s) made to Services by you/your agency', 'si prega di registrare ogni rinvio ad altro servizio effettuato dal suo ente', 3),
(1533, 'None', 'nessuno', 3),
(1534, 'Judicial Services', 'Servizi giudiziari', 3),
(1535, 'for child ONLY', 'SOLO per il minore', 3),
(1536, 'for caregiver(s) ONLY', 'SOLO per il/i caregiver(s)', 3),
(1537, 'for child AND family', 'per il minore E per la famiglia', 3),
(1538, 'Mental Health Services', 'Servizi di salute mentale', 3),
(1539, 'Independent Authorities', 'Autorità indipendenti', 3),
(1540, 'Social Welfare Services', 'Servizi di assistenza sociale', 3),
(1541, 'Law Enforcement related Services', 'Servizi connessi alle forze dell\'ordine', 3),
(1542, 'Community Organizations and NGOs', 'Organizzazioni comunitarie e le ONG', 3),
(1543, 'Existing Registries and Research Organizations', 'Registri esistenti e Organizzazioni di ricerca', 3),
(1544, 'Educational Services', 'Servizi educative', 3),
(1545, 'Other related Services', 'Altri servizi connessi', 3),
(1546, 'End of Record', 'fine della registrazione', 3),
(1547, 'CHECK RECORD OPTIONS', 'CONTROLLA I DATI', 3),
(1548, 'Please check the record options', 'Si prega di verificare le opzioni registrate', 3),
(1549, 'You can make any changes by navigating throught the right panel!', 'E\' possibile apportare le modifiche navigando attraverso il pannello sulla destra', 3),
(1550, 'Incident', 'Episodio', 3),
(1551, 'ID', 'Identificativo', 3),
(1552, 'Sex', 'Sesso', 3),
(1553, 'Date of birth', 'Data di nascita', 3),
(1554, 'Family and Caregiver(s)', 'Famiglia e caregiver(s)', 3),
(1555, 'Services', 'Servizi', 3),
(1556, 'Submit Record', 'Inoltrare i dati', 3),
(1557, 'Loading', 'ustionare', 3),
(1558, 'RECORD COMPLETED', 'REGISTRAZIONE COMPLETATA', 3),
(1559, 'Display/print the record', 'Visualizzare/stampare la registrazione', 3),
(1560, 'Report', 'Relazione', 3),
(1561, 'RECORD', 'REGISTRARE', 3),
(1562, 'Agency', 'Ente', 3),
(1563, 'Information provided by', 'Informazione fornita da', 3),
(1564, 'Age at the date of incident', 'Età al momento in cui si è verificato l\'evento', 3),
(1565, 'Age at the date of recording', 'Età al momento dell\'inserimento', 3),
(1566, 'Type of family', 'Tipo di famiglia', 3),
(1567, 'Family\'s member(s)', 'familiare/i', 3),
(1568, '1st', '1°', 3),
(1569, 'born', 'Nato', 3),
(1570, '2nd', '2°', 3),
(1571, 'Back', 'Indietro', 3),
(1572, 'KNOWN CHILD', 'MINORE SCONOSCIUTO', 3),
(1573, 'EXISTING CHILD RECORD', 'MINORE ESISTENTE', 3),
(1574, 'You are going to proceed with the record of a new CM incident for  the child', 'Sta per procedere con la registrazione di un nuovo episodio di maltrattamento per il minore', 3),
(1575, 'Please proceed with checking of', 'Si prega di procedere con il controllo di', 3),
(1576, 'TIP: Update –if needed', 'Suggerimento: aggiornare se necessario', 3),
(1577, 'Known Incidents', 'episodio conosciuto', 3),
(1578, 'The incident you are trying to record might already exist!', 'l\'episodio che stai per registrare potrebbe essere già stato registrato!', 3),
(1579, 'Please check the incident record(s) below', 'si prega di controllare il record dell\'episodio  registrato qui sotto', 3),
(1580, 'for Child\'s ID:', 'per ID Minore', 3),
(1581, 'and Date of Incident:', 'e data dell\'episodio', 3),
(1582, 'Date-Time of Record', 'Data di inserimento', 3),
(1583, 'Display', 'Dimostrazione', 3),
(1584, 'Add new incident', 'aggiungi nuovi episodi', 3),
(1585, 'ENTER Username', 'INTRODUCEŢI numele de utilizator', 4),
(1586, 'ENTER Password', 'INTRODUCEŢI parola', 4),
(1587, 'Log in', 'Logare', 4),
(1588, 'MEMO: Meaning of Symbols & Colors', 'MEMO: Semnificaţia Simbolurilor & Culorilor', 4),
(1589, 'Auto-Completed variable', 'Variabilă auto-completată', 4),
(1590, 'Variable already recorded by the Operator', 'Variabilă deja înregistrată de către operator', 4),
(1591, 'Single selection (mutually exclusive codes)', 'Selecție unică (codurile se exclud reciproc)', 4),
(1592, 'Multiple selection (select as many as applicable)', 'Selecție multiplă (selectați cât mai multe, după caz)', 4),
(1593, 'Open list of sub-codes (drop-down menu)', 'Deschideți lista de opțiuni', 4),
(1594, 'Close list of sub-codes (drop-down menu)', 'Închideţi lista de opțiuni', 4),
(1595, 'Instruction to Operator', 'Instrucțiuni pentru operator', 4),
(1596, 'Recorded Variable’s Name', 'Înregistraţi numele variabilei', 4),
(1597, 'Codes of Recorded variable', 'Codurile variabilei înregistrate', 4),
(1598, 'Note to Operator for the recording', 'Notă pentru operator pentru înregistrare', 4),
(1599, 'Note to Operator for system’s operations', 'Notă pentru operator pentru operațiunile de sistem', 4),
(1600, 'Automated process (filters etc.)', 'Proces automat (filtre, etc.)', 4),
(1601, 'ALREADY EXISTING ID (can appear in CHILD’S ID AND in INCIDENT ID)', 'DI există deja  (poate să apară în DI ale COPILULUI și în DI ale INCIDENTULUI)', 4),
(1602, 'Skip', 'Săriţi / treceţi peste', 4),
(1603, 'Start Page', 'Incepeţi pagina', 4),
(1604, 'Operator\'s Panel', '', 4),
(1605, 'my account', 'Contul meu', 4),
(1606, 'Contact Details', 'Contact', 4),
(1607, 'Change Password', 'Schimbă parola', 4),
(1608, 'my previous cases', ' cazurile mele anterioare', 4),
(1609, 'List of incidents', 'Lista incidentelor', 4),
(1610, 'List of Children’s ID', ' Lista datelor de identificare (DI) ale copiilor', 4),
(1611, 'my current cases', ' cazurile mele curente', 4),
(1612, 'List of temporary Child\'s ID', 'Lista datelor de identificare (DI) temporare  ale copiilor', 4),
(1613, 'Information ', '', 4),
(1614, 'New Incident', 'incident nou', 4),
(1615, 'My Profile', '', 4),
(1616, 'Change Pass', 'Schimbă parola', 4),
(1617, 'List of Child\'s ID', '', 4),
(1618, 'Log out!', 'Ieșiţi', 4),
(1619, 'Welcome', 'Bine aţi venit', 4),
(1620, 'New ', 'nou', 4),
(1621, 'Record Progress', 'Înregistrați progresul', 4),
(1622, 'Agency\'s ID', 'DI ale agenției', 4),
(1623, 'Operator\'s ID', 'DI ale operatorului', 4),
(1624, 'Child\'s ID', 'DI ale copilului', 4),
(1625, 'Date of Record', 'Data înregistrării', 4),
(1626, 'Incident\'s ID', 'DI ale incidentului', 4),
(1627, 'Date of Incident', 'Data incidentului', 4),
(1628, 'Source of Information', 'Sursa de informare', 4),
(1629, 'Forms of Maltreatment', 'Forme de maltratare', 4),
(1630, 'Place of Incident', 'Locul incidentului', 4),
(1631, 'Child\'s Sex', 'Sex copilului', 4),
(1632, 'Child\'s DoB', 'Data nașterii copilului', 4),
(1633, 'Child\'s Citizenship Status', 'Cetățenia copilului', 4),
(1634, 'Family Composition', 'Componența familiei', 4),
(1635, 'CGs Relationship to Child', 'Relația îngrijitorilor/ îngrijitorului principal cu copilul', 4),
(1636, 'Caregiver(s)\' Sex', 'Sexul îngrijitorilor/ îngrijitorului', 4),
(1637, 'Caregiver(s)\' DoB', 'Data nașterii îngrijitorilor/ îngrijitorului', 4),
(1638, 'Institutional Response', 'Răspuns instituțional', 4),
(1639, 'Referral(s) to Services', 'Sesizare pentru acordarea de servicii', 4),
(1640, 'Agencys\'s ID', 'DI ale agentiei', 4),
(1641, 'Identity Confirmation', 'Confirmarea identităţii', 4),
(1642, 'TIP', 'RECOMANDARE', 4),
(1643, 'If the above information needs update, please contact the CAN-MDS Administration Office.', 'În cazul în care informațiile de mai sus au nevoie de actualizare, vă rugăm contactați Biroul de Administrare CAN-SMD.', 4),
(1644, 'Date & Type of Incident', 'Data şi tipul incidentului', 4),
(1645, 'Incident ID', 'DI ale Incidentului', 4),
(1646, 'Type Of Record', 'Tipul înregistrării', 4),
(1647, 'Type Of Incident', '', 4),
(1648, 'Notifications', 'Notificări', 4),
(1649, 'Subject', 'subiect', 4),
(1650, 'Message', 'mesaj', 4),
(1651, 'Replace ID', ' Înlocuieşte DI', 4),
(1652, 'WELCOME TO CAN-MDS', 'Bine aţi venit pe CAN-SMD', 4),
(1653, 'To proceed with the record, please follow the CAN-MDS Operations’ Protocol.', 'Pentru a continua înregistrarea, vă rugăm urmați protocolul operațiuni CAN SMD.', 4),
(1654, 'If you need more information, please use the CAN-MDS Guide for Operators.', 'Dacă aveți nevoie de mai multe informații, vă rugăm folosiți Ghidul CAN-SMD pentru operatori.', 4),
(1655, 'Continue with the record', 'Continuați cu înregistrarea', 4),
(1656, 'Please, insert Child’s ID provided to you by the Administrator', 'Vă rugăm introduceți DI ale copilului care v-au fost furnizate de către administrator', 4),
(1657, 'NOT KNOW CHILD\'S ID', 'DI ALE COPILULUI NECUNOSCUT', 4),
(1658, 'The Child’s ID you provided is referred to an', 'DI datele de identificare ale copilului pe care le-ați furnizat se referă la', 4),
(1659, 'UNKNOWN CHILD', 'COPIL NECUNOSCUT', 4),
(1660, 'NEW CHILD RECORD', 'COPIL ÎNREGISTRARE NOUĂ', 4),
(1661, 'NEW INCIDENT RECORD', 'ÎNREGISTRAREA UNUI INCIDENT NOU', 4),
(1662, 'You are going to proceed with the record of a new case of (alleged) child maltreatment.', 'Aveți de gând să continuați cu înregistrarea unui nou caz de (presupusă) maltratare a copilului.', 4),
(1663, 'Please proceed with recording of', 'Continuați cu înregistrarea', 4),
(1664, '-incident related variables', 'variabilelor legate de incident', 4),
(1665, '-child related variables', 'variabilele legate de copil', 4),
(1666, '-family related variables', 'variabilele legate de familie', 4),
(1667, '-services related variables', 'variabilelor legate de servicii', 4),
(1668, 'Please record the referred Date of Incident', 'Vă rugăm înregistraţi data la care incidentul a fost referit', 4),
(1669, 'Unknown', 'Necunoscut', 4),
(1670, 'A \"distinct\" event took place – Not continuous maltreatment', '', 4),
(1671, 'YYYY', 'AA anul', 4),
(1672, 'MM', 'LL luna', 4),
(1673, 'DD', 'ZZ ziua', 4),
(1674, 'Continuous maltreatment – including \"distinct event(s)\"', '', 4),
(1675, 'start date', 'data de început', 4),
(1676, 'duration', 'durată', 4),
(1677, 'Years', 'ani', 4),
(1678, 'Months', 'luni', 4),
(1679, 'Days', 'zile', 4),
(1680, 'During the last 12 months', 'Pe parcursul ultimelor 12 luni', 4),
(1681, 'Before the last 12 months', 'Înainte de ultimele 12 luni', 4),
(1682, 'Lifelong', 'Pe tot parcursul vieții', 4),
(1683, 'Last known CM incident date', 'Data ultimului incident', 4),
(1684, 'Continuous maltreatment - No \"distinct event\" took place', '', 4),
(1685, 'GO -> R4', 'MERGEŢI LA  -> R4', 4),
(1686, 'Click to open sub-list', 'Click pentru a deschide sub-lista', 4),
(1687, 'Complete as precisely as possible YYYY-MM-DD', 'Completați cât mai precis posibil AAAA-LL-ZZ', 4),
(1688, 'Neglect/other abuse taking place over a longer period', 'Neglijare / alte abuzuri care au loc de vreme îndelungată', 4),
(1689, 'Check ONE in the sub-list', 'Verificați UNA / UNUL din sub-listă', 4),
(1690, 'Click to close sub-list', 'Click pentru a închide sub-lista', 4),
(1691, 'approximately', 'aproximativ', 4),
(1692, 'or less', 'sau mai puțin', 4),
(1693, 'Wrong date', 'data greșită', 4),
(1694, 'year', 'an', 4),
(1695, 'month', 'lună', 4),
(1696, 'day', 'zi', 4),
(1697, 'One day', 'într-o zi', 4),
(1698, 'Please record the Source of Information', 'Vă rugăm înregistraţi sursa de informare', 4),
(1699, 'Unspecified', 'nespecificat', 4),
(1700, 'Identified (via routine screening)', 'Identificată (prin scanarea de rutina)', 4),
(1701, 'Child (alleged) victim', 'Copil (presupusa) victimă', 4),
(1702, 'Parent /foster parent/ parent’s partner/ care provider', 'Părinte / părinte de plasament sau asistent maternal/ partenerul părintelui / îngrijitor', 4),
(1703, 'Relative (siblings, grandparents, etc.) living with the child', 'Rude (frați, surori, bunici, etc.) care trăiesc cu copilul', 4),
(1704, 'Relative (siblings, grandparents, etc.) not living with the child', 'Rude (frați, surori, bunici, etc.) care nu locuiesc cu copilul', 4),
(1705, 'Friend / Neighbor', 'Prieten / vecin', 4),
(1706, 'Self-reported as (alleged) perpetrator', '(Presupusul) făptuitor autodeclarat', 4),
(1707, 'School /preschool /kindergarten personnel', 'Personal din şcoală / învăţământ preșcolar / grădiniță', 4),
(1708, 'Leisure activity staff (e.g., scout leader, clergy, sport coach)', 'Personal pentru activităţi de petrecere a timpului liber (de exemplu, lider cercetaș, cler, antrenor sportiv)', 4),
(1709, 'Anonymous reporter', 'Raportor anonim', 4),
(1710, 'Personnel working in Child day care services', 'Personal care lucrează în serviciile de îngrijire de zi pentru copii', 4),
(1711, 'Personnel working in Social Services/ Public–Central/Local', 'Personal care lucrează în domeniul serviciilor sociale / publice centrale sau locale', 4),
(1712, 'Personnel working in Health services', 'Personal care lucrează în serviciile de sănătate', 4),
(1713, 'Personnel working in Mental Health Services', 'Personal care lucrează în serviciile de sănătate mintală', 4),
(1714, 'Personnel working in Ordinary/Juvenile Court and related services', 'Personal care lucrează în instanțele de judecată (ex. tribunal pentru minori) și servicii conexe', 4),
(1715, 'Personnel working in Police /low enforcement', 'Personal care lucrează în poliție / instituțiile de aplicare a legii', 4),
(1716, 'Personnel working in Helpline', 'Personal care lucrează cu liniile de sprijin în situaţii de criză', 4),
(1717, 'Personnel working in Community agency including agencies working against DV', 'Personal care lucrează într-o agenție comunitară, inclusiv în agenții care lucrează împotriva violenţei domestice', 4),
(1718, 'Personnel working in Ombudsman', 'Personal care lucrează la Avocatul Poporului', 4),
(1719, 'Personnel working in NGOs/associations', 'Personal care lucrează în ONG-uri / asociații și fundații', 4),
(1720, 'Personnel working in services for people with disabilities', 'Personal care lucrează în serviciile pentru persoanele cu dizabilități', 4),
(1721, 'Other', 'Altele', 4),
(1722, 'GO -> I3', 'MERGEŢI LA -> I3', 4),
(1723, 'Check ONE from the list', 'Verificați UNA / UNUL din listă', 4),
(1724, 'Please record the Form(s) of Maltreatment', 'Vă rugăm înregistraţi forma / formele de maltratare', 4),
(1725, 'Form(s) of Maltreatment', 'Forma/ forme de maltratare', 4),
(1726, 'Expand/Collapse list', 'Lista extinsă / Listă redusă', 4),
(1727, 'Check as many as applicable. By selecting from child menu, broad categories are auto-selected.', 'Verificați cât mai multe, după caz. Prin selectarea din meniul copil, se auto-selectează categoriile largi.', 4),
(1728, 'Please provide as detailed as possible information (by using sub-menus).', 'Vă rugăm furnizați informații cât mai detaliate (prin utilizarea de sub-meniuri).', 4),
(1729, 'Acts Committed', 'Acte comise', 4),
(1730, 'Violent acts against self /Self-harm actions', 'Acte violente împotriva propriei persoane/ auto-vătămare corporală', 4),
(1731, 'Eating disorder', 'Tulburare de alimentatie', 4),
(1732, 'Substance use/ abuse', 'Consum de substante / abuz', 4),
(1733, 'Runaway', 'Fuga/Alungarea de acasă', 4),
(1734, 'Self-inflicted injuries', 'Leziuni auto-provocate', 4),
(1735, 'Suicidal thoughts', 'Gânduri suicidale', 4),
(1736, 'Suicide attempt', 'cu tentativă de suicid', 4),
(1737, 'Actual suicide', 'Rele tratamente urmate de sinucidere reușită', 4),
(1738, 'Other self-harm action (unspecified)', 'Alte acțiuni de auto-vătămare (nespecificat)', 4),
(1739, 'Physical violence acts committed [with or without injury]', 'Acte comise de violența fizică [cu sau fără vătămare]', 4),
(1740, 'Physical violent acts/ corporal punishment/ “disciplines”', 'Acte violente fizice / pedepse corporale / \"disciplinare\"', 4),
(1741, 'Slapping', 'Bătaie', 4),
(1742, 'Smacking', 'Pălmuire', 4),
(1743, 'Spanking', 'Pui de bătaie', 4),
(1744, 'Pinching', 'Ciupit', 4),
(1745, 'Twisting ear(s)', 'Răsucirea urechilor', 4),
(1746, 'Pulling hair', 'Tragerea de păr', 4),
(1747, 'Hitting with an object', 'Lovirea cu un obiect', 4),
(1748, 'Beating', 'Bătaie', 4),
(1749, 'Tying up or tying to something /restraining to cloth sacks', 'Legarea sau legarea de ceva / imobilizarea în saci de pânză', 4),
(1750, 'Locking up', 'Întemniţa/ încuia', 4),
(1751, 'Leaving child to lie in their own excrement', 'Lăsarea copilului să stea în propriile excremente', 4),
(1752, 'Pushing', 'Împingerea', 4),
(1753, 'Throwing', 'Aruncarea', 4),
(1754, 'Shaking', 'A zgudui', 4),
(1755, 'Grabbing', 'Înşfăcare', 4),
(1756, 'Choking', 'Sufocare', 4),
(1757, 'Squeezing neck', 'Strângere de gât', 4),
(1758, 'Kicking', 'Lovirea cu piciorul', 4),
(1759, 'Hitting on head (with hand or against the wall)', 'Lovirea capului (cu mâna sau de perete)', 4),
(1760, 'Boxing ear', 'Lovirea cu palma peste ureche', 4),
(1761, 'Scratching', 'A zgâria', 4),
(1762, 'Biting', 'A muşca', 4),
(1763, 'Burning', 'A arde', 4),
(1764, 'Scalding', 'A opărî', 4),
(1765, 'Violent acts known also as harmful practices', 'Acte violente cunoscute de asemenea ca practici dăunătoare', 4),
(1766, 'Hitting on the soles of the feet', 'Lovirea peste tălpile picioarelor', 4),
(1767, 'Forcing to ingest spicy food', 'Forţarea de a ingera alimente picante', 4),
(1768, 'Forced feeding', 'Hrănire forțată', 4),
(1769, 'Forcing children to stay in uncomfortable positions', 'Forţarea copiilor de-a sta în poziții incomode', 4),
(1770, 'Binding', 'Legarea', 4),
(1771, 'Inflicting scars/ scarring', 'A provoca răni/ tăieturi/ cicatrici', 4),
(1772, 'Teeth extraction as punishment', 'Extracția de dinti ca pedeapsă', 4),
(1773, 'Branding', 'A înfiera', 4),
(1774, 'Fattening', 'Îngrășare', 4),
(1775, '“Retribution” acts of violence', 'Acte  violente de pedeapsire', 4),
(1776, 'Virginity testing (inspecting girls’ genitalia)', 'Testarea virginităţii (inspecția organelor genitale la fete)', 4),
(1777, 'Forced circumcision', 'Circumcizia forțată', 4),
(1778, 'Female genital mutilation', 'Mutilarea genitală a femeilor', 4),
(1779, 'Uvulectomy', 'Excizia omuşorului', 4),
(1780, 'Forced marriage and early marriage', 'Căsătorie forțată și căsătorie timpurie', 4),
(1781, 'Violent and degrading initiation rites / “hazing”', 'Ritualuri de inițiere violente și degradante / \"hărțuire\"', 4),
(1782, 'Practices as “exorcism” after accusations of “witchcraft”', 'Practici ca \"exorcism\", după acuzații de \"vrăjitorie\"', 4),
(1783, 'Forced sterilization, particularly girls', 'Sterilizare forțată, în special fete', 4),
(1784, 'Violence in the guise of treatment', 'Violența deghizată în tratament', 4),
(1785, 'Deliberate infliction of disabilities for exploiting/begging', 'Dizabilitare intenționată în scopuri de exploatare / cerșit', 4),
(1786, 'Acts of life threatening maltreatment', 'Acte de maltratare care pune viața în pericol (cu intenție)', 4),
(1787, 'Administering unnecessary invasive medical procedures', 'Administrarea de proceduri medicale invazive inutile', 4),
(1788, 'Administering non prescribed substances', 'Administrarea de substanțe neprescrise', 4),
(1789, 'Child has been given poison', '(intenționat) Otrăvire', 4),
(1790, 'Threatening with a knife (also psychological abuse)', 'Amenințarea cu un cuțit (abuz de asemenea psihologic)', 4),
(1791, 'Threatening with a gun (also psychological abuse)', 'Amenințarea cu un pistol (abuz de asemenea psihologic)', 4),
(1792, 'Stabbing', 'Înjunghiere', 4),
(1793, 'Shooting', 'Filmare', 4),
(1794, 'Dowry-related violence/death (also harmful practice)', 'Violență / moarte legată de zestre (practică de asemenea dăunătoare)', 4),
(1795, '“Honour” crimes (also harmful practice)', 'Crimă din ”onoare” (practică de asemenea dăunătoare)', 4),
(1796, 'Abduction-related acts', 'Acte legate de răpire', 4),
(1797, 'Non-family abduction', 'Răpire de către o persoană din afara familiei', 4),
(1798, 'Family abduction', 'Răpire de familie', 4),
(1799, 'Institutional and system violations of child rights', 'Încălcări instituționale și de sistem ale drepturilor copilului', 4),
(1800, 'Caning', 'A bate cu băţul', 4),
(1801, 'Flogging', 'Biciuire', 4),
(1802, 'Stoning', 'Lapidare (lovire cu pietre)', 4),
(1803, 'Torture (all forms)', 'Tortura (toate formele)', 4),
(1804, 'Amputations', 'Amputaţii', 4),
(1805, 'Imposing of death sentence for crimes committed', 'A impune condamnarea la moarte pentru crimele comise', 4),
(1806, 'Other described physical acts', 'Alte acte fizice descrise', 4),
(1807, 'No specific information for reported/suspected physical violence', 'Nu există informații specifice pentru violența fizică raportată / suspectată', 4),
(1808, 'Sexual violence acts committed [with or without injury]', 'Acte comise de violență sexuală [cu sau fără prejudiciu]', 4),
(1809, 'Sexual violence acts', 'Acte de violență sexuală', 4),
(1810, 'Acts involving penetration (intrusion)', 'Actele care implică penetrare (intruziune)', 4),
(1811, 'Without force', 'Fără forţă', 4),
(1812, 'anus', 'anal', 4),
(1813, 'vulva', 'vaginal', 4),
(1814, 'mouth', 'oral', 4),
(1815, 'Involving use of force', 'Ce implică utilizarea forței', 4),
(1816, 'Attempted sexual abuse (not involving penetration)', 'Tentativă de abuz sexual  (care nu implică penetrare)', 4),
(1817, 'with physical contact', 'cu contact fizic', 4),
(1818, 'without physical contact', 'fără contact fizic', 4),
(1819, 'Threatened sexual abuse', 'Ameninţarea cu abuzul sexual', 4),
(1820, 'Touching/fondling genitals', 'Atingerea organelor genitale / giugiuleală', 4),
(1821, 'Showing genitals to child', 'Expunerea organelor genitale în faţa copilului', 4),
(1822, 'Sexual harassment', 'Hărțuire sexuală', 4),
(1823, 'Voyeurism /spying on the children intimate behaviours', 'Voyeurism / spionaj asupra comportamentelor intime ale copilului', 4),
(1824, 'Providing sexually explicit materials', 'Furnizarea de materiale sexuale explicite', 4),
(1825, 'Forced exposure to pornography', 'Expunerea forțată la pornografie', 4),
(1826, 'Forcing to witness sexual violence against mother', 'Forţarea de a asista la violența sexuală împotriva mamei', 4),
(1827, 'Sexual “luring” (via ICT)', '\"Ademenirea\" sexuală (prin TIC)', 4),
(1828, 'Online sexual stalking /harassment', 'Urmarire sexuală online  / hărțuire', 4),
(1829, 'Other Sexual violence acts', 'Alte acte de violență sexuală', 4),
(1830, 'Sexual exploitation acts', 'Acte de exploatare sexuală', 4),
(1831, 'Child prostitution', 'Prostituarea copiilor', 4),
(1832, 'Use of children in commercial sexual exploitation', 'Utilizarea copiilor în exploatarea sexuală comercială', 4),
(1833, 'Sexual exploitation in travel and tourism', 'Exploatarea sexuală în voiaj și turism', 4),
(1834, 'Sexual slavery', 'Sclavie sexuală', 4),
(1835, 'Sale of children for sexual purposes', 'Comerţ cu copii în scopuri sexuale', 4),
(1836, 'Trafficking (within and between countries)', 'Traficul (în interiorul ţării și între țări)', 4),
(1837, 'Involvement in pornography', 'Implicarea în pornografie', 4),
(1838, 'Other sexual exploitation acts (unspecified)', 'Alte acte de exploatare sexuală (nespecificat)', 4),
(1839, 'No specific information for reported/suspected sexual violence', 'Nu există informații/urme specifice pentru violența sexuală raportată / suspectată', 4),
(1840, 'Psychological violence acts committed [with or without injury]', 'Acte comise de violența psihologică [cu sau fără prejudiciu]', 4),
(1841, 'Violent acts with or without obvious consequences', 'Acte de violență, cu sau fără urme', 4),
(1842, 'Bullying/ Psychological bullying and hazing', 'Intimidare / terorizare psihologică și hărțuire', 4),
(1843, 'by other children', 'de alți copii', 4),
(1844, 'by adults', 'de adulți', 4),
(1845, 'Homophobic bullying /related to sexual orientation', 'Hărțuire homofobă / legată de orientarea sexuală', 4),
(1846, 'Cyber bullying (via ICTs / mobile phones /Internet)', 'Terorizare cibernetică (prin TIC / telefoane mobile / internet)', 4),
(1847, 'Ignoring and favoritism', 'Ignorare și favoritism', 4),
(1848, 'Denying emotional responsiveness', 'Negarea sensibilităţii emoţionale', 4),
(1849, 'Over protection', 'Hiperprotecție', 4),
(1850, 'Isolation (social)', 'Izolare (socială)', 4),
(1851, 'Close confinement (tying/binding)', 'Captivitate în relaţiile apropiate (care leagă / legare)', 4),
(1852, 'Placement in solitary confinement', 'Plasarea în regim de captivitate solitară', 4),
(1853, 'Degrading /inhuman conditions of detention', 'Condiții degradante / inumane de detenție', 4),
(1854, 'Humiliation /Insults, name-calling, belittling, ridiculing', 'Umilirea / insultarea, batjocorirea, discreditarea, ridiculizarea', 4),
(1855, 'Humiliation via ICT', 'Umilirea prin telefon, internet, etc.', 4),
(1856, 'Rejection and Spurning', 'Respingere și disprețuire', 4),
(1857, 'Verbal assaults', 'Atacuri verbale', 4),
(1858, 'Terrorization / Scaring', 'Terorizarea / Înfricoşarea', 4),
(1859, 'Threats of sexual violence (with or without contact)', 'Amenințări cu violența sexuală (cu sau fără de contact)', 4),
(1860, 'Threats of other maltreatment', 'Amenințări cu alte maltratări', 4),
(1861, 'Other related acts hurting child’s feelings', 'Alte acte asociate / conexe /similare ce rănesc sentimentele copilului', 4),
(1862, 'Exploitation related psychological violent acts', 'Acte psihologice violente asociate / conexe / similare exploatării', 4),
(1863, 'Exploiting and corrupting', 'Exploatare și corupere', 4),
(1864, 'Labour/economic exploitation', 'Exploatare economică/ prin muncă', 4),
(1865, 'Forcing to undertake adult\'s responsibilities/parent’s role', 'Forţarea de a-şi asuma responsabilități de adult', 4),
(1866, 'Forcing to begging', 'Forţarea la cerșetorie', 4),
(1867, 'Forcing to participate in religious ritual', 'Forţarea de a participa la ritualuri religioase', 4),
(1868, 'Forcing to participate in a violent political event', 'Forţarea de a participa la un eveniment politic violent', 4),
(1869, 'No specific info for reported/suspected exploitation acts', 'Fără informaţii specifice pentru actele de exploatare raportate/ suspectate', 4),
(1870, 'Exposure related psychological violent acts', 'Acte psihologice violente similare / conexe expunerii', 4),
(1871, 'Exposure to any kind of violence in the family / DV', 'Expunerea la orice fel de violență în familie / violenţă domestică', 4),
(1872, 'Exposure to violence against other children', 'Expunerea la violența împotriva altor copii', 4),
(1873, 'Exposure to intimate partner violence', 'Expunerea la violenţa asupra partenerului intim', 4),
(1874, 'Exposure to violence against other adults', 'Expunerea la violența împotriva altor adulți', 4),
(1875, 'Exposition to the homicide of a significant person', 'Expunerea la omuciderea unei persoane semnificative', 4),
(1876, 'Exposure to a violent environment outside the family', 'Expunerea la un mediu violent din afara familiei', 4),
(1877, 'Exposure to violence via electronic means', 'Expunerea la violență prin mijloace electronice', 4),
(1878, 'information and communication technologies', 'tehnologii ale informației și comunicațiilor', 4),
(1879, 'in the mass media', 'în mass-media', 4),
(1880, 'No specific info for reported/suspected related exposure', 'Fără informaţii specifice pentru expunere similară', 4),
(1881, 'No specific info for reported/suspected psych/l abuse violent acts', 'Fără informaţii specifice pentru acte violente de abuz psihologic', 4),
(1882, 'Omissions', 'Omisiunile', 4),
(1883, 'Omissions in child’s care / Neglect', 'Omisiuni în  îngrijirea copilului / Neglijarea', 4),
(1884, 'Emotional neglect related omissions', 'Omisiuni similare / asociate neglijării emoționale / legate de îngrijirea emoţională', 4),
(1885, 'Persistent ignoring of the child’s emotional needs/ Chronic inattention to the child', 'Ignorarea persistentă a nevoilor emoționale / lipsa cronică de atenţie faţă de copil', 4),
(1886, 'Psychologically “unavailable” caregivers', 'Persoanele care îngrijesc copii sunt indisponibile psihologic', 4),
(1887, 'Inappropriately advanced expectations (def.  According to child’s characteristics)', 'Așteptări ridicate inadecvate (def. În acord cu caracteristicile copilului)', 4),
(1888, 'No specific information for omissions related to emotional neglect', 'Fără informații specifice pentru omisiuni similare neglijării emoționale', 4),
(1889, 'Physical neglect related omissions', 'Omisiuni similare neglijării fizice / legate de îngrijirea fizică', 4),
(1890, 'Inadequate / inappropriate nutrition', 'Nutriție inadecvată / nepotrivită', 4),
(1891, 'Inadequate / inappropriate personal hygiene', 'Igienă personală indecvată / nepotrivită', 4),
(1892, 'Inadequate / inappropriate clothing', 'Îmbrăcăminte inadecvată / nepotrivită', 4),
(1893, 'Inadequate / inappropriate shelter', 'Adăpost inadecvat/ nepotrivit', 4),
(1894, 'No specific information for omissions related child’s physical needs', 'Nu există informații specifice pentru omisiuni legate de nevoile fizice ale copilului', 4),
(1895, 'Medical neglect related omissions', 'Omisiuni similare neglijării medicale/ legate de îngrijirea medicală', 4),
(1896, 'Refusal to provide preventive health care (vaccinations, vision, and dental care)', 'Refuzul de a asigura îngrijirea preventivă a sănătăţii (vaccinări, fler şi îngrijire dentară)', 4),
(1897, 'Refusal to allow /provide needed medical care for diagnosed health condition/ impairment', 'Refuzul de a permite / a asigura îngrijirea medicală necesară pentru starea de sănătate diagnosticată/ deteriorată', 4),
(1898, 'Unjustified delay to seek needed care', 'Întârziere nejustificată în căutare îngrijirii necesare', 4),
(1899, 'Failure to provide with basic medical care', 'Eşecul de-a asigura îngrijirea medicală de bază', 4),
(1900, 'Withholding essential medical care', 'Refuzul de-a asigura îngrijirea medicală de bază', 4);
INSERT INTO `u_translate` (`id`, `text_en`, `text_trans`, `language_id`) VALUES
(1901, 'No specific information for omissions related child’s medical needs', 'Nu există informații specifice pentru omisiuni legate de nevoile medicale ale copilului', 4),
(1902, 'Educational neglect related omissions', 'Omisiuni similare neglijării educaţionle/ legate de educaţie', 4),
(1903, 'Persistent failure to register child at the school', 'Eșec persistent de-a înscrie copilul la şcoală', 4),
(1904, 'Has not attended school at all', 'Nu a urmat şcoala deloc', 4),
(1905, 'Dropped out', 'A abandonat școala', 4),
(1906, 'Persistent failure to enrol at the school resulting to irregular school attendance', 'Frecventarea neregulată a școlii ca urmare a eșecului persistent de-a înscrie copilul la şcoală', 4),
(1907, 'compulsory school', 'frecventarea școlară obligatorie', 4),
(1908, 'non compulsory (ECEC)', 'Școlarizare fără participare școlară obligatorie (ECEC)', 4),
(1909, 'Chronic truancy', 'Chiul cronic', 4),
(1910, 'Refusal to attend special educational needs', 'Refuzul de a se îngriji de nevoi educaționale speciale', 4),
(1911, 'Refusal to allow needed attention to special educational needs', 'Refuzul de a permite atenția necesară faţă de nevoi educaționale speciale', 4),
(1912, 'Refusal to provide needed attention to special educational needs', 'Refuzul de a asigura atenția necesară faţă de nevoi educaționale speciale', 4),
(1913, 'No specific information for omissions related child’s educational needs', 'Nu există informații specifice pentru omisiuni legate de nevoile educaționale ale copilului', 4),
(1914, 'Risk exposure related omissions', 'Omisiuni similare expunerii la risc / legate de protecţia faţă de expunerea la risc', 4),
(1915, 'Exposure to hazardous/ dangerous environments', 'Expunerea la medii periculoase', 4),
(1916, 'Inside household', 'În casă', 4),
(1917, 'Outside home', 'În afara casei', 4),
(1918, 'Exposure to substances use/misuse by others', 'Expunerea la consumul de substanțe / abuzul de către alții', 4),
(1919, 'Alcohol', 'Alcool', 4),
(1920, 'Drugs', 'Droguri', 4),
(1921, 'Other substances', 'Alte substanțe', 4),
(1922, 'No specific information for reported/ suspected omissions for exposure to risks', 'Nu există informații specifice pentru omisiunile raportate / suspectate referitoare la expunerea la riscuri', 4),
(1923, 'Supervision related omissions', 'Omisiuni legate de supraveghere', 4),
(1924, 'Inadequate/ lack of supervision resulting in physical harm', 'Inadecvare în / lipsa de supraveghere ce a dus la vătămări fizice', 4),
(1925, 'Persisted lack of supervision concerning substance use/misuse by the child', 'Lipsa persistată de supraveghere cu privire la consumul de substante / abuzul de către copil', 4),
(1926, 'No specific information for omissions related to the child’s supervision', 'Nu există informații specifice pentru omisiuni referitoare la supravegherea copilului', 4),
(1927, 'Refusal of custody/abandonment', 'Refuzul de custodie / abandon', 4),
(1928, 'Unstable custody arrangements', 'Aranjamente de custodie instabilă', 4),
(1929, 'Illegal transfers of custody', 'Transferuri ilegale de custodie', 4),
(1930, 'Refusal of custody', 'Refuzul de custodie', 4),
(1931, 'Abandonment (primary caregiver(s) runaway / migrate and leave the children behind)', 'Abandon (îngrijitorul principal fuge / migrează și părăseşte copiii)', 4),
(1932, 'children out of wedlock', 'copii din afara căsătoriei', 4),
(1933, 'children with disabilities', 'copiii cu dizabilități', 4),
(1934, 'No specific information for omissions related child’s refusal of custody', 'Nu există informații specifice pentru omisiunile legate de custodie/ similare refuzului de custodie', 4),
(1935, 'Please record the Place of Incident', 'Vă rugăm înregistraţi locaţia incidentului', 4),
(1936, 'Unknown/ Unspecified place', 'Loc necunoscut / nespecificat', 4),
(1937, 'Home/ Family', 'Casă / Familie', 4),
(1938, 'Home/ Relatives', 'Casă / Rude', 4),
(1939, 'Home/ Friends', 'Casă / Prieteni', 4),
(1940, 'Child care institution (residential care)', 'Centru rezidențial', 4),
(1941, 'Child care institution (day care)', 'Centru de zi', 4),
(1942, 'Detention or correctional institution', 'Instituție de detenție sau corecțională', 4),
(1943, 'Leisure/ Playground/ Recreational area', 'Timp liber / loc de joaca / zonă de agrement', 4),
(1944, 'Sports-athletics', 'Sport atletism', 4),
(1945, 'School', 'Şcoală', 4),
(1946, 'Educational institution', 'Instituție de învățământ', 4),
(1947, 'Medical Services', 'Servicii medicale', 4),
(1948, 'Public transportation', 'Transport public', 4),
(1949, 'Public place/ street, commercial & surrounding area', 'Loc public / stradă, zonă comercială & înconjurătoare', 4),
(1950, 'Other place', 'Alte locaţii', 4),
(1951, 'GO -> C2', 'MERGEŢI LA -> C2', 4),
(1952, 'Click as many as applicable', 'Faceți clic pe cât mai multe, după caz', 4),
(1953, 'Please record Child’s Sex, Date of Birth and Citizenship Status', 'Vă rugăm înregistraţi sexul copilului, data nașterii și cetățenia lui', 4),
(1954, 'Male', 'masculin', 4),
(1955, 'Female', 'femeie', 4),
(1956, 'Not known', 'Necunoscut', 4),
(1957, 'Check ONE from the list below', 'Verificați UNA/ UNUL din lista de mai jos', 4),
(1958, 'Child’s Date of Birth', 'Data nașterii copilului', 4),
(1959, '<18 years old (if no year is known)', '<18 ani (în cazul în care nu se cunoaște anul)', 4),
(1960, '<18 years old', '<18 ani', 4),
(1961, '>18 (\"minor\" according to legislation)', '', 4),
(1962, '>18 years old', '> 18 ani', 4),
(1963, 'Unborn', 'Nenăscut', 4),
(1964, 'Please record the full date of birth:', 'Vă rugăm înregistraţi data nașterii:', 4),
(1965, 'YYYY-MM-DD', 'AAAA-LL-ZZ', 4),
(1966, 'If DD is unknown:', 'Dacă ZZ este necunoscută:', 4),
(1967, 'YYYY-MM', 'AAAA-LL', 4),
(1968, 'If MM-DD are unknown:', 'În cazul în care LL-ZZ sunt necunoscute:', 4),
(1969, 'If YYYY-MM-DD are unknown AND the alleged victim is a child:', 'Dacă AAAA-LL-ZZ sunt necunoscute și presupusa victima este un copil:', 4),
(1970, '<18', '<18', 4),
(1971, 'Citizenship Status', 'Cetățenia', 4),
(1972, 'Not a citizen', 'Fără cetățenie Ro', 4),
(1973, 'Citizen', 'Cetățean', 4),
(1974, 'with ID', 'are CNP', 4),
(1975, 'Citizen with ID', 'Cetățean cu CNP', 4),
(1976, 'without ID', 'Nu are CNP (certificat de naștere)', 4),
(1977, 'Citizen without ID', 'Cetățean fără CNP (certificat de naștere)', 4),
(1978, 'Unaccompanied foreign child or refugee', '', 4),
(1979, 'Check ONE from the list below. If the child is “Citizen”, please define in sub-list', 'Alegeți O VARIANTĂ din lista de mai jos. În cazul în care copilul este cetăţean Român, vă rugăm să definiți în sub-listă', 4),
(1980, 'Please record Family Composition and indicate up to two Primary Caregivers', 'Vă rugăm înregistraţi componența familiei și indicaţi până la două persoane principale care îngrijesc copilul', 4),
(1981, 'A: Type of Family', 'A: Tipul de familie', 4),
(1982, 'Boarder(s) (child lives in residential/institutional care)', 'Copil/copii în plasament instituțional/îngrijire rezidențială', 4),
(1983, 'Child lives with his/her family (including biological/ adoptive)', 'Copilul locuieste cu familia lui/ ei (inclusiv biologică / adoptivă)', 4),
(1984, 'Child lives in a foster family', 'Copilul trăiește într-o familie de plasament', 4),
(1985, 'Child lives in a re-composed family', 'Copilul trăiește într-o familie re-organizată (părinți recăsătoriți)', 4),
(1986, 'Child lives in a family other than its family/ foster family', 'Copilul trăiește într-o altă familie decât familia lui/ ei', 4),
(1987, 'Relatives’ family', 'Rudele familiei', 4),
(1988, 'Child lives in a family other than its family/ foster family - Relatives’ family', 'Copilul trăiește într-o altă familie decât familia lui/ ei  - Rudele familiei', 4),
(1989, 'Friends’ family', 'Prietenii familiei', 4),
(1990, 'Child lives in a family other than its family/ foster family - Friends’ family', 'Copilul trăiește într-o altă familie decât familia lui/ ei  - Prietenii familiei', 4),
(1991, 'SKIP “B”; GO -> F3', 'SĂRIŢI \"B\"; MERGEŢI LA -> F3', 4),
(1992, 'If you DON\'T chose Boarder(s) -> B: Members of Family', 'Dacă NU AŢI ALES Copil/ copii în pensiune (în îngrijire rezidenţială/ instituţională)-> B: Membrii de familie', 4),
(1993, 'B: Member(s) of Family', 'B: membru (membrii) de familie', 4),
(1994, 'Number', 'Număr', 4),
(1995, 'Primary caregiver(s)', 'Pentru principalele/principala persoană care îngrijește copilul', 4),
(1996, 'Parent(s)', 'Părinte/ părinţi', 4),
(1997, 'Step Parent(s)', 'Părinte/ părinţi vitregi', 4),
(1998, 'Parent(s)’ partner(s)', 'Partenerii/ partenerul părintelui/ părinţilor', 4),
(1999, 'Sibling(s)', 'Fraţi şi/sau surori', 4),
(2000, 'Younger than the (alleged) victim', 'Mai tânăr/ă decât (presupusa) victimă', 4),
(2001, 'Older than the (alleged) victim (<18)', 'Mai în vârstă decât (presupusa) victima (<18)', 4),
(2002, 'Older than the (alleged) victim (>18)', 'Mai în vârstă decât (presupusa) victima (> 18)', 4),
(2003, 'Grandparent(s)', 'Bunic/ bunică/ bunici', 4),
(2004, 'Other relative(s)', 'Altă rudă/ alte rude', 4),
(2005, 'Blood relatives', 'Rude de sânge', 4),
(2006, '<18 [child(ren)]', '<18 [copil/ copii]', 4),
(2007, '>18 [adult(s)]', '> 18 [adult /adulţi]', 4),
(2008, 'By law relatives', 'Rude de drept/ prin lege', 4),
(2009, 'Family friend(s)', 'Prieten/ prieteni de familie', 4),
(2010, 'Other not-related household members', 'Alți membri din gospodărie care nu sunt legaţi (prin sânge sau lege)', 4),
(2011, 'Please indicate up to 2 child’s primary caregiver(s) (you can uncheck)', 'Vă rugăm indicați până la două persoane principale care îngrijesc copilul (puteți debifa)', 4),
(2012, 'members', 'membrii', 4),
(2013, 'member family', 'membru de familie', 4),
(2014, 'Please record Caregiver(s) Relationship to Child, Sex and Date of Birth', 'Vă rugăm înregistraţi relaţia îngrijitorilor/ îngrijitorului principal cu copilul, sexul și data nașterii', 4),
(2015, 'Relationship to Child', 'Relația cu copilul', 4),
(2016, '1st Caregiver', 'primul îngrijitor', 4),
(2017, 'Professional Caregiver', 'Îngrijitor profesional', 4),
(2018, 'Temporary caregiver/Other', 'Îngrijitor temporar / altele', 4),
(2019, 'Unknown relationship', 'Relație necunoscută', 4),
(2020, 'Check ONE per Caregiver', 'Verificați câte UNUL pentru fiecare îngrijitor', 4),
(2021, 'Caregiver(s) Sex', 'Sexul îngrijitorilor/ îngrijitorului', 4),
(2022, 'Caregiver(s) DoB', 'Data nașterii îngrijitorilor/ îngrijitorului', 4),
(2023, 'YY', 'AA', 4),
(2024, '\'s', '', 4),
(2025, 'YY-MM-DD', 'AA-LL-ZZ', 4),
(2026, 'If YYYY-MM-DD are unknown then record the decade:', 'Dacă AAAA-LL-ZZ sunt necunoscute, atunci înregistraţi deceniul:', 4),
(2027, 'If DECADE is unknown, then:', 'Dacă DECENIUL este necunoscut, atunci:', 4),
(2028, 'Please record any Institutional Response', 'Vă rugăm înregistraţi orice răspuns instituțional', 4),
(2029, 'No response was required DUE TO CHILD’S DEATH', 'NU a fost solicitat nici-un răspuns din cauza decesului COPILULUI', 4),
(2030, 'No Response', 'FĂRĂ răspuns', 4),
(2031, 'Yes', 'Da', 4),
(2032, 'Immediate intervention(s)', 'Intervenţii imediate', 4),
(2033, 'Physical Medical exam(s)', 'Examenare medicală - starea fizică', 4),
(2034, 'Mental Health exam(s)', 'Examen de Sănătate Mintală', 4),
(2035, 'Forensic evaluation initiated', 'Inițiată evaluarea medico-legală', 4),
(2036, 'Child protection /welfare services assessment', 'Evaluarea Serviciilor de protecția copilului / protecţie socială', 4),
(2037, 'Police intervention', 'Intervenția Poliției', 4),
(2038, 'Action taken -NO COURT INVOLVEMENT', 'Acțiuni întreprinse - FĂRĂ IMPLICAREA TRIBUNALULUI', 4),
(2039, 'Child remains in family with planned intervention', 'Copilul rămâne în familie cu intervenție planificată', 4),
(2040, 'Emergency placement', 'Plasament de urgență', 4),
(2041, 'Supportive intervention for current caregiver(s)', 'Susținerea persoanei care actualmente îngrijește copilul', 4),
(2042, 'Mother/child shelter with parent and child together', 'Adăpost pentru mamă / copii cu părinți și copii împreună', 4),
(2043, 'Police emergency protection procedures', 'Intervenția poliției în regim de urgență', 4),
(2044, 'CPS/welfare services emergency protection procedures', 'Intervenția serviciilor de protecție a copilului  / protecţie socială în regim de urgență', 4),
(2045, 'Referral to child protection /welfare services', 'Referire la serviciile de protecție a copilului / de protecție socială', 4),
(2046, 'Action taken -COURT or EQUIVALENT AUTHORITY TO THE COURT INVOLVEMENT', 'Acțiuni întreprinse - CU IMPLICAREA TRIBUNALULUI SAU A UNOR AUTORITĂŢI SIMILARE', 4),
(2047, '(Family) Court measures initiated', 'Măsuri iniţiate de tribunal', 4),
(2048, 'Action to protect victim by court order(s)', 'Măsura de protecție a  victimei prin hotărâre judecătorească', 4),
(2049, 'Action to remove parent(s)’ rights', 'Suspendarea  drepturilor părinteşti', 4),
(2050, 'Expulsion of (alleged) abuser from home', 'Evacuarea agresorului din domiciliu prin hotărâre judecătorească', 4),
(2051, 'Action to prosecute perpetrator(s)', 'Urmărirea penală a făptuitorilor', 4),
(2052, 'Out of home placement', 'Scoaterea copilului din familie', 4),
(2053, 'Kinship Care (relatives/extended family)', 'Îngrijire din partea rudelor (rude / familie extinsă)', 4),
(2054, 'Foster Care', 'Asistentă maternală', 4),
(2055, 'Children’s Home Institution', 'Instituţia Casa de copii', 4),
(2056, 'Adoption with parents’ agreement', 'Adopţia cu acordul părinților', 4),
(2057, 'Adoption by court order', 'Adopţia prin hotărâre judecătorească', 4),
(2058, 'GO -> S2', 'MERGEŢI LA -> S2', 4),
(2059, 'Check below as many as applicable', 'Verificați mai jos cât mai multe, după caz', 4),
(2060, 'Please record any Referral(s) made to Services by you/your agency', 'Vă rugăm înregistraţi orice referire / referirile către servicii făcute de dvs/ agenția dvs', 4),
(2061, 'None', 'Niciuna / niciunul', 4),
(2062, 'Judicial Services', 'Servicii judiciare', 4),
(2063, 'for child ONLY', 'DOAR pentru copil', 4),
(2064, 'for caregiver(s) ONLY', 'DOAR pentru îngrijitori / îngrijitor', 4),
(2065, 'for child AND family', 'pentru Copil și Familie', 4),
(2066, 'Mental Health Services', 'Servicii de Sănătate Mintală', 4),
(2067, 'Independent Authorities', 'Autorități independente', 4),
(2068, 'Social Welfare Services', 'Servicii sociale', 4),
(2069, 'Law Enforcement related Services', 'Instituții și servicii de monitorizare a aplicarii legislației', 4),
(2070, 'Community Organizations and NGOs', 'Organizatii civice și ONG-uri', 4),
(2071, 'Existing Registries and Research Organizations', 'Instituții de arhivare și Institutii de cercetare', 4),
(2072, 'Educational Services', 'Servicii educaționale', 4),
(2073, 'Other related Services', 'Alte servicii conexe', 4),
(2074, 'End of Record', 'Finalizarea înregistrării', 4),
(2075, 'CHECK RECORD OPTIONS', 'VERIFICAŢI OPŢIUNILE DE ÎNREGISTRARE', 4),
(2076, 'Please check the record options', 'Vă rugăm verificați opțiunile de înregistrare', 4),
(2077, 'You can make any changes by navigating throught the right panel!', 'Puteți face orice modificări navigând prin aplicaţia din dreapta!', 4),
(2078, 'Incident', 'Incident', 4),
(2079, 'ID', 'DI', 4),
(2080, 'Sex', 'Sex', 4),
(2081, 'Date of birth', 'Data nașterii', 4),
(2082, 'Family and Caregiver(s)', 'Familie și îngrijitori / îngrijitor', 4),
(2083, 'Services', 'Servicii', 4),
(2084, 'Submit Record', 'Trimite înregistrarea', 4),
(2085, 'Loading', 'A opărî', 4),
(2086, 'RECORD COMPLETED', 'ÎNREGISTRARE FINALIZATĂ', 4),
(2087, 'Display/print the record', 'Afișează / imprimă înregistrarea', 4),
(2088, 'Report', 'Raport', 4),
(2089, 'RECORD', 'ÎNREGISTRARE', 4),
(2090, 'Agency', 'agenție', 4),
(2091, 'Information provided by', 'Informații furnizate de', 4),
(2092, 'Age at the date of incident', 'Vârsta la data incidentului', 4),
(2093, 'Age at the date of recording', 'Vârsta la data înregistrării', 4),
(2094, 'Type of family', 'Tipul de familie', 4),
(2095, 'Family\'s member(s)', 'Pentru membrul/ii familiei', 4),
(2096, '1st', 'primul', 4),
(2097, 'born', 'născut', 4),
(2098, '2nd', 'al 2-lea', 4),
(2099, 'Back', 'Înapoi', 4),
(2100, 'KNOWN CHILD', 'COPILUL RECUNOSCUT ÎN BAZA DE DATE', 4),
(2101, 'EXISTING CHILD RECORD', 'COPILUL A FOST IN PREALABIL INREGISTRAT ÎN BAZA DE DATE', 4),
(2102, 'You are going to proceed with the record of a new CM incident for  the child', 'Continuați cu înregistrarea unui nou incident de maltratare a copilului', 4),
(2103, 'Please proceed with checking of', 'Vă rugăm înregistrați/ verificați', 4),
(2104, 'TIP: Update –if needed', 'SFAT: Actualizaţi daca este necesar', 4),
(2105, 'Known Incidents', 'Incidente cunoscute', 4),
(2106, 'The incident you are trying to record might already exist!', 'Incidentul pe care încercați să-l înregistraţi ar putea exista deja!', 4),
(2107, 'Please check the incident record(s) below', 'Vă rugăm verificați înregistrarea incidentului de mai jos', 4),
(2108, 'for Child\'s ID:', 'pentru DI ale copilului:', 4),
(2109, 'and Date of Incident:', 'și data incidentului:', 4),
(2110, 'Date-Time of Record', 'Data - Ora înregistrării', 4),
(2111, 'Display', 'Expunere', 4),
(2112, 'Add new incident', 'Adăugați incident nou', 4),
(2113, 'ENTER Username', 'VOER gebruikersnaam IN', 5),
(2114, 'ENTER Password', 'VOER wachtwoord IN', 5),
(2115, 'Log in', 'Log in', 5),
(2116, 'MEMO: Meaning of Symbols & Colors', 'MEMO: betekenis van symbolen en kleuren', 5),
(2117, 'Auto-Completed variable', 'Automatisch aangevulde variabele', 5),
(2118, 'Variable already recorded by the Operator', 'Variabele al genoteerd door de gebruiker', 5),
(2119, 'Single selection (mutually exclusive codes)', 'Enkelvoudige selectie (onverenigbare codes)', 5),
(2120, 'Multiple selection (select as many as applicable)', 'Meervoudige selectie (selecteer alles wat van toepassing is)', 5),
(2121, 'Open list of sub-codes (drop-down menu)', 'Open lijst met subcodes (uitklapmenu)', 5),
(2122, 'Close list of sub-codes (drop-down menu)', 'Sluit lijst met subcodes (uitklapmenu)', 5),
(2123, 'Instruction to Operator', 'Instructie voor gebruiker', 5),
(2124, 'Recorded Variable’s Name', 'Naam van genoteerde variabele', 5),
(2125, 'Codes of Recorded variable', 'Codes van genoteerde variabele', 5),
(2126, 'Note to Operator for the recording', 'Noot voor de gebruiker voor het noteren', 5),
(2127, 'Note to Operator for system’s operations', 'Noot voor de gebruiker voor de systeemfuncties', 5),
(2128, 'Automated process (filters etc.)', 'Geautomatiseerde procedure (filters enz.)', 5),
(2129, 'ALREADY EXISTING ID (can appear in CHILD’S ID AND in INCIDENT ID)', 'AL BESTAAND ID (kan verschijnen in ID VAN HET KIND EN in ID VAN HET INCIDENT)', 5),
(2130, 'Skip', 'Sla over', 5),
(2131, 'Start Page', 'Startpagina', 5),
(2132, 'Operator\'s Panel', '', 5),
(2133, 'my account', '', 5),
(2134, 'Contact Details', '', 5),
(2135, 'Change Password', '', 5),
(2136, 'my previous cases', '', 5),
(2137, 'List of incidents', '', 5),
(2138, 'List of Children’s ID', '', 5),
(2139, 'my current cases', '', 5),
(2140, 'List of temporary Child\'s ID', '', 5),
(2141, 'Information ', '', 5),
(2142, 'New Incident', '', 5),
(2143, 'My Profile', '', 5),
(2144, 'Change Pass', '', 5),
(2145, 'List of Child\'s ID', '', 5),
(2146, 'Log out!', 'Log out!', 5),
(2147, 'Welcome', 'Welkom', 5),
(2148, 'New ', '', 5),
(2149, 'Record Progress', 'Verloop bestand', 5),
(2150, 'Agency\'s ID', 'ID van het agentschap', 5),
(2151, 'Operator\'s ID', 'ID van gebruiker', 5),
(2152, 'Child\'s ID', 'ID van het kind', 5),
(2153, 'Date of Record', 'Datum van noteren', 5),
(2154, 'Incident\'s ID', 'ID van het incident', 5),
(2155, 'Date of Incident', 'Datum van het incident', 5),
(2156, 'Source of Information', 'Informatiebron', 5),
(2157, 'Forms of Maltreatment', 'Vormen van mishandeling', 5),
(2158, 'Place of Incident', 'Plaats van het incident', 5),
(2159, 'Child\'s Sex', 'Geslacht van het kind', 5),
(2160, 'Child\'s DoB', 'Geboortedatum van het kind', 5),
(2161, 'Child\'s Citizenship Status', 'Status staatsburgerschap van het kind', 5),
(2162, 'Family Composition', 'Gezinssamenstelling', 5),
(2163, 'CGs Relationship to Child', 'Relatie tot het kind van de verzorger', 5),
(2164, 'Caregiver(s)\' Sex', 'Geslacht verzorger(s)', 5),
(2165, 'Caregiver(s)\' DoB', 'Geboortedatum van  de verzorger(s)', 5),
(2166, 'Institutional Response', 'Formele respons', 5),
(2167, 'Referral(s) to Services', 'Verwijzing(en) naar diensten', 5),
(2168, 'Agencys\'s ID', 'ID van het agentschap', 5),
(2169, 'Identity Confirmation', 'Bevestiging identificatie', 5),
(2170, 'TIP', 'TIP', 5),
(2171, 'If the above information needs update, please contact the CAN-MDS Administration Office.', 'Neen contact op met de administratieve afdeling van CAN-MDS als de informatie hierboven een update moet krijgen.', 5),
(2172, 'Date & Type of Incident', '', 5),
(2173, 'Incident ID', 'ID van het incident', 5),
(2174, 'Type Of Record', '', 5),
(2175, 'Type Of Incident', '', 5),
(2176, 'Notifications', '', 5),
(2177, 'Subject', '', 5),
(2178, 'Message', '', 5),
(2179, 'Replace ID', '', 5),
(2180, 'WELCOME TO CAN-MDS', 'WELKOM BIJ CAN-MDS', 5),
(2181, 'To proceed with the record, please follow the CAN-MDS Operations’ Protocol.', 'Volg het gebruikersprotocol van CAN-MDS om verder te gaan met het bestand.', 5),
(2182, 'If you need more information, please use the CAN-MDS Guide for Operators.', 'Raadpleeg de gebruikershandleiding van CAN-MDS voor meer informatie.', 5),
(2183, 'Continue with the record', 'Ga verder met het bestand', 5),
(2184, 'Please, insert Child’s ID provided to you by the Administrator', 'Voeg het ID van het kind in dat de beheerder u gaf', 5),
(2185, 'NOT KNOW CHILD\'S ID', '', 5),
(2186, 'The Child’s ID you provided is referred to an', 'De ID van het kind die u ingaf, verwijst naar een', 5),
(2187, 'UNKNOWN CHILD', 'ONBEKEND KIND', 5),
(2188, 'NEW CHILD RECORD', 'BESTAND NIEUW KIND', 5),
(2189, 'NEW INCIDENT RECORD', 'BESTAND VAN EEN NIEUW INCIDENT', 5),
(2190, 'You are going to proceed with the record of a new case of (alleged) child maltreatment.', 'U gaat nu verder met het bestand van een nieuw geval van (vermeende) kindermishandeling', 5),
(2191, 'Please proceed with recording of', 'Noteer nu het volgende:', 5),
(2192, '-incident related variables', '-incidentgerelateerde variabelen', 5),
(2193, '-child related variables', '-kindgerelateerde variabelen', 5),
(2194, '-family related variables', '-gezinsgerelateerde variabelen', 5),
(2195, '-services related variables', '-dienstgerelateerde variabelen', 5),
(2196, 'Please record the referred Date of Incident', 'Noteer de betreffende datum van het incident', 5),
(2197, 'Unknown', 'Onbekend', 5),
(2198, 'A \"distinct\" event took place – Not continuous maltreatment', '', 5),
(2199, 'YYYY', 'JJJJ', 5),
(2200, 'MM', 'MM', 5),
(2201, 'DD', 'DD', 5),
(2202, 'Continuous maltreatment – including \"distinct event(s)\"', '', 5),
(2203, 'start date', 'begindatum', 5),
(2204, 'duration', 'duur', 5),
(2205, 'Years', 'Jaren', 5),
(2206, 'Months', 'Maanden', 5),
(2207, 'Days', 'Dagen', 5),
(2208, 'During the last 12 months', 'Gedurende de afgelopen 12 maanden', 5),
(2209, 'Before the last 12 months', 'Voor de afgelopen 12 maanden', 5),
(2210, 'Lifelong', 'Levenslang', 5),
(2211, 'Last known CM incident date', 'Datum laatste bekende KM-incident', 5),
(2212, 'Continuous maltreatment - No \"distinct event\" took place', '', 5),
(2213, 'GO -> R4', 'GA NAAR -> R4', 5),
(2214, 'Click to open sub-list', 'Klik om de sublijst te openen', 5),
(2215, 'Complete as precisely as possible YYYY-MM-DD', 'Vul zo correct mogelijk JJJJ-MM-DD in', 5),
(2216, 'Neglect/other abuse taking place over a longer period', 'Verwaarlozing/andere mishandeling gedurende een langere periode', 5),
(2217, 'Check ONE in the sub-list', 'Duid EEN ITEM aan in de sublijst', 5),
(2218, 'Click to close sub-list', 'Klik om te sluiten sublijst', 5),
(2219, 'approximately', 'ongeveer', 5),
(2220, 'or less', 'of minder', 5),
(2221, 'Wrong date', 'Verkeerde datum', 5),
(2222, 'year', 'jaar', 5),
(2223, 'month', 'maand', 5),
(2224, 'day', 'dag', 5),
(2225, 'One day', 'Een dag', 5),
(2226, 'Please record the Source of Information', 'Noteer de informatiebron', 5),
(2227, 'Unspecified', 'niet gespecificeerd', 5),
(2228, 'Identified (via routine screening)', 'Ge?dentificeerd (via routinescreening)', 5),
(2229, 'Child (alleged) victim', 'Kind (vermeend) slachtoffer', 5),
(2230, 'Parent /foster parent/ parent’s partner/ care provider', 'Ouder/pleegouder/partner van de ouder/verzorger', 5),
(2231, 'Relative (siblings, grandparents, etc.) living with the child', 'Familielid (broers en zussen, grootouders enz.) die met het kind samenwonen', 5),
(2232, 'Relative (siblings, grandparents, etc.) not living with the child', 'Familielid (broers en zussen, grootouders enz.) die niet met het kind samenwonen', 5),
(2233, 'Friend / Neighbor', 'Vriend/buur', 5),
(2234, 'Self-reported as (alleged) perpetrator', 'Zelf aangemeld als (vermeende) dader', 5),
(2235, 'School /preschool /kindergarten personnel', 'Personeel van de school/peuterklas/kleuterschool', 5),
(2236, 'Leisure activity staff (e.g., scout leader, clergy, sport coach)', 'Team van de vrijetijdsbesteding (bv. scoutsleider, geestelijke, sportcoach)', 5),
(2237, 'Anonymous reporter', 'Anonieme melder', 5),
(2238, 'Personnel working in Child day care services', 'Personeel van diensten voor kinderdagverblijf', 5),
(2239, 'Personnel working in Social Services/ Public–Central/Local', 'Personeel van sociale diensten/openbaar-centraal/plaatselijk', 5),
(2240, 'Personnel working in Health services', 'Personeel van gezondheidszorg', 5),
(2241, 'Personnel working in Mental Health Services', 'Personeel van diensten voor geestelijke gezondheidszorg', 5),
(2242, 'Personnel working in Ordinary/Juvenile Court and related services', 'Personeel van rechtbank/jeugdrechtbank en gerelateerde diensten', 5),
(2243, 'Personnel working in Police /low enforcement', 'Personeel van politie/ordehandhaving', 5),
(2244, 'Personnel working in Helpline', 'Personeel van hulplijn', 5),
(2245, 'Personnel working in Community agency including agencies working against DV', 'Personeel van publieke agentschappen, ook agentschappen die strijden tegen huiselijk geweld', 5),
(2246, 'Personnel working in Ombudsman', 'Personeel van de ombudsdienst', 5),
(2247, 'Personnel working in NGOs/associations', 'Personeel van ngo\'s/verenigingen', 5),
(2248, 'Personnel working in services for people with disabilities', 'Personeel van diensten voor mensen met een handicap', 5),
(2249, 'Other', 'Andere', 5),
(2250, 'GO -> I3', 'GA NAAR I3', 5),
(2251, 'Check ONE from the list', 'Duid EEN ITEM uit de lijst aan', 5),
(2252, 'Please record the Form(s) of Maltreatment', 'Noteer de vorm(en) van mishandeling', 5),
(2253, 'Form(s) of Maltreatment', 'Vorm(en) van mishandeling', 5),
(2254, 'Expand/Collapse list', 'Lijst uitklappen/inklappen', 5),
(2255, 'Check as many as applicable. By selecting from child menu, broad categories are auto-selected.', 'Duid alles aan wat van toepassing is. Door de selectie uit het kindmenu worden automatisch ruime categorie?n geselecteerd.', 5),
(2256, 'Please provide as detailed as possible information (by using sub-menus).', 'Geef zo nauwkeurig mogelijke informatie (door de submenu\'s te gebruiken)', 5),
(2257, 'Acts Committed', 'Gepleegde daden', 5),
(2258, 'Violent acts against self /Self-harm actions', 'Geweld tegen zichzelf/automutilatie', 5),
(2259, 'Eating disorder', 'Eetstoornis', 5),
(2260, 'Substance use/ abuse', 'Gebruik/misbruik van verslavende middelen', 5),
(2261, 'Runaway', 'Wegloper', 5),
(2262, 'Self-inflicted injuries', 'Automutilatie', 5),
(2263, 'Suicidal thoughts', 'Zelfmoordgedachten', 5),
(2264, 'Suicide attempt', 'Zelfmoordpoging', 5),
(2265, 'Actual suicide', 'Effectieve zelfmoord', 5),
(2266, 'Other self-harm action (unspecified)', 'Andere automutilatie (niet gespecificeerd)', 5),
(2267, 'Physical violence acts committed [with or without injury]', 'Gepleegd fysiek geweld  [al dan niet met verwondingen]', 5),
(2268, 'Physical violent acts/ corporal punishment/ “disciplines”', 'Fysiek geweld/lijfstraffen/\'tuchtmaatregelen\'', 5),
(2269, 'Slapping', 'Een klap geven', 5),
(2270, 'Smacking', 'Slaag geven', 5),
(2271, 'Spanking', 'Een pak slaag geven', 5),
(2272, 'Pinching', 'Knijpen', 5),
(2273, 'Twisting ear(s)', 'Bij de oren trekken', 5),
(2274, 'Pulling hair', 'Bij het haar trekken', 5),
(2275, 'Hitting with an object', 'Slaan met een voorwerp', 5),
(2276, 'Beating', 'Slaan', 5),
(2277, 'Tying up or tying to something /restraining to cloth sacks', 'Vastbinden of vastmaken aan iets/in een zak stoppen', 5),
(2278, 'Locking up', 'Opsluiten', 5),
(2279, 'Leaving child to lie in their own excrement', 'Het kind in zijn eigen uitwerpselen laten liggen', 5),
(2280, 'Pushing', 'Duwen', 5),
(2281, 'Throwing', 'Werpen', 5),
(2282, 'Shaking', 'Schudden', 5),
(2283, 'Grabbing', 'Vastgrijpen', 5),
(2284, 'Choking', 'Verstikken', 5),
(2285, 'Squeezing neck', 'Bij de nek grijpen', 5),
(2286, 'Kicking', 'Schoppen', 5),
(2287, 'Hitting on head (with hand or against the wall)', 'Op het hoofd slaan (met de hand of tegen de muur)', 5),
(2288, 'Boxing ear', 'Op de oren slaan', 5),
(2289, 'Scratching', 'Krabben', 5),
(2290, 'Biting', 'Bijten', 5),
(2291, 'Burning', 'Verbranden', 5),
(2292, 'Scalding', 'Verbranden met hete vloeistof', 5),
(2293, 'Violent acts known also as harmful practices', 'Geweld, ook schadelijke praktijken genaamd', 5),
(2294, 'Hitting on the soles of the feet', 'Op de voetzolen slaan', 5),
(2295, 'Forcing to ingest spicy food', 'Dwingen pikant voedsel te eten', 5),
(2296, 'Forced feeding', 'Dwangvoeding', 5),
(2297, 'Forcing children to stay in uncomfortable positions', 'Kinderen dwingen in een oncomfortabele houding te blijven', 5),
(2298, 'Binding', 'Vastbinden', 5),
(2299, 'Inflicting scars/ scarring', 'Littekens veroorzaken/aanbrengen', 5),
(2300, 'Teeth extraction as punishment', 'Tanden uittrekken als straf', 5),
(2301, 'Branding', 'Brandmerken', 5),
(2302, 'Fattening', 'Vetmesten', 5),
(2303, '“Retribution” acts of violence', 'Geweld ter vergelding', 5),
(2304, 'Virginity testing (inspecting girls’ genitalia)', 'Maagdelijkheid controleren (de geslachtsdelen van meisjes inspecteren)', 5),
(2305, 'Forced circumcision', 'Gedwongen besnijdenis', 5),
(2306, 'Female genital mutilation', 'Vrouwelijke genitale verminking', 5),
(2307, 'Uvulectomy', 'Uvulectomie', 5),
(2308, 'Forced marriage and early marriage', 'Gedwongen huwelijk en kindhuwelijk', 5),
(2309, 'Violent and degrading initiation rites / “hazing”', 'Gewelddadige en onterende initiatieriten / \'ontgroening\'', 5),
(2310, 'Practices as “exorcism” after accusations of “witchcraft”', 'Praktijken als \'exorcisme\' na beschuldiging van \'hekserij\'', 5),
(2311, 'Forced sterilization, particularly girls', 'Gedwongen sterilisatie, vooral bij meisjes', 5),
(2312, 'Violence in the guise of treatment', 'Geweld onder het mom van behandeling', 5),
(2313, 'Deliberate infliction of disabilities for exploiting/begging', 'Opzettelijk toebrengen van handicap voor uitbuiting/bedelen', 5),
(2314, 'Acts of life threatening maltreatment', 'Handelingen van levensbedreigende mishandeling (opzettelijk)', 5),
(2315, 'Administering unnecessary invasive medical procedures', 'Onnodige invasieve medische ingrepen uitvoeren', 5),
(2316, 'Administering non prescribed substances', 'Niet voorgeschreven middelen toedienen', 5),
(2317, 'Child has been given poison', '(Opzettelijk) vergiftigen', 5),
(2318, 'Threatening with a knife (also psychological abuse)', 'Bedreigen met een mes (ook psychologisch geweld)', 5),
(2319, 'Threatening with a gun (also psychological abuse)', 'Bedreigen met een vuurwapen (ook psychologisch geweld)', 5),
(2320, 'Stabbing', 'Steken', 5),
(2321, 'Shooting', 'Schieten', 5),
(2322, 'Dowry-related violence/death (also harmful practice)', 'Geweld/dood gerelateerd aan bruidsschat (ook schadelijke praktijk)', 5),
(2323, '“Honour” crimes (also harmful practice)', 'Eergerelateerd\' misdrijf (ook schadelijke praktijk)', 5),
(2324, 'Abduction-related acts', 'Handelingen gerelateerd aan ontvoering', 5),
(2325, 'Non-family abduction', 'Niet-familiale ontvoering', 5),
(2326, 'Family abduction', 'Familiale ontvoering', 5),
(2327, 'Institutional and system violations of child rights', 'Institutionele en systemische schending van de kinderrechten', 5),
(2328, 'Caning', 'Afranselen met een rietje', 5),
(2329, 'Flogging', 'Geselen', 5),
(2330, 'Stoning', 'Stenigen', 5),
(2331, 'Torture (all forms)', 'Martelen (alle vormen)', 5),
(2332, 'Amputations', 'Amputaties', 5),
(2333, 'Imposing of death sentence for crimes committed', 'Doodstraf opleggen voor gepleegde misdaden', 5),
(2334, 'Other described physical acts', 'Andere beschreven fysieke daden', 5),
(2335, 'No specific information for reported/suspected physical violence', 'Geen specifieke informatie over gemeld/vermoed fysiek geweld', 5),
(2336, 'Sexual violence acts committed [with or without injury]', 'Gepleegd seksueel geweld [al dan niet met verwondingen]', 5),
(2337, 'Sexual violence acts', 'Seksueel geweld', 5),
(2338, 'Acts involving penetration (intrusion)', 'Handelingen met penetratie (inbrengen)', 5),
(2339, 'Without force', 'Zonder geweld', 5),
(2340, 'anus', 'anus', 5),
(2341, 'vulva', 'vulva', 5),
(2342, 'mouth', 'mond', 5),
(2343, 'Involving use of force', 'Met geweld', 5),
(2344, 'Attempted sexual abuse (not involving penetration)', 'Poging tot seksueel misbruik (zonder penetratie)', 5),
(2345, 'with physical contact', 'met fysiek contact', 5),
(2346, 'without physical contact', 'zonder fysiek contact', 5),
(2347, 'Threatened sexual abuse', 'Dreigend seksueel misbruik', 5),
(2348, 'Touching/fondling genitals', 'Geslachtsdelen aanraken/strelen', 5),
(2349, 'Showing genitals to child', 'Geslachtdelen laten zien aan een kind', 5),
(2350, 'Sexual harassment', 'Ongewenste intimiteiten', 5),
(2351, 'Voyeurism /spying on the children intimate behaviours', 'Voyeurisme/intiem gedrag van kinderen begluren', 5),
(2352, 'Providing sexually explicit materials', 'Expliciet seksueel materiaal verschaffen', 5),
(2353, 'Forced exposure to pornography', 'Gedwongen blootstelling aan pornografie', 5),
(2354, 'Forcing to witness sexual violence against mother', 'Dwingen toe te kijken bij seksueel geweld op moeder', 5),
(2355, 'Sexual “luring” (via ICT)', 'Seksueel \'lokken\' (via ICT)', 5),
(2356, 'Online sexual stalking /harassment', 'Online seksueel stalken/ongewenste intimiteiten', 5),
(2357, 'Other Sexual violence acts', 'Ander seksueel geweld', 5),
(2358, 'Sexual exploitation acts', 'Seksuele uitbuiting', 5),
(2359, 'Child prostitution', 'Kinderprostitutie', 5),
(2360, 'Use of children in commercial sexual exploitation', 'Gebruik van kinderen in seksindustrie', 5),
(2361, 'Sexual exploitation in travel and tourism', 'Seksuele uitbuiting tijdens reizen en bij toerisme', 5),
(2362, 'Sexual slavery', 'Seksuele slavernij', 5),
(2363, 'Sale of children for sexual purposes', 'Verkoop van kinderen voor seksuele doeleinden', 5),
(2364, 'Trafficking (within and between countries)', 'Handel (in en tussen landen)', 5),
(2365, 'Involvement in pornography', 'Betrokkenheid bij pornografie', 5),
(2366, 'Other sexual exploitation acts (unspecified)', 'Andere seksuele uitbuiting (niet gespecificeerd)', 5),
(2367, 'No specific information for reported/suspected sexual violence', 'Geen specifieke informatie over gemeld/vermoed seksueel geweld', 5),
(2368, 'Psychological violence acts committed [with or without injury]', 'Gepleegd psychologisch geweld [al dan niet met letsel]', 5),
(2369, 'Violent acts with or without obvious consequences', 'Geweld met of zonder duidelijke gevolgen', 5),
(2370, 'Bullying/ Psychological bullying and hazing', 'Bullyen/psychologisch bullyen en pesten', 5),
(2371, 'by other children', 'door andere kinderen', 5),
(2372, 'by adults', 'door volwassenen', 5),
(2373, 'Homophobic bullying /related to sexual orientation', 'Pesten als gevolg van homohaat/seksuele geaardheid', 5),
(2374, 'Cyber bullying (via ICTs / mobile phones /Internet)', 'Internetpesten (via ICT/mobiele telefoons/internet)', 5),
(2375, 'Ignoring and favoritism', 'Negeren en favoritisme', 5),
(2376, 'Denying emotional responsiveness', 'Emotionele ontvankelijkheid weerhouden', 5),
(2377, 'Over protection', 'Overbescherming', 5),
(2378, 'Isolation (social)', 'Isolement (sociaal)', 5),
(2379, 'Close confinement (tying/binding)', 'Strikte afzondering (vastbinden/vastsnoeren)', 5),
(2380, 'Placement in solitary confinement', 'In eenzame opsluiting plaatsen', 5),
(2381, 'Degrading /inhuman conditions of detention', 'Onterende/onmenselijke opsluitingsomstandigheden', 5),
(2382, 'Humiliation /Insults, name-calling, belittling, ridiculing', 'Vernederen/beledigen, uitmaken, kleineren, belachelijk maken', 5),
(2383, 'Humiliation via ICT', 'Vernedering via ICT', 5),
(2384, 'Rejection and Spurning', 'Verwerpen en afwijzen', 5),
(2385, 'Verbal assaults', 'Verbaal geweld', 5),
(2386, 'Terrorization / Scaring', 'Terroriseren/bang maken', 5),
(2387, 'Threats of sexual violence (with or without contact)', 'Gevaar voor seksueel geweld (met of zonder contact)', 5),
(2388, 'Threats of other maltreatment', 'Gevaar voor andere mishandeling', 5),
(2389, 'Other related acts hurting child’s feelings', 'Andere gerelateerde handelingen die de gevoelens van het kind kwetsen', 5),
(2390, 'Exploitation related psychological violent acts', 'Uitbuitingsgerelateerde psychologische geweldpleging', 5),
(2391, 'Exploiting and corrupting', 'Uitbuiting', 5),
(2392, 'Labour/economic exploitation', 'Arbeidsuitbuiting/economische uitbuiting', 5),
(2393, 'Forcing to undertake adult\'s responsibilities/parent’s role', 'Verplichting om verantwoordelijkheden van volwassenen op te nemen', 5),
(2394, 'Forcing to begging', 'Verplichting om te bedelen', 5),
(2395, 'Forcing to participate in religious ritual', 'Verplichting om deel te nemen aan een religieus ritueel', 5),
(2396, 'Forcing to participate in a violent political event', 'Verplichting om deel te nemen aan een gewelddadig politieke manifestatie', 5),
(2397, 'No specific info for reported/suspected exploitation acts', 'Geen specifieke informatie over gemelde/vermoedelijke uitbuiting', 5),
(2398, 'Exposure related psychological violent acts', 'Blootstelling aan psychologisch geweld', 5),
(2399, 'Exposure to any kind of violence in the family / DV', 'Blootstelling aan om het even welk soort geweld in het gezin / huiselijk geweld', 5),
(2400, 'Exposure to violence against other children', 'Blootstelling aan geweld tegen andere kinderen', 5),
(2401, 'Exposure to intimate partner violence', 'Blootstelling aan intiem partnergeweld', 5),
(2402, 'Exposure to violence against other adults', 'Blootstelling aan geweld tegen andere volwassenen', 5),
(2403, 'Exposition to the homicide of a significant person', 'Blootstelling aan moord op een belangrijke persoon', 5),
(2404, 'Exposure to a violent environment outside the family', 'Blootstelling aan een gewelddadige omgeving buiten het gezin', 5),
(2405, 'Exposure to violence via electronic means', 'Blootstelling aan geweld via elektronische weg', 5),
(2406, 'information and communication technologies', 'informatie- en communicatietechnologie?n', 5),
(2407, 'in the mass media', 'in massamedia', 5),
(2408, 'No specific info for reported/suspected related exposure', 'Geen specifieke informatie over gemelde/vermoede gerelateerde blootstelling', 5),
(2409, 'No specific info for reported/suspected psych/l abuse violent acts', 'Geen specifieke informatie over gemeld/vermoedel psychologisch geweld', 5),
(2410, 'Omissions', 'Verwaarlozing', 5),
(2411, 'Omissions in child’s care / Neglect', 'Verzuim van verzorging van het kind / verwaarlozing', 5),
(2412, 'Emotional neglect related omissions', 'Emotionele verwaarlozing', 5),
(2413, 'Persistent ignoring of the child’s emotional needs/ Chronic inattention to the child', 'Voortdurend negeren van de emotionele behoeften van het kind/chronisch tekort aan aandacht voor het kind', 5),
(2414, 'Psychologically “unavailable” caregivers', 'Psychologisch \'onbeschikbare\' verzorgers', 5),
(2415, 'Inappropriately advanced expectations (def.  According to child’s characteristics)', 'Ongepast geformuleerde verwachtingen (def. volgens de eigenschappen van het kind)', 5),
(2416, 'No specific information for omissions related to emotional neglect', 'Geen specifieke informatie over verzuim gerelateerd aan emotionele verwaarlozing', 5),
(2417, 'Physical neglect related omissions', 'Verzuim gerelateerd aan fysieke verwaarlozing', 5),
(2418, 'Inadequate / inappropriate nutrition', 'Onvoldoende/onaangepaste voeding', 5),
(2419, 'Inadequate / inappropriate personal hygiene', 'Onvoldoende/onaangepaste persoonlijke hygi?ne', 5),
(2420, 'Inadequate / inappropriate clothing', 'Onvoldoende/onaangepaste kleding', 5),
(2421, 'Inadequate / inappropriate shelter', 'Onvoldoende/onaangepaste opvang', 5),
(2422, 'No specific information for omissions related child’s physical needs', 'Geen specifieke informatie over verzuim gerelateerd aan de fysieke behoeften van het kind', 5),
(2423, 'Medical neglect related omissions', 'Verzuim gerelateerd aan medische verwaarlozing', 5),
(2424, 'Refusal to provide preventive health care (vaccinations, vision, and dental care)', 'Weigering om preventieve gezondheidszorg te bieden (vaccinaties, oog- en tandverzorging)', 5),
(2425, 'Refusal to allow /provide needed medical care for diagnosed health condition/ impairment', 'Weigering om noodzakelijke gezondheidszorg voor een gediagnosticeerde aandoening/afwijking te bieden/toe te staan', 5),
(2426, 'Unjustified delay to seek needed care', 'Ongerechtvaardigd uitstel om noodzakelijke zorg in te roepen', 5),
(2427, 'Failure to provide with basic medical care', 'Geen elementaire gezondheidszorg bieden', 5),
(2428, 'Withholding essential medical care', 'Onthouden van essenti?le gezondheidszorg', 5),
(2429, 'No specific information for omissions related child’s medical needs', 'Geen specifieke informatie over verzuim gerelateerd aan de medische behoeften van het kind', 5),
(2430, 'Educational neglect related omissions', 'Verzuim gerelateerd aan gebrek aan onderwijs', 5),
(2431, 'Persistent failure to register child at the school', 'Aanhoudend niet inschrijven van het kind op school', 5),
(2432, 'Has not attended school at all', 'Is nooit naar school geweest', 5),
(2433, 'Dropped out', 'Heeft de school niet afgemaakt', 5),
(2434, 'Persistent failure to enrol at the school resulting to irregular school attendance', 'Aanhoudend niet inschrijven op school met onregelmatig schoolbezoek als gevolg', 5),
(2435, 'compulsory school', 'leerplicht', 5),
(2436, 'non compulsory (ECEC)', 'geen leerplicht (OOJK)', 5),
(2437, 'Chronic truancy', 'Chronisch spijbelen', 5),
(2438, 'Refusal to attend special educational needs', 'Weigering te voorzien in speciale onderwijsbehoeften', 5),
(2439, 'Refusal to allow needed attention to special educational needs', 'Weigering noodzakelijke aandacht voor speciale onderwijsbehoeften toe te laten', 5),
(2440, 'Refusal to provide needed attention to special educational needs', 'Weigering te voorzien in noodzakelijke aandacht voor speciale onderwijsbehoeften', 5),
(2441, 'No specific information for omissions related child’s educational needs', 'Geen specifieke informatie over verzuim gerelateerd aan de onderwijsbehoeften van het kind', 5),
(2442, 'Risk exposure related omissions', 'Verzuim gerelateerd aan blootstelling aan gevaar', 5),
(2443, 'Exposure to hazardous/ dangerous environments', 'Blootstelling aan risicovolle/gevaarlijke omgevingen', 5),
(2444, 'Inside household', 'Binnen het gezin', 5),
(2445, 'Outside home', 'Buiten het gezin', 5),
(2446, 'Exposure to substances use/misuse by others', 'Blootstelling aan gebruik/misbruik van verslavende middelen door anderen', 5),
(2447, 'Alcohol', 'Alcohol', 5),
(2448, 'Drugs', 'Drugs', 5),
(2449, 'Other substances', 'Andere verslavende middelen', 5),
(2450, 'No specific information for reported/ suspected omissions for exposure to risks', 'Geen specifieke informatie over gemeld/vermoed verzuim gerelateerd aan blootstelling aan risico\'s', 5),
(2451, 'Supervision related omissions', 'Verzuim gerelateerd aan supervisie', 5),
(2452, 'Inadequate/ lack of supervision resulting in physical harm', 'Onvoldoende/ontbrekende supervisie met fysiek letsel als gevolg', 5),
(2453, 'Persisted lack of supervision concerning substance use/misuse by the child', 'Aanhoudend ontbreken van supervisie in verband met gebruik/misbruik van verslavende middelen door het kind', 5),
(2454, 'No specific information for omissions related to the child’s supervision', 'Geen specifieke informatie over verzuim gerelateerd aan supervisie van het kind', 5),
(2455, 'Refusal of custody/abandonment', 'Weigering hoederecht/verlating', 5),
(2456, 'Unstable custody arrangements', 'Onregelmatige hoederegeling', 5),
(2457, 'Illegal transfers of custody', 'Onwettelijke overdracht van hoederecht', 5),
(2458, 'Refusal of custody', 'Weigering hoederecht', 5),
(2459, 'Abandonment (primary caregiver(s) runaway / migrate and leave the children behind)', 'Verlating (voornaamste verzorger(s) gaat/gaan er vandoor / migreren en laten de kinderen achter)', 5),
(2460, 'children out of wedlock', 'buitenechtelijke kinderen', 5),
(2461, 'children with disabilities', 'kinderen met een handicap', 5),
(2462, 'No specific information for omissions related child’s refusal of custody', 'Geen specifieke informatie over verzuim gerelateerd aan weigeren hoederecht over het kind', 5),
(2463, 'Please record the Place of Incident', 'Noteer de plaats van het incident', 5),
(2464, 'Unknown/ Unspecified place', 'Onbekende/niet-gespecificeerde plaats', 5),
(2465, 'Home/ Family', 'Thuis/gezin', 5),
(2466, 'Home/ Relatives', 'Thuis/verwanten', 5),
(2467, 'Home/ Friends', 'Thuis/vrienden', 5),
(2468, 'Child care institution (residential care)', 'Instellingen voor kinderopvang (residenti?le opvang)', 5),
(2469, 'Child care institution (day care)', 'Instellingen voor kinderopvang (dagopvang)', 5),
(2470, 'Detention or correctional institution', 'Gevangenis of correctionele instelling', 5),
(2471, 'Leisure/ Playground/ Recreational area', 'Vrije tijd/speelplaats/recreatiezone', 5),
(2472, 'Sports-athletics', 'Sport-atletiek', 5),
(2473, 'School', 'School', 5),
(2474, 'Educational institution', 'Onderwijsinstelling', 5),
(2475, 'Medical Services', 'Medische diensten', 5),
(2476, 'Public transportation', 'Openbaar vervoer', 5),
(2477, 'Public place/ street, commercial & surrounding area', 'Openbare ruimte/straat, commerci?le & omringende zone', 5),
(2478, 'Other place', 'Andere plaats', 5),
(2479, 'GO -> C2', 'GA NAAR C2', 5),
(2480, 'Click as many as applicable', 'Klik alles aan wat van toepassing is.', 5),
(2481, 'Please record Child’s Sex, Date of Birth and Citizenship Status', 'Noteer het geslacht, de geboortedatum en de status van het staatsburgerschap van het kind', 5),
(2482, 'Male', 'Mannelijk', 5),
(2483, 'Female', 'Vrouwelijk', 5),
(2484, 'Not known', 'Onbekend', 5),
(2485, 'Check ONE from the list below', 'Duid EEN ITEM aan in de lijst hieronder', 5),
(2486, 'Child’s Date of Birth', 'Geboortedatum van het kind', 5),
(2487, '<18 years old (if no year is known)', '< 18 jaar oud (als jaar niet bekend is)', 5),
(2488, '<18 years old', '< 18 jaar oud', 5),
(2489, '>18 (\"minor\" according to legislation)', '', 5),
(2490, '>18 years old', '> or = 18 jaar oud', 5),
(2491, 'Unborn', 'Ongeboren', 5),
(2492, 'Please record the full date of birth:', 'Noteer de volledige geboortedatum', 5),
(2493, 'YYYY-MM-DD', 'JJJJ-MM-DD', 5),
(2494, 'If DD is unknown:', 'Als DD onbekend is:', 5),
(2495, 'YYYY-MM', 'JJJJ-MM', 5),
(2496, 'If MM-DD are unknown:', 'Als MM-DD onbekend zijn:', 5),
(2497, 'If YYYY-MM-DD are unknown AND the alleged victim is a child:', 'Als JJJJ-MM-DD onbekend zijn EN het vermeende slachtoffer een kind is:', 5),
(2498, '<18', '<18', 5),
(2499, 'Citizenship Status', 'Status staatsburgerschap', 5),
(2500, 'Not a citizen', 'Geen staatsburger', 5),
(2501, 'Citizen', 'Staatsburger', 5),
(2502, 'with ID', 'met ID', 5),
(2503, 'Citizen with ID', 'Staatsburger met ID', 5),
(2504, 'without ID', 'zonder ID', 5),
(2505, 'Citizen without ID', 'Staatsburger zonder ID', 5),
(2506, 'Unaccompanied foreign child or refugee', 'Niet-begeleide buitenlandse minderjarige of vluchteling', 5),
(2507, 'Check ONE from the list below. If the child is “Citizen”, please define in sub-list', 'Duid EEN ITEM aan in de lijst hieronder. Als het kind \'staatsburger\' is, definieer dan in de sublijst', 5),
(2508, 'Please record Family Composition and indicate up to two Primary Caregivers', 'Noteer de gezinssamenstelling en geef tot twee voornaamste verzorgers aan', 5),
(2509, 'A: Type of Family', 'A: soort gezin', 5),
(2510, 'Boarder(s) (child lives in residential/institutional care)', 'het kind zit in de residenti?le/institutionele zorgverlening', 5),
(2511, 'Child lives with his/her family (including biological/ adoptive)', 'Het kind verblijft bij zijn/haar gezin (ook biologisch/adoptief)', 5),
(2512, 'Child lives in a foster family', 'Het kind verblijft in een pleeggezin', 5),
(2513, 'Child lives in a re-composed family', 'Kind woont in een nieuw samengesteld gezin', 5),
(2514, 'Child lives in a family other than its family/ foster family', 'Kind woont in een gezin dat niet zijn eigen gezin/pleeggezin is', 5),
(2515, 'Relatives’ family', 'Gezin van verwanten', 5),
(2516, 'Child lives in a family other than its family/ foster family - Relatives’ family', 'Kind woont in een gezin dat niet zijn eigen gezin/pleeggezin is - Gezin van verwanten', 5),
(2517, 'Friends’ family', 'Gezin van vrienden', 5),
(2518, 'Child lives in a family other than its family/ foster family - Friends’ family', 'Kind woont in een gezin dat niet zijn eigen gezin/pleeggezin is - Gezin van vrienden', 5),
(2519, 'SKIP “B”; GO -> F3', 'SLA \'B\' OVER; GA NAAR F3', 5),
(2520, 'If you DON\'T chose Boarder(s) -> B: Members of Family', 'Als u NIET residenti?le/institutionele zorg kiest -> B: familieleden', 5),
(2521, 'B: Member(s) of Family', 'B: familielid/-leden', 5),
(2522, 'Number', 'Aantal', 5),
(2523, 'Primary caregiver(s)', 'Voornaamste verzorger(s)', 5),
(2524, 'Parent(s)', 'Ouder(s)', 5),
(2525, 'Step Parent(s)', 'Stiefouder(s)', 5),
(2526, 'Parent(s)’ partner(s)', 'Partner(s) van ouder(s)', 5),
(2527, 'Sibling(s)', 'Broers en zussen', 5),
(2528, 'Younger than the (alleged) victim', 'Jonger dan het (vermeende) slachtoffer', 5),
(2529, 'Older than the (alleged) victim (<18)', 'Ouder dan het (vermeende) slachtoffer (< 18)', 5),
(2530, 'Older than the (alleged) victim (>18)', 'Ouder dan het (vermeende) slachtoffer (> 18)', 5),
(2531, 'Grandparent(s)', 'Grootouder(s)', 5),
(2532, 'Other relative(s)', 'Andere verwant(en)', 5),
(2533, 'Blood relatives', 'Bloedverwanten', 5),
(2534, '<18 [child(ren)]', '< 18 [kind(eren)]', 5),
(2535, '>18 [adult(s)]', '> 18 [volwassene(n)]', 5);
INSERT INTO `u_translate` (`id`, `text_en`, `text_trans`, `language_id`) VALUES
(2536, 'By law relatives', 'Wettelijke verwanten', 5),
(2537, 'Family friend(s)', 'Familievriend(en)', 5),
(2538, 'Other not-related household members', 'Andere niet-verwante gezinsleden', 5),
(2539, 'Please indicate up to 2 child’s primary caregiver(s) (you can uncheck)', 'Geef tot 2 voornaamste verzorgers van het kind aan (u kunt afvinken)', 5),
(2540, 'members', 'leden', 5),
(2541, 'member family', 'familielid', 5),
(2542, 'Please record Caregiver(s) Relationship to Child, Sex and Date of Birth', 'Noteer de verwantschap tot het kind van de verzorger(s), het geslacht en de geboortedatum', 5),
(2543, 'Relationship to Child', 'Verwantschap tot het kind', 5),
(2544, '1st Caregiver', '1e verzorger', 5),
(2545, 'Professional Caregiver', 'Professionele verzorger', 5),
(2546, 'Temporary caregiver/Other', 'Tijdelijke verzorger/andere', 5),
(2547, 'Unknown relationship', 'Onbekende verwantschap', 5),
(2548, 'Check ONE per Caregiver', 'Duid EEN ITEM per verzorger aan', 5),
(2549, 'Caregiver(s) Sex', 'Geslacht van verzorger(s)', 5),
(2550, 'Caregiver(s) DoB', 'Geboortedatum verzorger(s)', 5),
(2551, 'YY', 'JJ', 5),
(2552, '\'s', '', 5),
(2553, 'YY-MM-DD', 'JJ-MM-DD', 5),
(2554, 'If YYYY-MM-DD are unknown then record the decade:', 'Als JJJJ-MM-DD onbekend zijn, noteer dan het decennium', 5),
(2555, 'If DECADE is unknown, then:', 'Als het DECENNIUM onbekend is, dan:', 5),
(2556, 'Please record any Institutional Response', 'Noteer eventuele institutionele reactie', 5),
(2557, 'No response was required DUE TO CHILD’S DEATH', 'Geen reactie nodig WEGENS OVERLIJDEN VAN HET KIND', 5),
(2558, 'No Response', 'Geen reactie', 5),
(2559, 'Yes', 'Ja', 5),
(2560, 'Immediate intervention(s)', 'Onmiddellijke tussenkomst', 5),
(2561, 'Physical Medical exam(s)', 'Fysiek medisch(e) onderzoek(en)', 5),
(2562, 'Mental Health exam(s)', 'Onderzoek(en) naar geestelijke gezondheid', 5),
(2563, 'Forensic evaluation initiated', 'Forensische evaluatie gestart', 5),
(2564, 'Child protection /welfare services assessment', 'Beoordeling van kinderbescherming/-welzijn', 5),
(2565, 'Police intervention', 'Tussenkomst van de politie', 5),
(2566, 'Action taken -NO COURT INVOLVEMENT', 'Actie ondernomen - GEEN TUSSENKOMST VAN HET GERECHT', 5),
(2567, 'Child remains in family with planned intervention', 'Het kind blijft in het gezin met geplande tussenkomst', 5),
(2568, 'Emergency placement', 'Spoedplaatsing', 5),
(2569, 'Supportive intervention for current caregiver(s)', 'Ondersteunende tussenkomst voor huidige verzorger(s)', 5),
(2570, 'Mother/child shelter with parent and child together', 'Opvang voor moeder/kind met ouder en kind samen', 5),
(2571, 'Police emergency protection procedures', 'Spoedprocedures voor politiebescherming', 5),
(2572, 'CPS/welfare services emergency protection procedures', 'Spoedprocedures voor bescherming door diensten voor kinderbescherming/-welzijn', 5),
(2573, 'Referral to child protection /welfare services', 'Verwijzing naar diensten voor kinderbescherming/-welzijn', 5),
(2574, 'Action taken -COURT or EQUIVALENT AUTHORITY TO THE COURT INVOLVEMENT', 'Actie ondernomen - TUSSENKOMST VAN HET GERECHT of EEN EVENWAARDIGE AUTORITEIT', 5),
(2575, '(Family) Court measures initiated', 'Maatregelen (familie)rechtbank gestart', 5),
(2576, 'Action to protect victim by court order(s)', 'Actie om het slachtoffer te beschermen via een of meerdere vonnissen', 5),
(2577, 'Action to remove parent(s)’ rights', 'Actie tot ontzetting uit ouderlijke macht', 5),
(2578, 'Expulsion of (alleged) abuser from home', 'Dader uit huis via vonnis', 5),
(2579, 'Action to prosecute perpetrator(s)', 'Actie om overtreder(s) te vervolgen', 5),
(2580, 'Out of home placement', 'Plaatsing buitenshuis', 5),
(2581, 'Kinship Care (relatives/extended family)', 'Verzorging door verwanten (familieleden/extended family)', 5),
(2582, 'Foster Care', 'Pleegzorg', 5),
(2583, 'Children’s Home Institution', 'Kindertehuis', 5),
(2584, 'Adoption with parents’ agreement', 'Adoptie met akkoord ouders', 5),
(2585, 'Adoption by court order', 'Adoptie via vonnis', 5),
(2586, 'GO -> S2', 'GA NAAR S2', 5),
(2587, 'Check below as many as applicable', 'Duid hieronder alles aan wat van toepassing is', 5),
(2588, 'Please record any Referral(s) made to Services by you/your agency', 'Noteer eventuele verwijzing(en) naar diensten die u/uw agentschap maakte', 5),
(2589, 'None', 'Geen', 5),
(2590, 'Judicial Services', 'Juridische diensten', 5),
(2591, 'for child ONLY', 'ENKEL voor het kind', 5),
(2592, 'for caregiver(s) ONLY', 'ENKEL voor de verzorger(s)', 5),
(2593, 'for child AND family', 'voor het kind EN het gezin', 5),
(2594, 'Mental Health Services', 'Diensten voor geestelijke gezondheidszorg', 5),
(2595, 'Independent Authorities', 'Onafhankelijke Autoriteit', 5),
(2596, 'Social Welfare Services', 'Diensten voor maatschappelijk werk', 5),
(2597, 'Law Enforcement related Services', 'Rechtshandhaving diensten', 5),
(2598, 'Community Organizations and NGOs', 'Maatschappelijke organisaties en NGO\'s', 5),
(2599, 'Existing Registries and Research Organizations', 'bestaande Registers en Onderzoeksorganisaties', 5),
(2600, 'Educational Services', 'Onderwijsdiensten', 5),
(2601, 'Other related Services', 'Andere aanverwante diensten', 5),
(2602, 'End of Record', 'Einde bestand', 5),
(2603, 'CHECK RECORD OPTIONS', 'CONTROLEER DE BESTANDSOPTIES', 5),
(2604, 'Please check the record options', 'Controleer de bestandsopties', 5),
(2605, 'You can make any changes by navigating throught the right panel!', 'U kunt wijzigingen aanbrengen door door het rechterluik te scrollen!', 5),
(2606, 'Incident', 'Incident', 5),
(2607, 'ID', 'ID', 5),
(2608, 'Sex', 'Geslacht', 5),
(2609, 'Date of birth', 'Geboortedatum', 5),
(2610, 'Family and Caregiver(s)', 'Familie en verzorger(s)', 5),
(2611, 'Services', 'Diensten', 5),
(2612, 'Submit Record', 'Geef bestand door', 5),
(2613, 'Loading', 'Verbranden met hete vloeistof', 5),
(2614, 'RECORD COMPLETED', 'BESTAND VERVOLLEDIGD', 5),
(2615, 'Display/print the record', 'Toon/print het bestand', 5),
(2616, 'Report', 'Verslag', 5),
(2617, 'RECORD', 'BESTAND', 5),
(2618, 'Agency', 'Agentschap', 5),
(2619, 'Information provided by', 'Informatie verschaft door', 5),
(2620, 'Age at the date of incident', 'Datum op het ogenblik van het incident', 5),
(2621, 'Age at the date of recording', 'Leeftijd op het moment van het noteren', 5),
(2622, 'Type of family', 'Soort familie', 5),
(2623, 'Family\'s member(s)', 'Familielid/-leden', 5),
(2624, '1st', '1e', 5),
(2625, 'born', 'geboren', 5),
(2626, '2nd', '2e', 5),
(2627, 'Back', 'Terug', 5),
(2628, 'KNOWN CHILD', 'BEKEND KIND', 5),
(2629, 'EXISTING CHILD RECORD', 'BESTAAND BESTAND VAN EEN KIND', 5),
(2630, 'You are going to proceed with the record of a new CM incident for  the child', 'U gaat nu verder met het bestand van een nieuw KM-incident voor het kind', 5),
(2631, 'Please proceed with checking of', 'Controleer het volgende', 5),
(2632, 'TIP: Update –if needed', 'TIP: update - indien nodig', 5),
(2633, 'Known Incidents', 'Bekende incidenten', 5),
(2634, 'The incident you are trying to record might already exist!', 'Het incident dat u wilt noteren, bestaat misschien al!', 5),
(2635, 'Please check the incident record(s) below', 'Controleer het/de incidentbestand(en) hieronder', 5),
(2636, 'for Child\'s ID:', 'voor ID van het kind:', 5),
(2637, 'and Date of Incident:', 'en de datum van het incident:', 5),
(2638, 'Date-Time of Record', 'Datum - tijd van noteren', 5),
(2639, 'Display', 'Weergave', 5),
(2640, 'Add new incident', 'Voeg een nieuw incident toe', 5),
(2641, 'ENTER Username', 'IDENTIFIANT', 6),
(2642, 'ENTER Password', 'MOT DE PASSE', 6),
(2643, 'Log in', 'Connexion', 6),
(2644, 'MEMO: Meaning of Symbols & Colors', 'MEMO: signification des symboles et couleurs', 6),
(2645, 'Auto-Completed variable', 'Variable autodéterminée', 6),
(2646, 'Variable already recorded by the Operator', 'Variable déjà enregistrée par l\'opérateur/trice', 6),
(2647, 'Single selection (mutually exclusive codes)', 'Sélection unique (les codes ne peuvent pas être combinés)', 6),
(2648, 'Multiple selection (select as many as applicable)', 'Sélection multiple (cochez autant de cases que nécessaire)', 6),
(2649, 'Open list of sub-codes (drop-down menu)', 'Liste ouverte d\'intitulés (menu déroulant)', 6),
(2650, 'Close list of sub-codes (drop-down menu)', 'Liste fermée d\'intitulés (menu déroulant)', 6),
(2651, 'Instruction to Operator', 'Instruction pour l\'opérateur/trice', 6),
(2652, 'Recorded Variable’s Name', 'Nom de la variable enregistrée', 6),
(2653, 'Codes of Recorded variable', 'Code de la variable enregistrée', 6),
(2654, 'Note to Operator for the recording', 'Note à l\'opérateur/trice pour l\'enregistrement', 6),
(2655, 'Note to Operator for system’s operations', 'Note à l\'opérateur/trice sur le fonctionnement du système', 6),
(2656, 'Automated process (filters etc.)', 'Processus automatisé (filtres etc.)', 6),
(2657, 'ALREADY EXISTING ID (can appear in CHILD’S ID AND in INCIDENT ID)', 'IDENTIFIANT (ID) DÉJÀ EXISTANT (peut apparaître pour ID de l\'enfant et ID de l\'incident)', 6),
(2658, 'Skip', 'Passer', 6),
(2659, 'Start Page', 'Page d\'accueil', 6),
(2660, 'Operator\'s Panel', 'Tableau de bord de l\'opérateur', 6),
(2661, 'my account', 'Mon compte', 6),
(2662, 'Contact Details', 'Coordonées', 6),
(2663, 'Change Password', 'Modifier le mot de passe', 6),
(2664, 'my previous cases', 'Mes précédents dossiers', 6),
(2665, 'List of incidents', 'Liste des incidents', 6),
(2666, 'List of Children’s ID', 'Liste des identifiants de l\'enfant (ID)', 6),
(2667, 'my current cases', 'Mes dossiers en cours', 6),
(2668, 'List of temporary Child\'s ID', 'Liste des identifiants temporaires de l\'enfant (ID)', 6),
(2669, 'Information ', 'Information', 6),
(2670, 'New Incident', 'Nouvel incident', 6),
(2671, 'My Profile', 'Mon Profil', 6),
(2672, 'Change Pass', '', 6),
(2673, 'List of Child\'s ID', 'Liste des identifiants de l\'enfant (ID)', 6),
(2674, 'Log out!', 'Déconnexion', 6),
(2675, 'Welcome', 'Bienvenue', 6),
(2676, 'New ', 'Nouveau', 6),
(2677, 'Record Progress', 'Enregistrement en cours', 6),
(2678, 'Agency\'s ID', 'Identifiant (ID) du service', 6),
(2679, 'Operator\'s ID', 'Identifiant (ID) de l\'opérateur/rice', 6),
(2680, 'Child\'s ID', 'Identifiant (ID) de l\'enfant', 6),
(2681, 'Date of Record', 'Date de l\'enregistrement', 6),
(2682, 'Incident\'s ID', 'Identifiant de l\'incident', 6),
(2683, 'Date of Incident', 'Date de l\'incident', 6),
(2684, 'Source of Information', 'Source de l\'information', 6),
(2685, 'Forms of Maltreatment', 'Formes de maltraitance', 6),
(2686, 'Place of Incident', 'Lieu de l\'incident', 6),
(2687, 'Child\'s Sex', 'Sexe de l\'enfant', 6),
(2688, 'Child\'s DoB', 'Date de naissance de l\'enfant.', 6),
(2689, 'Child\'s Citizenship Status', 'Statut de l\'enfant au regard de la nationalité', 6),
(2690, 'Family Composition', 'Composition de la famille', 6),
(2691, 'CGs Relationship to Child', 'Relation de l\'adulte de référence à l\'enfant', 6),
(2692, 'Caregiver(s)\' Sex', 'Sexe de l\'adulte de référence', 6),
(2693, 'Caregiver(s)\' DoB', 'Date de naissance du 1er adulte de référence', 6),
(2694, 'Institutional Response', 'Décision institutionnelle', 6),
(2695, 'Referral(s) to Services', 'Transmission aux services', 6),
(2696, 'Agencys\'s ID', 'Identifiant (ID) du service', 6),
(2697, 'Identity Confirmation', 'Confirmation d\'identité', 6),
(2698, 'TIP', 'CONSEIL', 6),
(2699, 'If the above information needs update, please contact the CAN-MDS Administration Office.', 'Si les informations ci-dessus doivent être mises à jour, merci de contacter le service d\'administration CAN-MDS', 6),
(2700, 'Date & Type of Incident', 'Date & Type d\'incident', 6),
(2701, 'Incident ID', 'Identifiant (ID) de l\'incident', 6),
(2702, 'Type Of Record', 'Type d\'enregistrement', 6),
(2703, 'Type Of Incident', 'Type d\'incident', 6),
(2704, 'Notifications', 'Notifications', 6),
(2705, 'Subject', 'Objet', 6),
(2706, 'Message', 'Message', 6),
(2707, 'Replace ID', 'Remplacer l\'identifiant', 6),
(2708, 'WELCOME TO CAN-MDS', 'BIENVENUE SUR L\'INTERFACE CAN-MDS', 6),
(2709, 'To proceed with the record, please follow the CAN-MDS Operations’ Protocol.', 'Pour réaliser l\'enregistrement, merci de suivre le protocole opératoire CAN-MDS', 6),
(2710, 'If you need more information, please use the CAN-MDS Guide for Operators.', 'Si vous avez besoin de plus d\'information, merci d\'utiliser le guide pour les opérateurs CAN-MDS', 6),
(2711, 'Continue with the record', 'Continuer l\'enregistrement', 6),
(2712, 'Please, insert Child’s ID provided to you by the Administrator', 'Merci d\'indiquer l\'ID de l\'enfant que vous a donné l\'administrateur/trice', 6),
(2713, 'NOT KNOW CHILD\'S ID', 'INDENTIFIANT DE L\'ENFANT INCONNU', 6),
(2714, 'The Child’s ID you provided is referred to an', 'L\'identifiant (ID) de l\'enfant renvoie à', 6),
(2715, 'UNKNOWN CHILD', 'ENFANT INCONNU(E)', 6),
(2716, 'NEW CHILD RECORD', 'ENREGISTREMENT D\'UNE NOUVELLE SITUATION POUR UN ENFANT', 6),
(2717, 'NEW INCIDENT RECORD', 'ENREGISTREMENT D\'UN NOUVEL INCIDENT', 6),
(2718, 'You are going to proceed with the record of a new case of (alleged) child maltreatment.', 'Vous êtes sur le point d\'enregistrer une nouvelle situation de violence à enfant (présumée)', 6),
(2719, 'Please proceed with recording of', 'Merci de bien vouloir continuer l\'enregistrement concernant', 6),
(2720, '-incident related variables', 'les variables relatives à l\'incident', 6),
(2721, '-child related variables', 'les variables relatives à l\'enfant', 6),
(2722, '-family related variables', 'les variables relatives à la famille', 6),
(2723, '-services related variables', 'les variables relatives aux services', 6),
(2724, 'Please record the referred Date of Incident', 'Merci d\'enregistrer la date de l\'incident en question', 6),
(2725, 'Unknown', 'Inconnu', 6),
(2726, 'A \"distinct\" event took place – Not continuous maltreatment', '', 6),
(2727, 'YYYY', 'AAAA', 6),
(2728, 'MM', 'MM', 6),
(2729, 'DD', 'JJ', 6),
(2730, 'Continuous maltreatment – including \"distinct event(s)\"', '', 6),
(2731, 'start date', 'Date de début', 6),
(2732, 'duration', 'Durée', 6),
(2733, 'Years', 'Années', 6),
(2734, 'Months', 'Mois', 6),
(2735, 'Days', 'Jours', 6),
(2736, 'During the last 12 months', 'Au cours des 12 derniers mois', 6),
(2737, 'Before the last 12 months', 'Il y a plus de 12 mois', 6),
(2738, 'Lifelong', 'Tout au long de la vie', 6),
(2739, 'Last known CM incident date', 'Dernier incident connu de violence à enfant', 6),
(2740, 'Continuous maltreatment - No \"distinct event\" took place', '', 6),
(2741, 'GO -> R4', 'ALLEZ DIRECTEMENT EN R4', 6),
(2742, 'Click to open sub-list', 'Cliquer pour dérouler la liste', 6),
(2743, 'Complete as precisely as possible YYYY-MM-DD', 'Remplissez le plus précisément possible AAAA-MM-JJ', 6),
(2744, 'Neglect/other abuse taking place over a longer period', 'Négligence/ autre type de violence sur le long terme', 6),
(2745, 'Check ONE in the sub-list', 'Cochez UNE case ci-dessous.', 6),
(2746, 'Click to close sub-list', 'Cliquer pour près la liste', 6),
(2747, 'approximately', 'Environ', 6),
(2748, 'or less', 'Ou moins', 6),
(2749, 'Wrong date', 'Mauvaise date', 6),
(2750, 'year', 'année', 6),
(2751, 'month', 'mois', 6),
(2752, 'day', 'jour', 6),
(2753, 'One day', 'Un jour', 6),
(2754, 'Please record the Source of Information', 'Merci d\'enregistrer la source de l\'information', 6),
(2755, 'Unspecified', 'non spécifié', 6),
(2756, 'Identified (via routine screening)', 'Situation identifiée par les services (contrôle de routine)', 6),
(2757, 'Child (alleged) victim', 'Enfant victime (présumée)', 6),
(2758, 'Parent /foster parent/ parent’s partner/ care provider', 'Parent/ Parent adoptif/partenaire d\'un parent/ adulte de référence', 6),
(2759, 'Relative (siblings, grandparents, etc.) living with the child', 'Membre de la famille (fratrie, grands-parents etc.) résidant avec l\'enfant', 6),
(2760, 'Relative (siblings, grandparents, etc.) not living with the child', 'Membre de la famille (fratrie, grands-parents etc.) ne résidant pas avec l\'enfant', 6),
(2761, 'Friend / Neighbor', 'Ami/e / voisin/e', 6),
(2762, 'Self-reported as (alleged) perpetrator', 'Auto-dénoncé comme auteur (présumé) des actes', 6),
(2763, 'School /preschool /kindergarten personnel', 'Personnel d\'établissement scolaire', 6),
(2764, 'Leisure activity staff (e.g., scout leader, clergy, sport coach)', 'Personnel de centre de loisirs (notamment chef/taine scout, clergé, entraîneur/se sportif/ve)', 6),
(2765, 'Anonymous reporter', 'Source anonyme', 6),
(2766, 'Personnel working in Child day care services', 'Personnel de services de garde d\'enfant', 6),
(2767, 'Personnel working in Social Services/ Public–Central/Local', 'Personnel des services sociaux (tous services)', 6),
(2768, 'Personnel working in Health services', 'Personnel des services médicaux et médico-sociaux', 6),
(2769, 'Personnel working in Mental Health Services', 'Personnel de services de santé mentale', 6),
(2770, 'Personnel working in Ordinary/Juvenile Court and related services', 'Personnel de la justice (pour enfants ou autres branches) et assimilé', 6),
(2771, 'Personnel working in Police /low enforcement', 'Personnel de police/gendarmerie et assimilé', 6),
(2772, 'Personnel working in Helpline', 'Personnel de lignes téléphoniques spécialisées', 6),
(2773, 'Personnel working in Community agency including agencies working against DV', 'Personnel de services de terrain (notamment travaillant contre les violences domestiques)', 6),
(2774, 'Personnel working in Ombudsman', 'Personnel lié au Défenseur des Enfants (ou des Droits)', 6),
(2775, 'Personnel working in NGOs/associations', 'Personnel d\'une association/ONG', 6),
(2776, 'Personnel working in services for people with disabilities', 'Personnel d\'un service pour personnes en situation de handicap', 6),
(2777, 'Other', 'Autre', 6),
(2778, 'GO -> I3', 'ALLEZ DIRECTEMENT EN I3', 6),
(2779, 'Check ONE from the list', 'Cochez UNE case de la liste', 6),
(2780, 'Please record the Form(s) of Maltreatment', 'Merci d\'enregistrer la forme de violence', 6),
(2781, 'Form(s) of Maltreatment', 'Forme(s) de violence', 6),
(2782, 'Expand/Collapse list', 'Dérouler/refermer la liste', 6),
(2783, 'Check as many as applicable. By selecting from child menu, broad categories are auto-selected.', 'Cochez autant de cases que nécessaire. En sélectionnant à l\'intérieur du menu, des catégories générales sont auto-sélectionnées', 6),
(2784, 'Please provide as detailed as possible information (by using sub-menus).', 'Merci de donner le plus d\'information possible (en utilisant les sous-menus)', 6),
(2785, 'Acts Committed', 'Actes perpétrés', 6),
(2786, 'Violent acts against self /Self-harm actions', 'Actes violents contre soi-même / violences auto-infligées', 6),
(2787, 'Eating disorder', 'Trouble du comportement alimentaire', 6),
(2788, 'Substance use/ abuse', 'Utilisation de substances psychotropes (dont alcool)', 6),
(2789, 'Runaway', 'Fugue', 6),
(2790, 'Self-inflicted injuries', 'Blessures auto-infligées', 6),
(2791, 'Suicidal thoughts', 'Pensées suicidaires', 6),
(2792, 'Suicide attempt', 'Tentative de suicide', 6),
(2793, 'Actual suicide', 'Suicide (abouti)', 6),
(2794, 'Other self-harm action (unspecified)', 'Autres actes de violence auto-infligés (non précisés)', 6),
(2795, 'Physical violence acts committed [with or without injury]', 'Actes de violence physique perpétrés (avec ou sans blessures)', 6),
(2796, 'Physical violent acts/ corporal punishment/ “disciplines”', 'Actes de violence physique/ châtiments corporels/ \"discipline\"', 6),
(2797, 'Slapping', 'Gifles', 6),
(2798, 'Smacking', 'Baffes', 6),
(2799, 'Spanking', 'Fessées', 6),
(2800, 'Pinching', 'L\'enfant est pincé/e', 6),
(2801, 'Twisting ear(s)', 'Les oreilles de l\'enfant sont tirées', 6),
(2802, 'Pulling hair', 'Les cheveux de l\'enfant sont tirés', 6),
(2803, 'Hitting with an object', 'L\'enfant est frappé/e au moyen d\'un objet', 6),
(2804, 'Beating', 'L\'enfant est battu', 6),
(2805, 'Tying up or tying to something /restraining to cloth sacks', 'L\'enfant est ligoté ou attaché à quelque chose,mis dans un/des sac(s)', 6),
(2806, 'Locking up', 'L\'enfant est enfermé', 6),
(2807, 'Leaving child to lie in their own excrement', 'L\'enfant doit dormir dans ses excréments', 6),
(2808, 'Pushing', 'L\'enfant est poussé/e', 6),
(2809, 'Throwing', 'L\'enfant est jeté/e', 6),
(2810, 'Shaking', 'L\'enfant est secoué/e', 6),
(2811, 'Grabbing', 'L\'enfant est empoigné/e', 6),
(2812, 'Choking', 'L\'enfant est étranglé/e ou étouffé/e', 6),
(2813, 'Squeezing neck', 'Le cou de l\'enfant est serré', 6),
(2814, 'Kicking', 'Coups de pieds', 6),
(2815, 'Hitting on head (with hand or against the wall)', 'Coups sur la tête (avec la main ou en poussant contre le mur)', 6),
(2816, 'Boxing ear', 'Coup de poing sur l\'oreille', 6),
(2817, 'Scratching', 'L\'enfant est écorché', 6),
(2818, 'Biting', 'L\'enfant est mordu/e', 6),
(2819, 'Burning', 'Brûlures', 6),
(2820, 'Scalding', 'L\'enfant est ébouillanté/e', 6),
(2821, 'Violent acts known also as harmful practices', 'Autres actes violents connus comme pratiques \"éducatives\" préjudiciables', 6),
(2822, 'Hitting on the soles of the feet', 'Coups sur la plante des pied', 6),
(2823, 'Forcing to ingest spicy food', 'L\'enfant est forcé/e à ingérer des aliments pimentés', 6),
(2824, 'Forced feeding', 'Gavage (l\'enfant est forcé/e à ingérer des aliments)', 6),
(2825, 'Forcing children to stay in uncomfortable positions', 'L\'enfant est forcé/e à tenir des positions inconfortables', 6),
(2826, 'Binding', 'L\'enfant est attaché', 6),
(2827, 'Inflicting scars/ scarring', 'Scarification/ infliction de cicatrices', 6),
(2828, 'Teeth extraction as punishment', 'Une/des dent(s) de l\'enfant est/sont arrachée/s en guise de punition', 6),
(2829, 'Branding', 'Marquage de l\'enfant', 6),
(2830, 'Fattening', 'L\'enfant est engraissé/e', 6),
(2831, '“Retribution” acts of violence', 'Correction \"éducative\"', 6),
(2832, 'Virginity testing (inspecting girls’ genitalia)', 'Examen/test de virginité (inspection du sexe des filles)', 6),
(2833, 'Forced circumcision', 'Mutilation génitale masculine', 6),
(2834, 'Female genital mutilation', 'Mutilation génitale féminine', 6),
(2835, 'Uvulectomy', 'Uvulectomie (ablation/réduction de la luette)', 6),
(2836, 'Forced marriage and early marriage', 'Mariage forcé, mariage précoce', 6),
(2837, 'Violent and degrading initiation rites / “hazing”', 'Rites d\'initiation violents et dégradants/ bizutage', 6),
(2838, 'Practices as “exorcism” after accusations of “witchcraft”', 'Pratiques similaires à un \"exorcisme\" suivant des accusations de \"sorcellerie\"', 6),
(2839, 'Forced sterilization, particularly girls', 'Stérilisation forcée', 6),
(2840, 'Violence in the guise of treatment', 'Violence présentée comme un traitement', 6),
(2841, 'Deliberate infliction of disabilities for exploiting/begging', 'Des handicaps sont délibérément infligés à l\'enfant en vue d\'exploitation ou de mendicité', 6),
(2842, 'Acts of life threatening maltreatment', 'Actes (délibérés) de violences pouvant entraîner la mort', 6),
(2843, 'Administering unnecessary invasive medical procedures', 'Des procédures médicales invasives sont administrées à l\'enfant sans nécessité', 6),
(2844, 'Administering non prescribed substances', 'Des substances psychotropes (dont alcool) sont administrées à l\'enfant sans prescription médicale', 6),
(2845, 'Child has been given poison', 'Empoisonnement (délibéré)', 6),
(2846, 'Threatening with a knife (also psychological abuse)', 'Menaces au moyen d\'un couteau (voir aussi violence psychologique)', 6),
(2847, 'Threatening with a gun (also psychological abuse)', 'Menaces au moyen d\'une arme à feu (voir aussi violence psychologique)', 6),
(2848, 'Stabbing', 'Coups de couteau', 6),
(2849, 'Shooting', 'Coups de feu', 6),
(2850, 'Dowry-related violence/death (also harmful practice)', 'Violence/mort faisant suite à des considérations de dot (voir aussi corrections \"éducatives\")', 6),
(2851, '“Honour” crimes (also harmful practice)', 'Crimes \"d\'honneur\" (voir aussi corrections \"éducatives\")', 6),
(2852, 'Abduction-related acts', 'Enlèvement et actes liés à un enlèvement', 6),
(2853, 'Non-family abduction', 'Enlèvement par quelqu\'un d\'extérieur à la famille', 6),
(2854, 'Family abduction', 'Enlèvement familial', 6),
(2855, 'Institutional and system violations of child rights', 'Violations institutionnelles et systémiques des droits des enfants', 6),
(2856, 'Caning', 'L\'enfant est frappé avec un objet rigide', 6),
(2857, 'Flogging', 'L\'enfant est frappé avec un objet souple (ceinture, fouet...)', 6),
(2858, 'Stoning', 'Lapidation', 6),
(2859, 'Torture (all forms)', 'Torture (sous toutes ses formes)', 6),
(2860, 'Amputations', 'Amputations', 6),
(2861, 'Imposing of death sentence for crimes committed', 'L\'enfant est condamné/e à la peine de mort pour des crimes commis', 6),
(2862, 'Other described physical acts', 'Autres actes physiques décrits', 6),
(2863, 'No specific information for reported/suspected physical violence', 'Pas d\'information spécifique pour les violences alléguées/soupçonnées', 6),
(2864, 'Sexual violence acts committed [with or without injury]', 'Actes de violence sexuelle perpétrés [avec ou sans blessure physique]', 6),
(2865, 'Sexual violence acts', 'Actes de violence sexuelle', 6),
(2866, 'Acts involving penetration (intrusion)', 'Actes comportant une pénétration (intrusion)', 6),
(2867, 'Without force', 'Sans usage de la force', 6),
(2868, 'anus', 'anus', 6),
(2869, 'vulva', 'vagin', 6),
(2870, 'mouth', 'bouche', 6),
(2871, 'Involving use of force', 'Avec usage de la force', 6),
(2872, 'Attempted sexual abuse (not involving penetration)', 'Tentative de violence sexuelle (sans pénétration)', 6),
(2873, 'with physical contact', 'avec contact physique', 6),
(2874, 'without physical contact', 'sans contact physique', 6),
(2875, 'Threatened sexual abuse', 'Menaces de violence sexuelle', 6),
(2876, 'Touching/fondling genitals', 'Attouchements/caresses au niveau du sexe', 6),
(2877, 'Showing genitals to child', 'L\'adulte exhibe son sexe à l\'enfant', 6),
(2878, 'Sexual harassment', 'Harcèlement sexuel', 6),
(2879, 'Voyeurism /spying on the children intimate behaviours', 'Voyeurisme/ espionnage des activités intimes de l\'enfant', 6),
(2880, 'Providing sexually explicit materials', 'L\'adulte met à disposition de l\'enfant du matériel pornographique', 6),
(2881, 'Forced exposure to pornography', 'Exposition forcée à de la pornographie', 6),
(2882, 'Forcing to witness sexual violence against mother', 'L\'enfant est forcé à être témoin de violence sexuelle à l\'égard de sa mère', 6),
(2883, 'Sexual “luring” (via ICT)', 'Prédation sexuelle (par internet et TIC)', 6),
(2884, 'Online sexual stalking /harassment', 'Harcèlement sexuel en ligne/ l\'enfant est traqué sexuellement sur internet', 6),
(2885, 'Other Sexual violence acts', 'Autres actes de violence sexuelle', 6),
(2886, 'Sexual exploitation acts', 'Actes d\'exploitation sexuelle', 6),
(2887, 'Child prostitution', 'Prostitution infantile', 6),
(2888, 'Use of children in commercial sexual exploitation', 'Utilisation d\'enfants dans le cadre d\'exploitation sexuelle commerciale', 6),
(2889, 'Sexual exploitation in travel and tourism', 'Exploitation sexuelle dans le cadre du tourisme ou des voyages', 6),
(2890, 'Sexual slavery', 'Esclavage sexuel', 6),
(2891, 'Sale of children for sexual purposes', 'Vente d\'enfants à des fins sexuelles', 6),
(2892, 'Trafficking (within and between countries)', 'Traite (à l\'intérieur d\'un pays ou entre pays)', 6),
(2893, 'Involvement in pornography', 'Implication de l\'enfant dans la réalisation de matériel pornographique', 6),
(2894, 'Other sexual exploitation acts (unspecified)', 'Autres actes d\'exploitation sexuelle (sans précision)', 6),
(2895, 'No specific information for reported/suspected sexual violence', 'Pas d\'information spécifique concernant des actes de violence sexuelle allégués/soupçonnés', 6),
(2896, 'Psychological violence acts committed [with or without injury]', 'Actes de violence psychologique perpétrés [avec ou sans blessure]', 6),
(2897, 'Violent acts with or without obvious consequences', 'Actes violents avec ou sans conséquences évidentes', 6),
(2898, 'Bullying/ Psychological bullying and hazing', 'Harcèlement (bullying)/ Harcèlement psychologique, bizutage', 6),
(2899, 'by other children', 'par d\'autres enfants', 6),
(2900, 'by adults', 'par des adultes', 6),
(2901, 'Homophobic bullying /related to sexual orientation', 'Harcèlement (bullying) en raison de l\'orientation sexuelle [réelle ou supposée]', 6),
(2902, 'Cyber bullying (via ICTs / mobile phones /Internet)', 'Cyberbullying (harcèlement en utilisant les TIC/téléphone portable/internet)', 6),
(2903, 'Ignoring and favoritism', 'L\'enfant est délibérément ignoré/ l\'adulte fait preuve de favoritisme', 6),
(2904, 'Denying emotional responsiveness', 'Refus d\'apporter une réponse affective aux demandes de l\'enfant', 6),
(2905, 'Over protection', 'Sur-protection', 6),
(2906, 'Isolation (social)', 'Isolement (social)', 6),
(2907, 'Close confinement (tying/binding)', 'Confinement dans un espace clos (enfant ligoté, attaché)', 6),
(2908, 'Placement in solitary confinement', 'L\'enfant est mis à l\'isolement cellulaire', 6),
(2909, 'Degrading /inhuman conditions of detention', 'Conditions de détention inhumaines ou dégradantes', 6),
(2910, 'Humiliation /Insults, name-calling, belittling, ridiculing', 'Humiliation/insultes, injures, dénigrement, l\'enfant est tourné/e en ridicule', 6),
(2911, 'Humiliation via ICT', 'Humiliation par le biais des réseaux sociaux, les TIC (internet, téléphone portable)', 6),
(2912, 'Rejection and Spurning', 'Rejet, mépris', 6),
(2913, 'Verbal assaults', 'Attaques verbales', 6),
(2914, 'Terrorization / Scaring', 'Terroriser / épouvanter l\'enfant, lui faire peur', 6),
(2915, 'Threats of sexual violence (with or without contact)', 'Menaces de violence sexuelle (avec ou sans contact)', 6),
(2916, 'Threats of other maltreatment', 'Menaces d\'autres types de violence', 6),
(2917, 'Other related acts hurting child’s feelings', 'Autres actes associés visant à blesser l\'enfant', 6),
(2918, 'Exploitation related psychological violent acts', 'Actes psychologiques violents liés à une situation d\'exploitation', 6),
(2919, 'Exploiting and corrupting', 'Exploitation et corruption', 6),
(2920, 'Labour/economic exploitation', 'Travail forcé/ exploitation économique', 6),
(2921, 'Forcing to undertake adult\'s responsibilities/parent’s role', 'Forcer l\'enfant à prendre les responsabilitésd\'un/e adulte', 6),
(2922, 'Forcing to begging', 'Forcer l\'enfant à la mendicité', 6),
(2923, 'Forcing to participate in religious ritual', 'Forcer l\'enfant à participer à un rituel religieux', 6),
(2924, 'Forcing to participate in a violent political event', 'Forcer l\'enfant à participer à un événement politique violent', 6),
(2925, 'No specific info for reported/suspected exploitation acts', 'Pas d\'information spécifique sur le type d\'exploitation allégué/soupçonné', 6),
(2926, 'Exposure related psychological violent acts', 'Actes psychologiques violents liés à une situation d\'exposition', 6),
(2927, 'Exposure to any kind of violence in the family / DV', 'Exposition à tout type de violence familiale ou domestique', 6),
(2928, 'Exposure to violence against other children', 'Exposition à de la violence envers un/des autre(s) enfant(s)', 6),
(2929, 'Exposure to intimate partner violence', 'Exposition à de la violence envers un/e partenaire/ conjoint/e', 6),
(2930, 'Exposure to violence against other adults', 'Exposition à de la violence envers d\'autres adultes', 6),
(2931, 'Exposition to the homicide of a significant person', 'Exposition à l\'homicide d\'une personne significative', 6),
(2932, 'Exposure to a violent environment outside the family', 'Exposition à un environnement violent à l\'extérieur de la famille', 6),
(2933, 'Exposure to violence via electronic means', 'Exposition à de la violence via des supports électroniques', 6),
(2934, 'information and communication technologies', 'Technologies de l\'information et de la communications', 6),
(2935, 'in the mass media', 'dans les médias de masse', 6),
(2936, 'No specific info for reported/suspected related exposure', 'Pas d\'information spécifique sur le type d\'exposition allégué/soupçonné', 6),
(2937, 'No specific info for reported/suspected psych/l abuse violent acts', 'Pas d\'information spécifique sur les actes de violence psychologique allégués/soupçonnés', 6),
(2938, 'Omissions', 'Omissions', 6),
(2939, 'Omissions in child’s care / Neglect', 'Omissions dans le soin apporté à l\'enfant / Négligence', 6),
(2940, 'Emotional neglect related omissions', 'Omissions liées à une négligence émotionnelle', 6),
(2941, 'Persistent ignoring of the child’s emotional needs/ Chronic inattention to the child', 'Absence persistante de réaction aux besoins émotionnels de l\'enfant/ Inattention chronique à l\'enfant', 6),
(2942, 'Psychologically “unavailable” caregivers', 'Adultes de référence \"indisponibles\" psychologiquement', 6),
(2943, 'Inappropriately advanced expectations (def.  According to child’s characteristics)', 'Attentes déraisonnablement élevées vis-à-vis de l\'enfant (à définir par rapport à ses caractéristiques)', 6),
(2944, 'No specific information for omissions related to emotional neglect', 'Pas d\'information spécifique sur les omissions liées à des négligences émotionnelles', 6),
(2945, 'Physical neglect related omissions', 'Omissions liées à une négligence physique', 6),
(2946, 'Inadequate / inappropriate nutrition', 'Nourriture inadéquate/inappropriée', 6),
(2947, 'Inadequate / inappropriate personal hygiene', 'Hygiène personnelle inadéquate/inappropriée', 6),
(2948, 'Inadequate / inappropriate clothing', 'Vêtements inadéquats/inappropriés', 6),
(2949, 'Inadequate / inappropriate shelter', 'Logement inadéquat/inapproprié', 6),
(2950, 'No specific information for omissions related child’s physical needs', 'Pas d\'information spécifique sur les omissions liées aux besoins physiques de l\'enfant', 6),
(2951, 'Medical neglect related omissions', 'Omissions liées à une négligence médicale', 6),
(2952, 'Refusal to provide preventive health care (vaccinations, vision, and dental care)', 'Refus de donner accès à la mdécine préventive (vaccinations, vision, dentisterie)', 6),
(2953, 'Refusal to allow /provide needed medical care for diagnosed health condition/ impairment', 'Refus de permettre/de solliciter des soins médicaux pour une affection/un handicap diagnostiqué/e', 6),
(2954, 'Unjustified delay to seek needed care', 'Retard injustifié dans le recours aux soins', 6),
(2955, 'Failure to provide with basic medical care', 'Soins médicaux essentiels non-prodigués', 6),
(2956, 'Withholding essential medical care', 'Restriction de l\'accès aux soins médicaux essentiels', 6),
(2957, 'No specific information for omissions related child’s medical needs', 'Pas d\'information spécifique sur les omissions liées aux besoins médicaux de l\'enfant', 6),
(2958, 'Educational neglect related omissions', 'Omissions liées à la négligence éducative', 6),
(2959, 'Persistent failure to register child at the school', 'Non-inscription persistente de l\'enfant à l\'école', 6),
(2960, 'Has not attended school at all', 'L\'enfant n\'a jamais été scolarisé', 6),
(2961, 'Dropped out', 'Abandon scolaire', 6),
(2962, 'Persistent failure to enrol at the school resulting to irregular school attendance', 'Non-inscription persistente de l\'enfant à l\'école résultant en une scolarisation irrégulière', 6),
(2963, 'compulsory school', 'Ecole obligatoire', 6),
(2964, 'non compulsory (ECEC)', 'Ecole non-obligatoire (avant 6 ans)', 6),
(2965, 'Chronic truancy', 'Absentéisme chronique', 6),
(2966, 'Refusal to attend special educational needs', 'Refus de donner accès aux accompagnements scolaires adaptés au handicap', 6),
(2967, 'Refusal to allow needed attention to special educational needs', 'Refus de permettre la prise en compte du handicap pour les besoins scolaires', 6),
(2968, 'Refusal to provide needed attention to special educational needs', 'Refus de solliciter la prise en compte du handicap pour les besoins scolaires', 6),
(2969, 'No specific information for omissions related child’s educational needs', 'Pas d\'information spécifique relative aux besoins éducatifs de l\'enfant', 6),
(2970, 'Risk exposure related omissions', 'Omissions liées à une absence d\'intervention alors que l\'enfant est exposé à des risques identifié', 6),
(2971, 'Exposure to hazardous/ dangerous environments', 'Exposition à des environnements risqués/dangereux', 6),
(2972, 'Inside household', 'A l\'intérieur du foyer', 6),
(2973, 'Outside home', 'A l\'extérieur du foyer', 6),
(2974, 'Exposure to substances use/misuse by others', 'Exposition aux addictions et à l\'usage de substances psychotropes (dont alcool) par d\'autres', 6),
(2975, 'Alcohol', 'Alcool', 6),
(2976, 'Drugs', 'Drogues', 6),
(2977, 'Other substances', 'Autres substances psychotropes', 6),
(2978, 'No specific information for reported/ suspected omissions for exposure to risks', 'Pas d\'information spécifique sur les omissions alléguées/soupçonnées liées à l\'exposition aux risques', 6),
(2979, 'Supervision related omissions', 'Omissions liées au défaut de supervision', 6),
(2980, 'Inadequate/ lack of supervision resulting in physical harm', 'Défaut de supervision/supervision inadéquate résultant en dommage physique', 6),
(2981, 'Persisted lack of supervision concerning substance use/misuse by the child', 'Défaut persistant de supervision en lien avec des conduites addictives de l\'enfant', 6),
(2982, 'No specific information for omissions related to the child’s supervision', 'Pas d\'information spécifique sur les omissions liées à la supervision de l\'enfant', 6),
(2983, 'Refusal of custody/abandonment', 'Refus de garde/abandon', 6),
(2984, 'Unstable custody arrangements', 'Arrangements irréguliers quant à la garde de l\'enfant', 6),
(2985, 'Illegal transfers of custody', 'Transferts illégaux de la garde de l\'enfant', 6),
(2986, 'Refusal of custody', 'Refus de garde', 6),
(2987, 'Abandonment (primary caregiver(s) runaway / migrate and leave the children behind)', 'Abandon (le/la principal/e adulte de référence s\'enfuit/migre sans les enfants)', 6),
(2988, 'children out of wedlock', 'Enfant(s) né(s) hors mariage', 6),
(2989, 'children with disabilities', 'Enfant(s) ayant un  handicap', 6),
(2990, 'No specific information for omissions related child’s refusal of custody', 'Pas d\'information spécifique pour les omissions en lien avec le refus de garde de l\'enfant', 6),
(2991, 'Please record the Place of Incident', 'Merci d\'enregistrer le lieu de l\'incident', 6),
(2992, 'Unknown/ Unspecified place', 'Lieu inconnu/non-précisé', 6),
(2993, 'Home/ Family', 'Domicile familial', 6),
(2994, 'Home/ Relatives', 'Domicile de proches', 6),
(2995, 'Home/ Friends', 'Domicile d\'amis', 6),
(2996, 'Child care institution (residential care)', 'Institution d\'accueil d\'enfants (accueil résidentiel)', 6),
(2997, 'Child care institution (day care)', 'Institution d\'accueil d\'enfants (accueil de jour)', 6),
(2998, 'Detention or correctional institution', 'Centres de détention, lieu pénitentiaire', 6),
(2999, 'Leisure/ Playground/ Recreational area', 'Centre de loisirs, cour de récréation, parc à jeux', 6),
(3000, 'Sports-athletics', 'Centre sportif, stade', 6),
(3001, 'School', 'Ecole', 6),
(3002, 'Educational institution', 'Institution éducative', 6),
(3003, 'Medical Services', 'Institution médicale ou médico-sociale', 6),
(3004, 'Public transportation', 'Transports publics', 6),
(3005, 'Public place/ street, commercial & surrounding area', 'Voie publique, rues, centres commerciaux et environs', 6),
(3006, 'Other place', 'Autre endroit', 6),
(3007, 'GO -> C2', 'ALLEZ DIRECTEMENT EN C2', 6),
(3008, 'Click as many as applicable', 'Cochez autant de cases que nécessaire', 6),
(3009, 'Please record Child’s Sex, Date of Birth and Citizenship Status', 'Merci de préciser le sexe, la date de naissance, et le statut national de l\'enfant', 6),
(3010, 'Male', 'Masculin', 6),
(3011, 'Female', 'Féminin', 6),
(3012, 'Not known', 'Inconnu/pas d’information', 6),
(3013, 'Check ONE from the list below', 'Cochez UNE des cases ci-dessous.', 6),
(3014, 'Child’s Date of Birth', 'Date de naissance de l\'enfant.', 6),
(3015, '<18 years old (if no year is known)', '<18 ans (si l\'année n\'est pas connue)', 6),
(3016, '<18 years old', '< 18 ans', 6),
(3017, '>18 (\"minor\" according to legislation)', '', 6),
(3018, '>18 years old', '> 18 ans', 6),
(3019, 'Unborn', 'Avant la naissance', 6),
(3020, 'Please record the full date of birth:', 'Merci d\'indiquer la date de naissance intégrale de l\'enfant', 6),
(3021, 'YYYY-MM-DD', 'AAAA-MM-JJ', 6),
(3022, 'If DD is unknown:', 'Si le jour est inconnu:', 6),
(3023, 'YYYY-MM', 'AAAA-MM', 6),
(3024, 'If MM-DD are unknown:', 'Si le mois et le jour sont inconnus:', 6),
(3025, 'If YYYY-MM-DD are unknown AND the alleged victim is a child:', 'Si l\'année, le mois et le jour sont inconnus ET que la victime supposée est un enfant:', 6),
(3026, '<18', '<18 ans', 6),
(3027, 'Citizenship Status', 'Statut de l\'enfant au regard de la nationalité', 6),
(3028, 'Not a citizen', 'Nationalité étrangère', 6),
(3029, 'Citizen', 'Nationalité Française', 6),
(3030, 'with ID', 'L\'enfant dispose de papiers d\'identité français', 6),
(3031, 'Citizen with ID', 'Nationalité française avec papiers d\'identité', 6),
(3032, 'without ID', 'Nationalité française sans papiers d\'identité', 6),
(3033, 'Citizen without ID', 'National du pays sans pièce d\'identité', 6),
(3034, 'Unaccompanied foreign child or refugee', 'Mineur non accompagné ou enfant ayant le satut de réfugié', 6),
(3035, 'Check ONE from the list below. If the child is “Citizen”, please define in sub-list', 'Cochez UNE case ci-dessous. Si l\'enfant est \"du pays\", merci de bien vouloir préciser dans la liste', 6),
(3036, 'Please record Family Composition and indicate up to two Primary Caregivers', 'Merci d\'enregistrer la composition de la famille et d\'indiquer au plus 2 adulte(s) de référence principal(aux)', 6),
(3037, 'A: Type of Family', 'A: Type de famille', 6),
(3038, 'Boarder(s) (child lives in residential/institutional care)', 'L\'enfant vit dans une structure collective (accueil résidentiel/institutionnel)', 6),
(3039, 'Child lives with his/her family (including biological/ adoptive)', 'L\'enfant vit avec sa famille (biologique ou adoptive)', 6),
(3040, 'Child lives in a foster family', 'L\'enfant vit en famille d\'accueil', 6),
(3041, 'Child lives in a re-composed family', 'L\'enfant vit dans une famille recomposée', 6),
(3042, 'Child lives in a family other than its family/ foster family', 'L\'enfant vit dans une famille autre que sa famille d\'origine ou d\'accueil', 6),
(3043, 'Relatives’ family', 'Famille élargie', 6),
(3044, 'Child lives in a family other than its family/ foster family - Relatives’ family', 'L\'enfant vit dans une famille autre que sa famille d\'origine ou d\'accueil - Famille élargie', 6),
(3045, 'Friends’ family', 'Amis de la famille', 6),
(3046, 'Child lives in a family other than its family/ foster family - Friends’ family', 'L\'enfant vit dans une famille autre que sa famille naturelle ou d\'accueil - Famille d\'amis', 6),
(3047, 'SKIP “B”; GO -> F3', 'SAUTER LA PARTIE B, PASSER DIRECTEMENT A LA QUESTION F3', 6),
(3048, 'If you DON\'T chose Boarder(s) -> B: Members of Family', 'Si vous ne choisissez PAS Logeur(s) -> B: Membres de la famille', 6),
(3049, 'B: Member(s) of Family', 'B: Membre(s) de la famille', 6),
(3050, 'Number', 'Nombre', 6),
(3051, 'Primary caregiver(s)', 'Principal(aux) adulte(s) de référence', 6),
(3052, 'Parent(s)', 'Parent(s)', 6),
(3053, 'Step Parent(s)', 'Beau(x)-parent(s)', 6),
(3054, 'Parent(s)’ partner(s)', 'Compagnon(s) du/des parent(s)', 6),
(3055, 'Sibling(s)', 'Frère(s) et sœur(s)', 6),
(3056, 'Younger than the (alleged) victim', 'Plus jeune(s) que la victime (supposée)', 6),
(3057, 'Older than the (alleged) victim (<18)', 'Plus âgé(s) que la victime (supposée) (<18 ans)', 6),
(3058, 'Older than the (alleged) victim (>18)', 'Plus âgé(s) que la victime (supposée) (>18 ans)', 6),
(3059, 'Grandparent(s)', 'Grand-parent(s)', 6),
(3060, 'Other relative(s)', 'Autre(s) membre(s) de la famille', 6),
(3061, 'Blood relatives', 'Famille élargie', 6),
(3062, '<18 [child(ren)]', '< 18 ans [enfant(s)]', 6),
(3063, '>18 [adult(s)]', '> 18 ans [adulte(s)]', 6),
(3064, 'By law relatives', 'Famille par alliance', 6),
(3065, 'Family friend(s)', 'Ami(s) de la famille', 6),
(3066, 'Other not-related household members', 'Autres membres du foyer extérieurs à la famille', 6),
(3067, 'Please indicate up to 2 child’s primary caregiver(s) (you can uncheck)', 'Merci d\'indiquer au plus 2 adulte(s) de référence principal(aux) (vous pouvez décocher)', 6),
(3068, 'members', 'Membres', 6),
(3069, 'member family', 'Membre de la famille', 6),
(3070, 'Please record Caregiver(s) Relationship to Child, Sex and Date of Birth', 'Merci de préciser la relation de l\'adulte à l\'enfant, son sexe et sa date de naissance', 6),
(3071, 'Relationship to Child', 'Relation à l\'enfant', 6),
(3072, '1st Caregiver', '1er adulte de référence', 6),
(3073, 'Professional Caregiver', 'Soignant professionnel', 6),
(3074, 'Temporary caregiver/Other', 'Adulte en charge de l\'enfant de manière temporaire/autre', 6),
(3075, 'Unknown relationship', 'Relation à l\'enfant inconnue', 6),
(3076, 'Check ONE per Caregiver', 'Cocher UNE catégorie par adulte de référence', 6),
(3077, 'Caregiver(s) Sex', 'Sexe de l\'adulte', 6),
(3078, 'Caregiver(s) DoB', 'Date de naissance de l\'adulte de référence', 6),
(3079, 'YY', 'AA', 6),
(3080, '\'s', '', 6),
(3081, 'YY-MM-DD', 'AA-MM-JJ', 6),
(3082, 'If YYYY-MM-DD are unknown then record the decade:', 'Si année, mois et jour sont inconnus, indiquer la décennie', 6),
(3083, 'If DECADE is unknown, then:', 'Si la DECENNIE est inconnue:', 6),
(3084, 'Please record any Institutional Response', 'Merci d\'enregistrer toute suite donnée par les services', 6),
(3085, 'No response was required DUE TO CHILD’S DEATH', 'Aucune suite possible en raison du décès de l’enfant', 6),
(3086, 'No Response', 'Pas de suite', 6),
(3087, 'Yes', 'Oui', 6),
(3088, 'Immediate intervention(s)', 'Aide immédiate', 6),
(3089, 'Physical Medical exam(s)', 'Examen de santé physique', 6),
(3090, 'Mental Health exam(s)', 'Examen de santé mentale', 6),
(3091, 'Forensic evaluation initiated', 'Evaluation  médico-légale', 6),
(3092, 'Child protection /welfare services assessment', 'Evaluation des services de protection de l\'enfance /services sociauxsociaux', 6),
(3093, 'Police intervention', 'Intervention de police', 6),
(3094, 'Action taken -NO COURT INVOLVEMENT', 'Décision prise - PAS D\'INTERVENTION JUDICIAIRE', 6),
(3095, 'Child remains in family with planned intervention', 'L\'enfant reste dans sa famille avec un programme d\'intervention à domicile (AED…)', 6),
(3096, 'Emergency placement', 'Placement d\'urgence', 6),
(3097, 'Supportive intervention for current caregiver(s)', 'Intervention d’aide et de soutien aux adultes de référence', 6),
(3098, 'Mother/child shelter with parent and child together', 'Hébergement mère/enfant avec l\'enfant et le parent accueillis ensemble', 6),
(3099, 'Police emergency protection procedures', 'Procédures de protection policière d\'urgence', 6),
(3100, 'CPS/welfare services emergency protection procedures', 'Procédures de protection administrative d\'urgence (services sociaux, aide à l\'enfance)', 6),
(3101, 'Referral to child protection /welfare services', 'Transmission aux services de protection de l\'enfance/ d\'aide à l\'enfance', 6),
(3102, 'Action taken -COURT or EQUIVALENT AUTHORITY TO THE COURT INVOLVEMENT', 'Décision prise - INTERVENTION JUDICIAIRE OU EQUIVALENT', 6),
(3103, '(Family) Court measures initiated', 'Décision de justice engagée (y compris affaires familiales)', 6),
(3104, 'Action to protect victim by court order(s)', 'Procédure de protection des/de la victime(s)', 6),
(3105, 'Action to remove parent(s)’ rights', 'Procédure de déchéance des droits parentaux', 6),
(3106, 'Expulsion of (alleged) abuser from home', 'L’auteur (supposé) est expulsé du domicile', 6),
(3107, 'Action to prosecute perpetrator(s)', 'Inculpation de la personne ayant perpétré les actes (ou alléguée telle)', 6),
(3108, 'Out of home placement', 'Placement hors du domicile', 6),
(3109, 'Kinship Care (relatives/extended family)', 'Prise en charge par les proches (Famille proche ou éloignée)', 6),
(3110, 'Foster Care', 'Accueil familial', 6),
(3111, 'Children’s Home Institution', 'Accueil résidentiel (institution pour enfant)', 6),
(3112, 'Adoption with parents’ agreement', 'Adoption avec l\'accord des parents (simple)', 6),
(3113, 'Adoption by court order', 'Adoption sans que l\'accord des parents soit requis (plénière)', 6),
(3114, 'GO -> S2', 'ALLEZ DIRECTEMENT EN S2', 6),
(3115, 'Check below as many as applicable', 'Cochez autant de cases que nécessaire.', 6),
(3116, 'Please record any Referral(s) made to Services by you/your agency', 'Merci d\'enregistrer toute transmission effectuée par vous ou votre service', 6),
(3117, 'None', 'Aucun service', 6),
(3118, 'Judicial Services', 'Services judiciaires', 6),
(3119, 'for child ONLY', 'SEULEMENT pour l\'enfant', 6),
(3120, 'for caregiver(s) ONLY', 'SEULEMENT pour les adultes de référence', 6),
(3121, 'for child AND family', 'pour l\'enfant ET la famille', 6),
(3122, 'Mental Health Services', 'Services de santé mentale', 6),
(3123, 'Independent Authorities', 'Autorités indépendantes', 6),
(3124, 'Social Welfare Services', 'Services sociaux', 6),
(3125, 'Law Enforcement related Services', 'Services chargés de l\'application de la loi', 6),
(3126, 'Community Organizations and NGOs', 'Organisations communautaires et associations/ONG', 6),
(3127, 'Existing Registries and Research Organizations', 'Registres existants et organismes de recherche', 6),
(3128, 'Educational Services', 'Services éducatifs', 6),
(3129, 'Other related Services', 'Autres services connexes', 6),
(3130, 'End of Record', 'Fin de l\'enregistrement', 6),
(3131, 'CHECK RECORD OPTIONS', 'VERIFIER LES OPTIONS D\'ENREGISTREMENT', 6),
(3132, 'Please check the record options', 'Merci de vérifier les options d\'enregistrement', 6),
(3133, 'You can make any changes by navigating throught the right panel!', 'Vous pouvez apporter des modifications en cliquant dans la zone de droite !', 6),
(3134, 'Incident', 'Incident', 6),
(3135, 'ID', 'Identifiant (ID)', 6),
(3136, 'Sex', 'Sexe', 6),
(3137, 'Date of birth', 'Date de naissance', 6),
(3138, 'Family and Caregiver(s)', 'Famille et adulte(s) de référence', 6),
(3139, 'Services', 'Service(s)', 6),
(3140, 'Submit Record', 'Enregistrer', 6);
INSERT INTO `u_translate` (`id`, `text_en`, `text_trans`, `language_id`) VALUES
(3141, 'Loading', 'En charge', 6),
(3142, 'RECORD COMPLETED', 'ENREGISTREMENT TERMINE', 6),
(3143, 'Display/print the record', 'Afficher/imprimer l\'enregistrement', 6),
(3144, 'Report', 'Rapport', 6),
(3145, 'RECORD', 'ENREGISTREMENT', 6),
(3146, 'Agency', 'Agence', 6),
(3147, 'Information provided by', 'Information fournie par', 6),
(3148, 'Age at the date of incident', 'Âge lors de l\'incident', 6),
(3149, 'Age at the date of recording', 'Âge lors de l\'enregistrement', 6),
(3150, 'Type of family', 'Type de famille', 6),
(3151, 'Family\'s member(s)', 'Membre(s) de la famille', 6),
(3152, '1st', '1er', 6),
(3153, 'born', 'né/e', 6),
(3154, '2nd', '2e', 6),
(3155, 'Back', 'Retour', 6),
(3156, 'KNOWN CHILD', 'ENFANT CONNU DES SERVICES', 6),
(3157, 'EXISTING CHILD RECORD', 'ENFANT DÉJÀ ENREGISTRÉ', 6),
(3158, 'You are going to proceed with the record of a new CM incident for  the child', 'Vous allez procéder à l\'enregistrement d\'un nouvel incident concernant l\'enfant', 6),
(3159, 'Please proceed with checking of', 'Merci de bien vouloir vérifier', 6),
(3160, 'TIP: Update –if needed', 'CONSEIL: Mettre à jour en cas de besoin', 6),
(3161, 'Known Incidents', 'Incidents connus', 6),
(3162, 'The incident you are trying to record might already exist!', 'L\'incident que vous essayez d\'enregistrer est peut-être déjà dans la base !', 6),
(3163, 'Please check the incident record(s) below', 'Merci de vérifier l\'enregistrement/les enregistrement d\'incident(s) ci-dessous', 6),
(3164, 'for Child\'s ID:', 'Pour l\'identifiant (ID) de l\'enfant:', 6),
(3165, 'and Date of Incident:', 'et date de l\'incident:', 6),
(3166, 'Date-Time of Record', 'Date- heure de l\'enregistrement', 6),
(3167, 'Display', 'Afficher', 6),
(3168, 'Add new incident', 'Ajouter un nouvel incident', 6),
(3169, 'ENTER Username', 'Въведи потребителско име', 7),
(3170, 'ENTER Password', 'Въведи парола', 7),
(3171, 'Log in', 'Вход', 7),
(3172, 'MEMO: Meaning of Symbols & Colors', 'MEMO: Легенда на символите и цветовете', 7),
(3173, 'Auto-Completed variable', 'Автоматично попълнена променлива', 7),
(3174, 'Variable already recorded by the Operator', 'Променлива вече вписана от Оператора', 7),
(3175, 'Single selection (mutually exclusive codes)', 'Един отговор (взаимно изключващи се кодове)', 7),
(3176, 'Multiple selection (select as many as applicable)', 'Повече от един отговор (изберете толкова, колкото е приложимо)', 7),
(3177, 'Open list of sub-codes (drop-down menu)', 'Отворете списъка с под-кодове от падащото меню', 7),
(3178, 'Close list of sub-codes (drop-down menu)', 'Затворете списъка с под-кодове от падащото меню', 7),
(3179, 'Instruction to Operator', 'Инструкция за Оператора', 7),
(3180, 'Recorded Variable’s Name', 'Име на записаната променливата', 7),
(3181, 'Codes of Recorded variable', 'Кодове на записаната променлива', 7),
(3182, 'Note to Operator for the recording', 'Бележка към Оператора за записа', 7),
(3183, 'Note to Operator for system’s operations', 'Бележка към Оператора за системните операции', 7),
(3184, 'Automated process (filters etc.)', 'Автоматизирани процеси (филтри и др.)', 7),
(3185, 'ALREADY EXISTING ID (can appear in CHILD’S ID AND in INCIDENT ID)', 'СЪЩЕСТВУВАЩ  КОД (може да се появи за Код на дете или Код на инцидент)', 7),
(3186, 'Skip', 'Прескочи', 7),
(3187, 'Start Page', 'Начална страница', 7),
(3188, 'Operator\'s Panel', 'Панел на оператора', 7),
(3189, 'my account', ' моят профил', 7),
(3190, 'Contact Details', ' Данни за контакт', 7),
(3191, 'Change Password', ' Смeнете паролата', 7),
(3192, 'my previous cases', ' Моите предишни случаи', 7),
(3193, 'List of incidents', 'Списък на инциденти', 7),
(3194, 'List of Children’s ID', ' Списък с идентификационните номера (ID) на децата', 7),
(3195, 'my current cases', ' моите текущи случаи', 7),
(3196, 'List of temporary Child\'s ID', 'Списък на временни ID на деца', 7),
(3197, 'Information ', 'Информация', 7),
(3198, 'New Incident', 'Нов инцидент', 7),
(3199, 'My Profile', 'Моят профил', 7),
(3200, 'Change Pass', 'Променете паролата', 7),
(3201, 'List of Child\'s ID', 'Списък с  ID на децата', 7),
(3202, 'Log out!', 'Изход', 7),
(3203, 'Welcome', 'Добре дошли', 7),
(3204, 'New ', ' нов', 7),
(3205, 'Record Progress', 'Запиши промените', 7),
(3206, 'Agency\'s ID', 'Код на Агенцията', 7),
(3207, 'Operator\'s ID', 'Код на Оператора', 7),
(3208, 'Child\'s ID', 'Код на детето', 7),
(3209, 'Date of Record', 'Дата на записа', 7),
(3210, 'Incident\'s ID', 'ID на инцидента', 7),
(3211, 'Date of Incident', 'Дата на инцидента', 7),
(3212, 'Source of Information', 'Източник на информация', 7),
(3213, 'Forms of Maltreatment', 'Форми на малтретиране', 7),
(3214, 'Place of Incident', 'Място на инцидента', 7),
(3215, 'Child\'s Sex', 'Пол на детето', 7),
(3216, 'Child\'s DoB', 'Дата на раждане на детето', 7),
(3217, 'Child\'s Citizenship Status', 'Гражданство на детето', 7),
(3218, 'Family Composition', 'Структура на семейството', 7),
(3219, 'CGs Relationship to Child', 'Връзка на грижещите се с детето', 7),
(3220, 'Caregiver(s)\' Sex', 'Пол на грижещия/грижещите се', 7),
(3221, 'Caregiver(s)\' DoB', 'Дата на раждане на грижещия/грижещите се', 7),
(3222, 'Institutional Response', 'Отговор на интитуцията', 7),
(3223, 'Referral(s) to Services', 'Насочване към  службите', 7),
(3224, 'Agencys\'s ID', 'Код на агенцията', 7),
(3225, 'Identity Confirmation', 'Идентификация', 7),
(3226, 'TIP', 'Препоръка', 7),
(3227, 'If the above information needs update, please contact the CAN-MDS Administration Office.', 'Ако информацията по-горе се нуждае от актуализация, моля свържете се с административния офис на CAN-MDS', 7),
(3228, 'Date & Type of Incident', 'Дата и тип на инцидента', 7),
(3229, 'Incident ID', 'ID  (Идентификационен код) на инцидента', 7),
(3230, 'Type Of Record', ' Тип на записа', 7),
(3231, 'Type Of Incident', 'Тип на  инцидент', 7),
(3232, 'Notifications', ' Известия', 7),
(3233, 'Subject', ' Тема', 7),
(3234, 'Message', 'съобщение', 7),
(3235, 'Replace ID', 'Заменете ID', 7),
(3236, 'WELCOME TO CAN-MDS', 'Добре дошли в CAN-MDS', 7),
(3237, 'To proceed with the record, please follow the CAN-MDS Operations’ Protocol.', 'За да продължите със записа, моля следвайте стъпките, описани в  Протокола за CAN-MDS', 7),
(3238, 'If you need more information, please use the CAN-MDS Guide for Operators.', 'Ако имате нужда от повече информация, моля използвайте CAN-MDS ръководството за Оператори', 7),
(3239, 'Continue with the record', 'Продължи с въвеждането', 7),
(3240, 'Please, insert Child’s ID provided to you by the Administrator', 'Моля въведете Код на детето, предоставен от администратора', 7),
(3241, 'NOT KNOW CHILD\'S ID', 'НЕИЗВЕСТЕН  ID на детето', 7),
(3242, 'The Child’s ID you provided is referred to an', 'Предложеният ID на детето се отнася до', 7),
(3243, 'UNKNOWN CHILD', 'НЕПОЗНАТО ДЕТЕ', 7),
(3244, 'NEW CHILD RECORD', 'НОВА  РЕГИСТРАЦИЯ НА ДЕТЕ', 7),
(3245, 'NEW INCIDENT RECORD', 'Регистрация НА НОВ СЛУЧАЙ', 7),
(3246, 'You are going to proceed with the record of a new case of (alleged) child maltreatment.', 'Продължете с регистрация на нов случай на (предполагаемо) малтретиране на дете', 7),
(3247, 'Please proceed with recording of', 'Моля продължете със записа на', 7),
(3248, '-incident related variables', '- променливи, свързани с инцидента', 7),
(3249, '-child related variables', '-променливи,  свързани с детето', 7),
(3250, '-family related variables', '-променливи, свързани със семейството', 7),
(3251, '-services related variables', '- променливи, свързани със службите', 7),
(3252, 'Please record the referred Date of Incident', 'Моля въведете  посочената дата на инцидента', 7),
(3253, 'Unknown', 'Няма данни', 7),
(3254, 'A \"distinct\" event took place – Not continuous maltreatment', '', 7),
(3255, 'YYYY', 'Година (ГГГГ)', 7),
(3256, 'MM', 'Месец (ММ)', 7),
(3257, 'DD', 'Ден (ДД)', 7),
(3258, 'Continuous maltreatment – including \"distinct event(s)\"', '', 7),
(3259, 'start date', 'начална дата', 7),
(3260, 'duration', 'продължителност', 7),
(3261, 'Years', 'Години', 7),
(3262, 'Months', 'Месеци', 7),
(3263, 'Days', 'Дни', 7),
(3264, 'During the last 12 months', 'През последните 12 месеца', 7),
(3265, 'Before the last 12 months', 'Преди 12 месеца', 7),
(3266, 'Lifelong', 'През целия живот', 7),
(3267, 'Last known CM incident date', 'Датата на последния известен инцидент на малтретиране на детето', 7),
(3268, 'Continuous maltreatment - No \"distinct event\" took place', '', 7),
(3269, 'GO -> R4', 'Преминете към R4', 7),
(3270, 'Click to open sub-list', 'Натиснете,за да отворите падащото меню', 7),
(3271, 'Complete as precisely as possible YYYY-MM-DD', 'Попълнете възможно най-точно ГГГГ-ММ-ДД', 7),
(3272, 'Neglect/other abuse taking place over a longer period', 'Пренебрегване/друго насилие, случвало се за дълъг период от време', 7),
(3273, 'Check ONE in the sub-list', 'Изберете ЕДИН отговор  от падащото меню', 7),
(3274, 'Click to close sub-list', 'Натиснете,за да затворите падащото меню', 7),
(3275, 'approximately', 'приблизително', 7),
(3276, 'or less', 'или по-малко', 7),
(3277, 'Wrong date', 'Грешна дата', 7),
(3278, 'year', 'година', 7),
(3279, 'month', 'месец', 7),
(3280, 'day', 'Ден (ДД)', 7),
(3281, 'One day', 'Един ден', 7),
(3282, 'Please record the Source of Information', 'Моля запишете източника на информация', 7),
(3283, 'Unspecified', 'неуточнен', 7),
(3284, 'Identified (via routine screening)', 'Идентифициран (при рутинна проверка)', 7),
(3285, 'Child (alleged) victim', 'Дете (предполагаема) жертва', 7),
(3286, 'Parent /foster parent/ parent’s partner/ care provider', 'Родител/приемен родител/партньор на родителя/грижещ се', 7),
(3287, 'Relative (siblings, grandparents, etc.) living with the child', 'Роднина (братя и сестри, баби, дядовци и др.) живеещи с детето', 7),
(3288, 'Relative (siblings, grandparents, etc.) not living with the child', 'Роднина (братя и сестри, баби, дядовци и др.) не живеещи с детето', 7),
(3289, 'Friend / Neighbor', 'Приятел/Съсед', 7),
(3290, 'Self-reported as (alleged) perpetrator', 'Извършителят (сам докладва)', 7),
(3291, 'School /preschool /kindergarten personnel', 'Персонал в училище/предучилищна/детска градина', 7),
(3292, 'Leisure activity staff (e.g., scout leader, clergy, sport coach)', 'Специалисти за дейности в свободното време (напр.треньори по спорт)', 7),
(3293, 'Anonymous reporter', 'Анонимен човек, предоставящ информация', 7),
(3294, 'Personnel working in Child day care services', 'Работещи в сферата на дневни грижи за деца', 7),
(3295, 'Personnel working in Social Services/ Public–Central/Local', 'Работещи в социални служби/публични/местни', 7),
(3296, 'Personnel working in Health services', 'Работещи в здравни служби/институции', 7),
(3297, 'Personnel working in Mental Health Services', 'Работещи в сферата на психичното здраве', 7),
(3298, 'Personnel working in Ordinary/Juvenile Court and related services', 'Работещи в  съдебната система/съдебна система за малолетни  и свързани дейности', 7),
(3299, 'Personnel working in Police /low enforcement', 'Работещи в полицията и други органи, прилагащи закона', 7),
(3300, 'Personnel working in Helpline', 'Работещи в „Гореща линия“', 7),
(3301, 'Personnel working in Community agency including agencies working against DV', 'Работещи в структури, включително структури срещу домашно насилие', 7),
(3302, 'Personnel working in Ombudsman', 'Работещи в службите на Омбудсмана', 7),
(3303, 'Personnel working in NGOs/associations', 'Работещи в неправителствени организации/асоциации', 7),
(3304, 'Personnel working in services for people with disabilities', 'Работещи в сферата на услугите за хора с увреждания', 7),
(3305, 'Other', 'Друг', 7),
(3306, 'GO -> I3', 'Преминете към I3', 7),
(3307, 'Check ONE from the list', 'Изберете ЕДНО от списъка', 7),
(3308, 'Please record the Form(s) of Maltreatment', 'Моля въведете формата/ите на насилие', 7),
(3309, 'Form(s) of Maltreatment', 'Форма(и) на малтретиране', 7),
(3310, 'Expand/Collapse list', 'Увеличи/Намали списъка', 7),
(3311, 'Check as many as applicable. By selecting from child menu, broad categories are auto-selected.', 'Моля отбележете приложимите. От менюто за детето категориите се избират автоматично', 7),
(3312, 'Please provide as detailed as possible information (by using sub-menus).', 'Моля представете възможно най-пълна инфромация (като използвате падащите менюта)', 7),
(3313, 'Acts Committed', 'Извършени действия', 7),
(3314, 'Violent acts against self /Self-harm actions', 'Автоагресивни/самонараняващи  действия', 7),
(3315, 'Eating disorder', 'Хранително разстройство', 7),
(3316, 'Substance use/ abuse', 'Употреба на наркотични вещества/злоупотреба', 7),
(3317, 'Runaway', 'Бягство', 7),
(3318, 'Self-inflicted injuries', 'Самопричинени  увреждания', 7),
(3319, 'Suicidal thoughts', 'Мисли за самоубийство', 7),
(3320, 'Suicide attempt', 'Опит за самоубийство', 7),
(3321, 'Actual suicide', 'Самоубийство', 7),
(3322, 'Other self-harm action (unspecified)', 'Друго самонараняване (неуточнено)', 7),
(3323, 'Physical violence acts committed [with or without injury]', 'Физическо насилие (с или без нараняване)', 7),
(3324, 'Physical violent acts/ corporal punishment/ “disciplines”', 'Действия на физическо насилие/телесно наказание/\"дисциплина\"', 7),
(3325, 'Slapping', 'Удряне на шамар', 7),
(3326, 'Smacking', 'Зашлевяване', 7),
(3327, 'Spanking', 'Напляскване', 7),
(3328, 'Pinching', 'Щипане', 7),
(3329, 'Twisting ear(s)', 'Дърпане на ухо/уши', 7),
(3330, 'Pulling hair', 'Дърпане на коса', 7),
(3331, 'Hitting with an object', 'Удар с предмет', 7),
(3332, 'Beating', '\"Пребиване\"', 7),
(3333, 'Tying up or tying to something /restraining to cloth sacks', 'Завръзване', 7),
(3334, 'Locking up', 'Заключване', 7),
(3335, 'Leaving child to lie in their own excrement', 'Оставяне на детето да лежи в собствените му екстременти', 7),
(3336, 'Pushing', 'Бутане', 7),
(3337, 'Throwing', 'Хвърляне', 7),
(3338, 'Shaking', 'Раздрусване', 7),
(3339, 'Grabbing', 'Сграбчване', 7),
(3340, 'Choking', 'Задушаване', 7),
(3341, 'Squeezing neck', 'Стискане за врата', 7),
(3342, 'Kicking', 'Ритане', 7),
(3343, 'Hitting on head (with hand or against the wall)', 'Удряне по главата (с ръка или в стена)', 7),
(3344, 'Boxing ear', 'Грубо дърпане на уши', 7),
(3345, 'Scratching', 'Грубо щипане', 7),
(3346, 'Biting', 'Хапане', 7),
(3347, 'Burning', 'Горене', 7),
(3348, 'Scalding', 'Попарване', 7),
(3349, 'Violent acts known also as harmful practices', 'Насилствени действия , причиняващи болка и нараняване', 7),
(3350, 'Hitting on the soles of the feet', 'Удряне по стъпалата на краката', 7),
(3351, 'Forcing to ingest spicy food', 'Слагане на лютива чушка или пикантна храна в устата на детето', 7),
(3352, 'Forced feeding', 'Насилствено хранене', 7),
(3353, 'Forcing children to stay in uncomfortable positions', 'Принуждаване на детето да стои в болезнена за него поза', 7),
(3354, 'Binding', 'Връзване', 7),
(3355, 'Inflicting scars/ scarring', 'Оставяне на белези', 7),
(3356, 'Teeth extraction as punishment', 'Вадене на зъби като наказание', 7),
(3357, 'Branding', 'Жигосване', 7),
(3358, 'Fattening', 'Угояване', 7),
(3359, '“Retribution” acts of violence', 'Насилие  за \"отмъщение\"', 7),
(3360, 'Virginity testing (inspecting girls’ genitalia)', 'Проверка на девственост (проверяване на половите органи на момичета)', 7),
(3361, 'Forced circumcision', 'Принудително обрязване', 7),
(3362, 'Female genital mutilation', 'Осакатяване на женски полови органи', 7),
(3363, 'Uvulectomy', 'Увулектомия', 7),
(3364, 'Forced marriage and early marriage', 'Насилствено омъжване и ранно задомяване', 7),
(3365, 'Violent and degrading initiation rites / “hazing”', 'Насилствени и унизителни обреди/\"унижения\"', 7),
(3366, 'Practices as “exorcism” after accusations of “witchcraft”', 'Практикуване на\"екзорсизъм\" след обвинения в \"магьосничество\"', 7),
(3367, 'Forced sterilization, particularly girls', 'Насилствена стерилизация, особено на момичета', 7),
(3368, 'Violence in the guise of treatment', 'Насилие под маската на грижа', 7),
(3369, 'Deliberate infliction of disabilities for exploiting/begging', 'Умишлено нараняване  с цел  използване  за просия', 7),
(3370, 'Acts of life threatening maltreatment', 'Животозастрашаващо малтретиране (умишлено)', 7),
(3371, 'Administering unnecessary invasive medical procedures', 'Подлагане на ненужни инвазивни медицински процедури', 7),
(3372, 'Administering non prescribed substances', 'Даване на непредписани вещества', 7),
(3373, 'Child has been given poison', '(умишлено) Отравяне', 7),
(3374, 'Threatening with a knife (also psychological abuse)', 'Заплашване с нож (както психично насилие)', 7),
(3375, 'Threatening with a gun (also psychological abuse)', 'Заплашване с оръжие (както и психологично/психично  насилие)', 7),
(3376, 'Stabbing', 'Пробождане', 7),
(3377, 'Shooting', 'Прострелване', 7),
(3378, 'Dowry-related violence/death (also harmful practice)', 'Свързано със зестра насилие/смърт (както и практика, нанасяща вреда)', 7),
(3379, '“Honour” crimes (also harmful practice)', 'Престъпления \"на честта\"  (както и практика, нанасяща вреда )', 7),
(3380, 'Abduction-related acts', 'Действия, свързани с отвличане', 7),
(3381, 'Non-family abduction', 'Отвличане от не-член на семейството', 7),
(3382, 'Family abduction', 'Отвличане от член на семейството', 7),
(3383, 'Institutional and system violations of child rights', 'Институционални нарушения на правата на детето', 7),
(3384, 'Caning', 'Бой с пръчка', 7),
(3385, 'Flogging', 'Бой с камшик', 7),
(3386, 'Stoning', 'Замерване с камъни', 7),
(3387, 'Torture (all forms)', 'Изтезания (всички форми)', 7),
(3388, 'Amputations', 'Ампутации', 7),
(3389, 'Imposing of death sentence for crimes committed', 'Налагане на смъртна присъда за извършени престъпления', 7),
(3390, 'Other described physical acts', 'Други описани физически действия', 7),
(3391, 'No specific information for reported/suspected physical violence', 'Няма конкретна информация за докладвано/вероятно физическо насилие', 7),
(3392, 'Sexual violence acts committed [with or without injury]', 'Извършено сексуално насилие (с или без увреждане)', 7),
(3393, 'Sexual violence acts', 'Действия на сексуално насилие', 7),
(3394, 'Acts involving penetration (intrusion)', 'Действия, включващи проникване', 7),
(3395, 'Without force', 'Без сила', 7),
(3396, 'anus', 'анус', 7),
(3397, 'vulva', 'вулва', 7),
(3398, 'mouth', 'уста', 7),
(3399, 'Involving use of force', 'Включващи употребата на сила', 7),
(3400, 'Attempted sexual abuse (not involving penetration)', 'Опит за сексуално насилие (не включващо проникване)', 7),
(3401, 'with physical contact', 'с физически контакт', 7),
(3402, 'without physical contact', 'без физически контакт', 7),
(3403, 'Threatened sexual abuse', 'Заплаха за сексуално насилие', 7),
(3404, 'Touching/fondling genitals', 'Докосване/галене на гениталиите', 7),
(3405, 'Showing genitals to child', 'Показване на гениталиите на дете', 7),
(3406, 'Sexual harassment', 'Сексуален тормоз', 7),
(3407, 'Voyeurism /spying on the children intimate behaviours', 'Воайорство  / тайно наблюдаване на интимните поведения на  детето', 7),
(3408, 'Providing sexually explicit materials', 'Предлагане на недвусмислени сексуални материали', 7),
(3409, 'Forced exposure to pornography', 'Насилствено излагане на порнография', 7),
(3410, 'Forcing to witness sexual violence against mother', 'Принуждаване  да стане свидетел на сексуално насилие спрямо майката', 7),
(3411, 'Sexual “luring” (via ICT)', 'Сексуално \"примамване\" (чрез информационно-комуникационни технологии)', 7),
(3412, 'Online sexual stalking /harassment', 'Онлайн сексуално преследване/тормоз', 7),
(3413, 'Other Sexual violence acts', 'Други действия на сексуално насилие', 7),
(3414, 'Sexual exploitation acts', 'Действия на сексуална експлоатация', 7),
(3415, 'Child prostitution', 'Детска проституция', 7),
(3416, 'Use of children in commercial sexual exploitation', 'Използване на деца - сексуална експлоатация с търговска цел', 7),
(3417, 'Sexual exploitation in travel and tourism', 'Сексуална ескплоатация при пътуване и туризъм', 7),
(3418, 'Sexual slavery', 'Сексуално робство', 7),
(3419, 'Sale of children for sexual purposes', 'Продажба на деца за сексуални цели', 7),
(3420, 'Trafficking (within and between countries)', 'Трафик (в страната и извън границите й)', 7),
(3421, 'Involvement in pornography', 'Участие в порнография', 7),
(3422, 'Other sexual exploitation acts (unspecified)', 'Други действия на сексуална експлоатация (неопределени)', 7),
(3423, 'No specific information for reported/suspected sexual violence', 'Няма конкретна информация за докладвано/вероятно сексуално насилие', 7),
(3424, 'Psychological violence acts committed [with or without injury]', 'Извършено психическо насилие [с или без травма]', 7),
(3425, 'Violent acts with or without obvious consequences', 'Действия на насилие с или без явни последици', 7),
(3426, 'Bullying/ Psychological bullying and hazing', 'Тормоз/ Психологически тормоз и унижения', 7),
(3427, 'by other children', 'от други деца', 7),
(3428, 'by adults', 'от възрастни', 7),
(3429, 'Homophobic bullying /related to sexual orientation', 'Хомофобски тормоз / свързан със сексуалната ориентация', 7),
(3430, 'Cyber bullying (via ICTs / mobile phones /Internet)', 'Кибертормоз (чрез информационни и комуникационни технологии / мобилни телефони / интернет)', 7),
(3431, 'Ignoring and favoritism', 'Игнориране и фаворизиране', 7),
(3432, 'Denying emotional responsiveness', 'Отказ на емоционална подкрепа', 7),
(3433, 'Over protection', 'Свръхпротектиране', 7),
(3434, 'Isolation (social)', 'Изолация (социална)', 7),
(3435, 'Close confinement (tying/binding)', 'Затваряне (връзване)', 7),
(3436, 'Placement in solitary confinement', 'Настаняване в строг затвор', 7),
(3437, 'Degrading /inhuman conditions of detention', 'Унизителни/нечовешки условия на задържане', 7),
(3438, 'Humiliation /Insults, name-calling, belittling, ridiculing', 'Унижаване/Обиди, прякори, омаловажаване, подигравки', 7),
(3439, 'Humiliation via ICT', 'Унижение чрез информационни и комуникационни технологии', 7),
(3440, 'Rejection and Spurning', 'Отхвърляне и изгонване', 7),
(3441, 'Verbal assaults', 'Вербално насилие', 7),
(3442, 'Terrorization / Scaring', 'Тероризиране/Оставяне на белези', 7),
(3443, 'Threats of sexual violence (with or without contact)', 'Заплахи за сексуално насилие (с или без контакт)', 7),
(3444, 'Threats of other maltreatment', 'Заплахи за друго малтретиране', 7),
(3445, 'Other related acts hurting child’s feelings', 'Други подобни действия, нараняващи чувствата на детето', 7),
(3446, 'Exploitation related psychological violent acts', 'Експлоатация, свързана с  психологически актове на насилие', 7),
(3447, 'Exploiting and corrupting', 'Експлоатация и покваряване', 7),
(3448, 'Labour/economic exploitation', 'Трудова/икономическа експлоатация', 7),
(3449, 'Forcing to undertake adult\'s responsibilities/parent’s role', 'Принуждаване да поеме отговорностите на възрастния', 7),
(3450, 'Forcing to begging', 'Принуждаване да проси', 7),
(3451, 'Forcing to participate in religious ritual', 'Принуждаване да участва в религиозни ритуали', 7),
(3452, 'Forcing to participate in a violent political event', 'Принуждаване да участва в политическо събитие с насилие', 7),
(3453, 'No specific info for reported/suspected exploitation acts', 'Няма конкретна информация за регистрирани/предполагаеми действие на експлоатация', 7),
(3454, 'Exposure related psychological violent acts', 'Свидетел на психическо насилие', 7),
(3455, 'Exposure to any kind of violence in the family / DV', 'Свидетел на всякакъв вид насилие в семейството/домашно насилие', 7),
(3456, 'Exposure to violence against other children', 'Свидетел на насилие срещу деца', 7),
(3457, 'Exposure to intimate partner violence', 'Свидетел на насилие от интимния партньор', 7),
(3458, 'Exposure to violence against other adults', 'Свидетел на насилие срещу други възрастни', 7),
(3459, 'Exposition to the homicide of a significant person', 'Свидетел на убийство на значим човек', 7),
(3460, 'Exposure to a violent environment outside the family', 'Присъствие в  насилствена среда извън семейството', 7),
(3461, 'Exposure to violence via electronic means', 'Насилие чрез електронни форми/кибертормоз', 7),
(3462, 'information and communication technologies', 'информационни и комуникационни технологии', 7),
(3463, 'in the mass media', 'в  медиите', 7),
(3464, 'No specific info for reported/suspected related exposure', 'Няма конкретна информация за регистрирани/предполагаеми действия', 7),
(3465, 'No specific info for reported/suspected psych/l abuse violent acts', 'Няма конкретна информация за регистрирани/предполагаеми действия на физическо насилие', 7),
(3466, 'Omissions', 'Пренебрегване', 7),
(3467, 'Omissions in child’s care / Neglect', 'Пренебрегване в грижите за детето/пренебрегване', 7),
(3468, 'Emotional neglect related omissions', 'Емоционално пренебрегване', 7),
(3469, 'Persistent ignoring of the child’s emotional needs/ Chronic inattention to the child', 'Постоянно игнориране на емоционалните нужди на детето / Хронична незаинтересованост към детето', 7),
(3470, 'Psychologically “unavailable” caregivers', 'Психологически \"недостъпни\" грижещи се', 7),
(3471, 'Inappropriately advanced expectations (def.  According to child’s characteristics)', 'Неадекватно високи очаквания (според характеристиките на детето)', 7),
(3472, 'No specific information for omissions related to emotional neglect', 'Няма конкретна информация за пренебрегване, свързана с емоционалните нужди на детето', 7),
(3473, 'Physical neglect related omissions', 'Физическо пренебрегване', 7),
(3474, 'Inadequate / inappropriate nutrition', 'Неадекватно/неподходящо хранене', 7),
(3475, 'Inadequate / inappropriate personal hygiene', 'Неадекватна/неподходяща лична хигиена', 7),
(3476, 'Inadequate / inappropriate clothing', 'Неадекватно/неподходящо обличане', 7),
(3477, 'Inadequate / inappropriate shelter', 'Неадекватни/неподходящи битови условия', 7),
(3478, 'No specific information for omissions related child’s physical needs', 'Няма конкретна информация за пренебрегване, свързано с физическите нужди на детето', 7),
(3479, 'Medical neglect related omissions', 'Пренебрегване по отношение на здравни грижи', 7),
(3480, 'Refusal to provide preventive health care (vaccinations, vision, and dental care)', 'Отказ за предоставяне на превантивни здравни грижи (ваксинации, прегледи и стоматологична помощ)', 7),
(3481, 'Refusal to allow /provide needed medical care for diagnosed health condition/ impairment', 'Отказ за предоставяне на необходимата медицинска помощ за диагностициране на състоянието', 7),
(3482, 'Unjustified delay to seek needed care', 'Неоснователно забавяне да се потърси медицинска помощ', 7),
(3483, 'Failure to provide with basic medical care', 'Неуспешно осигуряване на  основна медицинска помощ', 7),
(3484, 'Withholding essential medical care', 'Отказ  за оказване на  жизненоважна медицинска помощ', 7),
(3485, 'No specific information for omissions related child’s medical needs', 'Няма конкретна информация за пренебрегване, свързано със здравните нужди на детето', 7),
(3486, 'Educational neglect related omissions', 'Пренебрегване по отношение на образованието', 7),
(3487, 'Persistent failure to register child at the school', 'Постоянно неизпълнение на задължението да се запише детето в училище', 7),
(3488, 'Has not attended school at all', 'Не посещава училище изобщо', 7),
(3489, 'Dropped out', 'Отпаднало от училище', 7),
(3490, 'Persistent failure to enrol at the school resulting to irregular school attendance', 'Постоянно неизпълнение на задължението да осигури редовно посещение в училище', 7),
(3491, 'compulsory school', 'подлежащи на задължително обучение', 7),
(3492, 'non compulsory (ECEC)', 'неподлежащи', 7),
(3493, 'Chronic truancy', 'Постоянни бягства от училище', 7),
(3494, 'Refusal to attend special educational needs', 'Отказ да се даде възможност да посещава специализирани програми за деца със специални образователни потребности', 7),
(3495, 'Refusal to allow needed attention to special educational needs', 'Отказва да  отдели  необходимото внимание на специалните образователни потребности', 7),
(3496, 'Refusal to provide needed attention to special educational needs', 'Отказва да осигури/ или предвиди/ необходимите грижи и внимание  породени от специалните образователни потребности.', 7),
(3497, 'No specific information for omissions related child’s educational needs', 'Няма  информация за пренебрегване по отношение на образованието', 7),
(3498, 'Risk exposure related omissions', 'Пренебрегване чрез излагане на риск', 7),
(3499, 'Exposure to hazardous/ dangerous environments', 'Излагане в опасна среда', 7),
(3500, 'Inside household', 'В домашна среда', 7),
(3501, 'Outside home', 'Извън дома', 7),
(3502, 'Exposure to substances use/misuse by others', 'Употреба на психоактивни вещества/злоупотреба от други', 7),
(3503, 'Alcohol', 'Алкохол', 7),
(3504, 'Drugs', 'Наркотици', 7),
(3505, 'Other substances', 'Други вещества', 7),
(3506, 'No specific information for reported/ suspected omissions for exposure to risks', 'Няма конкретна информация за пренебрегване чрез излагане на рискове', 7),
(3507, 'Supervision related omissions', 'Пренебрегване, свързано с надзора', 7),
(3508, 'Inadequate/ lack of supervision resulting in physical harm', 'Физическо увреждане вследствие на неадекватен или липсващ надзор', 7),
(3509, 'Persisted lack of supervision concerning substance use/misuse by the child', 'Постоянна липса на контрол относно употребата на вещества/злоупотреба от детето', 7),
(3510, 'No specific information for omissions related to the child’s supervision', 'Няма информация за пренебрегване във връзка с надзор над детето', 7),
(3511, 'Refusal of custody/abandonment', 'Отказ от родителски права/изоставяне', 7),
(3512, 'Unstable custody arrangements', 'Непостоянно попечителство', 7),
(3513, 'Illegal transfers of custody', 'Незаконно прехвърляне на родителски права', 7),
(3514, 'Refusal of custody', 'Отказ от родителски права', 7),
(3515, 'Abandonment (primary caregiver(s) runaway / migrate and leave the children behind)', 'Изоставяне (Основният грижещ се е избягал/емигрирал и оставил децата)', 7),
(3516, 'children out of wedlock', 'извънбрачни деца', 7),
(3517, 'children with disabilities', 'деца с увреждания', 7),
(3518, 'No specific information for omissions related child’s refusal of custody', 'Няма конкретна информация свързана с пренебрегване, свързано с отказ от родителски права', 7),
(3519, 'Please record the Place of Incident', 'Моля въведете мястото на инцидента', 7),
(3520, 'Unknown/ Unspecified place', 'Непознато/неуточнено място', 7),
(3521, 'Home/ Family', 'Дом/Семейство', 7),
(3522, 'Home/ Relatives', 'Дом/Роднини', 7),
(3523, 'Home/ Friends', 'Дом/Приятели', 7),
(3524, 'Child care institution (residential care)', 'Институция за отглеждане на деца (резидентна грижа)', 7),
(3525, 'Child care institution (day care)', 'Социална услуга в общността  за деца (дневна грижа)', 7),
(3526, 'Detention or correctional institution', 'Институция за лишаване от свобода или възпитателни интернати', 7),
(3527, 'Leisure/ Playground/ Recreational area', 'Зона за отдих/спорт/развлечения', 7),
(3528, 'Sports-athletics', 'Спорт-атлетика', 7),
(3529, 'School', 'Училище', 7),
(3530, 'Educational institution', 'Учебно заведение', 7),
(3531, 'Medical Services', 'Медицински услуги', 7),
(3532, 'Public transportation', 'Обществен транспорт', 7),
(3533, 'Public place/ street, commercial & surrounding area', 'Публично място/улица, търговски център', 7),
(3534, 'Other place', 'Друго място', 7),
(3535, 'GO -> C2', 'Премини към C2', 7),
(3536, 'Click as many as applicable', 'Отбележете толкова, колкото са приложими', 7),
(3537, 'Please record Child’s Sex, Date of Birth and Citizenship Status', 'Моля отбележете пол на детето, дата на раждане и гражданство', 7),
(3538, 'Male', 'Мъжки', 7),
(3539, 'Female', 'Женски', 7),
(3540, 'Not known', 'Няма данни', 7),
(3541, 'Check ONE from the list below', 'Отбележете ЕДНО от изброените по-долу', 7),
(3542, 'Child’s Date of Birth', 'Дата на раждане на детето', 7),
(3543, '<18 years old (if no year is known)', '<18 години (ако годината е неизвестна)', 7),
(3544, '<18 years old', '<18 години', 7),
(3545, '>18 (\"minor\" according to legislation)', '', 7),
(3546, '>18 years old', 'над 18 години', 7),
(3547, 'Unborn', 'Неродено', 7),
(3548, 'Please record the full date of birth:', 'Моля отбележете пълната дата на раждане:', 7),
(3549, 'YYYY-MM-DD', 'ГГГГ-ММ-ДД', 7),
(3550, 'If DD is unknown:', 'ако няма данни за датата :', 7),
(3551, 'YYYY-MM', 'ГГГГ-ММ', 7),
(3552, 'If MM-DD are unknown:', 'ако няма данни за месеца и датата:', 7),
(3553, 'If YYYY-MM-DD are unknown AND the alleged victim is a child:', 'Ако ГГГГ-ММ-ДД са неизвестни и предполагаемата жертва е дете', 7),
(3554, '<18', '<18 години', 7),
(3555, 'Citizenship Status', 'Гражданство', 7),
(3556, 'Not a citizen', 'не е български гражданин', 7),
(3557, 'Citizen', 'Гражданин на', 7),
(3558, 'with ID', 'с EГН', 7),
(3559, 'Citizen with ID', 'Гражданин с  EГН', 7),
(3560, 'without ID', 'без  EГН', 7),
(3561, 'Citizen without ID', 'Гражданин без EГН', 7),
(3562, 'Unaccompanied foreign child or refugee', 'Непридружено дете - чужденец или бежанец', 7),
(3563, 'Check ONE from the list below. If the child is “Citizen”, please define in sub-list', 'Моля отбележете ЕДИН от отговорите от списъка. Ако детето е \"Гражданин на\", моля определете от падащото меню', 7),
(3564, 'Please record Family Composition and indicate up to two Primary Caregivers', 'Моля отбележете структурата на семейството и посочете до двама основни грижещи се', 7),
(3565, 'A: Type of Family', 'А. Вид на семейството', 7),
(3566, 'Boarder(s) (child lives in residential/institutional care)', 'Детето е настанено в институция', 7),
(3567, 'Child lives with his/her family (including biological/ adoptive)', 'Детето живее в семейство си (включително биологично/осиновителско)', 7),
(3568, 'Child lives in a foster family', 'Детето живее в приемно семейство', 7),
(3569, 'Child lives in a re-composed family', 'Детето живее в реконструирано семейство', 7),
(3570, 'Child lives in a family other than its family/ foster family', 'Детето живее в различно от неговото семейство/ приемно семейство', 7),
(3571, 'Relatives’ family', 'Семейство на роднини', 7),
(3572, 'Child lives in a family other than its family/ foster family - Relatives’ family', 'Детето живее  в  различно от неговото семейство/приемно семейство - Семейство на роднини', 7),
(3573, 'Friends’ family', 'Семейство на близки', 7),
(3574, 'Child lives in a family other than its family/ foster family - Friends’ family', 'Детето живеев в  различно от неговото семейство/приемно семейство - Семейство на близки', 7),
(3575, 'SKIP “B”; GO -> F3', 'Прескочи \"Б\"; премини към Е3', 7),
(3576, 'If you DON\'T chose Boarder(s) -> B: Members of Family', 'Ако НЕ изберете \"детето е настанено в инстутиция\" ->Б: членове на семейството', 7),
(3577, 'B: Member(s) of Family', 'Б: Член (ове) на семейството', 7),
(3578, 'Number', 'Брой', 7),
(3579, 'Primary caregiver(s)', 'Основен/ни грижещ/и се', 7),
(3580, 'Parent(s)', 'Родител(и)', 7),
(3581, 'Step Parent(s)', 'Втора майка/баща', 7),
(3582, 'Parent(s)’ partner(s)', 'Партьор (и) на родител(и)', 7),
(3583, 'Sibling(s)', 'Брат(я) и сестра (и)', 7),
(3584, 'Younger than the (alleged) victim', 'По-малък от (предполагаемата) жертва', 7),
(3585, 'Older than the (alleged) victim (<18)', 'По-голям от (предполагаемата) жертва (<18)', 7),
(3586, 'Older than the (alleged) victim (>18)', 'По-голям от (предполагаемата) жертва (>18)', 7),
(3587, 'Grandparent(s)', 'Баба и дядо', 7),
(3588, 'Other relative(s)', 'Друг(и) роднина(и)', 7),
(3589, 'Blood relatives', 'Кръвни родственици', 7),
(3590, '<18 [child(ren)]', '<18 [дете/деца]', 7),
(3591, '>18 [adult(s)]', '>18 [възрастен/и]', 7),
(3592, 'By law relatives', 'Законни родственици', 7),
(3593, 'Family friend(s)', 'Близки на семейството', 7),
(3594, 'Other not-related household members', 'Други, несвързани със семейството членове', 7),
(3595, 'Please indicate up to 2 child’s primary caregiver(s) (you can uncheck)', 'Моля отбележете до двама грижещи се за детето (можете да премахнете отметката)', 7),
(3596, 'members', 'членове', 7),
(3597, 'member family', 'член на семейството', 7),
(3598, 'Please record Caregiver(s) Relationship to Child, Sex and Date of Birth', 'Моля отбележете пол, дата на раждане и връзката на грижещия се с детето', 7),
(3599, 'Relationship to Child', 'Връзка с детето', 7),
(3600, '1st Caregiver', 'Първи грижещ се', 7),
(3601, 'Professional Caregiver', 'Професионален грижещ се', 7),
(3602, 'Temporary caregiver/Other', 'Временно грижещ се за детето/Други', 7),
(3603, 'Unknown relationship', 'Няма данни за връзката', 7),
(3604, 'Check ONE per Caregiver', 'Посочете един отговор за грижещ се', 7),
(3605, 'Caregiver(s) Sex', 'Пол на полагащия грижа за детето', 7),
(3606, 'Caregiver(s) DoB', 'Дата на раждане на грижещия се за детето', 7),
(3607, 'YY', 'Година (ГГ)', 7),
(3608, '\'s', '', 7),
(3609, 'YY-MM-DD', 'ГГ-ММ-ДД', 7),
(3610, 'If YYYY-MM-DD are unknown then record the decade:', 'Ако годината, месеца и датата са неизвестни, отбележете десетилетието', 7),
(3611, 'If DECADE is unknown, then:', 'Ако десетилетието е неизвестно, тогава:', 7),
(3612, 'Please record any Institutional Response', 'Моля въведете отговора на институцията', 7),
(3613, 'No response was required DUE TO CHILD’S DEATH', 'Отговор не бе необходим поради смърт на детето', 7),
(3614, 'No Response', 'Без отговор', 7),
(3615, 'Yes', 'Да', 7),
(3616, 'Immediate intervention(s)', 'Незабавна интервенция/и', 7),
(3617, 'Physical Medical exam(s)', 'Медицински преглед/и', 7),
(3618, 'Mental Health exam(s)', 'Психиатричен преглед/и', 7),
(3619, 'Forensic evaluation initiated', 'Назначена съдебно-психиатрична оценка', 7),
(3620, 'Child protection /welfare services assessment', 'Защита на детето/оценка на социалните услуги', 7),
(3621, 'Police intervention', 'Намеса на полиция', 7),
(3622, 'Action taken -NO COURT INVOLVEMENT', 'Предприети действия - без участието на съд', 7),
(3623, 'Child remains in family with planned intervention', 'Детето остава в семейството с планирана интервенция', 7),
(3624, 'Emergency placement', 'Спешно настаняване', 7),
(3625, 'Supportive intervention for current caregiver(s)', 'Професионална подкрепа за грижещия/грижещите се', 7),
(3626, 'Mother/child shelter with parent and child together', 'Настаняване на детето  заедно с родител', 7),
(3627, 'Police emergency protection procedures', 'Действия на незабавна полицейска закрила', 7),
(3628, 'CPS/welfare services emergency protection procedures', 'Служби за закрила на детето/социални служби, предлагащи спешни мерки за закрила', 7),
(3629, 'Referral to child protection /welfare services', 'Насочване към отделите за  закрила на детето/социални служби', 7),
(3630, 'Action taken -COURT or EQUIVALENT AUTHORITY TO THE COURT INVOLVEMENT', 'Предприети действия - с участието на  съд или подобен орган', 7),
(3631, '(Family) Court measures initiated', 'Мерки, предприети от (семеен) съд', 7),
(3632, 'Action to protect victim by court order(s)', 'Действия за защита на жертвите по съдебен ред', 7),
(3633, 'Action to remove parent(s)’ rights', 'Действия за отнемане на родителски права', 7),
(3634, 'Expulsion of (alleged) abuser from home', 'Насилникът напуска дома със съдебно нареждане', 7),
(3635, 'Action to prosecute perpetrator(s)', 'Иск за наказателно преследване на насилника/насилниците', 7),
(3636, 'Out of home placement', 'Настаняване извън дома', 7),
(3637, 'Kinship Care (relatives/extended family)', 'Грижа от близки (роднини/разширено семейство)', 7),
(3638, 'Foster Care', 'Приемно семейство', 7),
(3639, 'Children’s Home Institution', 'Домове на деца', 7),
(3640, 'Adoption with parents’ agreement', 'Осиновяване със съгласие на родителите', 7),
(3641, 'Adoption by court order', 'Осиновяване със съдебно решение', 7),
(3642, 'GO -> S2', 'Премини към S2', 7),
(3643, 'Check below as many as applicable', 'Отбележете по-долу толкова отговора, колкото са приложими', 7),
(3644, 'Please record any Referral(s) made to Services by you/your agency', 'Моля въведете всички насочвания към служби/ услуги, направени от Вашата аенция', 7),
(3645, 'None', 'Никакви', 7),
(3646, 'Judicial Services', ' Юридически услуги/служби', 7),
(3647, 'for child ONLY', 'САМО за детето', 7),
(3648, 'for caregiver(s) ONLY', 'САМО за грижещия/ите се', 7),
(3649, 'for child AND family', 'за детето И семейството', 7),
(3650, 'Mental Health Services', 'Психично-здравни услуги', 7),
(3651, 'Independent Authorities', 'Независими органи', 7),
(3652, 'Social Welfare Services', 'Социални услуги', 7),
(3653, 'Law Enforcement related Services', 'Правораздавателни органи', 7),
(3654, 'Community Organizations and NGOs', 'Неправителствени организации', 7),
(3655, 'Existing Registries and Research Organizations', 'Съществуващи регистри и научно-изследователски организации', 7),
(3656, 'Educational Services', 'Образователни услуги', 7),
(3657, 'Other related Services', 'Други служби', 7),
(3658, 'End of Record', 'Край на записа', 7),
(3659, 'CHECK RECORD OPTIONS', 'ПРОВЕРКА НА ВЪЗМОЖНОСТИТЕ ЗА ЗАПИС', 7),
(3660, 'Please check the record options', 'Моля проверете възможностите за запис', 7),
(3661, 'You can make any changes by navigating throught the right panel!', 'Може да правите промени като използвате десния панел', 7),
(3662, 'Incident', 'Инцидент', 7),
(3663, 'ID', 'ID (Идентификационен код) ', 7),
(3664, 'Sex', 'Пол', 7),
(3665, 'Date of birth', 'Дата на раждане', 7),
(3666, 'Family and Caregiver(s)', 'Семейство и грижещ/и се за детето', 7),
(3667, 'Services', 'Служби', 7),
(3668, 'Submit Record', 'Въвеждане на запис', 7),
(3669, 'Loading', 'Попарване', 7),
(3670, 'RECORD COMPLETED', 'ЗАПИСЪТ Е ЗАВЪРШЕН', 7),
(3671, 'Display/print the record', 'Показване & Отпечатване на запис', 7),
(3672, 'Report', 'Доклад', 7),
(3673, 'RECORD', 'ЗАПИС', 7),
(3674, 'Agency', 'Служба', 7),
(3675, 'Information provided by', 'Информация, предоставена от', 7),
(3676, 'Age at the date of incident', 'Възраст към датата на инцидента', 7),
(3677, 'Age at the date of recording', 'Години на детето към датата на запис', 7),
(3678, 'Type of family', 'Вид на семейството', 7),
(3679, 'Family\'s member(s)', 'Член/ове на семейството', 7),
(3680, '1st', 'Първи грижещ се', 7),
(3681, 'born', 'роден на', 7),
(3682, '2nd', 'Втори грижещ се', 7),
(3683, 'Back', 'Обратно', 7),
(3684, 'KNOWN CHILD', 'ПОЗНАТО ДЕТЕ', 7),
(3685, 'EXISTING CHILD RECORD', 'СЪЩЕСТВУВАЩА РЕГИСТРАЦИЯ НА ДЕТЕ', 7),
(3686, 'You are going to proceed with the record of a new CM incident for  the child', 'Продължете с регистрацията на нов инцидент на малтретиране за детето', 7),
(3687, 'Please proceed with checking of', 'Моля продължете с проверка на', 7),
(3688, 'TIP: Update –if needed', 'Препоръка: обновете, ако е необходимо', 7),
(3689, 'Known Incidents', 'Известни инциденти', 7),
(3690, 'The incident you are trying to record might already exist!', 'Инцидентът, който се опитвате да въведете може вече да съществува!', 7),
(3691, 'Please check the incident record(s) below', 'Моля проверете записа/записите на въведените по-долу  случаи', 7),
(3692, 'for Child\'s ID:', 'за код на детето:', 7),
(3693, 'and Date of Incident:', 'и датата на инцидента', 7),
(3694, 'Date-Time of Record', 'Дата-час на запис', 7),
(3695, 'Display', 'Покажи', 7),
(3696, 'Add new incident', 'Добавете нови инциденти', 7),
(3697, 'ENTER Username', 'EINGABE Benutzername', 8),
(3698, 'ENTER Password', 'EINGABE Passwort', 8),
(3699, 'Log in', 'Anmeldung', 8),
(3700, 'MEMO: Meaning of Symbols & Colors', 'MEMO: Bedeutung der Symbole & Farben', 8),
(3701, 'Auto-Completed variable', 'automatisch vervollständigte Variable', 8),
(3702, 'Variable already recorded by the Operator', 'Variable bereits von einem anderen Anwender vervollständigt', 8),
(3703, 'Single selection (mutually exclusive codes)', 'Einzelauswahl (sich gegenseitig ausschließende Werte)', 8),
(3704, 'Multiple selection (select as many as applicable)', 'Mehrfachauswahl (wählen Sie so viele wie zutreffend aus)', 8),
(3705, 'Open list of sub-codes (drop-down menu)', 'Öffne Liste mit Unterkategorien (Drop-Down Menü)', 8),
(3706, 'Close list of sub-codes (drop-down menu)', 'Schließe Liste mit Unterkategorien (Drop-Down Menü)', 8),
(3707, 'Instruction to Operator', 'Instruktion für den Anwender', 8),
(3708, 'Recorded Variable’s Name', 'Name der dokumentierten Variable', 8),
(3709, 'Codes of Recorded variable', 'Werte der dokumentierten Variable', 8),
(3710, 'Note to Operator for the recording', 'Hinweis für den Anwender für die Dokumentation', 8),
(3711, 'Note to Operator for system’s operations', 'Hinweis für den Anwender für Systemoperationen', 8),
(3712, 'Automated process (filters etc.)', 'Automatisierte Prozesse (Filter etc.)', 8),
(3713, 'ALREADY EXISTING ID (can appear in CHILD’S ID AND in INCIDENT ID)', 'BEREITS EXISTIERENDE ID (kann bei ID DES KINDES UND ID DES EREIGNISSES auftreten)', 8),
(3714, 'Skip', 'Weiter', 8),
(3715, 'Start Page', 'Startseite', 8),
(3716, 'Operator\'s Panel', '', 8),
(3717, 'my account', '', 8),
(3718, 'Contact Details', '', 8),
(3719, 'Change Password', '', 8),
(3720, 'my previous cases', '', 8),
(3721, 'List of incidents', '', 8),
(3722, 'List of Children’s ID', '', 8),
(3723, 'my current cases', '', 8),
(3724, 'List of temporary Child\'s ID', '', 8),
(3725, 'Information ', '', 8),
(3726, 'New Incident', '', 8),
(3727, 'My Profile', '', 8),
(3728, 'Change Pass', '', 8),
(3729, 'List of Child\'s ID', '', 8),
(3730, 'Log out!', 'Abmelden!', 8),
(3731, 'Welcome', 'Willkommen', 8),
(3732, 'New ', '', 8),
(3733, 'Record Progress', 'Fortschritt', 8),
(3734, 'Agency\'s ID', 'ID der Einrichtung', 8),
(3735, 'Operator\'s ID', 'ID des Anwenders', 8),
(3736, 'Child\'s ID', 'ID des Kindes', 8),
(3737, 'Date of Record', 'Datum der Dokumentation', 8),
(3738, 'Incident\'s ID', 'ID des Ereignisses', 8),
(3739, 'Date of Incident', 'Datum des Ereignisses', 8),
(3740, 'Source of Information', 'Informationsquelle', 8),
(3741, 'Forms of Maltreatment', 'Formen von Misshandlung', 8),
(3742, 'Place of Incident', 'Ort des Ereignisses', 8),
(3743, 'Child\'s Sex', 'Geschlecht des Kindes', 8),
(3744, 'Child\'s DoB', 'Geburtsdatum Kind', 8),
(3745, 'Child\'s Citizenship Status', 'Status der Staatsangehörigkeit Kind', 8),
(3746, 'Family Composition', 'Zusammensetzung der Familie zum Zeitpunkt des Ereignisses', 8),
(3747, 'CGs Relationship to Child', 'Beziehung der Betreuungsperson zum Zeitpunkt des Ereignisses zum Kind', 8),
(3748, 'Caregiver(s)\' Sex', 'Geschlecht der Betreuungsperson', 8),
(3749, 'Caregiver(s)\' DoB', 'Geburtsdatum der Betreuungsperson', 8),
(3750, 'Institutional Response', 'Institutionelle Reaktion', 8),
(3751, 'Referral(s) to Services', 'Empfehlungen von /Überweisungen an Maßnahmen', 8),
(3752, 'Agencys\'s ID', 'ID der Einrichtung', 8),
(3753, 'Identity Confirmation', 'Identitätsprüfung', 8),
(3754, 'TIP', 'TIPP', 8),
(3755, 'If the above information needs update, please contact the CAN-MDS Administration Office.', 'Falls oben stehende Information ein Update benötigen, kontaktieren Sie bitte den Administrator', 8),
(3756, 'Date & Type of Incident', '', 8),
(3757, 'Incident ID', 'ID des Ereignisses', 8),
(3758, 'Type Of Record', '', 8),
(3759, 'Type Of Incident', '', 8),
(3760, 'Notifications', '', 8),
(3761, 'Subject', '', 8),
(3762, 'Message', '', 8),
(3763, 'Replace ID', '', 8),
(3764, 'WELCOME TO CAN-MDS', 'WILLKOMMEN IN CAN-MDS', 8),
(3765, 'To proceed with the record, please follow the CAN-MDS Operations’ Protocol.', 'bitte folgen Sie dem CAN-MDS Anwedungsprotokoll, um mit dem Eintrrag fortzufahren', 8),
(3766, 'If you need more information, please use the CAN-MDS Guide for Operators.', 'Falls sie mehr Informationen benötigen, nutzen Sie bitte das CAN-MDS Handbuch für Anwender', 8),
(3767, 'Continue with the record', 'Weiter', 8),
(3768, 'Please, insert Child’s ID provided to you by the Administrator', 'Bitte tragen Sie die ID des Kindes (vom Administrator erteilt) ein', 8),
(3769, 'NOT KNOW CHILD\'S ID', '', 8),
(3770, 'The Child’s ID you provided is referred to an', 'Die von Ihnen eingegebene ID des Kindes gehört zu:', 8),
(3771, 'UNKNOWN CHILD', 'KIND UNBEKANNT', 8),
(3772, 'NEW CHILD RECORD', 'NEUER EINTRAG KIND', 8),
(3773, 'NEW INCIDENT RECORD', 'NEUER EINTRAG EINES EREIGNISSES', 8),
(3774, 'You are going to proceed with the record of a new case of (alleged) child maltreatment.', 'Sie fahren mit dem Eintrag eines neuen Falls von (mutmaßlicher) Kindesmisshandlung fort', 8),
(3775, 'Please proceed with recording of', 'Bitte fahren Sie mit dem Eintrag fort', 8),
(3776, '-incident related variables', 'Variablen bezogen auf das Ereignis', 8),
(3777, '-child related variables', 'Variablen bezogen auf das Kind', 8),
(3778, '-family related variables', 'Variablen bezogen auf die Familie', 8),
(3779, '-services related variables', 'Variablen bezogen auf Maßnahmen', 8),
(3780, 'Please record the referred Date of Incident', 'Bitte dokumentieren Sie das Datum des Ereignisses', 8),
(3781, 'Unknown', 'unbekannt', 8),
(3782, 'A \"distinct\" event took place – Not continuous maltreatment', '', 8),
(3783, 'YYYY', 'JJJJ', 8),
(3784, 'MM', 'MM', 8),
(3785, 'DD', 'TT', 8),
(3786, 'Continuous maltreatment – including \"distinct event(s)\"', '', 8),
(3787, 'start date', 'Anfangsdatum', 8),
(3788, 'duration', 'Dauer', 8),
(3789, 'Years', 'Jahre', 8),
(3790, 'Months', 'Monate', 8),
(3791, 'Days', 'Tage', 8),
(3792, 'During the last 12 months', 'Während der letzten 12 Monate', 8),
(3793, 'Before the last 12 months', 'Vor den letzten 12 Monaten', 8),
(3794, 'Lifelong', 'lebenslang', 8),
(3795, 'Last known CM incident date', 'letztes bekanntes Datum des Ereignisses', 8),
(3796, 'Continuous maltreatment - No \"distinct event\" took place', '', 8),
(3797, 'GO -> R4', 'Gehe zu -> R4', 8),
(3798, 'Click to open sub-list', 'Klicken Sie zum Öffnen der Unterkategorien', 8),
(3799, 'Complete as precisely as possible YYYY-MM-DD', 'vervollständigen Sie so präzise, wie möglich JJJJ-MM-TT', 8),
(3800, 'Neglect/other abuse taking place over a longer period', 'Vernachlässigung/andere Misshandlung über eine längere Periode', 8),
(3801, 'Check ONE in the sub-list', 'Wählen Sie EINE Option der Unterkategorie aus', 8),
(3802, 'Click to close sub-list', 'Klick zum Schließen der Unterkategorie', 8),
(3803, 'approximately', 'zirka', 8),
(3804, 'or less', 'oder weniger', 8),
(3805, 'Wrong date', 'Falsches Datum', 8),
(3806, 'year', 'Jahr', 8),
(3807, 'month', 'Monat', 8),
(3808, 'day', 'Tag', 8),
(3809, 'One day', 'ein Tag', 8),
(3810, 'Please record the Source of Information', 'Bitte dokumentieren Sie die Informationsquelle', 8),
(3811, 'Unspecified', 'nicht näher spezifiziert', 8),
(3812, 'Identified (via routine screening)', 'Identifiziert (über Routinescreening)', 8),
(3813, 'Child (alleged) victim', '(mutmaßlich)betroffenes Kind', 8);
INSERT INTO `u_translate` (`id`, `text_en`, `text_trans`, `language_id`) VALUES
(3814, 'Parent /foster parent/ parent’s partner/ care provider', 'Eltern/Pflegeeltern/Partner des einen Elternteils/ Betreuungsperson', 8),
(3815, 'Relative (siblings, grandparents, etc.) living with the child', 'Verwandte (Geschwister, Großeltern, usw.), die mit dem Kind zusammenleben', 8),
(3816, 'Relative (siblings, grandparents, etc.) not living with the child', 'Verwandte (Geschwister, Großeltern, usw.), die nicht mit dem Kind zusammenleben', 8),
(3817, 'Friend / Neighbor', 'Freund/ Nachbar', 8),
(3818, 'Self-reported as (alleged) perpetrator', 'Selbstbericht des (mutmaßlichen) Verursachers', 8),
(3819, 'School /preschool /kindergarten personnel', 'Schul-/ Vorschul-/ Kindergartenpersonal', 8),
(3820, 'Leisure activity staff (e.g., scout leader, clergy, sport coach)', 'Personal aus Freizeitaktivitäten (z.B. Pfadfinderführer, Geistlicher, Sport-Coach)', 8),
(3821, 'Anonymous reporter', 'Anonymer Berichterstatter', 8),
(3822, 'Personnel working in Child day care services', 'Personal aus Kindertagesstätten', 8),
(3823, 'Personnel working in Social Services/ Public–Central/Local', 'Personal aus Jugendhilfe und dem Sozialwesen/öffentlich-zentral/lokal', 8),
(3824, 'Personnel working in Health services', 'Personal aus medizinischen Einrichtungen', 8),
(3825, 'Personnel working in Mental Health Services', 'Personal aus Einrichtungen für psychische Gesundheit', 8),
(3826, 'Personnel working in Ordinary/Juvenile Court and related services', 'Personal aus dem (Jugend)gericht und damit verbundenen Einrichtungen', 8),
(3827, 'Personnel working in Police /low enforcement', 'Personal der Polizei/Gesetzesvollzug', 8),
(3828, 'Personnel working in Helpline', 'Personal von Hilfetelefonen', 8),
(3829, 'Personnel working in Community agency including agencies working against DV', 'Personal aus Beratungseinrichtungen inkl. Für den Bereich häusliche Gewalt', 8),
(3830, 'Personnel working in Ombudsman', 'Bürgerbeauftragte', 8),
(3831, 'Personnel working in NGOs/associations', 'Personal aus NGOs/Vereinen', 8),
(3832, 'Personnel working in services for people with disabilities', 'Personal aus Einrichtungen für Personen mit Behinderungen', 8),
(3833, 'Other', 'Andere', 8),
(3834, 'GO -> I3', 'Gehe zu -> I3', 8),
(3835, 'Check ONE from the list', 'Wählen Sie EINE Option aus der Liste', 8),
(3836, 'Please record the Form(s) of Maltreatment', 'Bitte dokumentieren Sie die Form(en) von Misshandlung', 8),
(3837, 'Form(s) of Maltreatment', 'Form(en) von Misshandlung', 8),
(3838, 'Expand/Collapse list', 'Ausklappen/Einklappen der Liste', 8),
(3839, 'Check as many as applicable. By selecting from child menu, broad categories are auto-selected.', 'Wählen Sie so viele, wie zutreffend. Auswahl aus Untermenü, übergeordnete Kategorien werden automatisch ausgewählt.', 8),
(3840, 'Please provide as detailed as possible information (by using sub-menus).', 'Bitte dokumentieren die Informationen so detailliert, wie möglich (nutzen Sie Untermenüs)', 8),
(3841, 'Acts Committed', 'Taten', 8),
(3842, 'Violent acts against self /Self-harm actions', 'Gegen sich selbst gerichtete Gewalt/ Selbstschädigende Handlungen', 8),
(3843, 'Eating disorder', 'Essstörung', 8),
(3844, 'Substance use/ abuse', 'Substanzkonsum/-missbrauch', 8),
(3845, 'Runaway', 'Ausreißer', 8),
(3846, 'Self-inflicted injuries', 'Nicht-suizidales Selbstverletzendes Verhalten', 8),
(3847, 'Suicidal thoughts', 'suizidale Gedanken', 8),
(3848, 'Suicide attempt', 'Suizidversuch(e)', 8),
(3849, 'Actual suicide', 'Suizid', 8),
(3850, 'Other self-harm action (unspecified)', 'andere selbstverletzende Handlung (unspezifische Informationen)', 8),
(3851, 'Physical violence acts committed [with or without injury]', 'Körperliche Gewalt [mit oder ohne Verletzung]', 8),
(3852, 'Physical violent acts/ corporal punishment/ “disciplines”', 'körperliche Gewalt/ körperliche Bestrafung/ Disziplinierung', 8),
(3853, 'Slapping', 'Schlagen', 8),
(3854, 'Smacking', 'festeres Schlagen', 8),
(3855, 'Spanking', 'Hintern verhauen', 8),
(3856, 'Pinching', 'Kneifen', 8),
(3857, 'Twisting ear(s)', 'Verdrehen der Ohren', 8),
(3858, 'Pulling hair', 'an den Haaren ziehen', 8),
(3859, 'Hitting with an object', 'mit einem Gegenstand schlagen', 8),
(3860, 'Beating', 'Verprügeln', 8),
(3861, 'Tying up or tying to something /restraining to cloth sacks', 'Anbinden oder Festbinden /in Stoffsäcke stecken', 8),
(3862, 'Locking up', 'Einsperren', 8),
(3863, 'Leaving child to lie in their own excrement', 'Das Kind in seinen Exkrementen liegen lassen', 8),
(3864, 'Pushing', 'Schubsen', 8),
(3865, 'Throwing', 'Werfen', 8),
(3866, 'Shaking', 'Schütteln', 8),
(3867, 'Grabbing', 'Packen', 8),
(3868, 'Choking', 'Würgen', 8),
(3869, 'Squeezing neck', 'Im Genick packen', 8),
(3870, 'Kicking', 'Treten', 8),
(3871, 'Hitting on head (with hand or against the wall)', 'Schlagen des Kopfes (mit der Hand, gegen die Wand)', 8),
(3872, 'Boxing ear', 'aufs Ohr schlagen/Ohrfeige', 8),
(3873, 'Scratching', 'Kratzen', 8),
(3874, 'Biting', 'Beißen', 8),
(3875, 'Burning', 'Verbrennen', 8),
(3876, 'Scalding', 'Verbrühen', 8),
(3877, 'Violent acts known also as harmful practices', 'Gewalt, bekannt als schädlich', 8),
(3878, 'Hitting on the soles of the feet', 'auf die Fußsohlen schlagen', 8),
(3879, 'Forcing to ingest spicy food', 'Zwingen scharfe Nahrung zu sich zu nehmen', 8),
(3880, 'Forced feeding', 'zwangsweise Nahrungszuführung', 8),
(3881, 'Forcing children to stay in uncomfortable positions', 'Zwang in unbequemen Positionen zu verharren', 8),
(3882, 'Binding', 'Fesseln', 8),
(3883, 'Inflicting scars/ scarring', 'Narben zufügen', 8),
(3884, 'Teeth extraction as punishment', 'Entfernen der Zähne als Bestrafung', 8),
(3885, 'Branding', 'Brandmarken', 8),
(3886, 'Fattening', 'Mästen', 8),
(3887, '“Retribution” acts of violence', 'Gewalttätige Vergeltungsakte', 8),
(3888, 'Virginity testing (inspecting girls’ genitalia)', 'Jungfräulichkeitstests (Kontrolle der Genitalien von Mädchen)', 8),
(3889, 'Forced circumcision', 'Zwangsbeschneidung', 8),
(3890, 'Female genital mutilation', 'Verstümmelung weiblicher Genitalien', 8),
(3891, 'Uvulectomy', 'Uvulektomie', 8),
(3892, 'Forced marriage and early marriage', 'Zwangsheirat und frühes Verheiraten', 8),
(3893, 'Violent and degrading initiation rites / “hazing”', 'Gewaltsame und erniedrigende Initiationsriten/ “schikanieren”', 8),
(3894, 'Practices as “exorcism” after accusations of “witchcraft”', '“Exorzismus” nach Anschuldigung von “Hexerei”', 8),
(3895, 'Forced sterilization, particularly girls', 'Zwangssterilisation', 8),
(3896, 'Violence in the guise of treatment', 'Gewalt unter Deckmantel von Behandlung', 8),
(3897, 'Deliberate infliction of disabilities for exploiting/begging', 'Vorsätzliche Zufügung von Behinderungen für Ausbeutung', 8),
(3898, 'Acts of life threatening maltreatment', 'lebensbedrohliche Misshandlung (mit Intention)', 8),
(3899, 'Administering unnecessary invasive medical procedures', 'Durchführung unnötiger invasiver medizinischer Prozeduren', 8),
(3900, 'Administering non prescribed substances', 'Gabe nicht-verschriebener Substanzen', 8),
(3901, 'Child has been given poison', '(absichtliches) Vergiften', 8),
(3902, 'Threatening with a knife (also psychological abuse)', 'Bedrohen mit einem Messer (auch psychische Misshandlung)', 8),
(3903, 'Threatening with a gun (also psychological abuse)', 'Bedrohen mit einer Waffe (auch psychische Misshandlung)', 8),
(3904, 'Stabbing', 'Niederstechen', 8),
(3905, 'Shooting', 'Er- oder anschießen', 8),
(3906, 'Dowry-related violence/death (also harmful practice)', 'Mit Mitgift in Verbindung stehende Gewalt/Tod (ebenfalls eine schädliche Praktik))', 8),
(3907, '“Honour” crimes (also harmful practice)', '\"Ehren-\" Verbrechen (auch schädliche Praktiken)', 8),
(3908, 'Abduction-related acts', 'Taten verbunden mit Entführung', 8),
(3909, 'Non-family abduction', 'Entführung innerhalb der Familie', 8),
(3910, 'Family abduction', 'Entführung innerhalb des Familie', 8),
(3911, 'Institutional and system violations of child rights', 'Institutionelle, systemische Verstöße gegen das Recht des Kindes', 8),
(3912, 'Caning', 'mit einem Stock schlagen', 8),
(3913, 'Flogging', 'Auspeitschen', 8),
(3914, 'Stoning', 'Steinigen', 8),
(3915, 'Torture (all forms)', 'Folter', 8),
(3916, 'Amputations', 'Amputationen', 8),
(3917, 'Imposing of death sentence for crimes committed', 'Verhängen der Todesstrafe für begangene Straftaten', 8),
(3918, 'Other described physical acts', 'andere beschriebene körperliche Taten', 8),
(3919, 'No specific information for reported/suspected physical violence', 'unspezifische Information über berichtete/mutmaßliche körperliche Gewalt', 8),
(3920, 'Sexual violence acts committed [with or without injury]', 'sexuelle Gewalt (mit oder ohne Verletzung)', 8),
(3921, 'Sexual violence acts', 'sexuelle Gewalt', 8),
(3922, 'Acts involving penetration (intrusion)', 'Taten mit Penetration', 8),
(3923, 'Without force', 'gewaltfrei', 8),
(3924, 'anus', 'Anus', 8),
(3925, 'vulva', 'Vulva', 8),
(3926, 'mouth', 'Mund', 8),
(3927, 'Involving use of force', 'mit Gewaltanwendung', 8),
(3928, 'Attempted sexual abuse (not involving penetration)', 'Versuchter sexueller Missbrauch (ohne Penetration)', 8),
(3929, 'with physical contact', 'Mit Körperkontakt', 8),
(3930, 'without physical contact', 'Ohne Körperkontakt', 8),
(3931, 'Threatened sexual abuse', 'Angedrohter sexueller Missbrauch', 8),
(3932, 'Touching/fondling genitals', 'Berühren/”Befummeln” der Genitalien', 8),
(3933, 'Showing genitals to child', 'Genitalien dem Kind zeigen', 8),
(3934, 'Sexual harassment', 'Sexuelle Belästigung', 8),
(3935, 'Voyeurism /spying on the children intimate behaviours', 'Voyeurismus /intimes Verhalten des Kindes ausspionieren child intimate behaviour', 8),
(3936, 'Providing sexually explicit materials', 'Zeigen von sexuell eindeutigem Material', 8),
(3937, 'Forced exposure to pornography', 'Gezwungenes Aussetzen von Pornographie', 8),
(3938, 'Forcing to witness sexual violence against mother', 'Zeuge sexueller Gewalt gegen Mutter werden', 8),
(3939, 'Sexual “luring” (via ICT)', 'Sexuelles “Ködern” (über Informations-Kommunikatinstechnologie (IKT))', 8),
(3940, 'Online sexual stalking /harassment', 'sexuelles Stalking online / sexuelle Belästigung online', 8),
(3941, 'Other Sexual violence acts', 'Andere sexuelle Gewalt', 8),
(3942, 'Sexual exploitation acts', 'Sexuelle Ausbeutung', 8),
(3943, 'Child prostitution', 'Kinderprostitution', 8),
(3944, 'Use of children in commercial sexual exploitation', 'kommerzielle sexuelle Ausbeutung von Kindern', 8),
(3945, 'Sexual exploitation in travel and tourism', 'Sexuelle Ausbeutung bei Reisen und im Tourismus', 8),
(3946, 'Sexual slavery', 'Sexuelle Sklaverei', 8),
(3947, 'Sale of children for sexual purposes', 'Verkauf eines Kindes für sexuelle Zwecke', 8),
(3948, 'Trafficking (within and between countries)', 'Trafficking (innerhalb und zwischen Ländern)', 8),
(3949, 'Involvement in pornography', 'Involvierung in Pornographie', 8),
(3950, 'Other sexual exploitation acts (unspecified)', 'Andere sexuelle Ausbeutung (unspezifiziert)', 8),
(3951, 'No specific information for reported/suspected sexual violence', 'Keine spezifische Information über berichtete/vermutete sexuelle Gewalt', 8),
(3952, 'Psychological violence acts committed [with or without injury]', 'Psychische Gewalt (Taten) [mit oder ohne Verletzung]', 8),
(3953, 'Violent acts with or without obvious consequences', 'Gewalt mit oder ohne offensichtliche Konsequenzen', 8),
(3954, 'Bullying/ Psychological bullying and hazing', 'Bullying/ Psychisches Bullying und Schikanieren', 8),
(3955, 'by other children', 'Durch andere Kinder', 8),
(3956, 'by adults', 'Durch andere Erwachsene', 8),
(3957, 'Homophobic bullying /related to sexual orientation', 'Homophobes Bullying /bezogen auf sexuelle Orientierung', 8),
(3958, 'Cyber bullying (via ICTs / mobile phones /Internet)', 'Cyber Bullying (über IKT / Mobiltelefone /Internet)', 8),
(3959, 'Ignoring and favoritism', 'Ignorieren und Bevorzugung', 8),
(3960, 'Denying emotional responsiveness', 'Versagen emotionaler Ansprechbarkeit', 8),
(3961, 'Over protection', 'Überbehütung', 8),
(3962, 'Isolation (social)', 'Isolation (sozial)', 8),
(3963, 'Close confinement (tying/binding)', 'In strengem Gewahrsam halten (Anbinden –auch physische Akte)', 8),
(3964, 'Placement in solitary confinement', 'Einzelhaft', 8),
(3965, 'Degrading /inhuman conditions of detention', 'Erniedrigung /unmenschliche Umstände von Haft/Arrest', 8),
(3966, 'Humiliation /Insults, name-calling, belittling, ridiculing', 'Demütigung/Beleidigung, Herabsetzen, Lächerlichmachen, Namen rufen,', 8),
(3967, 'Humiliation via ICT', 'Demütigung über IKT', 8),
(3968, 'Rejection and Spurning', 'Zurückweisen und Verschmähen', 8),
(3969, 'Verbal assaults', 'verbale Angriffe', 8),
(3970, 'Terrorization / Scaring', 'Terrorisieren / Ängstigen', 8),
(3971, 'Threats of sexual violence (with or without contact)', 'Androhen sexueller Gewalt (mit oder ohne Kontakt)', 8),
(3972, 'Threats of other maltreatment', 'Androhen anderer Misshandlung', 8),
(3973, 'Other related acts hurting child’s feelings', 'andere Taten, die die Gefühle des Kindes verletzen', 8),
(3974, 'Exploitation related psychological violent acts', 'psychische Gewalt verbunden mit Ausbeutung', 8),
(3975, 'Exploiting and corrupting', 'Ausbeutung und Korruption', 8),
(3976, 'Labour/economic exploitation', 'Ausbeutung der Arbeitskraft/ökonomische Ausbeutung', 8),
(3977, 'Forcing to undertake adult\'s responsibilities/parent’s role', 'Zwang Verantwortlichkeiten des Erwachsenen zu übernehmen', 8),
(3978, 'Forcing to begging', 'Kind zum Betteln zwingen', 8),
(3979, 'Forcing to participate in religious ritual', 'Zwang an religiösem Ritual teilzunehmen', 8),
(3980, 'Forcing to participate in a violent political event', 'Zwang an einem gewalttätigen politischen Akt teilzunehmen', 8),
(3981, 'No specific info for reported/suspected exploitation acts', 'unspezifische Informationen über berichtete/gemutmaßte Ausbeutung', 8),
(3982, 'Exposure related psychological violent acts', 'psychische Gewalt verbunden mit Aussetzen', 8),
(3983, 'Exposure to any kind of violence in the family / DV', 'Aussetzen jeglicher Gewalt in der Familie / häusliche Gewalt', 8),
(3984, 'Exposure to violence against other children', 'Aussetzen von Gewalt gegen andere Kinder', 8),
(3985, 'Exposure to intimate partner violence', 'Aussetzen von Gewalt in der Partnerschaft', 8),
(3986, 'Exposure to violence against other adults', 'Aussetzen von Gewalt gegen andere Erwachsene', 8),
(3987, 'Exposition to the homicide of a significant person', 'Aussetzen gegenüber Mord einer signifikanten Person', 8),
(3988, 'Exposure to a violent environment outside the family', 'gewaltätigem Umfeld außerhalb der Familie aussetzen', 8),
(3989, 'Exposure to violence via electronic means', 'Gewalt über elektronische Medien aussetzen', 8),
(3990, 'information and communication technologies', 'Informations- und Kommunikationstechnologie', 8),
(3991, 'in the mass media', 'In den Massenmedien', 8),
(3992, 'No specific info for reported/suspected related exposure', 'unspezifische Information über berichtetes/mutmaßliches Aussetzen', 8),
(3993, 'No specific info for reported/suspected psych/l abuse violent acts', 'unspezifische Information über berichtete/mutmaßliche psych. Gewalt', 8),
(3994, 'Omissions', 'Unterlassungen', 8),
(3995, 'Omissions in child’s care / Neglect', 'Unterlassungen in der Fürsorge für Kindes/Vernachlässigung', 8),
(3996, 'Emotional neglect related omissions', 'emotionale Vernachlässigung', 8),
(3997, 'Persistent ignoring of the child’s emotional needs/ Chronic inattention to the child', 'anhaltendes Ignorieren der emotionalen Bedürfnisse des Kindes/ chronische Nichtbeachtung des Kindes', 8),
(3998, 'Psychologically “unavailable” caregivers', 'psychisch \"nicht erreichbare\" Betreuungsperson', 8),
(3999, 'Inappropriately advanced expectations (def.  According to child’s characteristics)', 'unangemessen hohe Erwartungen (gemessen an den Charakteristiken des Kindes)', 8),
(4000, 'No specific information for omissions related to emotional neglect', 'unspezifische Informationen über Unterlassungen in Verbindung mit emotionaler Vernachlässigung', 8),
(4001, 'Physical neglect related omissions', 'körperliche Vernachlässigung', 8),
(4002, 'Inadequate / inappropriate nutrition', 'Inadäquate / unangemessene Ernährung', 8),
(4003, 'Inadequate / inappropriate personal hygiene', 'Inadäquate / unangemessene Körperhygiene', 8),
(4004, 'Inadequate / inappropriate clothing', 'Inadäquate / unangemessene Kleidung', 8),
(4005, 'Inadequate / inappropriate shelter', 'Inadäquate / unangemessene Unterkunft', 8),
(4006, 'No specific information for omissions related child’s physical needs', 'unspezifische Informationen über Unterlassungen in Verbindung mit den körperlichen Bedürfnissen des Kindes', 8),
(4007, 'Medical neglect related omissions', 'medizinische Vernachlässigung', 8),
(4008, 'Refusal to provide preventive health care (vaccinations, vision, and dental care)', 'Weigerung Vorsorgemaßnahmen zu treffen (Impfungen, Untersuchungen, Zahnpflege)', 8),
(4009, 'Refusal to allow /provide needed medical care for diagnosed health condition/ impairment', 'Verweigerung medizinscher Betreuung bei Diagnose eines beeinträchtigten Gesundheitszustandes', 8),
(4010, 'Unjustified delay to seek needed care', 'ungerechtfertigte Verzögerung benötigte Hilfe zu suchen', 8),
(4011, 'Failure to provide with basic medical care', 'keine Bereitstellung grundlegender medizinischer Versorgung', 8),
(4012, 'Withholding essential medical care', 'Vorenthaltung essentieller medizinischer Versorgung', 8),
(4013, 'No specific information for omissions related child’s medical needs', 'unspezifische Informationen über Unterlassungen in Verbindung mit den medizinischen Bedürfnissen des Kindes', 8),
(4014, 'Educational neglect related omissions', 'erzieherische Vernachlässigung', 8),
(4015, 'Persistent failure to register child at the school', 'ständiges Versäumen der Anmeldung des Kindes in der Schule', 8),
(4016, 'Has not attended school at all', 'Hat noch nie die Schule besucht (definiert gemäß dem Alter des Kindes)', 8),
(4017, 'Dropped out', 'Schulabbruch', 8),
(4018, 'Persistent failure to enrol at the school resulting to irregular school attendance', 'ständiges Versäumen der Anmeldung des Kindes in der Schule und unregelmäßiger Schulbesuch', 8),
(4019, 'compulsory school', 'allgemein schulpflichtig', 8),
(4020, 'non compulsory (ECEC)', 'nicht schulpflichtig (ECEC)', 8),
(4021, 'Chronic truancy', 'Chronisches Schwänzen', 8),
(4022, 'Refusal to attend special educational needs', 'Verweigerung an spezifischen erzieherischen Maßnahmen teilzunehmen', 8),
(4023, 'Refusal to allow needed attention to special educational needs', 'Weigerung spezifischen erzieherischen Bedürfnissen nötige Beachtung zu schenken', 8),
(4024, 'Refusal to provide needed attention to special educational needs', 'Weigerung spezifischen erzieherischen Bedürfnissen nachzukommen', 8),
(4025, 'No specific information for omissions related child’s educational needs', 'unspezifische Informationen zu Unterlassungen in Verbindung mit den erzieherischen Bedürfnissen des Kindes', 8),
(4026, 'Risk exposure related omissions', 'Aussetzung von Risiken in Verbindung mit Unterlassungen', 8),
(4027, 'Exposure to hazardous/ dangerous environments', 'Aussetzung von riskanten/gefährlichen Umgebungen', 8),
(4028, 'Inside household', 'innerhalb des Haushaltes', 8),
(4029, 'Outside home', 'Außerhalb des Zuhauses', 8),
(4030, 'Exposure to substances use/misuse by others', 'Aussetzung von Substanzkonsum/-missbrauch anderer', 8),
(4031, 'Alcohol', 'Alkohol', 8),
(4032, 'Drugs', 'Drogen', 8),
(4033, 'Other substances', 'andere Substanzen', 8),
(4034, 'No specific information for reported/ suspected omissions for exposure to risks', 'unspezifische Informationen zu berichteten/mutmaßlichen Unterlassungen bezüglich der Ausseztung von Risiken', 8),
(4035, 'Supervision related omissions', 'Unterlassungen in Verbindung mit der Aufsichtspflicht', 8),
(4036, 'Inadequate/ lack of supervision resulting in physical harm', 'Inadäquate/ fehlende Aufsicht resultiert in körperliche Schäden', 8),
(4037, 'Persisted lack of supervision concerning substance use/misuse by the child', 'ständiges Fehlen von Aufsicht bezogen auf Substanzkonsum-missbrauch des Kindes', 8),
(4038, 'No specific information for omissions related to the child’s supervision', 'unspezifische Informationen zu Unterlassungen bezüglich der Aufsichtspflicht', 8),
(4039, 'Refusal of custody/abandonment', 'Verzicht/Verweigerung des Sorgerechts', 8),
(4040, 'Unstable custody arrangements', 'instabile Sorgerechtsregelungen', 8),
(4041, 'Illegal transfers of custody', 'illegale Übertragung des Sorgerechts', 8),
(4042, 'Refusal of custody', 'Verweigerung des Sorgerechts', 8),
(4043, 'Abandonment (primary caregiver(s) runaway / migrate and leave the children behind)', 'Zurücklassen (Verschwinden des (der) Hauptsorgeberechtigten/ Weglaufen und Zurücklassen des Kindes)', 8),
(4044, 'children out of wedlock', 'uneheliches Kind', 8),
(4045, 'children with disabilities', 'Kind mit Behinderungen', 8),
(4046, 'No specific information for omissions related child’s refusal of custody', 'unspezifische Informationen zu Unterlassungen bezüglich der Verweigerung des Sorgerechts eines Kindes', 8),
(4047, 'Please record the Place of Incident', 'Bitte dokumentieren Sie den Ort des Ereignisses', 8),
(4048, 'Unknown/ Unspecified place', 'Nicht bekannt/ nicht näher spezifizierter Ort', 8),
(4049, 'Home/ Family', 'Zuhause/Familie', 8),
(4050, 'Home/ Relatives', 'Zuhause/Verwandte', 8),
(4051, 'Home/ Friends', 'Zuhause/Freunde', 8),
(4052, 'Child care institution (residential care)', 'Stationäre Jugendhilfeeinrichtung (stationäre Unterbringung)', 8),
(4053, 'Child care institution (day care)', 'Betreungseinrichtung (Tagesstätte)', 8),
(4054, 'Detention or correctional institution', 'Haftanstalt oder Erziehungsanstalt', 8),
(4055, 'Leisure/ Playground/ Recreational area', 'Freizeitbereich/ Spielplatz/ Erholungsgebiet', 8),
(4056, 'Sports-athletics', 'Sport', 8),
(4057, 'School', 'Schule', 8),
(4058, 'Educational institution', 'Bildungseinrichtung', 8),
(4059, 'Medical Services', 'Medizinische Einrichtung', 8),
(4060, 'Public transportation', 'Öffentliche Verkehrsmittel', 8),
(4061, 'Public place/ street, commercial & surrounding area', 'Öffentlicher Ort/Straße, Einkaufs- und Wohnviertel', 8),
(4062, 'Other place', 'Anderer Ort', 8),
(4063, 'GO -> C2', 'Gehe zu -> C2', 8),
(4064, 'Click as many as applicable', 'Klicken Sie so viele wie zutreffend an', 8),
(4065, 'Please record Child’s Sex, Date of Birth and Citizenship Status', 'Bitte dokumentieren Sie Geschlecht, Geburtsdatum und Status der Staatsangehörigkeit des Kindes', 8),
(4066, 'Male', 'Männlich', 8),
(4067, 'Female', 'Weiblich', 8),
(4068, 'Not known', 'unbekannt', 8),
(4069, 'Check ONE from the list below', 'Wählen Sie EINE Option aus der Liste', 8),
(4070, 'Child’s Date of Birth', 'Geburtsdatum des Kindes', 8),
(4071, '<18 years old (if no year is known)', '< 18 Jahre alt (wenn das Jahr nicht bekannt ist)', 8),
(4072, '<18 years old', '< 18 Jahre alt', 8),
(4073, '>18 (\"minor\" according to legislation)', '', 8),
(4074, '>18 years old', '> 18 Jahre alt', 8),
(4075, 'Unborn', 'Ungeboren', 8),
(4076, 'Please record the full date of birth:', 'Bitte tragen Sie das Geburtsdatum ein:', 8),
(4077, 'YYYY-MM-DD', 'JJJJ-MM-TT', 8),
(4078, 'If DD is unknown:', 'Falls TT nicht bekannt ist:', 8),
(4079, 'YYYY-MM', 'JJJ-MM', 8),
(4080, 'If MM-DD are unknown:', 'Falls MM-TT nicht bekannt sind:', 8),
(4081, 'If YYYY-MM-DD are unknown AND the alleged victim is a child:', 'Falls JJJJ-MM-TT unbekannt sind UND der/die mutmaßlich Betroffene ein Kind ist', 8),
(4082, '<18', '< 18', 8),
(4083, 'Citizenship Status', 'Status der Staatsangehörigkeit', 8),
(4084, 'Not a citizen', 'kein Staatsangehöriger', 8),
(4085, 'Citizen', 'Staatsangehöriger', 8),
(4086, 'with ID', 'mit Pass', 8),
(4087, 'Citizen with ID', 'Staatsangehöriger mit Pass', 8),
(4088, 'without ID', 'ohne Pass', 8),
(4089, 'Citizen without ID', 'Staatsangehöriger ohne Pass', 8),
(4090, 'Unaccompanied foreign child or refugee', '', 8),
(4091, 'Check ONE from the list below. If the child is “Citizen”, please define in sub-list', 'Wählen Sie EINE Option. Wenn das Kind \"Staatsangehöriger\" ist, definieren Sie bitte in der Unterkategorie.', 8),
(4092, 'Please record Family Composition and indicate up to two Primary Caregivers', 'Bitte dokumentieren Sie die Familienzusammensetzung zum Zeitpunkt des Ereignisses und geben Sie bis zu 2 Betreuungspersonen an', 8),
(4093, 'A: Type of Family', 'A: Art der Familie', 8),
(4094, 'Boarder(s) (child lives in residential/institutional care)', 'Unterbringung(en) (Kind ist stationär/institutionell untergebracht)', 8),
(4095, 'Child lives with his/her family (including biological/ adoptive)', 'Kind lebte in seiner Familie (inkl. biologische/adoptiv Familie)', 8),
(4096, 'Child lives in a foster family', 'Kind lebte in einer Pflegefamilie', 8),
(4097, 'Child lives in a re-composed family', 'Kind lebte in einer neu zusammengesetzten Familie', 8),
(4098, 'Child lives in a family other than its family/ foster family', 'Kind lebte in einer Familie, die nicht seine eigene oder eine Pflegefamilie ist', 8),
(4099, 'Relatives’ family', 'Familie von Verwandten', 8),
(4100, 'Child lives in a family other than its family/ foster family - Relatives’ family', 'Kind lebte in einer Familie, die nicht seine eigene oder eine Pflegefamilie ist - Familie von Verwandten', 8),
(4101, 'Friends’ family', 'Familie von Freunden', 8),
(4102, 'Child lives in a family other than its family/ foster family - Friends’ family', 'Kind lebte in einer Familie, die nicht seine eigene oder eine Pflegefamilie ist - Familie von Freunden', 8),
(4103, 'SKIP “B”; GO -> F3', 'Überspringe \"B\" ; Gehe zu -> F3', 8),
(4104, 'If you DON\'T chose Boarder(s) -> B: Members of Family', 'wenn Sie NICHT \"Unterbringung\" wählen -> B: Familienmitglieder', 8),
(4105, 'B: Member(s) of Family', 'B: Familienmitglieder zum Zeitpunkt des Ereignisses', 8),
(4106, 'Number', 'Anzahl', 8),
(4107, 'Primary caregiver(s)', 'Betreuungsperson', 8),
(4108, 'Parent(s)', 'Eltern', 8),
(4109, 'Step Parent(s)', 'Stiefeltern', 8),
(4110, 'Parent(s)’ partner(s)', 'Partner(in) des Elternteils', 8),
(4111, 'Sibling(s)', 'Geschwister', 8),
(4112, 'Younger than the (alleged) victim', 'jünger als der/die (mutmaßlich) Betroffene', 8),
(4113, 'Older than the (alleged) victim (<18)', 'älter als der/die (mutmaßlich) Betroffene (<18)', 8),
(4114, 'Older than the (alleged) victim (>18)', 'älter als der/die (mutmaßlich) Betroffene (>18)', 8),
(4115, 'Grandparent(s)', 'Großeltern', 8),
(4116, 'Other relative(s)', 'Andere Verwandte', 8),
(4117, 'Blood relatives', 'Blutsverwandte', 8),
(4118, '<18 [child(ren)]', '< 18 [Kind(er)]', 8),
(4119, '>18 [adult(s)]', '>18 [Erwachsene]', 8),
(4120, 'By law relatives', 'angeheiratete Verwandte', 8),
(4121, 'Family friend(s)', 'Freunde der Familie', 8),
(4122, 'Other not-related household members', 'Andere nicht verwandte Mitglieder des Haushaltes', 8),
(4123, 'Please indicate up to 2 child’s primary caregiver(s) (you can uncheck)', 'Bitte geben Sie bis zu 2 Betreuungspersonen des Kindes an (Sie können die Auswahl aufheben)', 8),
(4124, 'members', 'Mitlglieder', 8),
(4125, 'member family', 'Familienmitglieder zum Zeitpunkt des Ereignisses', 8),
(4126, 'Please record Caregiver(s) Relationship to Child, Sex and Date of Birth', 'Bitte dokumentieren Sie Geburtsdatum, Geschlecht der Betreuungsperson sowie Beziehung der Betreuungsperson zum Kind', 8),
(4127, 'Relationship to Child', 'Beziehung der Betreuungsperson zum Zeitpunkt des Ereignisses zum Kind', 8),
(4128, '1st Caregiver', '1. Betreuungsperson', 8),
(4129, 'Professional Caregiver', 'Professionelle Betreuungsperson', 8),
(4130, 'Temporary caregiver/Other', 'vorübergehende Betreuungsperson/Andere', 8),
(4131, 'Unknown relationship', 'unbekannte Beziehung', 8),
(4132, 'Check ONE per Caregiver', 'Wählen Sie EINE Option je Betreuungsperson', 8),
(4133, 'Caregiver(s) Sex', 'Geschlecht der Betreuungsperson', 8),
(4134, 'Caregiver(s) DoB', 'Geburtsdatum Betreuungsperson', 8),
(4135, 'YY', 'JJ', 8),
(4136, '\'s', '-er', 8),
(4137, 'YY-MM-DD', 'JJ-MM-TT', 8),
(4138, 'If YYYY-MM-DD are unknown then record the decade:', 'Falls JJJJ-MM-TT unbekannt sind, tragen Sie die Dekade ein:', 8),
(4139, 'If DECADE is unknown, then:', 'Falls die Dekade unbekannt ist, dann:', 8),
(4140, 'Please record any Institutional Response', 'Bitte dokumentieren Sie alle Maßnahmen der Einrichtung', 8),
(4141, 'No response was required DUE TO CHILD’S DEATH', 'Keine Maßnahmen AUFGRUND TOD DES KINDES', 8),
(4142, 'No Response', 'Keine Maßnahmen', 8),
(4143, 'Yes', 'Ja', 8),
(4144, 'Immediate intervention(s)', 'unmittelbare Intervention(en)', 8),
(4145, 'Physical Medical exam(s)', 'körperliche medizinische Untersuchung(en)', 8),
(4146, 'Mental Health exam(s)', 'Untersuchung(en) der psychischen Gesundheit', 8),
(4147, 'Forensic evaluation initiated', 'Einleitung einer rechtsmedizinischen Untersuchung', 8),
(4148, 'Child protection /welfare services assessment', 'Einschätzung der Kindeswohlgefährdung nach §8a SGB VIII', 8),
(4149, 'Police intervention', 'polizeiliche Intervention', 8),
(4150, 'Action taken -NO COURT INVOLVEMENT', 'Weitere Maßnahmen', 8),
(4151, 'Child remains in family with planned intervention', 'Verbleib des Kindes in der Familie mit Hilfeplan', 8),
(4152, 'Emergency placement', 'Inobhutnahme (nach §42 SGB VIII)', 8),
(4153, 'Supportive intervention for current caregiver(s)', 'Unterstützende Intervention für derzeitige Betreuungsperson(en)', 8),
(4154, 'Mother/child shelter with parent and child together', 'Frauenhaus oder Kinderschutzhaus (gemeinsame Unterbringung Eltern und Kind)', 8),
(4155, 'Police emergency protection procedures', 'Polizeieinsatz zur sofortigen Gefahrenabwehr (Gewaltschutz)', 8),
(4156, 'CPS/welfare services emergency protection procedures', 'Einschaltung des Jugendamts zur weiteren Hilfeplanung (Hilfen zur Erziehung)', 8),
(4157, 'Referral to child protection /welfare services', 'Empfehlung von Kinderschutz-/Jugendhilfemaßnahmen', 8),
(4158, 'Action taken -COURT or EQUIVALENT AUTHORITY TO THE COURT INVOLVEMENT', 'Ergreifung von Maßnahmen - MITEINBEZUG DES GERICHTS ODER ÄQUIVALENTEN BEHÖRDEN', 8),
(4159, '(Family) Court measures initiated', 'Einleitung von (Familien)gerichtlichen Maßnahmen', 8),
(4160, 'Action to protect victim by court order(s)', 'Maßnahmen zum Schutz des Betroffenen durch Gerichtsbeschluss', 8),
(4161, 'Action to remove parent(s)’ rights', 'Antrag/Meldung an das Familiengericht zur Einschränkung der elterliches Sorge', 8),
(4162, 'Expulsion of (alleged) abuser from home', 'Entfernung des Täters aus dem Haushalt durch Gerichtsbeschluss', 8),
(4163, 'Action to prosecute perpetrator(s)', 'Strafanzeige/ Einleitung eines Strafermittlungsverfahrens/ Strafverfolgung', 8),
(4164, 'Out of home placement', 'Unterbringung außerhalb der Familie', 8),
(4165, 'Kinship Care (relatives/extended family)', 'Fremdunterbringung in Verwandtenpflegestelle', 8),
(4166, 'Foster Care', 'Fremdunterbringung in Pflegefamilie', 8),
(4167, 'Children’s Home Institution', 'Fremdunterbringung in stationärer Jugendhilfeeinrichtung', 8),
(4168, 'Adoption with parents’ agreement', 'Adoption mit dem Einverständnis der Eltern', 8),
(4169, 'Adoption by court order', 'Adoption durch Gerichtsbeschluss', 8),
(4170, 'GO -> S2', 'Gehe zu -> S2', 8),
(4171, 'Check below as many as applicable', 'Wählen Sie so viele, wie zutreffend aus.', 8),
(4172, 'Please record any Referral(s) made to Services by you/your agency', 'Bitte dokumentieren Sie alle Empfehlungen und Überweisungen Ihrer Einrichtung', 8),
(4173, 'None', 'Keine', 8),
(4174, 'Judicial Services', 'rechtliche Maßnahmen', 8),
(4175, 'for child ONLY', 'NUR für Kind', 8),
(4176, 'for caregiver(s) ONLY', 'NUR für Sorgeberechtigte', 8),
(4177, 'for child AND family', 'für Kind UND Familie', 8),
(4178, 'Mental Health Services', 'Maßnahme psych. Gesunheit', 8),
(4179, 'Independent Authorities', 'unabhängige Behörden', 8),
(4180, 'Social Welfare Services', 'Jugendhilfemaßnahme', 8),
(4181, 'Law Enforcement related Services', 'Maßnahmen von Strafvollzugsbehörden', 8),
(4182, 'Community Organizations and NGOs', 'Gemeindeorganisationen und NGOs', 8),
(4183, 'Existing Registries and Research Organizations', 'existierende Register und Forschungseinrichtungen', 8),
(4184, 'Educational Services', 'Bildungsmaßnahmen', 8),
(4185, 'Other related Services', 'andere Maßnahmen', 8),
(4186, 'End of Record', 'Ende des Eintrags', 8),
(4187, 'CHECK RECORD OPTIONS', 'OPTIONEN DES EINTRAGS PRÜFEN', 8),
(4188, 'Please check the record options', 'Bitte prüfen Sie die Optionen des Eintrags', 8),
(4189, 'You can make any changes by navigating throught the right panel!', 'Sie können Änderungen vornehmen, indem Sie die rechte Leiste nutzen', 8),
(4190, 'Incident', 'Ereignis', 8),
(4191, 'ID', 'ID', 8),
(4192, 'Sex', 'Geschlecht', 8),
(4193, 'Date of birth', 'Geburtsdatum', 8),
(4194, 'Family and Caregiver(s)', 'Familie und Betreuungspersonen', 8),
(4195, 'Services', 'Maßnahmen', 8),
(4196, 'Submit Record', 'Eintrag absenden', 8),
(4197, 'Loading', 'Verbrühen', 8),
(4198, 'RECORD COMPLETED', 'EINTRAG VOLLSTÄNDIG', 8),
(4199, 'Display/print the record', 'Zeige/Drucke Eintrag', 8),
(4200, 'Report', 'Bericht', 8),
(4201, 'RECORD', 'DOKUMENTATION/EINTRAG', 8),
(4202, 'Agency', 'Einrichtung', 8),
(4203, 'Information provided by', 'Informationen von', 8),
(4204, 'Age at the date of incident', 'Alter zum Zeitpunkt des Eintrags', 8),
(4205, 'Age at the date of recording', 'Alter zum Zeitpunkt des Eintrags', 8),
(4206, 'Type of family', 'Art der Familie zum Zeitpunkt des Ereignisses', 8),
(4207, 'Family\'s member(s)', 'Familienmitglieder zum Zeitpunkt des Ereignisses', 8),
(4208, '1st', '1er', 8),
(4209, 'born', 'geboren', 8),
(4210, '2nd', '2er', 8),
(4211, 'Back', 'Zurück', 8),
(4212, 'KNOWN CHILD', 'BEKANNTES KIND', 8),
(4213, 'EXISTING CHILD RECORD', 'EXISTIERENDER EINTRAG', 8),
(4214, 'You are going to proceed with the record of a new CM incident for  the child', 'Sie fahren mit dem Eintrag eines neuen Misshandlungsereignisses für ein Kind fort', 8),
(4215, 'Please proceed with checking of', 'Bitte prüfen Sie', 8),
(4216, 'TIP: Update –if needed', 'TIPP: Update- falls notwendig', 8),
(4217, 'Known Incidents', 'Bekannte Ereignisse', 8),
(4218, 'The incident you are trying to record might already exist!', 'Das Ereignis, das Sie dokumentieren möchten, existiert möglicherweise bereits!', 8),
(4219, 'Please check the incident record(s) below', 'Bitte prüfen Sie die Einträge unten', 8),
(4220, 'for Child\'s ID:', 'für ID des Kindes', 8),
(4221, 'and Date of Incident:', 'und Datum des Ereignisses', 8),
(4222, 'Date-Time of Record', 'Datum-Uhrzeit des Eintrags', 8),
(4223, 'Display', 'Anzeige', 8),
(4224, 'Add new incident', 'neues Ereignis hinzufügen', 8),
(4225, 'ENTER Username', 'Introduïu el nom d\'usuària o usuari', 9),
(4226, 'ENTER Password', 'Introduïu la contrasenya', 9),
(4227, 'Log in', 'Inicieu la sessió', 9),
(4228, 'MEMO: Meaning of Symbols & Colors', 'NOTA: Significat dels símbols i colors', 9),
(4229, 'Auto-Completed variable', 'Variable autoemplenada', 9),
(4230, 'Variable already recorded by the Operator', 'Variable ja registrada per la persona operadora', 9),
(4231, 'Single selection (mutually exclusive codes)', 'Selecció única (codis mútuament excloents)', 9),
(4232, 'Multiple selection (select as many as applicable)', 'Selecció múltiple (marqueu totes les que correspongui)', 9),
(4233, 'Open list of sub-codes (drop-down menu)', 'Llista oberta de subcodis (menú desplegable)', 9),
(4234, 'Close list of sub-codes (drop-down menu)', 'Llista tancada de subcodis (menú desplegable)', 9),
(4235, 'Instruction to Operator', 'Instruccions per a la persona operadora', 9),
(4236, 'Recorded Variable’s Name', 'Nom de la variable registrada', 9),
(4237, 'Codes of Recorded variable', 'Codis de la variable registrada', 9),
(4238, 'Note to Operator for the recording', 'Nota per a la persona operadora per al registre', 9),
(4239, 'Note to Operator for system’s operations', 'Nota per a la persona operadora relativa a les operacions de l\'aplicatiu', 9),
(4240, 'Automated process (filters etc.)', 'Procés automatitzat (filtres, etc.)', 9),
(4241, 'ALREADY EXISTING ID (can appear in CHILD’S ID AND in INCIDENT ID)', 'ID JA EXISTENT (pot aparèixer l\'ID DE LA NENA, EL NEN O L\'ADOLESCENT i a l\'ID DE L\'INCIDENT)', 9),
(4242, 'Skip', 'Saltar', 9),
(4243, 'Start Page', 'Pàgina principal', 9),
(4244, 'Operator\'s Panel', 'Tauler de control', 9),
(4245, 'my account', 'El meu compte', 9),
(4246, 'Contact Details', 'Dades de contacte', 9),
(4247, 'Change Password', 'Canviar contrasenya', 9),
(4248, 'my previous cases', 'Els meus casos anteriors', 9),
(4249, 'List of incidents', 'Llistat d\'Incidents', 9),
(4250, 'List of Children’s ID', 'Llistat de ID\'s dels Infants', 9),
(4251, 'my current cases', 'Els meus casos actuals', 9),
(4252, 'List of temporary Child\'s ID', 'Llistat de ID\'s temporals', 9),
(4253, 'Information ', 'Informació', 9),
(4254, 'New Incident', 'Nou cas', 9),
(4255, 'My Profile', '', 9),
(4256, 'Change Pass', 'Canviar contrasenya', 9),
(4257, 'List of Child\'s ID', 'Llistat d\'ID\'s de les nenes, els nens i adolescents', 9),
(4258, 'Log out!', 'Sortiu', 9),
(4259, 'Welcome', 'Benvinguda, benvingut', 9),
(4260, 'New ', 'Nou', 9),
(4261, 'Record Progress', 'Progrés del registre', 9),
(4262, 'Agency\'s ID', 'ID agència', 9),
(4263, 'Operator\'s ID', 'ID persona operadora', 9),
(4264, 'Child\'s ID', 'ID nena, nen o adolescent', 9),
(4265, 'Date of Record', 'Data de registre', 9),
(4266, 'Incident\'s ID', 'ID incident', 9),
(4267, 'Date of Incident', 'Data incident', 9),
(4268, 'Source of Information', 'Font d\'informació', 9),
(4269, 'Forms of Maltreatment', 'Forma o formes de maltractament', 9),
(4270, 'Place of Incident', 'Lloc incident', 9),
(4271, 'Child\'s Sex', 'Sexe nena, nen o adolescent', 9),
(4272, 'Child\'s DoB', 'Data naixement nena, nen o adolescent', 9),
(4273, 'Child\'s Citizenship Status', 'Situació administrativa nena, nen o adolescent', 9),
(4274, 'Family Composition', 'Composició família', 9),
(4275, 'CGs Relationship to Child', 'Relació persona cuidadora amb nena, nen o adolescent ', 9),
(4276, 'Caregiver(s)\' Sex', 'Sexe persones cuidadores principals', 9),
(4277, 'Caregiver(s)\' DoB', 'Data naixement persones cuidadores principals', 9),
(4278, 'Institutional Response', 'Resposta institucional', 9),
(4279, 'Referral(s) to Services', 'Derivació o derivacions a serveis', 9),
(4280, 'Agencys\'s ID', 'ID de l\'agència', 9),
(4281, 'Identity Confirmation', 'Confirmació de la identitat', 9),
(4282, 'TIP', 'SUGGERIMENT', 9),
(4283, 'If the above information needs update, please contact the CAN-MDS Administration Office.', 'Si trobeu que aquesta informació ha de ser actualitzada, poseu-vos en contacte amb l\'Oficina d\'Administració de CAN-MDS.', 9),
(4284, 'Date & Type of Incident', 'Data i Tipus d\'incident', 9),
(4285, 'Incident ID', 'ID de l\'incident', 9),
(4286, 'Type Of Record', 'Tipus de Registre', 9),
(4287, 'Type Of Incident', '', 9),
(4288, 'Notifications', 'Notificacions', 9),
(4289, 'Subject', 'Assumpte', 9),
(4290, 'Message', 'Missatge', 9),
(4291, 'Replace ID', 'Substituir ID', 9),
(4292, 'WELCOME TO CAN-MDS', 'BENVINGUDA, BENVINGUT A CAN-MDS', 9),
(4293, 'To proceed with the record, please follow the CAN-MDS Operations’ Protocol.', 'Per fer el registre, seguiu el Protocol per a persones operadores de CAN-MDS.', 9),
(4294, 'If you need more information, please use the CAN-MDS Guide for Operators.', 'Si necessiteu més informació, consulteu el Manual per a persones operadores de CAN-MDS.', 9),
(4295, 'Continue with the record', 'Continueu amb el registre', 9),
(4296, 'Please, insert Child’s ID provided to you by the Administrator', 'Si us plau, inseriu l\'ID de la nena, el nen o l\'adolescent que us ha proporcionat la persona administradora', 9),
(4297, 'NOT KNOW CHILD\'S ID', 'ID temporal', 9),
(4298, 'The Child’s ID you provided is referred to an', 'La identificació (ID) de la nena, el nen o l\'adolescent que heu indicat fa referència a', 9),
(4299, 'UNKNOWN CHILD', 'NENA, NEN O ADOLESCENT NO EXISTENT A L\'APLICATIU', 9),
(4300, 'NEW CHILD RECORD', 'NOU REGISTRE DE NENA, NEN O ADOLESCENT', 9),
(4301, 'NEW INCIDENT RECORD', 'REGISTRE D\'UN NOU INCIDENT', 9),
(4302, 'You are going to proceed with the record of a new case of (alleged) child maltreatment.', 'Esteu a punt de registrar un nou cas de maltractament infantil o presumpte maltractament infantil', 9),
(4303, 'Please proceed with recording of', 'Si us plau, registreu', 9),
(4304, '-incident related variables', 'les variables relatives a l\'incident', 9),
(4305, '-child related variables', 'les variables relatives a la nena, el nen o l\'adolescent', 9),
(4306, '-family related variables', 'les variables relatives a la família', 9),
(4307, '-services related variables', 'les variables relatives als serveis', 9),
(4308, 'Please record the referred Date of Incident', 'Si us plau, registreu la data de l\'incident al que us referiu', 9),
(4309, 'Unknown', 'No es coneix', 9),
(4310, 'A \"distinct\" event took place – Not continuous maltreatment', 'Va tenir lloc un “incident aïllat” – maltractament no continuat', 9),
(4311, 'YYYY', 'AAAA', 9),
(4312, 'MM', 'MM', 9),
(4313, 'DD', 'DD', 9),
(4314, 'Continuous maltreatment – including \"distinct event(s)\"', 'Maltractament continuat – inclou “incident o incidents aïllats”', 9),
(4315, 'start date', 'data d\'inici', 9),
(4316, 'duration', 'durada', 9),
(4317, 'Years', 'anys', 9),
(4318, 'Months', 'mesos', 9),
(4319, 'Days', 'dies', 9),
(4320, 'During the last 12 months', 'Durant els últims 12 mesos', 9),
(4321, 'Before the last 12 months', 'Abans dels últims 12 mesos', 9),
(4322, 'Lifelong', 'Continuat', 9),
(4323, 'Last known CM incident date', 'Data de l\'últim incident de maltractament conegut', 9),
(4324, 'Continuous maltreatment - No \"distinct event\" took place', 'Maltractament continuat – no va tenir lloc cap “incident aïllat”', 9),
(4325, 'GO -> R4', 'ANAR -> R4', 9),
(4326, 'Click to open sub-list', 'Feu clic per obrir subllista', 9),
(4327, 'Complete as precisely as possible YYYY-MM-DD', 'Empleneu DD-MM-AAAA de la manera més precisa possible', 9),
(4328, 'Neglect/other abuse taking place over a longer period', 'Maltractament esdevingut en un període de temps més llarg', 9),
(4329, 'Check ONE in the sub-list', 'Marqueu UNA opció de la subllista', 9),
(4330, 'Click to close sub-list', 'Feu clic per tancar subllista', 9),
(4331, 'approximately', 'aproximadament', 9),
(4332, 'or less', 'o menys', 9),
(4333, 'Wrong date', 'Data errònia', 9),
(4334, 'year', 'any', 9),
(4335, 'month', 'mes', 9),
(4336, 'day', 'dia', 9),
(4337, 'One day', 'Un dia', 9),
(4338, 'Please record the Source of Information', 'Si us plau, registreu la font d\'informació', 9),
(4339, 'Unspecified', 'Sense especificar', 9),
(4340, 'Identified (via routine screening)', 'Detecció mitjançant una avaluació rutinària', 9),
(4341, 'Child (alleged) victim', 'Nena, nen o adolescent víctima o presumpta víctima ', 9),
(4342, 'Parent /foster parent/ parent’s partner/ care provider', 'Persona progenitora, progenitora adoptiva, parella de la persona progenitora, cuidadora principal', 9),
(4343, 'Relative (siblings, grandparents, etc.) living with the child', 'Familiar (germanes i/o germans, àvies i/o avis, etc.) que conviu amb la nena, el nen o l\'adolescent', 9),
(4344, 'Relative (siblings, grandparents, etc.) not living with the child', 'Familiar (germanes i/o germans, àvies i/o avis, etc.) que no conviu amb la nena, el nen o l\'adolescent', 9),
(4345, 'Friend / Neighbor', 'Amiga o amic, veïna o veí', 9),
(4346, 'Self-reported as (alleged) perpetrator', 'Persona autodeclarada (presumpta) culpable', 9),
(4347, 'School /preschool /kindergarten personnel', 'Personal que treballa en una escola o una escola bressol', 9),
(4348, 'Leisure activity staff (e.g., scout leader, clergy, sport coach)', 'Personal d\'activitats de lleure (p. ex. monitores i monitors, entrenadores i entrenadors d\'esports)', 9),
(4349, 'Anonymous reporter', 'Font anònima', 9),
(4350, 'Personnel working in Child day care services', 'Personal de serveis d\'acollida de dia', 9),
(4351, 'Personnel working in Social Services/ Public–Central/Local', 'Personal de serveis socials públics centrals o locals', 9),
(4352, 'Personnel working in Health services', 'Personal de serveis mèdics', 9),
(4353, 'Personnel working in Mental Health Services', 'Personal de serveis de salut mental', 9),
(4354, 'Personnel working in Ordinary/Juvenile Court and related services', 'Personal de tribunals ordinaris de la infància i serveis relacionats', 9),
(4355, 'Personnel working in Police /low enforcement', 'Personal de la policia o de les forces de l’ordre', 9),
(4356, 'Personnel working in Helpline', 'Personal de línies d’atenció telefònica especialitzada', 9),
(4357, 'Personnel working in Community agency including agencies working against DV', 'Personal d’agències comunitàries (incloses les que treballen contra la violència masclista)', 9),
(4358, 'Personnel working in Ombudsman', 'Personal de l’agència de defensa de la infància ', 9),
(4359, 'Personnel working in NGOs/associations', 'Personal d’ONG i associacions diverses ', 9),
(4360, 'Personnel working in services for people with disabilities', 'Personal de serveis d’atenció a persones amb discapacitat', 9),
(4361, 'Other', 'Altres', 9),
(4362, 'GO -> I3', 'ANAR -> I3', 9),
(4363, 'Check ONE from the list', 'Marqueu UNA opció de la llista', 9),
(4364, 'Please record the Form(s) of Maltreatment', 'Si us plau, indiqueu la forma o formes de maltractament', 9),
(4365, 'Form(s) of Maltreatment', 'Forma o formes maltractament ', 9),
(4366, 'Expand/Collapse list', 'Ampliar/reduir la llista', 9),
(4367, 'Check as many as applicable. By selecting from child menu, broad categories are auto-selected.', 'Marqueu totes les opcions que siguin pertinents. Seleccionant a partir del següent menú, les categories generals són seleccionades automàticament', 9),
(4368, 'Please provide as detailed as possible information (by using sub-menus).', 'Si us plau, faciliteu tanta informació com sigui possible (utilitzeu els submenús)', 9),
(4369, 'Acts Committed', 'Actes comesos', 9),
(4370, 'Violent acts against self /Self-harm actions', 'Actes violents autoinflingits/autolesions', 9),
(4371, 'Eating disorder', 'Trastorn de la conducta alimentària', 9),
(4372, 'Substance use/ abuse', 'Ús/abús de substàncies', 9),
(4373, 'Runaway', 'Fuga', 9),
(4374, 'Self-inflicted injuries', 'Autolesions', 9),
(4375, 'Suicidal thoughts', 'Pensaments suïcides', 9),
(4376, 'Suicide attempt', 'Intent de suïcidi', 9),
(4377, 'Actual suicide', 'Suïcidi efectiu', 9),
(4378, 'Other self-harm action (unspecified)', 'Altres accions d\'autolesió (no especificades)', 9),
(4379, 'Physical violence acts committed [with or without injury]', 'Actes de violència física [amb lesió o sense]', 9),
(4380, 'Physical violent acts/ corporal punishment/ “disciplines”', 'Actes de violència física/càstig corporal/\"disciplines\"', 9),
(4381, 'Slapping', 'Bufetejar', 9),
(4382, 'Smacking', 'Pegar', 9),
(4383, 'Spanking', 'Colpejar les natges', 9),
(4384, 'Pinching', 'Pessigar', 9),
(4385, 'Twisting ear(s)', 'Doblegar les orelles', 9),
(4386, 'Pulling hair', 'Estirar els cabells', 9),
(4387, 'Hitting with an object', 'Donar cops amb un objecte', 9),
(4388, 'Beating', 'Donar una pallissa', 9),
(4389, 'Tying up or tying to something /restraining to cloth sacks', 'Lligar o lligar a alguna cosa/immobilitzar amb una camisa de forces', 9),
(4390, 'Locking up', 'Tancar amb clau', 9),
(4391, 'Leaving child to lie in their own excrement', 'Deixar la nena, el nen o l\'adolescent sobre els seus propis excrements', 9),
(4392, 'Pushing', 'Donar empentes', 9),
(4393, 'Throwing', 'Sacsejar', 9),
(4394, 'Shaking', 'Agitar', 9),
(4395, 'Grabbing', 'Agafar', 9),
(4396, 'Choking', 'Asfixiar', 9),
(4397, 'Squeezing neck', 'Estrènyer el coll', 9),
(4398, 'Kicking', 'Donar puntades de peu', 9),
(4399, 'Hitting on head (with hand or against the wall)', 'Colpejar el cap (amb les mans o contra la paret)', 9),
(4400, 'Boxing ear', 'Estirar les orelles', 9),
(4401, 'Scratching', 'Esgarrapar', 9),
(4402, 'Biting', 'Mossegar', 9),
(4403, 'Burning', 'Cremar', 9),
(4404, 'Scalding', 'Escaldar', 9),
(4405, 'Violent acts known also as harmful practices', 'Actes violents entesos també com a pràctiques danyoses', 9),
(4406, 'Hitting on the soles of the feet', 'Colpejar les plantes dels peus', 9),
(4407, 'Forcing to ingest spicy food', 'Obligar a ingerir aliments picants', 9),
(4408, 'Forced feeding', 'Obligar a menjar', 9),
(4409, 'Forcing children to stay in uncomfortable positions', 'Obligar a adoptar posicions incòmodes', 9),
(4410, 'Binding', 'Embenar', 9),
(4411, 'Inflicting scars/ scarring', 'Deixar cicatrius', 9),
(4412, 'Teeth extraction as punishment', 'Treure peces dentals com a càstig', 9),
(4413, 'Branding', 'Marcar', 9),
(4414, 'Fattening', 'Encebar', 9),
(4415, '“Retribution” acts of violence', 'Actes de violència “com a càstig”', 9),
(4416, 'Virginity testing (inspecting girls’ genitalia)', 'Comprovar la virginitat (inspeccionar els genitals de les nenes)', 9),
(4417, 'Forced circumcision', 'Circumcisió obligatòria', 9),
(4418, 'Female genital mutilation', 'Mutilació genital femenina', 9),
(4419, 'Uvulectomy', 'Uvulectomía', 9),
(4420, 'Forced marriage and early marriage', 'Matrimoni forçós i matrimoni precoç (pràctica danyosa)', 9),
(4421, 'Violent and degrading initiation rites / “hazing”', 'Ritus d\'iniciació violents i degradants/“novatades\"', 9),
(4422, 'Practices as “exorcism” after accusations of “witchcraft”', 'Pràctiques com l\'“exorcisme” arran d\'acusacions de “bruixeria”', 9),
(4423, 'Forced sterilization, particularly girls', 'Esterilització forçada, sobretot en nenes', 9),
(4424, 'Violence in the guise of treatment', 'Violència disfressada de tractament', 9),
(4425, 'Deliberate infliction of disabilities for exploiting/begging', 'Provocació deliberada d\'invalidesa per explotar/fer pidolar ', 9),
(4426, 'Acts of life threatening maltreatment', 'Casos de maltractament en què es posa en perill la vida', 9),
(4427, 'Administering unnecessary invasive medical procedures', 'Aplicar procediments mèdics invasius que siguin innecessaris', 9),
(4428, 'Administering non prescribed substances', 'Administrar substàncies medicamentoses perilloses', 9),
(4429, 'Child has been given poison', 'Enverinar (intencionadament)', 9),
(4430, 'Threatening with a knife (also psychological abuse)', 'Amenaçar amb un ganivet ', 9);
INSERT INTO `u_translate` (`id`, `text_en`, `text_trans`, `language_id`) VALUES
(4431, 'Threatening with a gun (also psychological abuse)', 'Amenaçar amb una pistola ', 9),
(4432, 'Stabbing', 'Apunyalar', 9),
(4433, 'Shooting', 'Disparar', 9),
(4434, 'Dowry-related violence/death (also harmful practice)', 'Violència/mort relacionada amb la dot (també pràctica danyosa)', 9),
(4435, '“Honour” crimes (also harmful practice)', '“Delictes d\'honor” (també pràctica danyosa)', 9),
(4436, 'Abduction-related acts', 'Fets relacionats amb segrest', 9),
(4437, 'Non-family abduction', 'Segrest no familiar', 9),
(4438, 'Family abduction', 'Segrest familiar', 9),
(4439, 'Institutional and system violations of child rights', 'Violacions dels drets de la nena, el nen o l\'adolescent per part de les institucions i del sistema', 9),
(4440, 'Caning', 'Fustigar', 9),
(4441, 'Flogging', 'Assotar', 9),
(4442, 'Stoning', 'Apedregar', 9),
(4443, 'Torture (all forms)', 'Tortura (totes les formes)', 9),
(4444, 'Amputations', 'Amputacions', 9),
(4445, 'Imposing of death sentence for crimes committed', 'Imposar la pena de mort per delictes comesos', 9),
(4446, 'Other described physical acts', 'Altres actes de violència física', 9),
(4447, 'No specific information for reported/suspected physical violence', 'Sense informació específica sobre violència física ', 9),
(4448, 'Sexual violence acts committed [with or without injury]', 'Actes de violència sexual comesos [amb lesió o sense]', 9),
(4449, 'Sexual violence acts', 'Actes de violència sexual', 9),
(4450, 'Acts involving penetration (intrusion)', 'Actes amb penetració ', 9),
(4451, 'Without force', 'Sense ús de la força', 9),
(4452, 'anus', 'anus', 9),
(4453, 'vulva', 'vulva', 9),
(4454, 'mouth', 'boca', 9),
(4455, 'Involving use of force', 'Amb ús de la força', 9),
(4456, 'Attempted sexual abuse (not involving penetration)', 'Intent d\'abús sexual (sense penetració)', 9),
(4457, 'with physical contact', 'amb contacte físic', 9),
(4458, 'without physical contact', 'sense contacte físic', 9),
(4459, 'Threatened sexual abuse', 'Amenaça d\'abús sexual', 9),
(4460, 'Touching/fondling genitals', 'Tocar/acariciar els genitals', 9),
(4461, 'Showing genitals to child', 'Mostrar els genitals a la nena, el nen o l\'adolescent', 9),
(4462, 'Sexual harassment', 'Assetjament sexual', 9),
(4463, 'Voyeurism /spying on the children intimate behaviours', 'Voyeurisme/espionatge del comportament íntim de la nena, el nen o l\'adolescent', 9),
(4464, 'Providing sexually explicit materials', 'Facilitar materials sexualment explícits', 9),
(4465, 'Forced exposure to pornography', 'Exposició forçada a material pornogràfic', 9),
(4466, 'Forcing to witness sexual violence against mother', 'Obligar a presenciar violència sexual contra la mare', 9),
(4467, 'Sexual “luring” (via ICT)', '\"Esquer\" sexual via TIC', 9),
(4468, 'Online sexual stalking /harassment', 'Assetjament sexual per internet (sexpreading)', 9),
(4469, 'Other Sexual violence acts', 'Altres actes de violència sexual', 9),
(4470, 'Sexual exploitation acts', 'Actes d\'explotació sexual', 9),
(4471, 'Child prostitution', 'Prostitució infantil', 9),
(4472, 'Use of children in commercial sexual exploitation', 'Utilitzar la nena, el nen o l\'adolescent per explotació sexual comercial', 9),
(4473, 'Sexual exploitation in travel and tourism', 'Explotació sexual en viatges i turisme', 9),
(4474, 'Sexual slavery', 'Esclavatge sexual', 9),
(4475, 'Sale of children for sexual purposes', 'Venda de nenes, nens i adolescents amb fins sexuals', 9),
(4476, 'Trafficking (within and between countries)', 'Tràfic sexual (dins i entre països)', 9),
(4477, 'Involvement in pornography', 'Implicació en pornografia ', 9),
(4478, 'Other sexual exploitation acts (unspecified)', 'Altres actes d\'explotació sexual (sense especificar)', 9),
(4479, 'No specific information for reported/suspected sexual violence', 'Sense informació específica sobre violència sexual ', 9),
(4480, 'Psychological violence acts committed [with or without injury]', 'Actes de violència psicològica comesos [amb o sense lesió]', 9),
(4481, 'Violent acts with or without obvious consequences', 'Actes de violència amb o sense conseqüències òbvies', 9),
(4482, 'Bullying/ Psychological bullying and hazing', 'Assetjament escolar/assetjament escolar psicològic i novatades', 9),
(4483, 'by other children', 'per part d\'altres nenes, nens o adolescents', 9),
(4484, 'by adults', 'per part de persones adultes', 9),
(4485, 'Homophobic bullying /related to sexual orientation', 'Assetjament LGTBI fòbic/relacionat amb l\'orientació sexual', 9),
(4486, 'Cyber bullying (via ICTs / mobile phones /Internet)', 'Ciberassetjament (via TIC/telèfons mòbils/internet)', 9),
(4487, 'Ignoring and favoritism', 'Exclusió i favoritismes', 9),
(4488, 'Denying emotional responsiveness', 'Rebutjar l\'afectivitat emocional', 9),
(4489, 'Over protection', 'Sobreprotecció', 9),
(4490, 'Isolation (social)', 'Aïllament (social)', 9),
(4491, 'Close confinement (tying/binding)', 'Confinament (lligar/embenar)', 9),
(4492, 'Placement in solitary confinement', 'Sotmetiment a una situació d\'aïllament', 9),
(4493, 'Degrading /inhuman conditions of detention', 'Condicions degradants/inhumanes de detenció', 9),
(4494, 'Humiliation /Insults, name-calling, belittling, ridiculing', 'Humiliar/Insultar, posar malnoms, menysprear, ridiculitzar', 9),
(4495, 'Humiliation via ICT', 'Humiliació a través de les TIC', 9),
(4496, 'Rejection and Spurning', 'Rebuig i refús', 9),
(4497, 'Verbal assaults', 'Agressions verbals', 9),
(4498, 'Terrorization / Scaring', 'Aterrir/espantar', 9),
(4499, 'Threats of sexual violence (with or without contact)', 'Amenaçar amb violència sexual (amb contacte o sense)', 9),
(4500, 'Threats of other maltreatment', 'Amenaçar amb altres formes de maltractament', 9),
(4501, 'Other related acts hurting child’s feelings', 'Altres actes relacionats en què es fereixin els sentiments de la nena, el nen o l\'adolescent', 9),
(4502, 'Exploitation related psychological violent acts', 'Actes de violència psicològica relacionats amb l\'explotació', 9),
(4503, 'Exploiting and corrupting', 'Explotar i corrompre', 9),
(4504, 'Labour/economic exploitation', 'Explotació laboral/econòmica', 9),
(4505, 'Forcing to undertake adult\'s responsibilities/parent’s role', 'Obligar a assumir responsabilitats de persona adulta', 9),
(4506, 'Forcing to begging', 'Obligar a pidolar', 9),
(4507, 'Forcing to participate in religious ritual', 'Obligar a participar en rituals religiosos', 9),
(4508, 'Forcing to participate in a violent political event', 'Obligar a participar en un esdeviment polític violent', 9),
(4509, 'No specific info for reported/suspected exploitation acts', 'Sense informació específica sobre actes d\'explotació ', 9),
(4510, 'Exposure related psychological violent acts', 'Actes de violència psicològica relacionats amb l’exposició ', 9),
(4511, 'Exposure to any kind of violence in the family / DV', 'Exposició a algun tipus de violència en la família o a violència masclista', 9),
(4512, 'Exposure to violence against other children', 'Exposició a violència contra altres nenes, nens o adolescents', 9),
(4513, 'Exposure to intimate partner violence', 'Exposició a violència masclista en l\'àmbit de la parella o ex-parella', 9),
(4514, 'Exposure to violence against other adults', 'Exposició a violència contra altres persones adultes', 9),
(4515, 'Exposition to the homicide of a significant person', 'Exposició a l\'homicidi d\'una persona significativa', 9),
(4516, 'Exposure to a violent environment outside the family', 'Exposició a un entorn violent extern a la família', 9),
(4517, 'Exposure to violence via electronic means', 'Exposició a violència a través de mitjans electrònics', 9),
(4518, 'information and communication technologies', 'tecnologies de la informació i la comunicació', 9),
(4519, 'in the mass media', 'als mitjans de comunicació', 9),
(4520, 'No specific info for reported/suspected related exposure', 'Sense informació específica sobre l\'exposició ', 9),
(4521, 'No specific info for reported/suspected psych/l abuse violent acts', 'Sense informació específica sobre actes violents de maltractament psicològic ', 9),
(4522, 'Omissions', 'Omissions', 9),
(4523, 'Omissions in child’s care / Neglect', 'Omissions o negligència en l\'atenció a la nena, el nen o l\'adolescent', 9),
(4524, 'Emotional neglect related omissions', 'Omissions relacionades amb falta d\'atenció emocional', 9),
(4525, 'Persistent ignoring of the child’s emotional needs/ Chronic inattention to the child', 'Omissió continuada de les necessitats emocionals de la nena, el nen o l\'adolescent. Desatenció crònica ', 9),
(4526, 'Psychologically “unavailable” caregivers', 'Persones cuidadores “no disponibles” des d\'un punt de vista psicològic i afectiu', 9),
(4527, 'Inappropriately advanced expectations (def.  According to child’s characteristics)', 'Expectatives inadequades (definides en funció de les característiques de la nena, el nen o l\'adolescent)', 9),
(4528, 'No specific information for omissions related to emotional neglect', 'Sense informació específica sobre omissions relacionades amb negligència afectiva', 9),
(4529, 'Physical neglect related omissions', 'Omissions relacionades amb falta d\'atenció física', 9),
(4530, 'Inadequate / inappropriate nutrition', 'Alimentació inadequada/inapropiada', 9),
(4531, 'Inadequate / inappropriate personal hygiene', 'Higiene personal inadequada/inapropiada', 9),
(4532, 'Inadequate / inappropriate clothing', 'Roba inadequada/inapropiada', 9),
(4533, 'Inadequate / inappropriate shelter', 'Allotjament inadequat/inapropiat', 9),
(4534, 'No specific information for omissions related child’s physical needs', 'Sense informació específica sobre omissions relacionades amb les necessitats físiques', 9),
(4535, 'Medical neglect related omissions', 'Omissions relacionades amb falta d\'atenció mèdica', 9),
(4536, 'Refusal to provide preventive health care (vaccinations, vision, and dental care)', 'Negativa a facilitar atenció sanitària preventiva (p. ex. atenció oftalmològica i odontològica)', 9),
(4537, 'Refusal to allow /provide needed medical care for diagnosed health condition/ impairment', 'Negativa a permetre/facilitar assistència mèdica necessària per a un problema de salut o deficiència', 9),
(4538, 'Unjustified delay to seek needed care', 'Retard injustificat en la cerca d\'assistència mèdica', 9),
(4539, 'Failure to provide with basic medical care', 'Negligència a l\'hora de facilitar atenció mèdica bàsica', 9),
(4540, 'Withholding essential medical care', 'Negativa a proporcionar atenció mèdica bàsica', 9),
(4541, 'No specific information for omissions related child’s medical needs', 'Sense informació específica sobre omissions relacionades amb necessitats mèdiques', 9),
(4542, 'Educational neglect related omissions', 'Omissions relacionades amb negligències en matèria educativa', 9),
(4543, 'Persistent failure to register child at the school', 'Negligència continuada a l\'hora de matricular la nena, el nen o l\'adolescent en un centre escolar o oferir-li una alternativa educativa ', 9),
(4544, 'Has not attended school at all', 'No ha anat mai a escola ni ha rebut educació alternativa estable i positiva', 9),
(4545, 'Dropped out', 'Abandonament', 9),
(4546, 'Persistent failure to enrol at the school resulting to irregular school attendance', 'Negligència contínua a l\'hora de facilitar la participació de la nena, el nen o l\'adolescent  en un centre escolar que deriva en una assistència irregular', 9),
(4547, 'compulsory school', 'ensenyament obligatori', 9),
(4548, 'non compulsory (ECEC)', 'no obligatori', 9),
(4549, 'Chronic truancy', 'Absentisme crònic', 9),
(4550, 'Refusal to attend special educational needs', 'Negativa a atendre necessitats educatives especials', 9),
(4551, 'Refusal to allow needed attention to special educational needs', 'Negativa a permetre l\'atenció requerida en casos de necessitats educatives especials', 9),
(4552, 'Refusal to provide needed attention to special educational needs', 'Negativa a facilitar l\'atenció requerida en casos de necessitats educatives especials', 9),
(4553, 'No specific information for omissions related child’s educational needs', 'Sense informació específica sobre omissions relacionades amb les necessitats educatives ', 9),
(4554, 'Risk exposure related omissions', 'Omissions relacionades amb exposició a riscos', 9),
(4555, 'Exposure to hazardous/ dangerous environments', 'Exposició a entorns perillosos o nocius', 9),
(4556, 'Inside household', 'Dins de casa', 9),
(4557, 'Outside home', 'Fora de casa', 9),
(4558, 'Exposure to substances use/misuse by others', 'Exposició a l\'ús/abús de substàncies per part d\'altres persones', 9),
(4559, 'Alcohol', 'Alcohol', 9),
(4560, 'Drugs', 'Drogues', 9),
(4561, 'Other substances', 'Altres substàncies', 9),
(4562, 'No specific information for reported/ suspected omissions for exposure to risks', 'Sense informació específica sobre omissions davant d\'exposició a riscos', 9),
(4563, 'Supervision related omissions', 'Omissions relacionades amb la supervisió', 9),
(4564, 'Inadequate/ lack of supervision resulting in physical harm', 'Supervisió inadequada/inexistent que provoca lesions físiques', 9),
(4565, 'Persisted lack of supervision concerning substance use/misuse by the child', 'Absència repetida de supervisió en relació amb l\'ús/abús de substàncies per part de la nena, el nen o l\'adolescent', 9),
(4566, 'No specific information for omissions related to the child’s supervision', 'Sense informació específica sobre omissions relacionades amb la supervisió ', 9),
(4567, 'Refusal of custody/abandonment', 'Refús de la custòdia/abandonament', 9),
(4568, 'Unstable custody arrangements', 'Acords inestables sobre la custòdia de la nena, el nen o l\'adolescent', 9),
(4569, 'Illegal transfers of custody', 'Transferències de custòdia il·legals', 9),
(4570, 'Refusal of custody', 'Negació de la custòdia', 9),
(4571, 'Abandonment (primary caregiver(s) runaway / migrate and leave the children behind)', 'Abandonament (les persones cuidadores principals fugen o emigren i abandonen la nena, el nen o l\'adolescent)', 9),
(4572, 'children out of wedlock', 'nenes, nens o adolescents que van néixer d\'una parella anterior', 9),
(4573, 'children with disabilities', 'nenes, nens o adolescents amb discapacitats', 9),
(4574, 'No specific information for omissions related child’s refusal of custody', 'Sense informació específica sobre omissions relacionades amb el refús de la custòdia ', 9),
(4575, 'Please record the Place of Incident', 'Si us plau, registreu el lloc de l\'incident', 9),
(4576, 'Unknown/ Unspecified place', 'Lloc desconegut/no especificat', 9),
(4577, 'Home/ Family', 'Casa/Família', 9),
(4578, 'Home/ Relatives', 'Casa/Mare, pare o persona cuidadora principal', 9),
(4579, 'Home/ Friends', 'Casa/Amistats', 9),
(4580, 'Child care institution (residential care)', 'Institució d\'atenció a la infància o l\'adolescència (atenció residencial)', 9),
(4581, 'Child care institution (day care)', 'Institució d\'atenció a la infància o l\'adolescència (centre de dia)', 9),
(4582, 'Detention or correctional institution', 'Centre educatiu de reforma/centre de justícia juvenil', 9),
(4583, 'Leisure/ Playground/ Recreational area', 'Zona de lleure/Pati de jocs/Zona recreativa', 9),
(4584, 'Sports-athletics', 'Zona esportiva', 9),
(4585, 'School', 'Escola', 9),
(4586, 'Educational institution', 'Institució educativa', 9),
(4587, 'Medical Services', 'Serveis mèdics', 9),
(4588, 'Public transportation', 'Transport públic', 9),
(4589, 'Public place/ street, commercial & surrounding area', 'Lloc públic/carrer, zona comercial i voltants', 9),
(4590, 'Other place', 'Altres llocs', 9),
(4591, 'GO -> C2', 'ANAR -> C2', 9),
(4592, 'Click as many as applicable', 'Marqueu totes les que correspongui', 9),
(4593, 'Please record Child’s Sex, Date of Birth and Citizenship Status', 'Si us plau, registreu el sexe, la data de naixement i la situació administrativa nena, el nen o l\'adolescent', 9),
(4594, 'Male', 'Home', 9),
(4595, 'Female', 'Dona', 9),
(4596, 'Not known', 'No es coneix', 9),
(4597, 'Check ONE from the list below', 'Marqueu UNA opció de la llista', 9),
(4598, 'Child’s Date of Birth', 'Data de naixement de la nena, el nen o l\'adolescent', 9),
(4599, '<18 years old (if no year is known)', '<18 anys (si no en sabeu els anys)', 9),
(4600, '<18 years old', '<18 anys', 9),
(4601, '>18 (\"minor\" according to legislation)', '>18 (\"menor\" segons la legislació)', 9),
(4602, '>18 years old', '>18 anys', 9),
(4603, 'Unborn', 'Nonata, nonat', 9),
(4604, 'Please record the full date of birth:', 'Si us plau, registreu la data de naixement completa', 9),
(4605, 'YYYY-MM-DD', 'DD-MM-AAAA', 9),
(4606, 'If DD is unknown:', 'Si no sabeu DD:', 9),
(4607, 'YYYY-MM', 'MM-AAAA', 9),
(4608, 'If MM-DD are unknown:', 'Si no sabeu DD-MM:', 9),
(4609, 'If YYYY-MM-DD are unknown AND the alleged victim is a child:', 'Si no sabeu DD-MM-AAAA i la nena, nen o adolescent', 9),
(4610, '<18', '<18', 9),
(4611, 'Citizenship Status', 'Situació administrativa', 9),
(4612, 'Not a citizen', 'Situació administrativa irregular', 9),
(4613, 'Citizen', 'Situació administrativa regular', 9),
(4614, 'with ID', 'amb DNI, NIE o altre document identificatiu', 9),
(4615, 'Citizen with ID', 'Ciutadana o ciutadà amb DNI/NIE', 9),
(4616, 'without ID', 'sense DNI, NIE o altre document identificatiu', 9),
(4617, 'Citizen without ID', 'Ciutadana o ciutadà sense DNI/NIE', 9),
(4618, 'Unaccompanied foreign child or refugee', 'Nena, nen o adolescent estranger no acompanyat / Refugiada o refugiat', 9),
(4619, 'Check ONE from the list below. If the child is “Citizen”, please define in sub-list', 'Marqueu UNA opció de la llista. Si la nena, el nen o l\'adolescent es troba en situació administrativa regular, trieu una de les opcions disponibles a la subllista', 9),
(4620, 'Please record Family Composition and indicate up to two Primary Caregivers', 'Si us plau, registreu la composició de la família i indiqueu fins a dues persones cuidadores', 9),
(4621, 'A: Type of Family', 'A: Tipus de família', 9),
(4622, 'Boarder(s) (child lives in residential/institutional care)', 'Interna o intern: la nena, el nen o l\'adolescent viu en una institució d\'acollida', 9),
(4623, 'Child lives with his/her family (including biological/ adoptive)', 'La nena, el nen o l\'adolescent viu amb la seva família (biològica o adoptiva)', 9),
(4624, 'Child lives in a foster family', 'La nena, el nen o l\'adolescent viu en una família d\'acollida', 9),
(4625, 'Child lives in a re-composed family', 'La nena, el nen o l\'adolescent viu en una família recomposta', 9),
(4626, 'Child lives in a family other than its family/ foster family', 'La nena, el nen o l\'adolescent viu en una família diferent de la seva família directa o d\'acollida', 9),
(4627, 'Relatives’ family', 'Família de parents', 9),
(4628, 'Child lives in a family other than its family/ foster family - Relatives’ family', 'La nena, el nen o l\'adolescent viu en una família diferent de la seva família directa o d\'acollida: parents', 9),
(4629, 'Friends’ family', 'Família d\'amistats', 9),
(4630, 'Child lives in a family other than its family/ foster family - Friends’ family', 'La nena, el nen o l\'adolescent viu en una família distinta de la seva família directa o d\'acollida: amistats', 9),
(4631, 'SKIP “B”; GO -> F3', 'SALTAR “B”; ANAR -> F3', 9),
(4632, 'If you DON\'T chose Boarder(s) -> B: Members of Family', 'Si NO trieu Interna o Intern -> B: Persones de la família', 9),
(4633, 'B: Member(s) of Family', 'B: Persones de la família', 9),
(4634, 'Number', 'Nombre', 9),
(4635, 'Primary caregiver(s)', 'Persones cuidadores principals', 9),
(4636, 'Parent(s)', 'Progenitores i/o progenitors', 9),
(4637, 'Step Parent(s)', 'Madrastres i/o padrastres', 9),
(4638, 'Parent(s)’ partner(s)', 'Parella o parelles de les persones progenitores', 9),
(4639, 'Sibling(s)', 'Germanes i/o germans', 9),
(4640, 'Younger than the (alleged) victim', 'Menors que la víctima o presumpta víctima', 9),
(4641, 'Older than the (alleged) victim (<18)', 'Majors que la víctima o presumpta víctima (<18)', 9),
(4642, 'Older than the (alleged) victim (>18)', 'Majors que la víctima o presumpta víctima (>18)', 9),
(4643, 'Grandparent(s)', 'Àvies i/o avis', 9),
(4644, 'Other relative(s)', 'Altres familiars', 9),
(4645, 'Blood relatives', 'Familiars amb relació de consanguinitat', 9),
(4646, '<18 [child(ren)]', '<18 [nenes, nens o adolescents]', 9),
(4647, '>18 [adult(s)]', '>18 [persones adultes]', 9),
(4648, 'By law relatives', 'Familiars per llei', 9),
(4649, 'Family friend(s)', 'Amistats de la família', 9),
(4650, 'Other not-related household members', 'Altres persones residents sense relació amb la família', 9),
(4651, 'Please indicate up to 2 child’s primary caregiver(s) (you can uncheck)', 'Si us plau, indiqueu un màxim de 2 persones cuidadores (podeu desmarcar-ne)', 9),
(4652, 'members', 'persones', 9),
(4653, 'member family', 'persones de la família o persona cuidadora principal', 9),
(4654, 'Please record Caregiver(s) Relationship to Child, Sex and Date of Birth', 'Si us plau, registreu la relació de les persones cuidadores principals amb la nena, el nen o l\'adolescent ', 9),
(4655, 'Relationship to Child', 'Relació amb la nena, el nen o l\'adolescent', 9),
(4656, '1st Caregiver', 'Primera persona cuidadora principal', 9),
(4657, 'Professional Caregiver', 'Persona cuidadora professional', 9),
(4658, 'Temporary caregiver/Other', 'Persona cuidadora temporal/Altres', 9),
(4659, 'Unknown relationship', 'Relació desconeguda', 9),
(4660, 'Check ONE per Caregiver', 'Marqueu UNA opció per persona cuidadora principal', 9),
(4661, 'Caregiver(s) Sex', 'Sexe de les persones cuidadores principals', 9),
(4662, 'Caregiver(s) DoB', 'Data de naixement de les persones cuidadores principals', 9),
(4663, 'YY', 'AA', 9),
(4664, '\'s', '', 9),
(4665, 'YY-MM-DD', 'DD-MM-AA', 9),
(4666, 'If YYYY-MM-DD are unknown then record the decade:', 'Si no sabeu DD-MM-AAAA, registreu la dècada:', 9),
(4667, 'If DECADE is unknown, then:', 'en cas que no sabeu la dècada:', 9),
(4668, 'Please record any Institutional Response', 'Si us plau, registreu totes les respostes institucionals', 9),
(4669, 'No response was required DUE TO CHILD’S DEATH', 'No es va requerir registre degut a la defunció de la nena, el nen o l\'adolescent', 9),
(4670, 'No Response', 'Sense resposta', 9),
(4671, 'Yes', 'Sí', 9),
(4672, 'Immediate intervention(s)', 'Intervenció o intervencions immediates', 9),
(4673, 'Physical Medical exam(s)', 'Exploracions físiques ', 9),
(4674, 'Mental Health exam(s)', 'Exploracions psicològiques', 9),
(4675, 'Forensic evaluation initiated', 'Examen forense en marxa', 9),
(4676, 'Child protection /welfare services assessment', 'Avaluació per part dels serveis de protecció infantil o serveis socials', 9),
(4677, 'Police intervention', 'Intervenció policial', 9),
(4678, 'Action taken -NO COURT INVOLVEMENT', 'Intervenció realitzada - SENSE INTERVENCIÓ JUDICIAL', 9),
(4679, 'Child remains in family with planned intervention', 'La nena, el nen o l\'adolescent es queda a la família amb una intervenció planificada', 9),
(4680, 'Emergency placement', 'Assignació d\'urgència', 9),
(4681, 'Supportive intervention for current caregiver(s)', 'Intervenció de suport a les persones cuidadores actuals', 9),
(4682, 'Mother/child shelter with parent and child together', 'Allotjament conjunt de la mare i la nena, el nen o l\'adolescent ', 9),
(4683, 'Police emergency protection procedures', 'Procediments de protecció d\'emergència per part de la policia', 9),
(4684, 'CPS/welfare services emergency protection procedures', 'Procediments de tutela d\'emergència per part dels serveis de protecció infantil o socials', 9),
(4685, 'Referral to child protection /welfare services', 'Derivació als serveis de protecció infantil o socials', 9),
(4686, 'Action taken -COURT or EQUIVALENT AUTHORITY TO THE COURT INVOLVEMENT', 'Intervenció realitzada - INTERVENCIÓ JUDICIAL o d\'AUTORITAT EQUIVALENT', 9),
(4687, '(Family) Court measures initiated', 'Accions legals iniciades als jutjats (de família)', 9),
(4688, 'Action to protect victim by court order(s)', 'Disposició per protegir la víctima per requeriment judicial', 9),
(4689, 'Action to remove parent(s)’ rights', 'Disposició per retirar els drets de tutela de les persones progenitores ', 9),
(4690, 'Expulsion of (alleged) abuser from home', 'La persona agressora abandona la llar per requeriment judicial', 9),
(4691, 'Action to prosecute perpetrator(s)', 'Disposició per encausar la persona o persones culpables', 9),
(4692, 'Out of home placement', 'Assignació fora de la llar', 9),
(4693, 'Kinship Care (relatives/extended family)', 'Deixar la nena, el nen o l\'adolescent a càrrec de familiars (parents o família extensa)', 9),
(4694, 'Foster Care', 'Acolliment familiar', 9),
(4695, 'Children’s Home Institution', 'Institució residencial per a infants i adolescents', 9),
(4696, 'Adoption with parents’ agreement', 'Adopció amb el consentiment de les persones progenitores', 9),
(4697, 'Adoption by court order', 'Adopció per ordre judicial', 9),
(4698, 'GO -> S2', 'ANAR -> S2', 9),
(4699, 'Check below as many as applicable', 'Marqueu totes les que corresponguin', 9),
(4700, 'Please record any Referral(s) made to Services by you/your agency', 'Si us plau, registreu qualsevol derivació als serveis per part vostra o de la vostra agència', 9),
(4701, 'None', 'Cap', 9),
(4702, 'Judicial Services', 'Serveis judicials', 9),
(4703, 'for child ONLY', 'NOMÉS per a la nena, el nen o l\'adolescent', 9),
(4704, 'for caregiver(s) ONLY', 'NOMÉS per a persones cuidadores', 9),
(4705, 'for child AND family', 'per a la nena, nen o adolescent i la família', 9),
(4706, 'Mental Health Services', 'Serveis de salut mental', 9),
(4707, 'Independent Authorities', 'Autoritats independents', 9),
(4708, 'Social Welfare Services', 'Serveis d\'assistència social', 9),
(4709, 'Law Enforcement related Services', 'Serveis relacionats amb les forces de l’ordre', 9),
(4710, 'Community Organizations and NGOs', 'Organitzacions comunitàries i ONG', 9),
(4711, 'Existing Registries and Research Organizations', 'Registres existents i organitzacions de recerca', 9),
(4712, 'Educational Services', 'Serveis educatius', 9),
(4713, 'Other related Services', 'Altres serveis relacionats', 9),
(4714, 'End of Record', 'Final de registre', 9),
(4715, 'CHECK RECORD OPTIONS', 'DADES DEL REGISTRE', 9),
(4716, 'Please check the record options', 'Si us plau, verifiqueu les dades del registre', 9),
(4717, 'You can make any changes by navigating throught the right panel!', 'Podeu fer canvis navegant per la barra de la dreta!', 9),
(4718, 'Incident', 'Incident', 9),
(4719, 'ID', 'ID', 9),
(4720, 'Sex', 'Sexe', 9),
(4721, 'Date of birth', 'Data de naixement', 9),
(4722, 'Family and Caregiver(s)', 'Família i persona o persones cuidadores ', 9),
(4723, 'Services', 'Serveis', 9),
(4724, 'Submit Record', 'Enviar el registre', 9),
(4725, 'Loading', '', 9),
(4726, 'RECORD COMPLETED', 'REGISTRE COMPLETAT', 9),
(4727, 'Display/print the record', 'Mostreu/imprimiu el registre', 9),
(4728, 'Report', 'Informe', 9),
(4729, 'RECORD', 'REGISTRAR', 9),
(4730, 'Agency', 'Agència', 9),
(4731, 'Information provided by', 'Informació proporcionada per', 9),
(4732, 'Age at the date of incident', 'Edat a la data en que es produí l\'incident', 9),
(4733, 'Age at the date of recording', 'Edat en el moment del registre', 9),
(4734, 'Type of family', 'Tipus de família', 9),
(4735, 'Family\'s member(s)', 'Persones de la família', 9),
(4736, '1st', '1r', 9),
(4737, 'born', 'nonata, nonat', 9),
(4738, '2nd', '2n', 9),
(4739, 'Back', 'Enrere', 9),
(4740, 'KNOWN CHILD', 'NENA, NEN O ADOLESCENT JA EXISTENT A L\'APLICATIU', 9),
(4741, 'EXISTING CHILD RECORD', 'REGISTRE D\'UNA NENA, NEN O ADOLESCENT EXISTENT', 9),
(4742, 'You are going to proceed with the record of a new CM incident for  the child', 'Esteu a punt de registrar un nou incident de maltractament infantil per a la nena, el nen o l\'adolescent', 9),
(4743, 'Please proceed with checking of', 'Si us plau, marqueu', 9),
(4744, 'TIP: Update –if needed', 'SUGGERIMENT: En cas necessari, actualitzeu', 9),
(4745, 'Known Incidents', 'Incidents coneguts', 9),
(4746, 'The incident you are trying to record might already exist!', 'L\'incident que intenteu registrar podria estar ja registrat', 9),
(4747, 'Please check the incident record(s) below', 'Si us plau, comproveu els registres d\'incidents a sota', 9),
(4748, 'for Child\'s ID:', 'per al ID de la nena, el nen o l\'adolescent:', 9),
(4749, 'and Date of Incident:', 'i la data de l\'incident', 9),
(4750, 'Date-Time of Record', 'Data-hora de registre', 9),
(4751, 'Display', 'Mostrar', 9),
(4752, 'Add new incident', 'Afegir un nou incident', 9),
(4753, 'ENTER Username', 'ΕΙΣΑΓΕΤΕ Username', 13),
(4754, 'ENTER Password', 'ΕΙΣΑΓΕΤΕ Password', 13),
(4755, 'Log in', 'Είσοδος', 13),
(4756, 'MEMO: Meaning of Symbols & Colors', 'ΥΠΟΜΝΗΜΑ: Επεξήγηση Συμβόλων και Χρωματικής Κωδικοποίησης', 13),
(4757, 'Auto-Completed variable', 'Η απαραίτητη πληροφορία έχει ήδη συμπληρωθεί από το Σύστημα', 13),
(4758, 'Variable already recorded by the Operator', 'Η απαραίτητη πληροφορία έχει ήδη καταγραφεί από τον/την Χρήστη/-στρια', 13),
(4759, 'Single selection (mutually exclusive codes)', 'ΜΟΝΑΔΙΚΗ επιλογή (οι διαθέσιμες εναλλακτικές είναι αμοιβαία αποκλειόμενες)', 13),
(4760, 'Multiple selection (select as many as applicable)', 'ΠΟΛΛΑΠΛΗ επιλογή (από τις διαθέσιμες εναλλακτικές επιλέγονται όλες όσες ισχύουν)', 13),
(4761, 'Open list of sub-codes (drop-down menu)', 'Ανάπτυξη λίστας (αναδυόμενη λίστα)', 13),
(4762, 'Close list of sub-codes (drop-down menu)', 'Σύμπτυξη λίστας (αναδυόμενη λίστα)', 13),
(4763, 'Instruction to Operator', 'Οδηγία προς τον/την Χρήστη/-στρια', 13),
(4764, 'Recorded Variable’s Name', 'Όνομα Στοιχείου Δεδομένων', 13),
(4765, 'Codes of Recorded variable', 'Κωδικός Στοιχείου Δεδομένων', 13),
(4766, 'Note to Operator for the recording', 'Σημείωση αναφορικά με την καταγραφή', 13),
(4767, 'Note to Operator for system’s operations', 'Σημείωση αναφορικά με τη λειτουργία του συστήματος', 13),
(4768, 'Automated process (filters etc.)', 'Αυτοματοποιημένη διαδικασία (φίλτρα κ.λπ.)', 13),
(4769, 'ALREADY EXISTING ID (can appear in CHILD’S ID AND in INCIDENT ID)', 'ΗΔΗ ΥΠΑΡΧΟΝ ID (αναγνωριστικό). Μπορεί να εμφανιστεί στα πεδία ID Παιδιού και ID Περιστατικού', 13),
(4770, 'Skip', 'Συνέχεια', 13),
(4771, 'Start Page', 'Αρχική Σελίδα', 13),
(4772, 'Operator\'s Panel', 'Εργαλεία Διαχείρισης', 13),
(4773, 'my account', 'ο λογαριασμός μου', 13),
(4774, 'Contact Details', '', 13),
(4775, 'Change Password', 'Αλλαγή κωδικού πρόσβασης', 13),
(4776, 'my previous cases', 'παλιότερα περιστατικά', 13),
(4777, 'List of incidents', 'Λίστα συμβάντων', 13),
(4778, 'List of Children’s ID', '', 13),
(4779, 'my current cases', 'τρέχοντα περιστατικά', 13),
(4780, 'List of temporary Child\'s ID', 'Λίστα προσωρινών αναγνωριστικών (IDs)', 13),
(4781, 'Information ', 'Πληροφορίες', 13),
(4782, 'New Incident', '', 13),
(4783, 'My Profile', 'Ο λογαριασμός μου', 13),
(4784, 'Change Pass', 'Αλλαγή κωδικού πρόσβασης', 13),
(4785, 'List of Child\'s ID', 'Λίστα αναγνωριστικών παιδιών (IDs)', 13),
(4786, 'Log out!', 'Αποσύνδεση!', 13),
(4787, 'Welcome', 'Καλώς ήλθατε', 13),
(4788, 'New ', 'Νέο', 13),
(4789, 'Record Progress', 'Πρόοδος Καταγραφής', 13),
(4790, 'Agency\'s ID', 'ID Φορέα', 13),
(4791, 'Operator\'s ID', 'Αναγνωριστικό (ID) Χρήστη/-στριας', 13),
(4792, 'Child\'s ID', 'ID Παιδιού', 13),
(4793, 'Date of Record', 'Ημερομηνία Καταγραφής', 13),
(4794, 'Incident\'s ID', 'ID Περιστατικού', 13),
(4795, 'Date of Incident', 'Ημερομηνία περιστατικού', 13),
(4796, 'Source of Information', 'Πηγή Πληροφοριών για το συγκεκριμένο Περιστατικό', 13),
(4797, 'Forms of Maltreatment', 'Μορφή/-ες Κακομεταχείρισης', 13),
(4798, 'Place of Incident', 'Χώρος στον οποίο έλαβε χώρα το Περιστατικό', 13),
(4799, 'Child\'s Sex', 'Φύλο παιδιού', 13),
(4800, 'Child\'s DoB', 'Ημερομηνία γέννησης παιδιού', 13),
(4801, 'Child\'s Citizenship Status', 'Υπηκοότητα', 13),
(4802, 'Family Composition', 'Σύνθεση Οικογένειας', 13),
(4803, 'CGs Relationship to Child', 'Σχέση Φροντιστή με παιδί', 13),
(4804, 'Caregiver(s)\' Sex', 'Φύλο Φροντιστή/-στριας', 13),
(4805, 'Caregiver(s)\' DoB', 'Ημερομηνία γέννησης φροντιστή', 13),
(4806, 'Institutional Response', 'Απόκριση του Φορέα', 13),
(4807, 'Referral(s) to Services', 'Παραπομπές σε Υπηρεσίες', 13),
(4808, 'Agencys\'s ID', 'ID Φορέα', 13),
(4809, 'Identity Confirmation', 'Επιβεβαίωση στοιχείων Χρήστη/-στριας', 13),
(4810, 'TIP', 'Χρήσιμη Συμβουλή!', 13),
(4811, 'If the above information needs update, please contact the CAN-MDS Administration Office.', 'Εάν τα παραπάνω στοιχεία χρειάζονται ενημέρωση, παρακαλούμε επικοινωνήστε με τον Εθνικό Διαχειριστή του CAN-MDS (info@can-via-mds.eu)', 13),
(4812, 'Date & Type of Incident', '', 13),
(4813, 'Incident ID', 'Αναγνωριστικό (ID) Περιστατικού', 13),
(4814, 'Type Of Record', '', 13),
(4815, 'Type Of Incident', '', 13),
(4816, 'Notifications', '', 13),
(4817, 'Subject', '', 13),
(4818, 'Message', '', 13),
(4819, 'Replace ID', '', 13),
(4820, 'WELCOME TO CAN-MDS', 'ΚΑΛΩΣ ΗΡΘΑΤΕ ΣΤΟ CAN-MDS', 13),
(4821, 'To proceed with the record, please follow the CAN-MDS Operations’ Protocol.', 'Για να προχωρήσετε με την καταγραφή, συμβουλευτείτε το βήμα-προς-βήμα Πρωτόκολλο Διαδικασιών Καταγραφής.', 13),
(4822, 'If you need more information, please use the CAN-MDS Guide for Operators.', 'Για περισσότερες πληροφορίες όσον αφορά τις κωδικοποιημένες απαντήσεις, απευθυνθείτε στον Οδηγό CAN-MDS για τον/την Χρήστη/-στρια.', 13),
(4823, 'Continue with the record', 'Συνεχίστε με την καταγραφή', 13),
(4824, 'Please, insert Child’s ID provided to you by the Administrator', 'Παρακαλώ εισάγετε τον αναγνωριστικό κωδικό (ID) του Παιδιού που σας δόθηκε από τον Διαχειριστή του συστήματος', 13),
(4825, 'NOT KNOW CHILD\'S ID', 'ΠΡΟΣΩΡΙΝΟ ID ΠΑΙΔΙΟΥ', 13),
(4826, 'The Child’s ID you provided is referred to an', 'To αναγνωριστικό (ID) του παιδιού που καταχωρήσατε αναφέρεται σε', 13),
(4827, 'UNKNOWN CHILD', 'ΑΓΝΩΣΤΗ ΠΕΡΙΠΤΩΣΗ (ΠΑΙΔΙ χωρίς προηγούμενη καταγραφή)', 13),
(4828, 'NEW CHILD RECORD', 'ΚΑΤΑΓΡΑΦΗ ΝΕΑΣ ΠΕΡΙΠΤΩΣΗΣ (ΠΑΙΔΙΟΥ χωρίς προηγούμενη καταγραφή)', 13),
(4829, 'NEW INCIDENT RECORD', 'ΚΑΤΑΓΡΑΦΗ ΝΕΟΥ ΠΕΡΙΣΤΑΤΙΚΟΥ', 13),
(4830, 'You are going to proceed with the record of a new case of (alleged) child maltreatment.', 'Πρόκειται να προχωρήσετε στην καταγραφή νέας περίπτωσης παιδιού (πιθανού)-θύματος κακομεταχείρισης', 13),
(4831, 'Please proceed with recording of', 'Συνεχίστε καταγράφοντας τα παρακάτω', 13),
(4832, '-incident related variables', '-στοιχεία δεδομένων που σχετίζονται με το περιστατικό', 13),
(4833, '-child related variables', '-στοιχεία δεδομένων που σχετίζονται με το παιδί', 13),
(4834, '-family related variables', '-στοιχεία δεδομένων που σχετίζονται με την οικογένεια', 13),
(4835, '-services related variables', '-στοιχεία δεδομένων που σχετίζονται με τις υπηρεσίες', 13),
(4836, 'Please record the referred Date of Incident', 'Παρακαλώ καταγράψτε την (αναφερόμενη) ημερομηνία κατά την οποία έλαβε χώρα το περιστατικό', 13),
(4837, 'Unknown', 'Άγνωστο', 13),
(4838, 'A \"distinct\" event took place – Not continuous maltreatment', '', 13),
(4839, 'YYYY', 'ΕΕΕΕ', 13),
(4840, 'MM', 'ΜΜ', 13),
(4841, 'DD', 'ΗΗ', 13),
(4842, 'Continuous maltreatment – including \"distinct event(s)\"', '', 13),
(4843, 'start date', 'ημερομηνία έναρξης', 13),
(4844, 'duration', 'διάρκεια', 13),
(4845, 'Years', 'Έτη', 13),
(4846, 'Months', 'Μήνες', 13),
(4847, 'Days', 'Ημέρες', 13),
(4848, 'During the last 12 months', 'Κατά τη διάρκεια των τελευταίων 12 μηνών', 13),
(4849, 'Before the last 12 months', 'Πριν τους 12 τελευταίους μήνες', 13),
(4850, 'Lifelong', 'Σε όλη τη διάρκεια της ζωής του παιδιού', 13),
(4851, 'Last known CM incident date', 'Ημερομηνία πιο πρόσφατου περιστατικού', 13),
(4852, 'Continuous maltreatment - No \"distinct event\" took place', '', 13),
(4853, 'GO -> R4', 'Μετάβαση --> R4', 13),
(4854, 'Click to open sub-list', 'Πατήστε εδώ για να ανοίξετε τη λίστα', 13),
(4855, 'Complete as precisely as possible YYYY-MM-DD', 'Συμπληρώστε ΕΕΕΕ-ΜΜ-ΗΗ', 13),
(4856, 'Neglect/other abuse taking place over a longer period', 'Παραμέληση/άλλη κακοποίηση που λαμβάνει χώρα για μεγάλο χρονικό διάστημα', 13),
(4857, 'Check ONE in the sub-list', 'Επιλέξτε ΕΝΑ από τη λίστα που ακολουθεί', 13),
(4858, 'Click to close sub-list', 'Σύμπτυξη λίστας', 13),
(4859, 'approximately', 'περίπου', 13),
(4860, 'or less', 'ή λιγότερο', 13),
(4861, 'Wrong date', 'Λανθασμένη ημερομηνία', 13),
(4862, 'year', 'έτος', 13),
(4863, 'month', 'μήνας', 13),
(4864, 'day', 'ημέρα', 13),
(4865, 'One day', 'Μία ημέρα', 13),
(4866, 'Please record the Source of Information', 'Παρακαλώ καταγράψτε την πηγή των πληροφοριών για το συγκεκριμένο περιστατικό', 13),
(4867, 'Unspecified', 'απροσδιόριστο', 13),
(4868, 'Identified (via routine screening)', 'Ανιχνεύτηκε από τον/την επαγγελματία του Φορέα που καταγράφει', 13),
(4869, 'Child (alleged) victim', 'Το ίδιο το παιδί (αυτο-αναφερόμενο ως) θύμα', 13),
(4870, 'Parent /foster parent/ parent’s partner/ care provider', 'Γονέας/ θετός γονέας/ σύντροφος γονέα/ φροντιστής/-στρια', 13),
(4871, 'Relative (siblings, grandparents, etc.) living with the child', 'Συγγενικό πρόσωπο (αδελφός/-ή, παππούς/γιαγιά, κλπ) που ζει στο ίδιο σπίτι με το παιδί', 13),
(4872, 'Relative (siblings, grandparents, etc.) not living with the child', 'Συγγενικό πρόσωπο (αδελφός/-ή, παππούς/γιαγιά, κλπ) που ΔΕΝ ζει στο ίδιο σπίτι με το παιδί', 13),
(4873, 'Friend / Neighbor', 'Φίλος/-η του παιδιού/ της οικογένειας/ Γείτονας/-ισσα', 13),
(4874, 'Self-reported as (alleged) perpetrator', 'Ο/η (αυτο-προσδιοριζόμενος/-η) ως δράστης/-στρια της κακομεταχείρισης του παιδιού', 13),
(4875, 'School /preschool /kindergarten personnel', 'Επαγγελματίας/ Εργαζόμενος/-η του σχολείου/ νηπιαγωγείου/ άλλης δομής προσχολικής αγωγής', 13),
(4876, 'Leisure activity staff (e.g., scout leader, clergy, sport coach)', 'Υπεύθυνος/-η για ψυχαγωγικές ή άλλες δραστηριότητες (όπως αρχηγός προσκόπων, κληρικός, προπονητής/-τρια)', 13),
(4877, 'Anonymous reporter', 'Ανώνυμη πηγή (το άτομο που παρέχει τις πληροφορίες θέλει να διατηρήσει την ανωνυμία του)', 13),
(4878, 'Personnel working in Child day care services', 'Επαγγελματίας/ Εργαζόμενος/-η σε υπηρεσία/φορέα ημερήσιας φροντίδας παιδιών', 13),
(4879, 'Personnel working in Social Services/ Public–Central/Local', 'Επαγγελματίας/ Εργαζόμενος/-η σε Κοινωνική Υπηρεσία Δημόσιου Τομέα (κεντρική ή τοπική)', 13),
(4880, 'Personnel working in Health services', 'Επαγγελματίας/ Εργαζόμενος/-η σε υπηρεσία/ οργανισμό/ φορέα Υγείας', 13),
(4881, 'Personnel working in Mental Health Services', 'Επαγγελματίας/ Εργαζόμενος/-η σε υπηρεσία/ οργανισμό/ φορέα Ψυχικής Υγείας', 13),
(4882, 'Personnel working in Ordinary/Juvenile Court and related services', 'Επαγγελματίας/ Εργαζόμενος/-η σε υπηρεσία του Υπουργείου Δικαιοσύνης και συναφείς υπηρεσίες', 13),
(4883, 'Personnel working in Police /low enforcement', 'Επαγγελματίας/ Εργαζόμενος/-η σε υπηρεσία/ τμήμα της Αστυνομίας', 13),
(4884, 'Personnel working in Helpline', 'Επαγγελματίας/ Εργαζόμενος/-η σε τηλεφωνκή γραμμή βοήθειας', 13),
(4885, 'Personnel working in Community agency including agencies working against DV', 'Επαγγελματίας/ Εργαζόμενος/-η σε κοινοτικό φορέα/ υπηρεσία για ενδοοικογενειακή βία', 13),
(4886, 'Personnel working in Ombudsman', 'Επαγγελματίας/ Εργαζόμενος/-η στον Επίτροπο Δικαιωμάτων του Παιδιού', 13),
(4887, 'Personnel working in NGOs/associations', 'Επαγγελματίας/ Εργαζόμενος/-η σε μη κυβερνητικό οργανισμό', 13),
(4888, 'Personnel working in services for people with disabilities', 'Επαγγελματίας/ Εργαζόμενος/-η σε υπηρεσία/φορέα για άτομα με ειδικές ανάγκες', 13),
(4889, 'Other', 'Άλλο', 13),
(4890, 'GO -> I3', 'Μετάβαση -> Ι3', 13),
(4891, 'Check ONE from the list', 'Επιλέξτε ΕΝΑ από τη λίστα που ακολουθεί', 13),
(4892, 'Please record the Form(s) of Maltreatment', 'Παρακαλώ καταγράψτε κάθε αναφερόμενη/-ες μορφή/-ές κακομεταχείρισης', 13),
(4893, 'Form(s) of Maltreatment', 'Μορφή/-ές κακοποίησης', 13),
(4894, 'Expand/Collapse list', 'Ανάπτυξη / Σύμπτυξη Λίστας', 13),
(4895, 'Check as many as applicable. By selecting from child menu, broad categories are auto-selected.', 'Από τη λίστα που ακολουθεί επιλέξτε όλα όσα ισχύουν. Η επιλογή με βάση τις υποκατηγορίες αυτόματα οδηγεί στην επιλογή των γενικότερων κατηγοριών.', 13),
(4896, 'Please provide as detailed as possible information (by using sub-menus).', 'Παρακαλώ συμπληρώστε όσο το δυνατό πιο ακριβείς πληροφορίες χρησιμοποιώντας τις λίστες που ακολουθούν.', 13),
(4897, 'Acts Committed', 'Βίαιες Πράξεις', 13),
(4898, 'Violent acts against self /Self-harm actions', 'Άσκηση βίας κατά εαυτού/ Αυτο-τραυματισμός', 13),
(4899, 'Eating disorder', 'διατροφική διαταραχή', 13),
(4900, 'Substance use/ abuse', 'Χρήση/κατάχρηση ουσιών', 13),
(4901, 'Runaway', 'Φυγή (από το σπίτι/ τη στέγη που ζει)', 13),
(4902, 'Self-inflicted injuries', 'Αυτο-τραυματισμός', 13),
(4903, 'Suicidal thoughts', 'Αυτοκτονικές σκέψεις', 13),
(4904, 'Suicide attempt', 'Απόπειρα αυτοκτονίας', 13),
(4905, 'Actual suicide', 'Αυτοκτονία', 13),
(4906, 'Other self-harm action (unspecified)', 'Άλλη (αδιευκρίνιστη) πράξη αυτο-τραυματισμού', 13),
(4907, 'Physical violence acts committed [with or without injury]', 'Άσκηση σωματικής βίας (με ή χωρίς τραυματισμό)', 13),
(4908, 'Physical violent acts/ corporal punishment/ “disciplines”', 'Άσκηση σωματικής βίας/ σωματική τιμωρία', 13),
(4909, 'Slapping', 'Χαστούκισμα', 13),
(4910, 'Smacking', 'Σκαμπίλισμα', 13),
(4911, 'Spanking', 'Ράπισμα στα οπίσθια', 13),
(4912, 'Pinching', 'Τσίμπημα', 13),
(4913, 'Twisting ear(s)', 'Τράβηγμα /Στρίψιμο αφτιών', 13),
(4914, 'Pulling hair', 'Τράβηγμα μαλλιών', 13),
(4915, 'Hitting with an object', 'Χτύπημα με αντικείμενο', 13),
(4916, 'Beating', 'Ξυλοδαρμός', 13),
(4917, 'Tying up or tying to something /restraining to cloth sacks', 'Δέσιμο του παιδιού πάνω σε κάτι/ περιορισμός με \"ειδικά\" ρούχα', 13),
(4918, 'Locking up', 'Κλείδωμα σε δωμάτιο/ άλλο χώρο', 13),
(4919, 'Leaving child to lie in their own excrement', 'Παράτημα του παιδιού στα περιττώματά του', 13),
(4920, 'Pushing', 'Σπρώξιμο', 13),
(4921, 'Throwing', 'Πέταγμα', 13),
(4922, 'Shaking', 'Ταρακούνημα', 13),
(4923, 'Grabbing', 'Άρπαγμα', 13),
(4924, 'Choking', 'Στραγγάλισμα', 13),
(4925, 'Squeezing neck', 'Πίεση στο σβέρκο', 13),
(4926, 'Kicking', 'Κλώτσημα', 13),
(4927, 'Hitting on head (with hand or against the wall)', 'Χτύπημα εστιασμένο στο κεφάλι (με το χέρι/ στον τοίχο)', 13),
(4928, 'Boxing ear', 'Γροθιά στο αφτί', 13),
(4929, 'Scratching', 'Γρατσούνισμα', 13),
(4930, 'Biting', 'Δάγκωμα', 13),
(4931, 'Burning', 'Κάψιμο', 13),
(4932, 'Scalding', 'Ζεμάτισμα', 13),
(4933, 'Violent acts known also as harmful practices', 'Βίαιες πράξεις που συνιστούν γνωστές επιβλαβείς πρακτικές', 13),
(4934, 'Hitting on the soles of the feet', 'Χτύπημα στα πέλματα των ποδιών', 13),
(4935, 'Forcing to ingest spicy food', 'Εξαναγκασμός του παιδιού σε κατάποση καυτερού φαγητού', 13),
(4936, 'Forced feeding', 'Εξαναγκασμός του παιδιού σε φαγητό', 13),
(4937, 'Forcing children to stay in uncomfortable positions', 'Εξαναγκασμός του παιδιού σε άβολη/επώδυνη στάση', 13),
(4938, 'Binding', 'Δέσιμο με αλυσίδες/λουριά', 13),
(4939, 'Inflicting scars/ scarring', 'Εκκούσια πρόκληση σημαδιού/ ουλής', 13),
(4940, 'Teeth extraction as punishment', 'Εξαγωγή δοντιού ως τιμωρία', 13),
(4941, 'Branding', 'Στιγματισμός/ πυροσφράγισμα/ \"μαρκάρισμα\"', 13),
(4942, 'Fattening', 'Εκκούσια πάχυνση του παιδιού', 13),
(4943, '“Retribution” acts of violence', 'Άσκηση σωματικής βίας ως \"τιμωρία\"', 13),
(4944, 'Virginity testing (inspecting girls’ genitalia)', 'Εξαναγκασμός κοριτσιού σε \"έλεγχο παρθενίας\"', 13),
(4945, 'Forced circumcision', 'Εξαναγκασμός αγοριού σε περιτομή', 13),
(4946, 'Female genital mutilation', 'Κλειτεριδεκτομή', 13),
(4947, 'Uvulectomy', 'Αφαίρεση σταφυλής', 13),
(4948, 'Forced marriage and early marriage', 'Εξαναγκασμός σε γάμο/ πρώιμος γάμος', 13),
(4949, 'Violent and degrading initiation rites / “hazing”', 'Εξαναγκασμός σε εξευτελιστική τελετή μύησης/ \"καψόνι\"', 13),
(4950, 'Practices as “exorcism” after accusations of “witchcraft”', 'Εφαρμογή πρακτικών όπως εξορκισμού μετά από κατηγορίες όπως δαιμονισμού', 13),
(4951, 'Forced sterilization, particularly girls', 'Εξαναγκασμός σε στείρωση', 13),
(4952, 'Violence in the guise of treatment', 'Άσκηση βίας με πρόφαση θεραπεία', 13),
(4953, 'Deliberate infliction of disabilities for exploiting/begging', 'Εκκούσια πρόκληση αναπηρίας στο παιδί για εκμετάλλευση/ όπως επαιτεία', 13),
(4954, 'Acts of life threatening maltreatment', 'Κακομεταχείριση απειλητική για τη ζωή του παιδιού (με πρόθεση)', 13),
(4955, 'Administering unnecessary invasive medical procedures', 'Χορήγηση περιττών επεμβατικών ιατρικών πράξεων', 13),
(4956, 'Administering non prescribed substances', 'Χορήγηση ακατάλληλων μη-συνταγογραφημένων φαρμακευτικών ουσιών', 13),
(4957, 'Child has been given poison', 'Δηλητηρίαση (με πρόθεση)', 13),
(4958, 'Threatening with a knife (also psychological abuse)', 'Απειλή με ένα μαχαίρι', 13),
(4959, 'Threatening with a gun (also psychological abuse)', 'Απειλή με όπλο', 13),
(4960, 'Stabbing', 'Μαχαίρωμα', 13),
(4961, 'Shooting', 'Πυροβολισμός', 13),
(4962, 'Dowry-related violence/death (also harmful practice)', 'Άσκηση βίας που σχετίζεται με απόδοση προίκας', 13),
(4963, '“Honour” crimes (also harmful practice)', 'Άσκηση βίας στο πλαίσιο \"εγκλήματος τιμής\"', 13),
(4964, 'Abduction-related acts', 'Πράξη που σχετίζεται με απαγωγή', 13),
(4965, 'Non-family abduction', 'Απαγωγή από τρίτους (όχι από μέλος/-η της οικογένειας)', 13),
(4966, 'Family abduction', 'Απαγωγή από μέλος/-η της οικογένειας', 13),
(4967, 'Institutional and system violations of child rights', 'Θεσμική ή/και συστημική παραβίαση των δικαιωμάτων του παιδιού', 13),
(4968, 'Caning', 'Ράβδισμα', 13),
(4969, 'Flogging', 'Μαστίγωμα', 13),
(4970, 'Stoning', 'Λιθοβολισμός', 13),
(4971, 'Torture (all forms)', 'Υποβολή σε (κάθε μορφής) βασανιστήριο', 13),
(4972, 'Amputations', 'Ακρωτηριασμός', 13),
(4973, 'Imposing of death sentence for crimes committed', 'Επιβολή θανατικής ποινής για έγκλημα που διαπράχθηκε από το παιδί', 13),
(4974, 'Other described physical acts', 'Άλλες αναφερόμενες πράξεις σωματικής βίας', 13),
(4975, 'No specific information for reported/suspected physical violence', 'Μη ακριβείς πληροφορίες για αναφερόμενες πράξεις σωματικής βίας', 13),
(4976, 'Sexual violence acts committed [with or without injury]', 'Άσκηση σεξουαλικής βίας (με ή χωρίς τραυματισμό)', 13),
(4977, 'Sexual violence acts', 'Άσκηση σεξουαλικής βίας', 13),
(4978, 'Acts involving penetration (intrusion)', 'Σεξουαλική παραβίαση (με διείσδυση)', 13),
(4979, 'Without force', 'χωρίς εξαναγκασμό', 13),
(4980, 'anus', 'πρωκτική', 13),
(4981, 'vulva', 'κολπική', 13),
(4982, 'mouth', 'στοματική', 13),
(4983, 'Involving use of force', 'με εξαναγκασμό', 13),
(4984, 'Attempted sexual abuse (not involving penetration)', 'Απόπειρα σεξουαλικής παραβίασης (χωρίς διείσδυση)', 13),
(4985, 'with physical contact', 'με φυσική επαφή', 13),
(4986, 'without physical contact', 'χωρίς φυσική επαφή', 13),
(4987, 'Threatened sexual abuse', 'Απειλή σεξουαλικής κακοποίησης', 13),
(4988, 'Touching/fondling genitals', 'Άγγιγμα γεννητικών οργάνων/ Θωπεία', 13),
(4989, 'Showing genitals to child', 'Επίδειξη γεννητικών οργάνων στο παιδί', 13),
(4990, 'Sexual harassment', 'Σεξουαλική παρενόχληση', 13),
(4991, 'Voyeurism /spying on the children intimate behaviours', 'Παρακολούθηση του παιδιού σε ιδιωτικές στιγμές/ Ηδονοβλεψία', 13),
(4992, 'Providing sexually explicit materials', 'Παροχή πορνογραφικού υλικού στο παιδί', 13),
(4993, 'Forced exposure to pornography', 'Εξαναγκασμός του παιδιού σε παρακολούθηση πορνογραφικού υλικού', 13),
(4994, 'Forcing to witness sexual violence against mother', 'Εξαναγκασμός του παιδιού να είναι παρόν κατά τη σεξουαλική κακοποίηση της μητέρας', 13),
(4995, 'Sexual “luring” (via ICT)', 'Σεξουαλική παρακίνηση/ \"δελεασμός\" (μέσω διαδικτύου/ τηλεφώνου)', 13),
(4996, 'Online sexual stalking /harassment', 'Ηλεκτρονική σεξουαλική καταδίωξη / παρενόχληση', 13),
(4997, 'Other Sexual violence acts', 'Άλλες πράξεις σεξουαλικής βίας', 13),
(4998, 'Sexual exploitation acts', 'Πράξεις σεξουαλικής εκμετάλλευσης', 13),
(4999, 'Child prostitution', 'Εξαναγκασμός του παιδιού σε πορνεία', 13),
(5000, 'Use of children in commercial sexual exploitation', 'Σεξουαλική εκμετάλλευση του παιδιού για εμπορικούς λόγους', 13),
(5001, 'Sexual exploitation in travel and tourism', 'Σεξουαλική εκμετάλλευση του παιδιού στο πλαίσιο σεξουαλικού τουρισμού', 13),
(5002, 'Sexual slavery', 'Σεξουαλική δουλεία', 13),
(5003, 'Sale of children for sexual purposes', 'Πώληση του παιδιού για σεξουαλικούς σκοπούς', 13),
(5004, 'Trafficking (within and between countries)', 'Εμπορία (εντός της χώρας ή/και μεταξύ χωρών)', 13),
(5005, 'Involvement in pornography', 'Εμπλοκή του παιδιού σε πορνογραφία', 13),
(5006, 'Other sexual exploitation acts (unspecified)', 'Άλλη μη προσδιορισμένη πράξη σεξουαλικής εκμετάλλευσης', 13),
(5007, 'No specific information for reported/suspected sexual violence', 'Μη ακριβείς πληροφορίες για αναφερόμενες πράξεις σεξουαλικής βίας', 13),
(5008, 'Psychological violence acts committed [with or without injury]', 'Πράξεις ψυχολογικής κακοποίησης (με ή χωρίς τραυματισμό)', 13),
(5009, 'Violent acts with or without obvious consequences', 'Βίαιες πράξεις κατά του παιδιού με ή χωρίς εμφανείς συνέπειες', 13),
(5010, 'Bullying/ Psychological bullying and hazing', 'Εκφοβισμός του παιδιού', 13),
(5011, 'by other children', 'από άλλο/-α παιδί/-ιά', 13),
(5012, 'by adults', 'από ενήλικο/-α άτομο/-α', 13),
(5013, 'Homophobic bullying /related to sexual orientation', 'Εκφοβισμός που σχετίζεται με τον σεξουαλικό προσανατολισμό του παιδιού/ Ομοφοβικός εκφοβισμός', 13),
(5014, 'Cyber bullying (via ICTs / mobile phones /Internet)', 'Κυβερνο-εκφοβισμός (μέσω τηλεφώνου/ Διαδικτύου)', 13),
(5015, 'Ignoring and favoritism', 'Αδιαφορία για το παιδί', 13),
(5016, 'Denying emotional responsiveness', 'Άρνηση συναισθηματικής απόκρισης', 13),
(5017, 'Over protection', 'Υπερπροστατευτισμός', 13),
(5018, 'Isolation (social)', 'Κοινωνική απομόνωση', 13),
(5019, 'Close confinement (tying/binding)', 'Εγκλεισμός (δέσιμο/ περιορισμός)', 13),
(5020, 'Placement in solitary confinement', 'Εγκλεισμός σε απομόνωση (απομονωμένο χώρο)', 13),
(5021, 'Degrading /inhuman conditions of detention', 'Ταπεινωτικές/ απάνθρωπες συνθήκες κράτησης', 13),
(5022, 'Humiliation /Insults, name-calling, belittling, ridiculing', 'Ταπείνωση/ προσβολές/ γελειοποίηση', 13),
(5023, 'Humiliation via ICT', 'Ταπείνωση /γελειοποίηση μέσω διαδικτύου/ τηλεφώνου', 13),
(5024, 'Rejection and Spurning', 'Απόρριψη', 13),
(5025, 'Verbal assaults', 'Λεκτική επίθεση', 13);
INSERT INTO `u_translate` (`id`, `text_en`, `text_trans`, `language_id`) VALUES
(5026, 'Terrorization / Scaring', 'Τρομοκράτηση', 13),
(5027, 'Threats of sexual violence (with or without contact)', 'Απειλή άσκησης σεξουαλικής βίας (με ή χωρίς σωματική επαφή)', 13),
(5028, 'Threats of other maltreatment', 'Απειλή άσκησης άλλης μορφής κακομεταχείρισης', 13),
(5029, 'Other related acts hurting child’s feelings', 'Άλλη σχετική πράξη που επηρεάζει αρνητικά τη συναισθηματική κατάσταση του παιδιού', 13),
(5030, 'Exploitation related psychological violent acts', 'Ψυχολογική κακοποίηση μέσα από πράξεις που σχετίζονται με την εκμετάλλευση του παιδιού', 13),
(5031, 'Exploiting and corrupting', 'Εκμετάλλευση και διαφθορά', 13),
(5032, 'Labour/economic exploitation', 'Εργασιακή/οικονομική εκμετάλλευση', 13),
(5033, 'Forcing to undertake adult\'s responsibilities/parent’s role', 'Εξαναγκασμός του παιδιού να αναλαμβάνει ευθύνες ενήλικα', 13),
(5034, 'Forcing to begging', 'Εξαναγκασμός του παιδιού να επαιτεί', 13),
(5035, 'Forcing to participate in religious ritual', 'Εξαναγκασμός του παιδιού να συμμετέχει σε βίαιες θρησκευτικές τελετουργίες', 13),
(5036, 'Forcing to participate in a violent political event', 'Εξαναγκασμός του παιδιού να συμμετέχει σε βίαια πολιτικά γεγονότα', 13),
(5037, 'No specific info for reported/suspected exploitation acts', 'Μη ακριβείς πληροφορίες για αναφερόμενες πράξεις εκμετάλλευσης του παιδιού', 13),
(5038, 'Exposure related psychological violent acts', 'Ψυχολογική κακοποίηση μέσω έκθεσης του παιδιού σε βίαιες πράξεις', 13),
(5039, 'Exposure to any kind of violence in the family / DV', 'Έκθεση σε οποιοδήποτε τύπο βίας στην οικογένεια/ ενδοοικογενειακή βία', 13),
(5040, 'Exposure to violence against other children', 'Έκθεση σε άσκηση βίας εναντίον άλλου παιδιού', 13),
(5041, 'Exposure to intimate partner violence', 'Έκθεση σε βία μεταξύ ερωτικών συντρόφων', 13),
(5042, 'Exposure to violence against other adults', 'Έκθεση σε βία εναντίον ενήλικου ατόμου', 13),
(5043, 'Exposition to the homicide of a significant person', 'Έκθεση σε δολοφονία προσώπου', 13),
(5044, 'Exposure to a violent environment outside the family', 'Έκθεση σε βίαιο περιβάλλον εκτός οικογένειας', 13),
(5045, 'Exposure to violence via electronic means', 'Έκθεση σε βία μέσω ηλεκτρονικών μέσων', 13),
(5046, 'information and communication technologies', 'τεχνολογίες ενημέρωσης και επικοινωνίας', 13),
(5047, 'in the mass media', 'στα μέσα μαζικής ενημέρωσης', 13),
(5048, 'No specific info for reported/suspected related exposure', 'Μη ακριβείς πληροφορίες για αναφερόμενες πράξεις σχετικές με έκθεση του παιδιού', 13),
(5049, 'No specific info for reported/suspected psych/l abuse violent acts', 'Μη ακριβείς πληροφορίες για αναφερόμενες πράξεις ψυχολογικής κακοποίησης του παιδιού', 13),
(5050, 'Omissions', 'Παραλείψεις', 13),
(5051, 'Omissions in child’s care / Neglect', 'Παραλείψεις στη φροντίδα του παιδιού/ Παραμέληση', 13),
(5052, 'Emotional neglect related omissions', 'Παραλείψεις όσον αφορά τις συναισθηματικές ανάγκες του παιδιού', 13),
(5053, 'Persistent ignoring of the child’s emotional needs/ Chronic inattention to the child', 'Χρόνια αδιαφορία για τις συναισθηματικές ανάγκες του παιδιού', 13),
(5054, 'Psychologically “unavailable” caregivers', 'Συναισθηματικά \"μη-διαθέσιμοι\" φροντιστές/-στριες', 13),
(5055, 'Inappropriately advanced expectations (def.  According to child’s characteristics)', 'Υπερβολικές προσδοκίες από το παιδί σε σχέση με τα ιδιαίτερα χαρακτηριστικά του', 13),
(5056, 'No specific information for omissions related to emotional neglect', 'Μη ακριβείς πληροφορίες για παραλείψεις που σχετίζονται με συναισθηματική παραμέληση', 13),
(5057, 'Physical neglect related omissions', 'Παραλείψεις σχετικές με φυσική παραμέληση του παιδιού', 13),
(5058, 'Inadequate / inappropriate nutrition', 'Ανεπαρκής/ ακατάλληλη διατροφή', 13),
(5059, 'Inadequate / inappropriate personal hygiene', 'Ανεπαρκής/ ακατάλληλη προσωπική υγιεινή', 13),
(5060, 'Inadequate / inappropriate clothing', 'Ανεπαρκής/ ακατάλληλη ένδυση', 13),
(5061, 'Inadequate / inappropriate shelter', 'Ανεπαρκής/ ακατάλληλη στέγαση', 13),
(5062, 'No specific information for omissions related child’s physical needs', 'Μη ακριβείς πληροφορίες για παραλείψεις που σχετίζονται με φυσική παραμέληση', 13),
(5063, 'Medical neglect related omissions', 'Παραλείψεις που σχετίζονται με παραμέληση υγείας και φροντίδας υγείας', 13),
(5064, 'Refusal to provide preventive health care (vaccinations, vision, and dental care)', 'Άρνηση παροχής προληπτικής φροντίδας υγείας (εμβολιασμοί, έλεγχος όρασης, στοματική υγιεινή)', 13),
(5065, 'Refusal to allow /provide needed medical care for diagnosed health condition/ impairment', 'Άρνηση παροχής ή συγκατάθεσης για παροχή απαραίτητης φροντίδας υγείας για διαγνωσμένες ασθένειες/αναπηρίες', 13),
(5066, 'Unjustified delay to seek needed care', 'Αδικαιολόγητη καθυστέρηση στην αναζήτηση ιατρικής φροντίδας', 13),
(5067, 'Failure to provide with basic medical care', 'Αποτυχία παροχής βασικής ιατρικής φροντίδας', 13),
(5068, 'Withholding essential medical care', 'Καθυστέρηση ή μη παροχή ζωτικής φροντίδας υγείας', 13),
(5069, 'No specific information for omissions related child’s medical needs', 'Μη ακριβείς πληροφορίες για παραλείψεις που σχετίζονται με θέματα υγείας του παιδιού', 13),
(5070, 'Educational neglect related omissions', 'Παραλείψεις που σχετίζονται με την εκπαίδευση/ εκπαιδευτική παραμέληση', 13),
(5071, 'Persistent failure to register child at the school', 'Μη-εγγραφή του παιδιού στο σχολείο', 13),
(5072, 'Has not attended school at all', 'Το παιδί δεν έχει πάει ποτέ στο σχολείο (ενώ θα έπρεπε)', 13),
(5073, 'Dropped out', 'Το παιδί έχει σταματήσει τη φοίτηση (ενώ δεν θα έπρεπε)', 13),
(5074, 'Persistent failure to enrol at the school resulting to irregular school attendance', 'Μη συστηματική φοίτηση/ περιστασιακή παρακολούθηση του σχολειου', 13),
(5075, 'compulsory school', 'υποχρεωτική εκπαίδευση', 13),
(5076, 'non compulsory (ECEC)', 'προσχολική εκπαίδευση', 13),
(5077, 'Chronic truancy', 'Συνεχή σκασιαρχεία', 13),
(5078, 'Refusal to attend special educational needs', 'Άρνηση αποδοχής ειδικών εκπαιδευτικών αναγκών του παιδιού', 13),
(5079, 'Refusal to allow needed attention to special educational needs', 'Άρνηση συγκατάθεσης για φροντίδα ειδικών εκπαιδευτικών αναγκών του παιδιού', 13),
(5080, 'Refusal to provide needed attention to special educational needs', 'Άρνηση παροχής αναγκαίας φροντίδας για ειδικές εκπαιδευτικές ανάγκες του παιδιού', 13),
(5081, 'No specific information for omissions related child’s educational needs', 'Μη ακριβείς πληροφορίες για παραλείψεις που σχετίζονται με τις εκπαιδευτικές ανάγκες του παιδιού', 13),
(5082, 'Risk exposure related omissions', 'Παραλείψεις που σχετίζονται με την έκθεση του παιδιού σε κίνδυνο', 13),
(5083, 'Exposure to hazardous/ dangerous environments', 'Έκθεση σε επικίνδυνα περιβάλλοντα', 13),
(5084, 'Inside household', 'Μέσα στο σπίτι', 13),
(5085, 'Outside home', 'Εκτός οικιακού περιβάλλοντος', 13),
(5086, 'Exposure to substances use/misuse by others', 'Έκθεση σε χρήση ουσιών από τρίτους', 13),
(5087, 'Alcohol', 'Αλκοόλ', 13),
(5088, 'Drugs', 'Ναρκωτικές ουσίες', 13),
(5089, 'Other substances', 'Άλλες ουσίες', 13),
(5090, 'No specific information for reported/ suspected omissions for exposure to risks', 'Μη ακριβείς πληροφορίες για αναφερόμενες παραλείψεις σχετικές με έκθεση του παιδιού σε κίνδυνο', 13),
(5091, 'Supervision related omissions', 'Παραλείψεις που σχετίζονται με πλημμελή φύλαξη του παιδιού', 13),
(5092, 'Inadequate/ lack of supervision resulting in physical harm', 'Ανεπαρκής ή/και παντελής απουσία φύλαξης του παιδιού που καταλήγει σε σωματική βλάβη', 13),
(5093, 'Persisted lack of supervision concerning substance use/misuse by the child', 'Ανεπαρκής εποπτεία όσον αφορά τη χρήση ουσιών από το παιδί', 13),
(5094, 'No specific information for omissions related to the child’s supervision', 'Μη ακριβείς πληροφορίες για παραλείψεις που σχετίζονται με την φύλαξη του παιδιού', 13),
(5095, 'Refusal of custody/abandonment', 'Άρνηση κηδεμονίας/ Εγκατάλειψη', 13),
(5096, 'Unstable custody arrangements', 'Ασταθές πρόγραμμα φύλαξης του παιδιού', 13),
(5097, 'Illegal transfers of custody', 'Παράνομη μεταβίβαση κηδεμονίας', 13),
(5098, 'Refusal of custody', 'Άρνηση κηδεμονίας', 13),
(5099, 'Abandonment (primary caregiver(s) runaway / migrate and leave the children behind)', 'Εγκατάλειψη (βασικοί φροντιστές/-στριες φεύγουν μακριά/ μεταναστεύουν και εγκαταλείπουν το παιδί)', 13),
(5100, 'children out of wedlock', 'παιδί εκτός γάμου', 13),
(5101, 'children with disabilities', 'παιδί με αναπηρία', 13),
(5102, 'No specific information for omissions related child’s refusal of custody', 'Μη ακριβείς πληροφορίες για παραλείψεις που σχετίζονται με την κηδεμονία του παιδιού', 13),
(5103, 'Please record the Place of Incident', 'Παρακαλώ καταγράψτε το χώρο όπου αναφέρεται ότι έλαβε χώρα το περιστατικό', 13),
(5104, 'Unknown/ Unspecified place', 'Απροσδιόριστο', 13),
(5105, 'Home/ Family', 'Στο σπίτι του παιδιού', 13),
(5106, 'Home/ Relatives', 'Σε σπίτι συγγενών', 13),
(5107, 'Home/ Friends', 'Σε φιλικό σπίτι', 13),
(5108, 'Child care institution (residential care)', 'Σε ίδρυμα κλειστής φιλοξενίας/ στέγη παιδιού', 13),
(5109, 'Child care institution (day care)', 'Σε παιδικό σταθμό ή ανάλογη δομή ημερήσιας φροντίδας παιδιών', 13),
(5110, 'Detention or correctional institution', 'Σε κατάστημα κράτησης ή παρόμοιο χώρο', 13),
(5111, 'Leisure/ Playground/ Recreational area', 'Σε παιδική χαρά/ άλλο χώρο αναψυχής', 13),
(5112, 'Sports-athletics', 'Σε γυμναστήριο/ άλλες αθλητικές εγκαταστάσεις', 13),
(5113, 'School', 'Στο σχολείο', 13),
(5114, 'Educational institution', 'Σε εκπαιδευτική δομή άλλη από σχολείο (π.χ. φροντιστήριο)', 13),
(5115, 'Medical Services', 'Υπηρεσία παροχής φροντίδας Υγείας', 13),
(5116, 'Public transportation', 'Σε μέσο μαζικής μεταφοράς', 13),
(5117, 'Public place/ street, commercial & surrounding area', 'Σε εμπορική περιοχή/ δρόμο ή άλλο δημόσιο χώρο', 13),
(5118, 'Other place', 'Αλλού', 13),
(5119, 'GO -> C2', 'Μετάβαση -> C2', 13),
(5120, 'Click as many as applicable', 'Επιλέξτε όλα όσα ισχύουν', 13),
(5121, 'Please record Child’s Sex, Date of Birth and Citizenship Status', 'Καταγράψτε φύλο, ημερομηνία γέννησης και κατάσταση υπηκοότητας του παιδιού', 13),
(5122, 'Male', 'Άρρεν', 13),
(5123, 'Female', 'Θήλυ', 13),
(5124, 'Not known', 'Άγνωστο', 13),
(5125, 'Check ONE from the list below', 'Επιλέξτε ΕΝΑ από τη λίστα που ακολουθεί', 13),
(5126, 'Child’s Date of Birth', 'Ημερομηνία γέννησης του παιδιού', 13),
(5127, '<18 years old (if no year is known)', '<18 χρονών (εάν το έτος γέννησης δεν είναι γνωστό)', 13),
(5128, '<18 years old', '<18 χρονών', 13),
(5129, '>18 (\"minor\" according to legislation)', '', 13),
(5130, '>18 years old', '>18 χρονών', 13),
(5131, 'Unborn', 'Αγέννητο', 13),
(5132, 'Please record the full date of birth:', 'Παρακαλώ συμπληρώστε την ημερομηνία γέννησης:', 13),
(5133, 'YYYY-MM-DD', 'ΕΕΕΕ-ΜΜ-ΗΗ', 13),
(5134, 'If DD is unknown:', 'Εάν η ημέρα (ΗΗ) δεν είναι γνωστή:', 13),
(5135, 'YYYY-MM', 'ΕΕΕΕ-ΜΜ', 13),
(5136, 'If MM-DD are unknown:', 'Εάν ο μήνας (ΜΜ) και η ημέρα (ΗΗ) δεν είναι γνωστά:', 13),
(5137, 'If YYYY-MM-DD are unknown AND the alleged victim is a child:', 'Εάν ΕΕΕΕ-ΜΜ-ΗΗ δεν είναι γνωστά και το φερόμενο θύμα είναι ανήλικο:', 13),
(5138, '<18', '<18', 13),
(5139, 'Citizenship Status', 'Υπηκοότητα', 13),
(5140, 'Not a citizen', 'Χωρίς υπηκοότητα', 13),
(5141, 'Citizen', 'Υπήκοος', 13),
(5142, 'with ID', 'με επίσημη αναγνώριση', 13),
(5143, 'Citizen with ID', 'Υπήκοος με επίσημη αναγνώριση', 13),
(5144, 'without ID', 'χωρίς επίσημη αναγνώριση', 13),
(5145, 'Citizen without ID', 'Υπήκοος χωρίς επίσημη αναγνώριση', 13),
(5146, 'Unaccompanied foreign child or refugee', 'Ασυνόδευτο αλλοδαπό παιδί ή πρόσφυγας', 13),
(5147, 'Check ONE from the list below. If the child is “Citizen”, please define in sub-list', 'Επιλέξτε ΕΝΑ από τη λίστα που ακολουθεί. Εάν το παιδί έχει υπηκοότητα, παρακαλώ προσδιορίστε:', 13),
(5148, 'Please record Family Composition and indicate up to two Primary Caregivers', 'Καταγράψτε τη σύνθεση της οικογένειας & υποδείξτε μέχρι 2 ενήλικα άτομα ως βασικούς/-ές φροντιστές/-στριες ΟΤΑΝ ΣΥΝΕΒΗ ΤΟ ΠΕΡΙΣΤΑΤΙΚΟ', 13),
(5149, 'A: Type of Family', 'Α. Τύπος οικογένειας', 13),
(5150, 'Boarder(s) (child lives in residential/institutional care)', 'Το παιδί ζει σε ίδρυμα κλειστής προτασίας (οικότροφος)', 13),
(5151, 'Child lives with his/her family (including biological/ adoptive)', 'Το παιδί ζει με την οικογένειά του (βιολογική ή θετή)', 13),
(5152, 'Child lives in a foster family', 'Το παιδί ζει σε ανάδοχη οικογένεια', 13),
(5153, 'Child lives in a re-composed family', 'Το παιδί ζει σε οικογένεια με γονιό που ξαναπαντρεύτηκε', 13),
(5154, 'Child lives in a family other than its family/ foster family', 'Το παιδί ζει σε οικογένεια άλλη από την οικογένειά του ή ανάδοχη οικογένεια', 13),
(5155, 'Relatives’ family', 'σε συγγενική οικογένεια', 13),
(5156, 'Child lives in a family other than its family/ foster family - Relatives’ family', 'Το παιδί ζει σε οικογένεια άλλη από την οικογένειά του ή ανάδοχη οικογένεια - σε συγγενική οικογένεια', 13),
(5157, 'Friends’ family', 'σε φιλική οικογένεια', 13),
(5158, 'Child lives in a family other than its family/ foster family - Friends’ family', 'Το παιδί ζει σε οικογένεια άλλη από την οικογένειά του ή ανάδοχη οικογένεια - σε φιλική οικογένεια', 13),
(5159, 'SKIP “B”; GO -> F3', 'Μετάβαση -->F3', 13),
(5160, 'If you DON\'T chose Boarder(s) -> B: Members of Family', 'Εάν ΔΕΝ επιλέξετε \"Οικότροφος\", προχωρήστε στη συμπλήρωση του \"Β: Μέλη της Οικογένειας\"', 13),
(5161, 'B: Member(s) of Family', 'Β: Μέλη της Οικογένειας', 13),
(5162, 'Number', 'Αριθμός', 13),
(5163, 'Primary caregiver(s)', 'Ενήλικα άτομα-Βασικοί Φροντιστές/-τριες του παιδιού ΟΤΑΝ ΣΥΝΕΒΗ ΤΟ ΠΕΡΙΣΤΑΤΙΚΟ', 13),
(5164, 'Parent(s)', 'Γονέας/-είς', 13),
(5165, 'Step Parent(s)', 'Θετός/-οί Γονέας/-είς', 13),
(5166, 'Parent(s)’ partner(s)', 'Σύντροφος/-οι Γονέα/-έων', 13),
(5167, 'Sibling(s)', 'Αδέλφια', 13),
(5168, 'Younger than the (alleged) victim', 'Νεώτερο από το παιδί (αναφερόμενο ως) θύμα', 13),
(5169, 'Older than the (alleged) victim (<18)', 'Μεγαλύτερο από το παιδί (αναφερόμενο ως) θύμα (<18)', 13),
(5170, 'Older than the (alleged) victim (>18)', 'Μεγαλύτερο από το παιδί (αναφερόμενο ως) θύμα (>18)', 13),
(5171, 'Grandparent(s)', 'Παππούς/-ούδες-Γιαγιά/-δες', 13),
(5172, 'Other relative(s)', 'Άλλος/-η/-οι συγγενής/-είς', 13),
(5173, 'Blood relatives', 'Συγγενείς εξ αίματος', 13),
(5174, '<18 [child(ren)]', '<18 (παιδί/-ιά)', 13),
(5175, '>18 [adult(s)]', '>18 (ενήλικος/-η/-ες)', 13),
(5176, 'By law relatives', 'Συγγενείς εξ αγχιστείας', 13),
(5177, 'Family friend(s)', 'Οικογενειακός/-ή/-οί φίλος/-η/-οι/-ες', 13),
(5178, 'Other not-related household members', 'Άλλο/-α μη συγγενικό/-ά άτομο/-α', 13),
(5179, 'Please indicate up to 2 child’s primary caregiver(s) (you can uncheck)', 'Παρακαλώ υποδείξτε μέχρι και 2 βασικούς/-ές φρονιστές/-στριες ΟΤΑΝ ΣΥΝΕΒΗ ΤΟ ΠΕΡΙΣΤΑΤΙΚΟ (αν επιλέξετε λάθος, μπορείτε να απο-επιλέξετε)', 13),
(5180, 'members', 'μέλη', 13),
(5181, 'member family', 'μέλη στην οικογένεια', 13),
(5182, 'Please record Caregiver(s) Relationship to Child, Sex and Date of Birth', 'Καταγράψτε για έως και 2 ενήλικα άτομα-βασικούς φροντιστές ΟΤΑΝ ΣΥΝΕΒΗ ΤΟ ΠΕΡΙΣΤΑΤΙΚΟ φύλο, ημερομηνία γέννησης και τη σχέση τους με το παιδί', 13),
(5183, 'Relationship to Child', 'Σχέση με το παιδί', 13),
(5184, '1st Caregiver', '1ος/-η Βασικός Φροντιστής/-στρια ΟΤΑΝ ΣΥΝΕΒΗ ΤΟ ΠΕΡΙΣΤΑΤΙΚΟ', 13),
(5185, 'Professional Caregiver', 'Επαγγελματίας Φροντιστής/-στρια', 13),
(5186, 'Temporary caregiver/Other', 'Προσωρινός/-ή Φροντιστής/-στρια/ Άλλο', 13),
(5187, 'Unknown relationship', 'Άγνωστη σχέση', 13),
(5188, 'Check ONE per Caregiver', 'Κάντε ΜΙΑ επιλογή ανά Φροντιστή', 13),
(5189, 'Caregiver(s) Sex', 'Φύλο Φροντιστή/-στριας', 13),
(5190, 'Caregiver(s) DoB', 'Ημερομηνία γέννησης Φροντιστή/-στριας', 13),
(5191, 'YY', 'ΔΔ', 13),
(5192, '\'s', '', 13),
(5193, 'YY-MM-DD', 'ΕΕ-ΜΜ-ΗΗ', 13),
(5194, 'If YYYY-MM-DD are unknown then record the decade:', 'Εάν το έτος (ΕΕΕΕ), ο μήνας (ΜΜ) και η ημέρα (ΗΗ) δεν είναι γνωστά, συμπληρώστε δεκαετία (ΔΔ):', 13),
(5195, 'If DECADE is unknown, then:', 'Εάν η δεκαετία (ΔΔ) δεν είναι γνωστή, τότε:', 13),
(5196, 'Please record any Institutional Response', 'Παρακαλώ καταγράψτε τις ενέργειες που έγιναν από το Φορέα σας σε συνέχεια του συγκεκριμένου περιστατικού', 13),
(5197, 'No response was required DUE TO CHILD’S DEATH', 'Δεν απαιτήθηκε καμία ενέργεια επειδή το παιδί απεβίωσε', 13),
(5198, 'No Response', 'Καμία ενέργεια', 13),
(5199, 'Yes', 'Ναι', 13),
(5200, 'Immediate intervention(s)', 'Άμεσες παρεμβάσεις', 13),
(5201, 'Physical Medical exam(s)', 'Ιατρική εξέταση του παιδιού', 13),
(5202, 'Mental Health exam(s)', 'Ψυχιατρική εξέταση του παιδιού', 13),
(5203, 'Forensic evaluation initiated', 'Ιατροδικαστική αξιολόγηση', 13),
(5204, 'Child protection /welfare services assessment', 'Αξιολόγηση συνθηκών διαβίωσης', 13),
(5205, 'Police intervention', 'Άμεση παρέμβαση Αστυνομίας', 13),
(5206, 'Action taken -NO COURT INVOLVEMENT', 'Ενέργειες που πραγματοποιήθηκαν - ΧΩΡΙΣ ΑΝΑΜΙΞΗ ΔΙΚΑΣΤΙΚΩΝ ΑΡΧΩΝ', 13),
(5207, 'Child remains in family with planned intervention', 'Παραμονή του παιδιού στην οικογένεια με προγραμματισμένη παρέμβαση', 13),
(5208, 'Emergency placement', 'Απομάκρυνση του παιδιού από την οικογένεια και άμεση τοποθέτηση (σε δομή ή άλλη οικογένεια)', 13),
(5209, 'Supportive intervention for current caregiver(s)', 'Υποστηρικτική παρέμβαση για τους/τις φροντιστές/-στριες', 13),
(5210, 'Mother/child shelter with parent and child together', 'Φιλοξενία του παιδιού σε ξενώνα κακοποιημένων γυναικών μαζί με τη μητέρα', 13),
(5211, 'Police emergency protection procedures', 'Λήψη άμεσων μέτρων προστασίας από την Αστυνομία (ασφαλιστικά μέτρα)', 13),
(5212, 'CPS/welfare services emergency protection procedures', 'Άμεσες ενέργειες από Κοινωνική Υπηρεσία (ενημέρωση Εισαγγελέα για διερεύνηση)', 13),
(5213, 'Referral to child protection /welfare services', 'Παραπομπή σε Υπηρεσία Παιδικής Προστασίας/ Ευημερίας', 13),
(5214, 'Action taken -COURT or EQUIVALENT AUTHORITY TO THE COURT INVOLVEMENT', 'Ενέργειες που πραγματοποιήθηκαν - ΜΕ ΑΝΑΜΙΞΗ ΔΙΚΑΣΤΙΚΩΝ Ή ΑΝΤΙΣΤΟΙΧΩΝ ΑΡΧΩΝ', 13),
(5215, '(Family) Court measures initiated', 'Εκκίνηση διερεύνησης με Εισαγγελική εντολή', 13),
(5216, 'Action to protect victim by court order(s)', 'Ενέργειες προστασίας θύματος με Εισαγγελική εντολή/ Δικαστική απόφαση', 13),
(5217, 'Action to remove parent(s)’ rights', 'Ενέργειες για αφαίρεση γονικών δικαιωμάτων', 13),
(5218, 'Expulsion of (alleged) abuser from home', 'Απομάκρυνση του/της δράστη/-στριας από το σπίτι με Δικαστική απόφαση', 13),
(5219, 'Action to prosecute perpetrator(s)', 'Δίωξη του/της δράστη/-στριας', 13),
(5220, 'Out of home placement', 'Τοποθέτηση του παιδιού εκτός οικογένειας', 13),
(5221, 'Kinship Care (relatives/extended family)', 'Τοποθέτηση σε συγγενική φροντίδα (συγγενείς/ διευρυμένη οικογένεια)', 13),
(5222, 'Foster Care', 'Τοποθέτηση σε ανάδοχη οικογένεια', 13),
(5223, 'Children’s Home Institution', 'Τοποθέτηση σε στέγη/ ίδρυμα κλειστής φροντίδας', 13),
(5224, 'Adoption with parents’ agreement', 'Τεκνοθεσία με τη σύμφωνη γνώμη των γονέων/ κηδεμόνων', 13),
(5225, 'Adoption by court order', 'Τεκνοθεσία με Δικαστική απόφαση', 13),
(5226, 'GO -> S2', 'Μετάβαση -> S2', 13),
(5227, 'Check below as many as applicable', 'Παρακαλώ επιλέξτε όλα όσα ισχύουν', 13),
(5228, 'Please record any Referral(s) made to Services by you/your agency', 'Παρακαλώ καταγράψτε τις παραπομπές που έγιναν από εσάς ή/και τον Φορέα σας σε άλλες Υπηρεσίες', 13),
(5229, 'None', 'Δεν έγινε παραπομπή', 13),
(5230, 'Judicial Services', 'Υπηρεσίες Δικαιοσύνης', 13),
(5231, 'for child ONLY', 'ΜΟΝΟ για το παιδί', 13),
(5232, 'for caregiver(s) ONLY', 'ΜΟΝΟ για φροντιστές/-στριες', 13),
(5233, 'for child AND family', 'για το παιδί ΚΑΙ την οικογένεια', 13),
(5234, 'Mental Health Services', 'Υπηρεσίες Ψυχικής Υγείας', 13),
(5235, 'Independent Authorities', 'Ανεξάρτητη Αρχή', 13),
(5236, 'Social Welfare Services', 'Υπηρεσίες Κοινωνικής Ευημερίας', 13),
(5237, 'Law Enforcement related Services', 'Υπηρεσίες Προστασίας των Πολιτών', 13),
(5238, 'Community Organizations and NGOs', 'Κοινοτικοί και Μη Κυβερνητικοί Οργανισμοί', 13),
(5239, 'Existing Registries and Research Organizations', 'Υπάρχοντα συστήματα καταγραφής και Ερευνητικοί Οργανισμοί', 13),
(5240, 'Educational Services', 'Υπηρεσίες Εκπαίδευσης', 13),
(5241, 'Other related Services', 'Άλλες σχετικές Υπηρεσίες', 13),
(5242, 'End of Record', 'Ολοκλήρωση καταγραφής περιστατικού', 13),
(5243, 'CHECK RECORD OPTIONS', 'ΕΛΕΓΧΟΣ ΚΑΤΑΓΡΑΦΗΣ ΠΡΙΝ ΤΗΝ ΥΠΟΒΟΛΗ', 13),
(5244, 'Please check the record options', 'Παρακαλώ ελέγξτε τις πληροφορίες που καταγράψατε', 13),
(5245, 'You can make any changes by navigating throught the right panel!', 'Χρησιμοποιήστε τη στήλη δεξιά ως πλοηγό για να δείτε τις πληροφορίες που έχετε καταγράψει και να κάνετε αλλαγές, εφόσον χρειάζεται!', 13),
(5246, 'Incident', 'Περιστατικό', 13),
(5247, 'ID', 'ID', 13),
(5248, 'Sex', 'Φύλο', 13),
(5249, 'Date of birth', 'Ημερομηνία γέννησης', 13),
(5250, 'Family and Caregiver(s)', 'Οικογένεια και Φροντιστές', 13),
(5251, 'Services', 'Υπηρεσίες', 13),
(5252, 'Submit Record', 'Υποβολή Καταγραφής', 13),
(5253, 'Loading', 'Ζεμάτισμα', 13),
(5254, 'RECORD COMPLETED', 'Η ΚΑΤΑΓΡΑΦΗ ΤΟΥ ΠΕΡΙΣΤΑΤΙΚΟΥ ΟΛΟΚΛΗΡΩΘΗΚΕ', 13),
(5255, 'Display/print the record', 'Εμφάνιση/ Εκτύπωση της καταγραφής αυτού του περιστατικού', 13),
(5256, 'Report', 'Αναφορά', 13),
(5257, 'RECORD', 'ΚΑΤΑΓΡΑΦΗ', 13),
(5258, 'Agency', 'Φορέας', 13),
(5259, 'Information provided by', 'Οι πληροφορίες παρασχέθηκαν από', 13),
(5260, 'Age at the date of incident', 'Ηλικία κατά την ημερομηνία που έλαβε χώρα το περιστατικό', 13),
(5261, 'Age at the date of recording', 'Ηλικία κατά την ημερομηνία καταγραφής', 13),
(5262, 'Type of family', 'Τύπος οικογένειας', 13),
(5263, 'Family\'s member(s)', 'Μέλη της οικογένειας', 13),
(5264, '1st', '1ο', 13),
(5265, 'born', 'γεννήθηκε', 13),
(5266, '2nd', '2ο', 13),
(5267, 'Back', 'Επιστροφή', 13),
(5268, 'KNOWN CHILD', 'ΗΔΗ ΓΝΩΣΤΗ ΠΕΡΙΠΤΩΣΗ (ΠΑΙΔΙ για το οποίο υπάρχει προηγούμενη καταγραφή)', 13),
(5269, 'EXISTING CHILD RECORD', 'ΗΔΗ ΚΑΤΑΧΩΡΗΜΕΝΟ ΠΑΙΔΙ', 13),
(5270, 'You are going to proceed with the record of a new CM incident for  the child', 'Πρόκειται να προχωρήσετε στην καταγραφή νέου περιστατικού (υποψίας) κακομεταχείρισης για το παιδί', 13),
(5271, 'Please proceed with checking of', 'Παρακαλώ προχωρήστε ελέγχοντας τα', 13),
(5272, 'TIP: Update –if needed', 'Χρήσιμη Συμβουλή: Εάν θεωρείτε ότι χρειάζεται, ενημερώστε την υπάρχουσα καταγραφή!', 13),
(5273, 'Known Incidents', 'Ήδη καταγεγραμμένα περιστατικά', 13),
(5274, 'The incident you are trying to record might already exist!', 'Το περιστατικό που προσπαθείτε να καταγράψετε μπορεί να υπάρχει ήδη!', 13),
(5275, 'Please check the incident record(s) below', 'Παρακαλώ ελέγξτε τα ήδη καταγεγραμμένα περιστατικά παρακάτω', 13),
(5276, 'for Child\'s ID:', 'για το ID του Παιδιού:', 13),
(5277, 'and Date of Incident:', 'και Ημερομηνία που έλαβε χώρα το Περιστατικό:', 13),
(5278, 'Date-Time of Record', 'Ημερομηνία και Ώρα Καταγραφής', 13),
(5279, 'Display', 'Εμφάνιση', 13),
(5280, 'Add new incident', 'Προσθήκη νέου περιστατικού', 13);

CREATE TABLE `u_translate_admin` (
  `id` int(11) NOT NULL,
  `hash` varchar(255) NOT NULL,
  `text` varchar(255) NOT NULL,
  `language_id` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `u_translate_admin` (`id`, `hash`, `text`, `language_id`) VALUES
(1, 'b3c5827f54218753bb2c3338236446c2', 'Operatori', 4),
(2, 'eeb9c5485b9274991ca2ff2b99fa76bf', 'Editeaza Operatori', 4),
(3, '3e47a1dfb30c0aec597c30261df9a0fe', 'Creeaza Operator', 4),
(4, 'f6039d44b29456b20f8f373155ae4973', 'Username', 4),
(5, 'dc647eb65e6711e155375218212b3964', 'Parola', 4),
(6, '6c7195551da0802a39b5e2bc7187df54', 'Alege navigare', 4),
(7, '1a445bc7ae5dc7e8811f6415c9b52e31', 'Management CAN-MDS-SS', 4),
(8, '13348442cc6a27032d2b4aa28b75a5d3', 'Cauta', 4),
(9, '75ec3e55a77288b4a132f7528619817b', 'Agentie', 4),
(10, '614003718464443c79f99d4641abc1df', 'Editeaza Agentie', 4),
(11, '5241da7ad22c15cb6fbe5aff0c90e320', 'Creeaza Agentie', 4),
(12, '59716c97497eb9694541f7c3d37b1a4d', 'Tara', 4),
(13, '428939f42a9ed1c5cb3ca533aa9d6cd8', 'Editeaza Tara', 4),
(14, 'e7dd12373d62df6ddfc9e6536d497ec5', 'Creeaza Tara', 4),
(15, '3a08e2e340ab29fd9263af48193cbf8e', 'Limbi', 4),
(16, 'd6928f0da8416cf6101e706e0abacc53', 'Editeaza Limbi', 4),
(17, 'cece4eed6238505f3027355df320d75e', 'Creeaza Limbi', 4),
(18, 'bf56e2022db795bf7aa86acfa470a399', 'Ocupatii', 4),
(19, '71780c189d4853095744a9ec1bdcf4d5', 'Editeaza Ocupatii', 4),
(20, '8bfa0d3827e490f31e7c83ba570c16f8', 'Creeaza ocupatii', 4),
(21, 'd6b258792ff06f82933c74eeb8aef591', 'Organizatie', 4),
(22, 'e62cdbc3dc833e3005bf1c1cd5a51cc3', 'Editeaza Organizatii', 4),
(23, 'dc175a42f28a118ca86e17792d2e40eb', 'Creeaza Organizatie', 4),
(24, '8f1e77e0d2be21da93cd4d9a939148f7', 'Schimba parola', 4),
(26, '70febc419840ffab3c91c81e9134e375', 'Hello,', 4),
(27, 'd8efa374f5851db4bd14a858135d1118', 'Sunt', 4),
(28, 'f0338453773ed5f09cc82557925a67b5', 'Agentii', 4),
(30, '2dd0664225aa8dc2a94b7b71d10cc22a', 'inregistrat in sistem', 4),
(31, 'a8182ab7ae1169cab49c9d403e76cfd5', 'Informatiile tale', 4),
(32, '91bbc859f6f9423be4658dd4d3aa7234', 'Operatori ID', 4),
(33, '1a9dacea9d384e8d764691d8423cfeab', 'Agentie ID', 4),
(34, 'bcc254b55c4a1babdf1dcb82c207506b', 'Telefon', 4),
(35, 'b5f4d5db869533be8c311d3369cf2f4a', 'Agentia ta', 4),
(36, '7381f5495177edd501235320608eecc0', 'Agentie nume', 4),
(37, 'a110c5c194a15bdec2f8390a8454c3c8', 'Strada', 4),
(38, '070a6f943470aec6d12c7090f290e10f', 'Numar strada', 4),
(39, '59086e95676f4e17bc7b8923f6fe40f1', 'Cod postal', 4),
(40, 'c16dac173aa8377a1c07aed8e0472f7c', 'Oras', 4),
(41, '2e941bd64a09f941a32e82f9efae9710', 'E-mail ID', 4),
(42, '752a9c20f00cd77f7c2aab0a5f7e78d1', 'Ocupatie', 4),
(43, 'b83247733544241528fb86fad6d6334a', 'Nivel de acces', 4),
(45, '49ee3087348e8d44e1feda1917443987', 'Nume', 4),
(46, '8512ae7d57b1396273f76fe6ed341a23', 'limba', 4),
(47, '1e884e3078d9978e216a027ecd57fb34', 'E-mail', 4),
(48, '7dce122004969d56ae2e0245cb754d35', 'Editeaza', 4),
(49, 'ae3bb2a1ac61750150b606298091d38a', 'Parola noua', 4),
(50, '5d5b78699e57104f2fa03bbdf7b9197b', 'Seteaza', 4),
(51, '13586200cec6a0e09263250b17173d9c', 'Perioada INREGISTRARILOR', 4),
(53, '5fb1f955b45e38e31789286a1790398d', 'TOATE', 4),
(54, '68a63290c347f42ffce5b24532833624', 'against self', 4),
(55, '842e5a39b01fadaead6970f5ff5de1d5', 'fizic', 4),
(56, 'c137d413187fccdc2a0e9954df5fbad0', 'sexual', 4),
(57, '3e83b7e2cad4e1c3a978fff44fa6ae20', 'psihologic', 4),
(58, '1022349b4bcb447934fb49084c887af2', 'omisiuni', 4),
(59, 'daab80c5dadc81fa2d019c562f805994', 'Sex', 4),
(60, '63889cfb9d3cbe05d1bd2be5cc9953fd', 'Masculin', 4),
(61, 'b719ce180ec7bd9641fece2f920f4817', 'Feminin', 4),
(62, '6311ae17c1ee52b36e68aaf4ad066387', 'Altele', 4),
(63, '29e43604b33ba5f84473daf2664a4bcf', 'Necunoscut', 4),
(64, 'f95e88f4e27f878eda846e7a4cfa95b9', 'Editeaza Incidente', 4),
(67, '8ba81f1258dd23b956fe923561d2da65', 'tipul_incidentului', 4),
(69, 'f36263a38d7de5cdaa953c1e2b2f79b5', 'ID Copil', 4),
(70, '7a620d438361c15161512c4d98341ef1', 'Subdivizie', 4),
(71, '5916391a654132a460c04967c05d54b2', 'tipul_organizatiei', 4),
(73, '1f1c16d7d257c193410bbcc4237aff4a', 'Numar strada sau loc', 4),
(74, 'b6ae8fbc00355aa62f1a1b6a5a9bee69', 'Numar ID 3 cifre (Operator)', 4),
(75, '4994a8ffeba4ac3140beb89e8d41f174', 'Limba', 4),
(76, 'f2a6c498fb90ee345d997f888fce3b18', 'Sterge', 4),
(77, '9e365dd1fae1b9ecae5a1d220a5fe86f', 'Confirma Stergere', 4),
(78, '4c02263746c1f9db4be5c8a886972338', 'Urmeaza sa stergi un Operator, aceasta procedura este ireversibila', 4),
(79, '33d8fefabfe95e71576a8641d21689ff', 'Vrei sa continui?', 4),
(80, 'ea4788705e6873b424c65e91c2846b19', 'Renunta', 4),
(81, '494757c91b2d7c66e04eb71e6d64133b', 'Operatori ID', 4),
(82, 'ca0dbad92a874b2f69b549293387925e', 'Cod', 4),
(83, 'f109acaa739584b76e9c321b25afba61', 'Agentie nume', 4),
(84, '83f0c30cf9b66b30b7cb1571d65596a9', 'Numar ID 3 cifre', 4),
(86, 'cce99c598cfdb9773ab041d54c3d973a', 'Profil', 4),
(87, '6dd08874f83507e9c7b23f1a46b7fa7c', 'Traducere', 4),
(88, '1860fb17b107cbb39cf6bbfa61130803', 'Editeaza Profil', 4),
(89, 'ce8ae9da5b7cd6c3df2929543a9af92d', 'E-mail', 4),
(90, '83218ac34c1834c26781fe4bde918ee4', 'Bun venit', 4),
(269, 'e490d4a33d555b8204c3bfd182d6ff8b', 'Admin traducere', 4),
(270, '46402d9b6a82fa4d1b7db5dbd1fa1c86', 'Traducere site', 4),
(271, 'e0626222614bdee31951d84c64e5e9ff', 'Selecteaza', 4),
(272, 'b9a2aa483b400156041a502d39ef9221', 'Tip de abuz', 4),
(273, '4351cfebe4b61d8aa5efa1d020710005', 'Afiseaza', 4),
(274, 'b83247733544241528fb86fad6d6334a', 'Επίπεδο πρόσβασης', 1),
(275, 'e490d4a33d555b8204c3bfd182d6ff8b', 'Μετάφραση διαχειριστικού περιβάλλοντος', 1),
(276, '68a63290c347f42ffce5b24532833624', 'κατά του εαυτού', 1),
(277, 'f0338453773ed5f09cc82557925a67b5', 'Φορείς', 1),
(278, '75ec3e55a77288b4a132f7528619817b', 'Φορέας', 1),
(279, '1a9dacea9d384e8d764691d8423cfeab', 'Αναγνωριστικό (ID) Φορέα', 1),
(280, '7381f5495177edd501235320608eecc0', 'Επωνυμία Φορέα', 1),
(281, 'f109acaa739584b76e9c321b25afba61', 'Επωνυμίας του Φορέα', 1),
(282, '5fb1f955b45e38e31789286a1790398d', 'ΟΛΑ', 1),
(283, '1a445bc7ae5dc7e8811f6415c9b52e31', 'Διαχείριση Συστήματος CAN-MDS', 1),
(284, 'ea4788705e6873b424c65e91c2846b19', 'Άκυρο', 1),
(285, '8f1e77e0d2be21da93cd4d9a939148f7', 'Αλλαγή κωδικού πρόσβασης', 1),
(286, 'ca0dbad92a874b2f69b549293387925e', 'Κωδικός', 1),
(287, '9e365dd1fae1b9ecae5a1d220a5fe86f', 'Επιβεβαίωση διαγραφής', 1),
(288, '59716c97497eb9694541f7c3d37b1a4d', 'Χώρα', 1),
(289, '5241da7ad22c15cb6fbe5aff0c90e320', 'Δημιουργία λογαριασμού Φορέα', 1),
(290, 'e7dd12373d62df6ddfc9e6536d497ec5', 'Δημιουργία κωδικού Χώρας', 1),
(291, 'cece4eed6238505f3027355df320d75e', 'Δημιουργία κωδικού Γλώσσας', 1),
(292, '8bfa0d3827e490f31e7c83ba570c16f8', 'Δημιουργία κωδικού Επαγγέλματος', 1),
(293, '3e47a1dfb30c0aec597c30261df9a0fe', 'Δημιουργία λογαριασμού Χρήστη/τριας', 1),
(294, 'dc175a42f28a118ca86e17792d2e40eb', 'Δημιουργία λογαριασμού Φορέα', 1),
(295, 'f2a6c498fb90ee345d997f888fce3b18', 'Διαγραφή', 1),
(296, '33d8fefabfe95e71576a8641d21689ff', 'Θέλετε να προχωρήσετε;', 1),
(297, '7dce122004969d56ae2e0245cb754d35', 'Επεξεργασία', 1),
(298, '614003718464443c79f99d4641abc1df', 'Επεξεργασία λογιαριασμού Φορέα', 1),
(299, '428939f42a9ed1c5cb3ca533aa9d6cd8', 'Επεξεργασία κωδικού Χώρας', 1),
(300, 'f95e88f4e27f878eda846e7a4cfa95b9', 'Επεξεργασία Συμβάντων', 1),
(301, 'd6928f0da8416cf6101e706e0abacc53', 'Επεξεργασία κωδικού Γλώσσας', 1),
(302, '71780c189d4853095744a9ec1bdcf4d5', 'Επεξεργασία κωδικού Επαγγέλματος', 1),
(303, 'eeb9c5485b9274991ca2ff2b99fa76bf', 'Επεξεργασία λογαριασμού Χρήστη/τριας', 1),
(304, 'e62cdbc3dc833e3005bf1c1cd5a51cc3', 'Επεξεργασία τύπου Φορέα', 1),
(305, '1860fb17b107cbb39cf6bbfa61130803', 'Επεξεργασία προφίλ', 1),
(306, 'b719ce180ec7bd9641fece2f920f4817', 'Θήλυ', 1),
(307, '70febc419840ffab3c91c81e9134e375', 'Γεια σας,', 1),
(308, '8512ae7d57b1396273f76fe6ed341a23', 'γλώσσα', 1),
(309, '4994a8ffeba4ac3140beb89e8d41f174', 'Γλώσσα', 1),
(310, '3a08e2e340ab29fd9263af48193cbf8e', 'Γλώσσες', 1),
(311, '63889cfb9d3cbe05d1bd2be5cc9953fd', 'Άρρεν', 1),
(312, '49ee3087348e8d44e1feda1917443987', 'Όνομα', 1),
(313, 'ae3bb2a1ac61750150b606298091d38a', 'Νέος κωδικός πρόσβασης', 1),
(314, '29e43604b33ba5f84473daf2664a4bcf', 'Άγνωστο', 1),
(315, '752a9c20f00cd77f7c2aab0a5f7e78d1', 'Επάγγελμα', 1),
(316, 'bf56e2022db795bf7aa86acfa470a399', 'Επαγγέλματα', 1),
(317, '1022349b4bcb447934fb49084c887af2', 'παραλείψεις στη φροντίδα', 1),
(318, '91bbc859f6f9423be4658dd4d3aa7234', 'Αναγνωριστικό (ID) Χρήστη/τριας', 1),
(319, '494757c91b2d7c66e04eb71e6d64133b', 'Αναγνωριστικού (ID) Χρήστη/τριας', 1),
(320, 'b3c5827f54218753bb2c3338236446c2', 'Χρήστες/Χρήστριες', 1),
(321, 'd6b258792ff06f82933c74eeb8aef591', 'Φορέας', 1),
(322, '6311ae17c1ee52b36e68aaf4ad066387', 'Άλλο', 1),
(323, 'dc647eb65e6711e155375218212b3964', 'Κωδικός Πρόσβασης', 1),
(324, '13586200cec6a0e09263250b17173d9c', 'Περίοδος Καταγραφής', 1),
(325, 'bcc254b55c4a1babdf1dcb82c207506b', 'Τηλέφωνο', 1),
(326, '842e5a39b01fadaead6970f5ff5de1d5', 'σωματική', 1),
(327, '59086e95676f4e17bc7b8923f6fe40f1', 'Ταχυδρομικός Κώδικας', 1),
(328, 'cce99c598cfdb9773ab041d54c3d973a', 'Προφιλ', 1),
(329, '3e83b7e2cad4e1c3a978fff44fa6ae20', 'ψυχολογική', 1),
(331, '2dd0664225aa8dc2a94b7b71d10cc22a', 'στο σύστημα.', 1),
(332, '13348442cc6a27032d2b4aa28b75a5d3', 'Στατιστικά', 1),
(333, 'e0626222614bdee31951d84c64e5e9ff', 'Επιλογή', 1),
(334, 'daab80c5dadc81fa2d019c562f805994', 'Φύλο', 1),
(335, 'c137d413187fccdc2a0e9954df5fbad0', 'σεξουαλική', 1),
(336, '46402d9b6a82fa4d1b7db5dbd1fa1c86', 'Μετάφραση περιβάλλοντος Χρηστών/τριών', 1),
(337, 'a110c5c194a15bdec2f8390a8454c3c8', 'Οδός', 1),
(338, '070a6f943470aec6d12c7090f290e10f', 'Αριθμός', 1),
(339, '1f1c16d7d257c193410bbcc4237aff4a', 'Αριθμός', 1),
(340, '7a620d438361c15161512c4d98341ef1', 'Γεωγραφική περιοχή', 1),
(341, '83f0c30cf9b66b30b7cb1571d65596a9', 'Τριψήφιος Αναγνωριστικός (ID) Αριθμός ', 1),
(342, 'b6ae8fbc00355aa62f1a1b6a5a9bee69', 'Τριψήφιος Αναγνωριστικός (ID) Αριθμός Χρήστη/τριας', 1),
(343, '6c7195551da0802a39b5e2bc7187df54', 'Εναλλαγή πλοήγησης', 1),
(344, 'c16dac173aa8377a1c07aed8e0472f7c', 'Πόλη', 1),
(345, '6dd08874f83507e9c7b23f1a46b7fa7c', 'Μετάφραση', 1),
(346, 'b9a2aa483b400156041a502d39ef9221', 'Τύπος κακοποίησης', 1),
(347, '8ba81f1258dd23b956fe923561d2da65', 'τύπος_περιστατικού', 1),
(348, '5916391a654132a460c04967c05d54b2', 'τύπος_Φορέα', 1),
(349, 'f6039d44b29456b20f8f373155ae4973', 'Όνομα Χρήστη/τριας', 1),
(350, '4351cfebe4b61d8aa5efa1d020710005', 'Προβολή', 1),
(351, '83218ac34c1834c26781fe4bde918ee4', 'Καλώς ορίσατε!', 1),
(352, '4c02263746c1f9db4be5c8a886972338', 'Πρόκειται να διαγράψετε ένα λογαριασμό Χρήστη/τριας. Αυτή η διαδικασία είναι μη αναστρέψιμη!', 1),
(353, 'b5f4d5db869533be8c311d3369cf2f4a', 'Ο Φορέας σας', 1),
(354, 'a8182ab7ae1169cab49c9d403e76cfd5', 'Οι πληροφορίες σας', 1),
(356, 'd8efa374f5851db4bd14a858135d1118', 'Υπάρχουν 38', 1),
(357, 'c33e404a441c6ba9648f88af3c68a1ca', 'Statistici', 4),
(358, '662528312baf38a60f258d903ef369d6', 'Creeaza Cont Agentie', 4),
(359, 'afa3b5206ed742de94dcfccc6a30f199', 'Creeaza Cont Operator', 4),
(360, 'cd7be8e4da4a2211fa0a42c9444a7b21', 'Creeaza cod tara nou', 4),
(361, 'fc7017fb33f5dddd79d98825892dfa51', 'Creeaza Limba', 4),
(362, '6cfb8b8aa3fdce38e675819691b48f5c', 'Creeaza tip nou', 4),
(363, '14151ea9f23ba5c2e2e42204b717fdbc', 'Data Inregistrare', 4),
(364, '06e981a2d2ec497221ce8d27b73a8f25', 'Data Incident', 4),
(365, '7275693a65a2386ad746b0a7a5b82e15', 'Tipul incidentului', 4),
(366, '2300e126395c693c5b52c227ec2a5248', 'ID_copil', 4),
(368, '921df56002ee5dc960debedc8ae06072', 'INREGISTRARE', 4),
(372, '42b216a83db155f2dac6a7a808475488', 'ID Incident', 4),
(374, 'b718adec73e04ce3ec720dd11a06a308', 'ID', 4),
(377, '88183b946cc5f0e8c96b2e66e1c74a7e', 'Necunoscut', 4),
(382, '4a0ced33ef669eafaf6250f8a5f3a689', 'Tipul familiei', 4),
(389, '124617f0ad4a4ecb40ac0b9dcad97ed9', 'Incident', 4),
(390, '67e6e5858993448ab7ed1a1003529445', 'Data Incident', 4),
(395, '992a0f0542384f1ee5ef51b7cf4ae6c4', 'Servicii', 4),
(399, 'da36cfaf48b9e19896e23e1207040d1e', 'luni', 4),
(400, '44fdec47036f482b68b748f9d786801b', 'zile', 4),
(404, '7d637d275668ed6d41a9b97e6ad3a556', 'age', 4),
(411, 'd55669822f1a8cf72ec1911e462a54eb', 'pentru', 4),
(417, '6adf97f83acf6453d4a6a4b1070f3754', 'Niciunul', 4),
(440, '4bbfe52be0397513327132a28a2fba2d', 'Conturi agentii', 4),
(441, 'f60a3c6183496609617f4ba2639b4ff4', 'Afiseaza & editeaza cont Agentie', 4),
(442, '38b3d64a566bb4337b624f87c46a32ff', 'Contul Operatorilor', 4),
(443, 'f932b02057ca6970e9f3e15c8dba64fd', 'Afiseaza & editeaza cont Operator', 4),
(444, 'b11fb06ead01ff04523c8e3ee952263c', 'Statistici CAN-MDS', 4),
(445, '503360433b87bf377a17916946a90b12', 'Profil admin & sistem', 4),
(446, 'bc09b552527231f49a320e71c5ddd6a4', 'Afiseaza & editeaza profil Admin', 4),
(447, '119680ae68afc9b678a1ceb6bb1ecd40', 'Schimba parola Admin', 4),
(448, '43460636ffeec024b91d6eb35af26d30', 'Date secundare pentru crearea unor noi conturi', 4),
(449, '790d59ef178acbc75d233bf4211763c6', 'Tari', 4),
(450, '908b28677cc79e0fe3ca52c7327c0556', 'Afiseaza codurile 2 Alpha ale Tarilor', 4),
(451, '51191c2496e3cac07fc8bb6f7112317f', 'Clasificarea Ocupatiilor', 4),
(452, '46e4c16e499315858db8b421ff6807ef', 'Afiseaza clasificari&cauta cod', 4),
(453, 'd0afd6efbc95a5de38cce630155e52aa', 'Subdivizii', 4),
(454, 'b6953f43780ad0de24ae79f892db0176', 'Afiseaza&editeaza coduri subdivizii', 4),
(455, 'a7386900f9c83931103381af61aaafb3', 'Afiseaza & editeaza Limbi', 4),
(456, '6a173fd91e6da0859b1d9de118d19ca6', 'Tip de organizatie', 4),
(457, '8e2bae6fcf0a34e7b12af874f6602139', 'Afiseaza clasificari&cauta cod', 4),
(458, '8713ab100a251f0c7505eff111ce9a17', 'Nivel de acces', 4),
(459, '2a1596f614702a29e732fdd7f57e2e26', 'Afiseaza nivelele drepturilor de acces si indica nivelul de acces adecvat', 4),
(460, '16b639ca335b241b224889bfda57abaa', 'Trimite notificari', 4),
(461, 'ce148c9b6c129dc6e45c00f6b7f4af75', 'afiseaza toate notificarile', 4),
(462, 'deb69c74ce8e37496bab339ad7d10905', 'View & Edit translation of admin interface', 4),
(463, 'f31817c128373efd882eade94f455b39', 'View & Edit translation of Operators\' interface', 4),
(464, 'b821c62f6d594c60e559baea365e6821', 'Se poate descarca', 4),
(465, 'e2c06fee97ab5f7e9dc55588113e820a', 'Manualul administratorului CAN-MDS', 4),
(466, 'e21bddf8a7f04b1a0ff58b513626d224', 'Manualul operatorului CAN-MDS', 4),
(467, '28b993ce06bf3fcdfb81b6257d79c808', 'Manualul de colectare a datelor CAN-MDS', 4),
(468, '9aa698f602b1e5694855cee73a683488', 'Contacte', 4),
(469, 'd3d2e617335f08df83599665eef8a418', 'Inchide', 4),
(470, '719a9aa2ccf126f36f979827f8d473a4', 'Contacteaza', 4),
(471, '19033fa8ff5c244682d92ed5f8f3d582', 'PENTRU toti Operatorii', 4),
(472, 'a274f4d4670213a9045ce258c6c56b80', 'Notificari', 4),
(473, '3e827076ee15c77c9d7cdab47feeab8d', 'Trimite Data', 4),
(474, 'c7892ebbb139886662c6f2fc8c450710', 'Subiect', 4),
(475, '9dffbf69ffba8bc38bc4e01abf4b1675', 'Text', 4),
(491, 'deb69c74ce8e37496bab339ad7d10905', 'View & Edit translation of admin interface', 3),
(492, 'f31817c128373efd882eade94f455b39', 'View & Edit translation of Operators\' interface', 3),
(493, '1a445bc7ae5dc7e8811f6415c9b52e31', 'CAN-MDS-SS Management-MAIN MENU', 3),
(494, 'bc09b552527231f49a320e71c5ddd6a4', 'Προβολή και Επεξεργασία προφίλ Διαχειριστή/τριας', 1),
(495, 'f60a3c6183496609617f4ba2639b4ff4', 'Προβολή & Επεξεργασία Λογαριασμού Φορέα', 1),
(496, 'a7386900f9c83931103381af61aaafb3', 'Προβολή & επεξεργασία Γλωσσών', 1),
(497, 'f932b02057ca6970e9f3e15c8dba64fd', 'Προβολή και Επεξεργασία Λογαριασμού Χρηστών/τριών', 1),
(498, 'deb69c74ce8e37496bab339ad7d10905', 'Προβολή & Επεξεργασία διεπιφάνειας Διαχειριστή/τριας', 1),
(499, 'f31817c128373efd882eade94f455b39', 'Προβολή & Επεξεργασία Διεπιφάνειας Χρήστη/τριας', 1),
(500, 'b6953f43780ad0de24ae79f892db0176', 'Προβολή και Εύρεση Κωδικών Περιοχών', 1),
(501, '2a1596f614702a29e732fdd7f57e2e26', 'Προβολή δικαιωμάτων ανά επίπεδο πρόσβασης και ορισμός πρόσβασης', 1),
(502, 'ce148c9b6c129dc6e45c00f6b7f4af75', 'Προβολή όλων των ειδοποιήσεων', 1),
(503, '46e4c16e499315858db8b421ff6807ef', 'Προβολή ταξινόμησης και εύρεση κωδικών', 1),
(504, '8e2bae6fcf0a34e7b12af874f6602139', 'Προβολή ταξινόμησης και εύρεσης κωδικών', 1),
(505, '908b28677cc79e0fe3ca52c7327c0556', 'Προβολή κωδικών Alpha-2 χωρών', 1),
(506, '503360433b87bf377a17916946a90b12', 'Ταυτότητα Διαχειριστή/τριας και Συστήματος', 1),
(507, '4bbfe52be0397513327132a28a2fba2d', 'Λογιαριασμοί Φορέων', 1),
(508, 'b821c62f6d594c60e559baea365e6821', 'Διαθέσιμα για λήψη', 1),
(509, 'e2c06fee97ab5f7e9dc55588113e820a', 'Αναλυτικός Οδηγός για τον/την Διαχειριστή/τρια', 1),
(510, '28b993ce06bf3fcdfb81b6257d79c808', 'CAN-MDS Οδηγός Συλλογής Δεδομένων', 1),
(511, 'e21bddf8a7f04b1a0ff58b513626d224', 'CAN-MDS Εγχειρίδιο Χρήστη/τριας', 1),
(512, 'b11fb06ead01ff04523c8e3ee952263c', 'CAN-MDS Στατιστικά Στοιχεία', 1),
(513, '119680ae68afc9b678a1ceb6bb1ecd40', 'Αλλαγή κωδικού πρόσβασης Διαχειριστή/τριας', 1),
(514, '9aa698f602b1e5694855cee73a683488', 'Επαφές', 1),
(515, '790d59ef178acbc75d233bf4211763c6', 'Χώρες', 1),
(516, '662528312baf38a60f258d903ef369d6', 'Δημιουργία λογαριασμού Φορέα', 1),
(517, 'fc7017fb33f5dddd79d98825892dfa51', 'Δημιουργία κωδικού Γλώσσας', 1),
(518, 'cd7be8e4da4a2211fa0a42c9444a7b21', 'Δημιουργία νέου κωδικού χώρας', 1),
(519, '6cfb8b8aa3fdce38e675819691b48f5c', 'Δημιουργία νέου τύπου', 1),
(520, 'afa3b5206ed742de94dcfccc6a30f199', 'Δημιουργία λογαριασμού Χρήστη/τριας', 1),
(521, '8713ab100a251f0c7505eff111ce9a17', 'Επίπεδο πρόσβασης', 1),
(522, 'da36cfaf48b9e19896e23e1207040d1e', 'μήνες', 1),
(523, '921df56002ee5dc960debedc8ae06072', 'ΕΓΓΡΑΦΗ', 1),
(524, '43460636ffeec024b91d6eb35af26d30', 'Δευτερεύοντα δεδομένα για τη δημιουργία νέων λογαριασμών', 1),
(525, '3e827076ee15c77c9d7cdab47feeab8d', 'Ημερομηνία αποστολής', 1),
(526, '16b639ca335b241b224889bfda57abaa', 'αποστολή ειδοποιήσεων', 1),
(527, '992a0f0542384f1ee5ef51b7cf4ae6c4', 'Υπηρεσίες', 1),
(528, 'c33e404a441c6ba9648f88af3c68a1ca', 'Δεδομένα', 1),
(529, 'd0afd6efbc95a5de38cce630155e52aa', 'Γεωγραφικές περιοχές', 1),
(530, 'c7892ebbb139886662c6f2fc8c450710', 'Θέμα', 1),
(531, '9dffbf69ffba8bc38bc4e01abf4b1675', 'Κείμενο', 1),
(532, '19033fa8ff5c244682d92ed5f8f3d582', 'Προς όλους/ες τους/τις χρήστες/τριες', 1),
(533, '4a0ced33ef669eafaf6250f8a5f3a689', 'Τύπος οικογένειας', 1),
(534, '7275693a65a2386ad746b0a7a5b82e15', 'Τύπος περιστατικού', 1),
(535, '6a173fd91e6da0859b1d9de118d19ca6', 'Τύπος Φορέα', 1),
(536, '88183b946cc5f0e8c96b2e66e1c74a7e', 'Άγνωστο', 1),
(537, '51191c2496e3cac07fc8bb6f7112317f', 'Ταξινόμηση Επαγγελμάτων', 1),
(538, '38b3d64a566bb4337b624f87c46a32ff', 'Λογαριασμοί Χρηστών/τριών', 1),
(539, '719a9aa2ccf126f36f979827f8d473a4', 'Επιλογή Επαφών', 1),
(540, 'deb69c74ce8e37496bab339ad7d10905', 'View & Edit translation of admin interface', 4),
(541, 'f31817c128373efd882eade94f455b39', 'View & Edit translation of Operators\' interface', 4),
(542, 'deb69c74ce8e37496bab339ad7d10905', 'View & Edit translation of admin interface', 5),
(543, 'f31817c128373efd882eade94f455b39', 'View & Edit translation of admin interface', 5),
(544, 'deb69c74ce8e37496bab339ad7d10905', 'View & Edit translation of admin interface', 6),
(545, 'f31817c128373efd882eade94f455b39', 'View & Edit translation of Operators\' interface', 6),
(546, 'deb69c74ce8e37496bab339ad7d10905', 'Прегледайте & Редактирайте превода на интерфейса на администратора ', 7),
(547, 'f31817c128373efd882eade94f455b39', 'Прегледайте & Редактирайте превода на интерфейса на операторите', 7),
(548, 'deb69c74ce8e37496bab339ad7d10905', 'View & Edit translation of admin interface', 8),
(549, 'f31817c128373efd882eade94f455b39', 'View & Edit translation of Operators\' interface', 8),
(550, 'deb69c74ce8e37496bab339ad7d10905', 'View & Edit translation of admin interface', 9),
(551, 'f31817c128373efd882eade94f455b39', 'View & Edit translation of Operators\' interface', 9),
(572, 'f35de2daf6d9622d6c00bf67aa25e958', 'NO INFORMATION', 4),
(578, '1c22cfebb03dac89eac7331361cb8df4', 'Educational Services', 4),
(604, 'bea4c2c8eb82d05891ddd71584881b56', 'Feedback', 4),
(605, '2df01f83032f752182355b25cb6e8d63', 'Temporary ID', 4),
(606, '4777bbe3c06c7939e97101b4589ba1eb', 'Date From', 4),
(607, 'd24e4fa285c1eab355817ed6c38ec1bd', 'Date To', 4),
(608, 'e1b3ec89ead7f83a9245ed5c9cacfdbf', 'Operator', 4),
(609, 'c02034b1cff4fde56cb3eadc40466f8f', 'Error Message', 4),
(610, 'c17d0ec9fbffe49e6a5d90dabc26e018', 'Recorded By Operator', 4),
(611, '9ca018764f7cdb0f650b1671576b99a9', 'Referral Agency', 4),
(612, 'ec53a8c4f07baed5d8825072c89799be', 'Status', 4),
(613, '686e697538050e4664636337cc3b834f', 'Creeaza ', 4),
(627, '4d3d769b812b6faa6b76e1a8abaece2d', 'Active', 4),
(643, 'b3c5827f54218753bb2c3338236446c2', 'Operators', 2),
(644, 'eeb9c5485b9274991ca2ff2b99fa76bf', 'Edit Operators', 2),
(645, '3e47a1dfb30c0aec597c30261df9a0fe', 'Create Operator', 2),
(646, 'f6039d44b29456b20f8f373155ae4973', 'Username', 2),
(647, 'dc647eb65e6711e155375218212b3964', 'Password', 2),
(648, '6c7195551da0802a39b5e2bc7187df54', 'Toggle navigation', 2),
(649, '1a445bc7ae5dc7e8811f6415c9b52e31', 'CAN-MDS-SS Management', 2),
(650, '13348442cc6a27032d2b4aa28b75a5d3', 'Search', 2),
(651, '75ec3e55a77288b4a132f7528619817b', 'Agency', 2),
(652, '614003718464443c79f99d4641abc1df', 'Edit Agency', 2),
(653, '5241da7ad22c15cb6fbe5aff0c90e320', 'Create Agency', 2),
(654, '59716c97497eb9694541f7c3d37b1a4d', 'Country', 2),
(655, '428939f42a9ed1c5cb3ca533aa9d6cd8', 'Edit Country', 2),
(656, 'e7dd12373d62df6ddfc9e6536d497ec5', 'Create Country', 2),
(657, '3a08e2e340ab29fd9263af48193cbf8e', 'Languages', 2),
(658, 'd6928f0da8416cf6101e706e0abacc53', 'Edit Languages', 2),
(659, 'cece4eed6238505f3027355df320d75e', 'Create Languages', 2),
(660, 'bf56e2022db795bf7aa86acfa470a399', 'Occupations', 2),
(661, '71780c189d4853095744a9ec1bdcf4d5', 'Edit Occupations', 2),
(662, '8bfa0d3827e490f31e7c83ba570c16f8', 'Create Occupations', 2),
(663, 'd6b258792ff06f82933c74eeb8aef591', 'Organization', 2),
(664, 'e62cdbc3dc833e3005bf1c1cd5a51cc3', 'Edit Organization', 2),
(665, 'dc175a42f28a118ca86e17792d2e40eb', 'Create Organization', 2),
(666, '8f1e77e0d2be21da93cd4d9a939148f7', 'Change Password', 2),
(667, '70febc419840ffab3c91c81e9134e375', 'Hello,', 2),
(668, 'd8efa374f5851db4bd14a858135d1118', 'There are 38', 2),
(669, 'f0338453773ed5f09cc82557925a67b5', 'Agencies', 2),
(671, '2dd0664225aa8dc2a94b7b71d10cc22a', 'registered in the system.', 2),
(672, 'a8182ab7ae1169cab49c9d403e76cfd5', 'Your Info', 2),
(673, '91bbc859f6f9423be4658dd4d3aa7234', 'Operator ID', 2),
(674, '1a9dacea9d384e8d764691d8423cfeab', 'Agency ID', 2),
(675, 'bcc254b55c4a1babdf1dcb82c207506b', 'Phone', 2),
(676, 'b5f4d5db869533be8c311d3369cf2f4a', 'Your Agency', 2),
(677, '7381f5495177edd501235320608eecc0', 'Agency Name', 2),
(678, 'a110c5c194a15bdec2f8390a8454c3c8', 'Street Name', 2),
(679, '070a6f943470aec6d12c7090f290e10f', 'Street Number', 2),
(680, '59086e95676f4e17bc7b8923f6fe40f1', 'Post Code', 2),
(681, 'c16dac173aa8377a1c07aed8e0472f7c', 'Town', 2),
(682, '2e941bd64a09f941a32e82f9efae9710', 'E-mail ID', 2),
(683, '752a9c20f00cd77f7c2aab0a5f7e78d1', 'Occupation', 2),
(684, 'b83247733544241528fb86fad6d6334a', 'Access Level', 2),
(685, '49ee3087348e8d44e1feda1917443987', 'Name', 2),
(686, '8512ae7d57b1396273f76fe6ed341a23', 'language', 2),
(687, '1e884e3078d9978e216a027ecd57fb34', 'E-mail', 2),
(688, '7dce122004969d56ae2e0245cb754d35', 'Edit', 2),
(689, 'ae3bb2a1ac61750150b606298091d38a', 'New Password', 2),
(690, '5d5b78699e57104f2fa03bbdf7b9197b', 'Set', 2),
(691, '13586200cec6a0e09263250b17173d9c', 'Period of RECORDS', 2),
(692, '5fb1f955b45e38e31789286a1790398d', 'ALL', 2),
(693, '68a63290c347f42ffce5b24532833624', 'against self', 2),
(694, '842e5a39b01fadaead6970f5ff5de1d5', 'physical', 2),
(695, 'c137d413187fccdc2a0e9954df5fbad0', 'sexual', 2),
(696, '3e83b7e2cad4e1c3a978fff44fa6ae20', 'psychological', 2),
(697, '1022349b4bcb447934fb49084c887af2', 'omissions', 2),
(698, 'daab80c5dadc81fa2d019c562f805994', 'Sex', 2),
(699, '63889cfb9d3cbe05d1bd2be5cc9953fd', 'Male', 2),
(700, 'b719ce180ec7bd9641fece2f920f4817', 'Female', 2),
(701, '6311ae17c1ee52b36e68aaf4ad066387', 'Other', 2),
(702, '29e43604b33ba5f84473daf2664a4bcf', 'Not Known', 2),
(703, 'f95e88f4e27f878eda846e7a4cfa95b9', 'Edit Incidents', 2),
(706, '8ba81f1258dd23b956fe923561d2da65', 'type_of_incident', 2),
(708, 'f36263a38d7de5cdaa953c1e2b2f79b5', 'child_id', 2),
(709, '7a620d438361c15161512c4d98341ef1', 'Subdivision', 2),
(710, '5916391a654132a460c04967c05d54b2', 'type_of_organization', 2),
(711, '1f1c16d7d257c193410bbcc4237aff4a', 'Street Number or Plot', 2),
(712, 'b6ae8fbc00355aa62f1a1b6a5a9bee69', 'Three Digit ID Number(Operator)', 2),
(713, '4994a8ffeba4ac3140beb89e8d41f174', 'Language', 2),
(714, 'f2a6c498fb90ee345d997f888fce3b18', 'Delete', 2),
(715, '9e365dd1fae1b9ecae5a1d220a5fe86f', 'Confirm Delete', 2),
(716, '4c02263746c1f9db4be5c8a886972338', 'You are about to delete one Operator, this procedure is irreversible.', 2),
(717, '33d8fefabfe95e71576a8641d21689ff', 'Do you want to proceed?', 2),
(718, 'ea4788705e6873b424c65e91c2846b19', 'Cancel', 2),
(719, '494757c91b2d7c66e04eb71e6d64133b', 'Operator\'s ID', 2),
(720, 'ca0dbad92a874b2f69b549293387925e', 'Code', 2),
(721, 'f109acaa739584b76e9c321b25afba61', 'Agency\'s Name', 2),
(722, '83f0c30cf9b66b30b7cb1571d65596a9', 'Three Digit ID Number', 2),
(723, 'cce99c598cfdb9773ab041d54c3d973a', 'Profile', 2),
(724, '6dd08874f83507e9c7b23f1a46b7fa7c', 'Translation', 2),
(725, '1860fb17b107cbb39cf6bbfa61130803', 'Edit Profile', 2),
(726, 'ce8ae9da5b7cd6c3df2929543a9af92d', 'Email', 2),
(727, '83218ac34c1834c26781fe4bde918ee4', 'Welcome', 2),
(728, 'e490d4a33d555b8204c3bfd182d6ff8b', 'Admin Translation', 2),
(729, '46402d9b6a82fa4d1b7db5dbd1fa1c86', 'Site Translation', 2),
(730, 'e0626222614bdee31951d84c64e5e9ff', 'Select', 2),
(731, 'b9a2aa483b400156041a502d39ef9221', 'Type of abuse', 2),
(732, '4351cfebe4b61d8aa5efa1d020710005', 'View', 2),
(733, 'c33e404a441c6ba9648f88af3c68a1ca', 'Statistics', 2),
(734, '662528312baf38a60f258d903ef369d6', 'Create Agency\'s account', 2),
(735, 'afa3b5206ed742de94dcfccc6a30f199', 'Create Operator\'s account', 2),
(736, 'cd7be8e4da4a2211fa0a42c9444a7b21', 'Create new country code', 2),
(737, 'fc7017fb33f5dddd79d98825892dfa51', 'Create Language', 2),
(738, '6cfb8b8aa3fdce38e675819691b48f5c', 'Create new type', 2),
(739, '14151ea9f23ba5c2e2e42204b717fdbc', 'Date of Record', 2),
(740, '06e981a2d2ec497221ce8d27b73a8f25', 'Date of Incident', 2),
(741, '7275693a65a2386ad746b0a7a5b82e15', 'Type Of Incident', 2),
(742, '2300e126395c693c5b52c227ec2a5248', 'Child\'s ID', 2),
(744, '921df56002ee5dc960debedc8ae06072', 'RECORD', 2),
(750, 'b718adec73e04ce3ec720dd11a06a308', 'ID', 2),
(753, '88183b946cc5f0e8c96b2e66e1c74a7e', 'Unknown', 2),
(758, '4a0ced33ef669eafaf6250f8a5f3a689', 'Type of family', 2),
(765, '124617f0ad4a4ecb40ac0b9dcad97ed9', 'Incident', 2),
(766, '67e6e5858993448ab7ed1a1003529445', 'Date of incident', 2),
(771, '992a0f0542384f1ee5ef51b7cf4ae6c4', 'Services', 2),
(775, 'da36cfaf48b9e19896e23e1207040d1e', 'months', 2),
(776, '44fdec47036f482b68b748f9d786801b', 'days', 2),
(780, '7d637d275668ed6d41a9b97e6ad3a556', 'age', 2),
(787, 'd55669822f1a8cf72ec1911e462a54eb', 'for', 2),
(793, '6adf97f83acf6453d4a6a4b1070f3754', 'None', 2),
(816, '4bbfe52be0397513327132a28a2fba2d', 'Agencies\' accounts', 2),
(817, 'f60a3c6183496609617f4ba2639b4ff4', 'View & Edit Agency\'s account', 2),
(818, '38b3d64a566bb4337b624f87c46a32ff', 'Operators\' accounts', 2),
(819, 'f932b02057ca6970e9f3e15c8dba64fd', 'View & Edit Operator\'s account', 2),
(820, 'b11fb06ead01ff04523c8e3ee952263c', 'CAN-MDS Statistics', 2),
(821, '503360433b87bf377a17916946a90b12', 'Admin Profile & System', 2),
(822, 'bc09b552527231f49a320e71c5ddd6a4', 'View & Edit Admin profile', 2),
(823, '119680ae68afc9b678a1ceb6bb1ecd40', 'Change Admin Password', 2),
(824, '43460636ffeec024b91d6eb35af26d30', 'Secondary data for creation of new accounts', 2),
(825, '790d59ef178acbc75d233bf4211763c6', 'Countries', 2),
(826, '908b28677cc79e0fe3ca52c7327c0556', 'View Countries\' Alpha-2 codes', 2),
(827, '51191c2496e3cac07fc8bb6f7112317f', 'Occupations\' Classification', 2),
(828, '46e4c16e499315858db8b421ff6807ef', 'View classification & find codes', 2),
(829, 'd0afd6efbc95a5de38cce630155e52aa', 'Subdivisions', 2),
(830, 'b6953f43780ad0de24ae79f892db0176', 'View & Find Subdivisions codes', 2),
(831, 'a7386900f9c83931103381af61aaafb3', 'View & Edit Languages', 2),
(832, '6a173fd91e6da0859b1d9de118d19ca6', 'Type of Organizations', 2),
(833, '8e2bae6fcf0a34e7b12af874f6602139', 'View Classification & find codes', 2),
(834, '8713ab100a251f0c7505eff111ce9a17', 'Level of Access', 2),
(835, '2a1596f614702a29e732fdd7f57e2e26', 'View access levels’ rights and assign access level accordingly', 2),
(836, '16b639ca335b241b224889bfda57abaa', 'send notifications', 2),
(837, 'ce148c9b6c129dc6e45c00f6b7f4af75', 'view all notifications', 2),
(838, 'deb69c74ce8e37496bab339ad7d10905', 'View & Edit translation of admin interface', 2),
(839, 'f31817c128373efd882eade94f455b39', 'View & Edit translation of Operators\' interface', 2),
(840, 'b821c62f6d594c60e559baea365e6821', 'Available to download', 2),
(841, 'e2c06fee97ab5f7e9dc55588113e820a', 'CAN-MDS Administrator\'s Manual', 2),
(842, 'e21bddf8a7f04b1a0ff58b513626d224', 'CAN-MDS Operator\'s Manual', 2),
(843, '28b993ce06bf3fcdfb81b6257d79c808', 'CAN-MDS Data Collection Manual', 2),
(844, '9aa698f602b1e5694855cee73a683488', 'Contacts', 2),
(845, 'd3d2e617335f08df83599665eef8a418', 'Close', 2),
(846, '719a9aa2ccf126f36f979827f8d473a4', 'Get Contacts', 2),
(847, '19033fa8ff5c244682d92ed5f8f3d582', 'TO all Operator', 2),
(848, 'a274f4d4670213a9045ce258c6c56b80', 'Notifications', 2),
(849, '3e827076ee15c77c9d7cdab47feeab8d', 'Send Date', 2),
(850, 'c7892ebbb139886662c6f2fc8c450710', 'Subject', 2),
(851, '9dffbf69ffba8bc38bc4e01abf4b1675', 'Text', 2),
(887, 'f35de2daf6d9622d6c00bf67aa25e958', 'NO INFORMATION', 2),
(893, '1c22cfebb03dac89eac7331361cb8df4', 'Educational Services', 2),
(919, 'bea4c2c8eb82d05891ddd71584881b56', 'Feedback', 2),
(920, '2df01f83032f752182355b25cb6e8d63', 'Temporary ID', 2),
(921, '4777bbe3c06c7939e97101b4589ba1eb', 'Date From', 2),
(922, 'd24e4fa285c1eab355817ed6c38ec1bd', 'Date To', 2),
(923, 'e1b3ec89ead7f83a9245ed5c9cacfdbf', 'Operator', 2),
(924, 'c02034b1cff4fde56cb3eadc40466f8f', 'Error Message', 2),
(925, 'c17d0ec9fbffe49e6a5d90dabc26e018', 'Recorded By Operator', 2),
(926, '9ca018764f7cdb0f650b1671576b99a9', 'Referral Agency', 2),
(927, 'ec53a8c4f07baed5d8825072c89799be', 'Status', 2),
(928, '686e697538050e4664636337cc3b834f', 'Create', 2),
(942, '4d3d769b812b6faa6b76e1a8abaece2d', 'Active', 2),
(962, 'e21bddf8a7f04b1a0ff58b513626d224', 'CAN-MDS Εγχειρίδιο Χρήστη/τριας', 13),
(963, '28b993ce06bf3fcdfb81b6257d79c808', 'CAN-MDS Οδηγός Συλλογής Δεδομένων', 13),
(964, 'b11fb06ead01ff04523c8e3ee952263c', 'CAN-MDS Στατιστικά Στοιχεία', 13),
(965, '88183b946cc5f0e8c96b2e66e1c74a7e', 'Άγνωστο', 13),
(966, '29e43604b33ba5f84473daf2664a4bcf', 'Άγνωστο', 13),
(967, 'ea4788705e6873b424c65e91c2846b19', 'Άκυρο', 13),
(968, '8f1e77e0d2be21da93cd4d9a939148f7', 'Αλλαγή κωδικού πρόσβασης', 13),
(969, '119680ae68afc9b678a1ceb6bb1ecd40', 'Αλλαγή κωδικού πρόσβασης Διαχειριστή/τριας', 13),
(970, '6311ae17c1ee52b36e68aaf4ad066387', 'Άλλο', 13),
(971, '1a9dacea9d384e8d764691d8423cfeab', 'Αναγνωριστικό (ID) Φορέα', 13),
(972, '91bbc859f6f9423be4658dd4d3aa7234', 'Αναγνωριστικό (ID) Χρήστη/τριας', 13),
(973, '494757c91b2d7c66e04eb71e6d64133b', 'Αναγνωριστικού (ID) Χρήστη/τριας', 13),
(974, 'e2c06fee97ab5f7e9dc55588113e820a', 'Αναλυτικός Οδηγός για τον/την Διαχειριστή/τρια', 13),
(975, '16b639ca335b241b224889bfda57abaa', 'αποστολή ειδοποιήσεων', 13),
(976, '070a6f943470aec6d12c7090f290e10f', 'Αριθμός', 13),
(977, '1f1c16d7d257c193410bbcc4237aff4a', 'Αριθμός', 13),
(978, '63889cfb9d3cbe05d1bd2be5cc9953fd', 'Άρρεν', 13),
(979, '70febc419840ffab3c91c81e9134e375', 'Γεια σας,', 13),
(980, 'd0afd6efbc95a5de38cce630155e52aa', 'Γεωγραφικές περιοχές', 13),
(981, '7a620d438361c15161512c4d98341ef1', 'Γεωγραφική περιοχή', 13),
(982, '8512ae7d57b1396273f76fe6ed341a23', 'γλώσσα', 13),
(983, '4994a8ffeba4ac3140beb89e8d41f174', 'Γλώσσα', 13),
(984, '3a08e2e340ab29fd9263af48193cbf8e', 'Γλώσσες', 13),
(985, 'c33e404a441c6ba9648f88af3c68a1ca', 'Δεδομένα', 13),
(986, '43460636ffeec024b91d6eb35af26d30', 'Δευτερεύοντα δεδομένα για τη δημιουργία νέων λογαριασμών', 13),
(987, 'fc7017fb33f5dddd79d98825892dfa51', 'Δημιουργία κωδικού Γλώσσας', 13),
(988, 'cece4eed6238505f3027355df320d75e', 'Δημιουργία κωδικού Γλώσσας', 13),
(989, '8bfa0d3827e490f31e7c83ba570c16f8', 'Δημιουργία κωδικού Επαγγέλματος', 13),
(990, 'e7dd12373d62df6ddfc9e6536d497ec5', 'Δημιουργία κωδικού Χώρας', 13),
(991, '662528312baf38a60f258d903ef369d6', 'Δημιουργία λογαριασμού Φορέα', 13),
(992, '5241da7ad22c15cb6fbe5aff0c90e320', 'Δημιουργία λογαριασμού Φορέα', 13),
(993, 'dc175a42f28a118ca86e17792d2e40eb', 'Δημιουργία λογαριασμού Φορέα', 13),
(994, 'afa3b5206ed742de94dcfccc6a30f199', 'Δημιουργία λογαριασμού Χρήστη/τριας', 13),
(995, '3e47a1dfb30c0aec597c30261df9a0fe', 'Δημιουργία λογαριασμού Χρήστη/τριας', 13),
(996, 'cd7be8e4da4a2211fa0a42c9444a7b21', 'Δημιουργία νέου κωδικού χώρας', 13),
(997, '6cfb8b8aa3fdce38e675819691b48f5c', 'Δημιουργία νέου τύπου', 13),
(998, 'f2a6c498fb90ee345d997f888fce3b18', 'Διαγραφή', 13),
(999, 'b821c62f6d594c60e559baea365e6821', 'Διαθέσιμα για λήψη', 13),
(1000, '1a445bc7ae5dc7e8811f6415c9b52e31', 'Διαχείριση Συστήματος CAN-MDS', 13),
(1001, '921df56002ee5dc960debedc8ae06072', 'ΕΓΓΡΑΦΗ', 13),
(1002, '6c7195551da0802a39b5e2bc7187df54', 'Εναλλαγή πλοήγησης', 13),
(1003, '752a9c20f00cd77f7c2aab0a5f7e78d1', 'Επάγγελμα', 13),
(1004, 'bf56e2022db795bf7aa86acfa470a399', 'Επαγγέλματα', 13),
(1005, '9aa698f602b1e5694855cee73a683488', 'Επαφές', 13),
(1006, '7dce122004969d56ae2e0245cb754d35', 'Επεξεργασία', 13),
(1007, 'd6928f0da8416cf6101e706e0abacc53', 'Επεξεργασία κωδικού Γλώσσας', 13),
(1008, '71780c189d4853095744a9ec1bdcf4d5', 'Επεξεργασία κωδικού Επαγγέλματος', 13),
(1009, '428939f42a9ed1c5cb3ca533aa9d6cd8', 'Επεξεργασία κωδικού Χώρας', 13),
(1010, 'eeb9c5485b9274991ca2ff2b99fa76bf', 'Επεξεργασία λογαριασμού Χρήστη/τριας', 13),
(1011, '614003718464443c79f99d4641abc1df', 'Επεξεργασία λογιαριασμού Φορέα', 13),
(1012, '1860fb17b107cbb39cf6bbfa61130803', 'Επεξεργασία προφίλ', 13),
(1013, 'f95e88f4e27f878eda846e7a4cfa95b9', 'Επεξεργασία Συμβάντων', 13),
(1014, 'e62cdbc3dc833e3005bf1c1cd5a51cc3', 'Επεξεργασία τύπου Φορέα', 13),
(1015, '9e365dd1fae1b9ecae5a1d220a5fe86f', 'Επιβεβαίωση διαγραφής', 13),
(1016, 'e0626222614bdee31951d84c64e5e9ff', 'Επιλογή', 13),
(1017, '719a9aa2ccf126f36f979827f8d473a4', 'Επιλογή Επαφών', 13),
(1018, '8713ab100a251f0c7505eff111ce9a17', 'Επίπεδο πρόσβασης', 13),
(1019, 'b83247733544241528fb86fad6d6334a', 'Επίπεδο πρόσβασης', 13),
(1020, '7381f5495177edd501235320608eecc0', 'Επωνυμία Φορέα', 13),
(1021, 'f109acaa739584b76e9c321b25afba61', 'Επωνυμίας του Φορέα', 13),
(1022, '3e827076ee15c77c9d7cdab47feeab8d', 'Ημερομηνία αποστολής', 13),
(1023, '33d8fefabfe95e71576a8641d21689ff', 'Θέλετε να προχωρήσετε;', 13),
(1024, 'c7892ebbb139886662c6f2fc8c450710', 'Θέμα', 13),
(1025, 'b719ce180ec7bd9641fece2f920f4817', 'Θήλυ', 13),
(1027, '83218ac34c1834c26781fe4bde918ee4', 'Καλώς ορίσατε!', 13),
(1028, '68a63290c347f42ffce5b24532833624', 'κατά του εαυτού', 13),
(1030, '9dffbf69ffba8bc38bc4e01abf4b1675', 'Κείμενο', 13),
(1031, 'ca0dbad92a874b2f69b549293387925e', 'Κωδικός', 13),
(1032, 'dc647eb65e6711e155375218212b3964', 'Κωδικός Πρόσβασης', 13),
(1033, '38b3d64a566bb4337b624f87c46a32ff', 'Λογαριασμοί Χρηστών/τριών', 13),
(1034, '4bbfe52be0397513327132a28a2fba2d', 'Λογιαριασμοί Φορέων', 13),
(1035, '6dd08874f83507e9c7b23f1a46b7fa7c', 'Μετάφραση', 13),
(1036, 'e490d4a33d555b8204c3bfd182d6ff8b', 'Μετάφραση διαχειριστικού περιβάλλοντος', 13),
(1037, '46402d9b6a82fa4d1b7db5dbd1fa1c86', 'Μετάφραση περιβάλλοντος Χρηστών/τριών', 13),
(1038, 'da36cfaf48b9e19896e23e1207040d1e', 'μήνες', 13),
(1039, 'ae3bb2a1ac61750150b606298091d38a', 'Νέος κωδικός πρόσβασης', 13),
(1040, 'b5f4d5db869533be8c311d3369cf2f4a', 'Ο Φορέας σας', 13),
(1041, 'a110c5c194a15bdec2f8390a8454c3c8', 'Οδός', 13),
(1042, 'a8182ab7ae1169cab49c9d403e76cfd5', 'Οι πληροφορίες σας', 13),
(1043, '5fb1f955b45e38e31789286a1790398d', 'ΟΛΑ', 13),
(1044, '49ee3087348e8d44e1feda1917443987', 'Όνομα', 13),
(1045, 'f6039d44b29456b20f8f373155ae4973', 'Όνομα Χρήστη/τριας', 13),
(1046, '1022349b4bcb447934fb49084c887af2', 'παραλείψεις στη φροντίδα', 13),
(1047, '13586200cec6a0e09263250b17173d9c', 'Περίοδος Καταγραφής', 13),
(1048, 'c16dac173aa8377a1c07aed8e0472f7c', 'Πόλη', 13),
(1049, '4351cfebe4b61d8aa5efa1d020710005', 'Προβολή', 13),
(1050, 'a7386900f9c83931103381af61aaafb3', 'Προβολή & επεξεργασία Γλωσσών', 13),
(1051, 'deb69c74ce8e37496bab339ad7d10905', 'Προβολή & Επεξεργασία διεπιφάνειας Διαχειριστή/τριας', 13),
(1052, 'f31817c128373efd882eade94f455b39', 'Προβολή & Επεξεργασία Διεπιφάνειας Χρήστη/τριας', 13),
(1053, 'f60a3c6183496609617f4ba2639b4ff4', 'Προβολή & Επεξεργασία Λογαριασμού Φορέα', 13),
(1054, '2a1596f614702a29e732fdd7f57e2e26', 'Προβολή δικαιωμάτων ανά επίπεδο πρόσβασης και ορισμός πρόσβασης', 13),
(1055, 'f932b02057ca6970e9f3e15c8dba64fd', 'Προβολή και Επεξεργασία Λογαριασμού Χρηστών/τριών', 13),
(1056, 'bc09b552527231f49a320e71c5ddd6a4', 'Προβολή και Επεξεργασία προφίλ Διαχειριστή/τριας', 13),
(1057, 'b6953f43780ad0de24ae79f892db0176', 'Προβολή και Εύρεση Κωδικών Περιοχών', 13),
(1058, '908b28677cc79e0fe3ca52c7327c0556', 'Προβολή κωδικών Alpha-2 χωρών', 13),
(1059, 'ce148c9b6c129dc6e45c00f6b7f4af75', 'Προβολή όλων των ειδοποιήσεων', 13),
(1060, '46e4c16e499315858db8b421ff6807ef', 'Προβολή ταξινόμησης και εύρεση κωδικών', 13),
(1061, '8e2bae6fcf0a34e7b12af874f6602139', 'Προβολή ταξινόμησης και εύρεσης κωδικών', 13),
(1062, '4c02263746c1f9db4be5c8a886972338', 'Πρόκειται να διαγράψετε ένα λογαριασμό Χρήστη/τριας. Αυτή η διαδικασία είναι μη αναστρέψιμη!', 13),
(1063, '19033fa8ff5c244682d92ed5f8f3d582', 'Προς όλους/ες τους/τις χρήστες/τριες', 13),
(1064, 'cce99c598cfdb9773ab041d54c3d973a', 'Προφιλ', 13),
(1065, 'c137d413187fccdc2a0e9954df5fbad0', 'σεξουαλική', 13),
(1066, '13348442cc6a27032d2b4aa28b75a5d3', 'Στατιστικά', 13),
(1067, '2dd0664225aa8dc2a94b7b71d10cc22a', 'στο σύστημα.', 13),
(1068, '842e5a39b01fadaead6970f5ff5de1d5', 'σωματική', 13),
(1069, '51191c2496e3cac07fc8bb6f7112317f', 'Ταξινόμηση Επαγγελμάτων', 13),
(1070, '503360433b87bf377a17916946a90b12', 'Ταυτότητα Διαχειριστή/τριας και Συστήματος', 13),
(1071, '59086e95676f4e17bc7b8923f6fe40f1', 'Ταχυδρομικός Κώδικας', 13),
(1072, 'bcc254b55c4a1babdf1dcb82c207506b', 'Τηλέφωνο', 13),
(1073, '83f0c30cf9b66b30b7cb1571d65596a9', 'Τριψήφιος Αναγνωριστικός (ID) Αριθμός ', 13),
(1074, 'b6ae8fbc00355aa62f1a1b6a5a9bee69', 'Τριψήφιος Αναγνωριστικός (ID) Αριθμός Χρήστη/τριας', 13),
(1075, 'b9a2aa483b400156041a502d39ef9221', 'Τύπος κακοποίησης', 13),
(1076, '4a0ced33ef669eafaf6250f8a5f3a689', 'Τύπος οικογένειας', 13),
(1077, '7275693a65a2386ad746b0a7a5b82e15', 'Τύπος περιστατικού', 13),
(1078, '6a173fd91e6da0859b1d9de118d19ca6', 'Τύπος Φορέα', 13),
(1079, '8ba81f1258dd23b956fe923561d2da65', 'τύπος_περιστατικού', 13),
(1080, '5916391a654132a460c04967c05d54b2', 'τύπος_Φορέα', 13),
(1081, 'd8efa374f5851db4bd14a858135d1118', 'Υπάρχουν 38', 13),
(1082, '992a0f0542384f1ee5ef51b7cf4ae6c4', 'Υπηρεσίες', 13),
(1083, '75ec3e55a77288b4a132f7528619817b', 'Φορέας', 13),
(1084, 'd6b258792ff06f82933c74eeb8aef591', 'Φορέας', 13),
(1085, 'f0338453773ed5f09cc82557925a67b5', 'Φορείς', 13),
(1086, 'daab80c5dadc81fa2d019c562f805994', 'Φύλο', 13),
(1087, 'b3c5827f54218753bb2c3338236446c2', 'Χρήστες/Χρήστριες', 13),
(1088, '59716c97497eb9694541f7c3d37b1a4d', 'Χώρα', 13),
(1089, '790d59ef178acbc75d233bf4211763c6', 'Χώρες', 13),
(1090, '3e83b7e2cad4e1c3a978fff44fa6ae20', 'ψυχολογική', 13),
(1091, '503360433b87bf377a17916946a90b12', 'Профил на Администратор & Система', 7),
(1092, 'e490d4a33d555b8204c3bfd182d6ff8b', ' Превод на Администратор', 7),
(1093, 'f0338453773ed5f09cc82557925a67b5', 'Служби', 7),
(1094, '4bbfe52be0397513327132a28a2fba2d', 'Профили на  службите', 7),
(1095, '75ec3e55a77288b4a132f7528619817b', 'Служба', 7),
(1096, '1a9dacea9d384e8d764691d8423cfeab', ' ID на службата', 7),
(1097, 'f109acaa739584b76e9c321b25afba61', 'Име на службата', 7),
(1098, '5fb1f955b45e38e31789286a1790398d', ' ВСИЧКИ', 7),
(1099, 'b821c62f6d594c60e559baea365e6821', 'Налично за изтегляне', 7),
(1100, 'e2c06fee97ab5f7e9dc55588113e820a', ' Наръчник на Администратора на CAN-MDS', 7),
(1101, '28b993ce06bf3fcdfb81b6257d79c808', 'Наръчник за събиране на данни за CAN-MDS', 7),
(1102, 'e21bddf8a7f04b1a0ff58b513626d224', ' Ръководство за оператор на CAN-MDS', 7),
(1103, 'b11fb06ead01ff04523c8e3ee952263c', ' CAN-MDS-Статистика', 7),
(1104, '1a445bc7ae5dc7e8811f6415c9b52e31', ' CAN-MDS-SS Мениджмънт', 7),
(1105, 'ea4788705e6873b424c65e91c2846b19', ' Отказ', 7),
(1106, '119680ae68afc9b678a1ceb6bb1ecd40', ' Променете паролата на администратора', 7),
(1107, '8f1e77e0d2be21da93cd4d9a939148f7', ' Променете паролата', 7),
(1109, '2300e126395c693c5b52c227ec2a5248', 'ID на детето/Документ за самоличност на детето', 7),
(1110, 'f36263a38d7de5cdaa953c1e2b2f79b5', 'дете_ id (документ за самоличност)', 7),
(1111, 'd3d2e617335f08df83599665eef8a418', 'Затворете', 7),
(1112, 'ca0dbad92a874b2f69b549293387925e', 'Код', 7),
(1113, '9e365dd1fae1b9ecae5a1d220a5fe86f', 'Потвърдете изтриване', 7),
(1114, '9aa698f602b1e5694855cee73a683488', 'Контакти', 7),
(1115, '790d59ef178acbc75d233bf4211763c6', 'Страни', 7),
(1116, '59716c97497eb9694541f7c3d37b1a4d', 'Страна', 7),
(1117, '5241da7ad22c15cb6fbe5aff0c90e320', 'Създайте служба', 7),
(1118, '662528312baf38a60f258d903ef369d6', 'Създайте профил на службата', 7),
(1119, 'e7dd12373d62df6ddfc9e6536d497ec5', 'Създайте страна', 7),
(1120, 'fc7017fb33f5dddd79d98825892dfa51', 'Създайте език', 7),
(1121, 'cece4eed6238505f3027355df320d75e', 'Създайте езици', 7),
(1122, 'cd7be8e4da4a2211fa0a42c9444a7b21', 'Създайте нов код за страната', 7),
(1123, '6cfb8b8aa3fdce38e675819691b48f5c', 'Създайте нов тип', 7),
(1124, '8bfa0d3827e490f31e7c83ba570c16f8', 'Създайте професии', 7),
(1125, '3e47a1dfb30c0aec597c30261df9a0fe', 'Създайте Оператор', 7),
(1126, 'afa3b5206ed742de94dcfccc6a30f199', 'Създайте профил на оператора', 7),
(1127, 'dc175a42f28a118ca86e17792d2e40eb', 'Създайте/Въведете Организация', 7),
(1129, '06e981a2d2ec497221ce8d27b73a8f25', 'Дата на инцидент', 7),
(1130, '14151ea9f23ba5c2e2e42204b717fdbc', 'Дата на  запис', 7),
(1133, '44fdec47036f482b68b748f9d786801b', ' дни', 7),
(1134, 'f2a6c498fb90ee345d997f888fce3b18', ' Изтрийте', 7),
(1135, '33d8fefabfe95e71576a8641d21689ff', ' Искате ли да продължите?', 7),
(1137, '7dce122004969d56ae2e0245cb754d35', 'Редактирайте', 7),
(1138, '614003718464443c79f99d4641abc1df', 'Редактирайте служба', 7),
(1139, '428939f42a9ed1c5cb3ca533aa9d6cd8', 'Редактирайте страна', 7),
(1140, 'f95e88f4e27f878eda846e7a4cfa95b9', 'Редактирайте инциденти', 7),
(1141, 'd6928f0da8416cf6101e706e0abacc53', 'Редактирайте езици', 7),
(1142, '71780c189d4853095744a9ec1bdcf4d5', 'Редактирайте професии', 7),
(1143, 'eeb9c5485b9274991ca2ff2b99fa76bf', 'Редактирайте  оператори', 7),
(1144, 'e62cdbc3dc833e3005bf1c1cd5a51cc3', 'Редактирайте организация', 7),
(1145, '1860fb17b107cbb39cf6bbfa61130803', 'Редактирайте профил', 7),
(1146, 'ce8ae9da5b7cd6c3df2929543a9af92d', 'Електронен поща', 7),
(1147, '1e884e3078d9978e216a027ecd57fb34', ' Електронен поща', 7),
(1148, '2e941bd64a09f941a32e82f9efae9710', ' Електронен адрес ID', 7),
(1149, 'b719ce180ec7bd9641fece2f920f4817', 'Женски', 7),
(1150, 'd55669822f1a8cf72ec1911e462a54eb', 'за', 7),
(1152, '719a9aa2ccf126f36f979827f8d473a4', 'Вземете контакти', 7),
(1153, '70febc419840ffab3c91c81e9134e375', 'Здравейте,', 7),
(1155, 'b718adec73e04ce3ec720dd11a06a308', 'ID/ документ за самоличност', 7),
(1156, '124617f0ad4a4ecb40ac0b9dcad97ed9', 'Инцидент', 7),
(1157, '42b216a83db155f2dac6a7a808475488', 'ID на инцидента', 7),
(1158, '8512ae7d57b1396273f76fe6ed341a23', 'език', 7),
(1159, '4994a8ffeba4ac3140beb89e8d41f174', 'Език', 7),
(1160, '3a08e2e340ab29fd9263af48193cbf8e', 'Езици', 7),
(1161, '8713ab100a251f0c7505eff111ce9a17', 'Ниво на достъп', 7),
(1162, '63889cfb9d3cbe05d1bd2be5cc9953fd', 'Мъжки', 7),
(1163, 'da36cfaf48b9e19896e23e1207040d1e', 'месеци', 7),
(1164, '49ee3087348e8d44e1feda1917443987', 'Име', 7),
(1165, 'ae3bb2a1ac61750150b606298091d38a', 'Нова парола', 7),
(1167, '6adf97f83acf6453d4a6a4b1070f3754', 'Никой/нищо', 7),
(1168, '29e43604b33ba5f84473daf2664a4bcf', 'Неизвестен/но', 7),
(1169, 'a274f4d4670213a9045ce258c6c56b80', 'Известия', 7),
(1170, '752a9c20f00cd77f7c2aab0a5f7e78d1', 'Професия', 7),
(1171, 'bf56e2022db795bf7aa86acfa470a399', 'Професии', 7),
(1172, '51191c2496e3cac07fc8bb6f7112317f', 'Класификация на професиите', 7),
(1173, '1022349b4bcb447934fb49084c887af2', 'Пропуски', 7),
(1174, '91bbc859f6f9423be4658dd4d3aa7234', 'ID на оператора', 7),
(1175, '494757c91b2d7c66e04eb71e6d64133b', 'ID на оператора', 7),
(1176, 'b3c5827f54218753bb2c3338236446c2', 'Оператори', 7),
(1177, '38b3d64a566bb4337b624f87c46a32ff', 'Профили на оператори', 7),
(1178, 'd6b258792ff06f82933c74eeb8aef591', 'Организация', 7),
(1179, '6311ae17c1ee52b36e68aaf4ad066387', 'Друг', 7),
(1181, 'dc647eb65e6711e155375218212b3964', 'Парола', 7),
(1182, '13586200cec6a0e09263250b17173d9c', 'Период на ЗАПИСИ', 7),
(1183, 'bcc254b55c4a1babdf1dcb82c207506b', 'Телефон', 7),
(1184, '842e5a39b01fadaead6970f5ff5de1d5', 'физическо', 7),
(1185, '59086e95676f4e17bc7b8923f6fe40f1', 'Пощенски код', 7),
(1186, 'cce99c598cfdb9773ab041d54c3d973a', 'Профил', 7),
(1187, '3e83b7e2cad4e1c3a978fff44fa6ae20', 'психологическо', 7),
(1188, '921df56002ee5dc960debedc8ae06072', 'ЗАПИС', 7),
(1190, '2dd0664225aa8dc2a94b7b71d10cc22a', ' регистриран в сиситемата', 7),
(1191, '13348442cc6a27032d2b4aa28b75a5d3', 'Търсете', 7),
(1192, '43460636ffeec024b91d6eb35af26d30', 'Вторични данни за създаване на нови профили', 7),
(1193, 'e0626222614bdee31951d84c64e5e9ff', 'Изберете', 7),
(1194, '3e827076ee15c77c9d7cdab47feeab8d', 'Изпратете дата ', 7),
(1195, '16b639ca335b241b224889bfda57abaa', 'Изпратете известия', 7),
(1196, '992a0f0542384f1ee5ef51b7cf4ae6c4', 'Служби/услуги', 7),
(1197, '5d5b78699e57104f2fa03bbdf7b9197b', 'Набор ', 7),
(1198, 'daab80c5dadc81fa2d019c562f805994', 'Пол', 7),
(1199, 'c137d413187fccdc2a0e9954df5fbad0', 'Полов', 7),
(1200, '46402d9b6a82fa4d1b7db5dbd1fa1c86', 'Превод на сайт', 7),
(1201, 'c33e404a441c6ba9648f88af3c68a1ca', 'Статистика', 7),
(1202, 'a110c5c194a15bdec2f8390a8454c3c8', 'Име на улица', 7),
(1203, '070a6f943470aec6d12c7090f290e10f', 'Номер на улица', 7),
(1204, '1f1c16d7d257c193410bbcc4237aff4a', 'Номер на улица или район', 7),
(1205, '7a620d438361c15161512c4d98341ef1', 'Подразделение', 7),
(1206, 'd0afd6efbc95a5de38cce630155e52aa', 'Подразделения', 7),
(1207, 'c7892ebbb139886662c6f2fc8c450710', 'Тема', 7),
(1208, '9dffbf69ffba8bc38bc4e01abf4b1675', 'Текст', 7),
(1209, '83f0c30cf9b66b30b7cb1571d65596a9', 'Трицифрен ID номер', 7),
(1210, 'b6ae8fbc00355aa62f1a1b6a5a9bee69', 'Трицифрен ID номер (Оператор)', 7),
(1211, '19033fa8ff5c244682d92ed5f8f3d582', 'ЗА всички оператори', 7),
(1212, '6c7195551da0802a39b5e2bc7187df54', 'Превключване на навигацията', 7),
(1213, 'c16dac173aa8377a1c07aed8e0472f7c', 'Град', 7),
(1214, '6dd08874f83507e9c7b23f1a46b7fa7c', 'Превод', 7),
(1215, 'b9a2aa483b400156041a502d39ef9221', 'Тип насилие', 7),
(1216, '4a0ced33ef669eafaf6250f8a5f3a689', 'Тип семейство', 7),
(1217, '7275693a65a2386ad746b0a7a5b82e15', 'Тип инцидент', 7),
(1218, '6a173fd91e6da0859b1d9de118d19ca6', 'Тип организации', 7),
(1219, '8ba81f1258dd23b956fe923561d2da65', 'тип_ инцидент', 7),
(1220, '5916391a654132a460c04967c05d54b2', 'Тип _организация', 7),
(1221, '88183b946cc5f0e8c96b2e66e1c74a7e', 'Неизвестен', 7),
(1222, 'f6039d44b29456b20f8f373155ae4973', 'Потребителско име', 7),
(1223, '4351cfebe4b61d8aa5efa1d020710005', 'Прегледайте', 7),
(1224, 'bc09b552527231f49a320e71c5ddd6a4', 'Прегледайте & Редактирайте профила на Администратора', 7),
(1225, 'f60a3c6183496609617f4ba2639b4ff4', 'Прегледайте & Редактирайте профила на службата', 7),
(1226, 'a7386900f9c83931103381af61aaafb3', 'Прегледайте & Редактирайте езици', 7),
(1227, 'f932b02057ca6970e9f3e15c8dba64fd', 'Прегледайте & Редактирайте профила  на Оператора', 7),
(1228, 'b6953f43780ad0de24ae79f892db0176', 'Прегледайте & Намерете кодове на подразделения', 7),
(1229, '2a1596f614702a29e732fdd7f57e2e26', 'Прегледайте правата за нива на достъп и задайте съответното ниво на достъп ', 7),
(1230, 'ce148c9b6c129dc6e45c00f6b7f4af75', 'Прегледайте всички известия', 7),
(1231, '46e4c16e499315858db8b421ff6807ef', 'Прегледайте класификацията & намерете кодовете', 7),
(1232, '908b28677cc79e0fe3ca52c7327c0556', 'Прегледайте Alpha-2 кодове на страните', 7),
(1233, '83218ac34c1834c26781fe4bde918ee4', 'Добре дошли', 7),
(1235, '4c02263746c1f9db4be5c8a886972338', 'На път сте да изтриете един Оператор, тази процедура е необратима', 7),
(1236, 'b5f4d5db869533be8c311d3369cf2f4a', 'Вашата служба', 7),
(1237, 'a8182ab7ae1169cab49c9d403e76cfd5', 'Вашата информация', 7),
(1238, '8e2bae6fcf0a34e7b12af874f6602139', 'Прегледайте класификацията & намерете кодовете', 7),
(1239, 'e265492707dd0595fd1f399bb8a2690e', 'Български', 7),
(1243, 'b83247733544241528fb86fad6d6334a', 'Ниво на достъп', 7),
(1245, '4d3d769b812b6faa6b76e1a8abaece2d', 'Активен', 7),
(1250, '68a63290c347f42ffce5b24532833624', 'срещу себе си/самонасочено', 7),
(1251, '7d637d275668ed6d41a9b97e6ad3a556', 'възраст', 7),
(1254, '7381f5495177edd501235320608eecc0', 'Име на службата', 7),
(1274, '686e697538050e4664636337cc3b834f', 'Създай', 7),
(1275, '4777bbe3c06c7939e97101b4589ba1eb', 'Дата от', 7),
(1276, '67e6e5858993448ab7ed1a1003529445', 'Дата на инцидент', 7),
(1277, 'd24e4fa285c1eab355817ed6c38ec1bd', 'Дата от', 7),
(1279, '1c22cfebb03dac89eac7331361cb8df4', 'Образователни услуги', 7),
(1281, 'c02034b1cff4fde56cb3eadc40466f8f', 'Съобщение за грешка', 7),
(1285, 'bea4c2c8eb82d05891ddd71584881b56', 'Обратна връзка', 7),
(1300, 'f35de2daf6d9622d6c00bf67aa25e958', 'Няма информация ', 7),
(1304, 'e1b3ec89ead7f83a9245ed5c9cacfdbf', 'Оператор', 7),
(1323, 'c17d0ec9fbffe49e6a5d90dabc26e018', 'Записано от Оператор', 7),
(1324, '9ca018764f7cdb0f650b1671576b99a9', 'Насочваща служба/агенция', 7),
(1339, 'ec53a8c4f07baed5d8825072c89799be', 'Статус', 7),
(1342, '2df01f83032f752182355b25cb6e8d63', 'Временен  ID ', 7),
(1343, 'd8efa374f5851db4bd14a858135d1118', 'Има 38', 7),
(1353, 'bea4c2c8eb82d05891ddd71584881b56', 'Ανατροφοδότηση', 1),
(1354, 'f35de2daf6d9622d6c00bf67aa25e958', 'Δεν υπάρχει πληροφορία', 1),
(1355, 'a274f4d4670213a9045ce258c6c56b80', 'Ειδοποιήσεις', 1),
(1356, '2df01f83032f752182355b25cb6e8d63', 'Προσωρινό Αναγνωριστικό (TEMP ID)', 1),
(1357, '4d3d769b812b6faa6b76e1a8abaece2d', 'Ενεργό', 1);

CREATE TABLE `u_users` (
  `id` int(11) NOT NULL,
  `operators_id` varchar(125) NOT NULL,
  `agency_id` varchar(214) NOT NULL,
  `operator_occupation` varchar(4) NOT NULL,
  `access_level` int(11) NOT NULL,
  `three_digit_id_number_o` varchar(3) NOT NULL,
  `name` varchar(100) DEFAULT NULL,
  `username` varchar(35) NOT NULL,
  `password` varchar(128) NOT NULL,
  `salt` varchar(128) DEFAULT NULL,
  `language` varchar(6) DEFAULT NULL,
  `phone` varchar(20) DEFAULT NULL,
  `email` varchar(30) DEFAULT NULL,
  `agency_nid` int(11) NOT NULL DEFAULT '0',
  `operator_occupation_nid` int(11) NOT NULL DEFAULT '0',
  `language_nid` int(11) NOT NULL DEFAULT '0',
  `Active` tinyint(4) NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


ALTER TABLE `c_child`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `c_child_dob`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `c_child_health`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `c_child_sex`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `c_citizenship_status`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `data_forms_of_maltreatment_acts_committed`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `data_forms_of_maltreatment_omissions`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `data_nationalities`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `f_caregivers`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `f_members_of_family`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `f_members_of_family_sub1`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `f_members_of_family_sub2`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `f_type_of_family`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `i_forms_of_maltreatment`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `i_forms_of_maltreatment_sub1`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `i_forms_of_maltreatment_sub2`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `i_forms_of_maltreatment_sub3`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `i_forms_of_maltreatment_sub4`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `i_incident`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `i_perpetrator`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `i_place_of_incident`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `i_source_of_information`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `i_specific_circumstances`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `notifications`
  ADD PRIMARY KEY (`notificationID`);

ALTER TABLE `s_feedback`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `s_institutional_response`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `s_institutional_response_sub1`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `s_institutional_response_sub2`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `s_referrals_to_services`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `s_referrals_to_services_sub1`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `s_referrals_to_services_sub2`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `s_referrals_to_services_sub3`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `u_admin`
  ADD UNIQUE KEY `id` (`id`);

ALTER TABLE `u_agencies`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `u_country`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `code` (`code`);

ALTER TABLE `u_languages`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `u_occupations`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `code` (`code`);

ALTER TABLE `u_organization_service_type`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `code` (`code`);

ALTER TABLE `u_region`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `code` (`code`);

ALTER TABLE `u_translate`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `u_translate_admin`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `u_users`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `operators_id` (`operators_id`);


ALTER TABLE `c_child`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `c_child_dob`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `c_child_health`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `c_child_sex`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `c_citizenship_status`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `data_forms_of_maltreatment_acts_committed`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=168;

ALTER TABLE `data_forms_of_maltreatment_omissions`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=56;

ALTER TABLE `data_nationalities`
  MODIFY `id` int(3) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=250;

ALTER TABLE `f_caregivers`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `f_members_of_family`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `f_members_of_family_sub1`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `f_members_of_family_sub2`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `f_type_of_family`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `i_forms_of_maltreatment`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `i_forms_of_maltreatment_sub1`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `i_forms_of_maltreatment_sub2`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `i_forms_of_maltreatment_sub3`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `i_forms_of_maltreatment_sub4`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `i_incident`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `i_perpetrator`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `i_place_of_incident`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `i_source_of_information`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `i_specific_circumstances`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `notifications`
  MODIFY `notificationID` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `s_feedback`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `s_institutional_response`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `s_institutional_response_sub1`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `s_institutional_response_sub2`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `s_referrals_to_services`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `s_referrals_to_services_sub1`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `s_referrals_to_services_sub2`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `s_referrals_to_services_sub3`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `u_agencies`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=98;

ALTER TABLE `u_country`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=14;

ALTER TABLE `u_languages`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=14;

ALTER TABLE `u_occupations`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=621;

ALTER TABLE `u_organization_service_type`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=21;

ALTER TABLE `u_region`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `u_translate`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=5281;

ALTER TABLE `u_translate_admin`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1358;

ALTER TABLE `u_users`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
